//--------------------------------------------------------------------------------------------------
//Definice
//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------
{$Define BGTYPE}
//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------
//
type TLimit = array[0..7] of integer;		//Pole limit
//
type TBGData = Record
	Image		: String;		//URL Image
	Info		: String;		//Info string
	RealName	: String;		//Skuten jmno odznaku (hlavn pro States)
	BadgeType	: String;		//Typ odznaku (Grey, B, G, S,...)
	Value		: integer;		//Vypoten hodnota
	Points		: extended;		//Body pro psek
	Percent		: integer;		//Procenta pro graf
	Index		: integer;		//Index do Badges (TBadgeDef)
	RealLimit	: TLimit;		//Limit podle kterho se pot
	OverlayImg	: String;		//URL Overlay Image
end;
//
type TBadgeDef = Record
	ShortName		: String;	//GGeoc
	Name			: String;	//The Geocacher
	Limits			: TLimit;	//500,1000,2000,3000,5000,8000,12000,18000			 - clasic counting
	LimitsEU		: TLimit;	//Limits or 500,1000,2000,3000,5000,8000,12000,18000 - European counting
	Units			: String;	//nothing or 'km','m','%'....
	Sign			: String;	//'+' or '-'
	Flags			: String;	//flags for special occasions
	Optional		: String;	//optional information
	GlobalVariables	: String;	//var1|var2|var3 									- normal only one variable
	BP				: integer;	//BlackPearl coeficient (-1 = nothing) normal
	BPEU			: integer;	//BlackPearl coeficient (-1 = nothing) EU
end;

Type TINIInformation = Record
	bIsOriginal		: Boolean;					//Original nebo EU
	sIsGraph		: String;
	sIsCompact		: String;
	sIsFlagCompact	: Boolean;
	bIsBelt			: Boolean;
	bIsInfo			: Boolean;
	bFlagsSeparetly	: Boolean;
	bShowGrey		: Boolean;
	//Manual Value
	iWaterCaches	: Integer;					//vodn kee
	iBenchmark		: Integer;					//NGC - Benchmarky	
	iPhotos			: Integer;					//Fotky
	iNight			: Integer;					//non kee
	iNightTAG		: String;					//non kee pes TAG
	iAllTB			: Integer;					//TB
	iAllGC			: Integer;					//GC
	iAllCWG			: Integer;					//CWG
	iCWGgcm			: Integer;					//CWG.gcm
	iCWGDB      : Integer;          //CWG z DB
	sCWGMethod  : String;           //pouit metoda
	sCWGgcmLogin	: String;					//CWG.gcm Login
	sCWGextDB   : String;           //extern databze CWG
	sCWGextDBSelect : String;       //dotaz do extern databze (mus vracet jedno slo)
	iLevel			: Integer;	//Level zobrazovanch odznak - (nap od zlatch nahoru po diamant)
	//Size
	iBadgeSize		: Integer;					//velikost odznaku 
	iBeltSize		: Integer;					//velikost psku
	//
	bWaymarking		: Boolean;					//Waymarking ANO/NE
	bBlackPearl		: Boolean;					//Level ern Perla ANO/NE 
	//
	sWaymarkingDB	: String;					//DB pro Waymarking
	//	
	sBadgesURL		: String;					//odkud odznaky
	//	
	DruhaDB	   		: TSqliteDatabase;			//Druha DB (Waymarking);
	//Belt point
	eTB, eGC		: extended;					
	eSumPoints		: extended;
	//Challenge
	sNoChallenge : String;						//Kee vylouen z Challenge SQL 
	//Timer
	//iTimer			: integer;					//Doba zobrazeni vystrelovaciho okna nastaveni
end;
//-----------------------------------------------------------------------------
//Konstanty
//-----------------------------------------------------------------------------
const
	CalcBG_sModuleTmp = '\Stator\Tmp\';
	CalcBG_sStates = 'http://www.geotrebic.cz/b/statelist.txt';
	CalcBG_sStatesCZ = 'http://www.drakmrak.cz/b/statelist.txt';
	CalcBG_sStatesTag = 'http://www.geotrebic.cz/b/statestag.txt';
	CalcBG_sGCM = 'http://cwg.gcm.cz/api/users/statbar/';
	CalcBG_sBadges = 'http://www.geocaching.cz/stator/img/bg/';
	CalcBG_Version = '1.2.0';
//-----------------------------------------------------------------------------
//Promnn Globln
//-----------------------------------------------------------------------------
var
	CalcBG_Data		: array of TBGData;			//Pole vsledk
	CalcBG_StateData: array of TBGData;			//Pole vsledk odznk stt
	//
	CalcBG_Badges	: array of TBadgeDef;		//Pole definic odznk
	//
	CalcBG_INI		: TINIInformation;			//Inicializan data
	//
	CalcBG_sCalcRun	: String;					//Pokud je CALC sputn obsahuje slovo 'CALC'
	RealLimit		: TLimit;					//podle toho se pot