const
	BC_Version = '1.0.5';

function BookmarkComposer_MakeLinkToBookmark(sBookmark, sGUID:String):String;
begin
	if Lowercase(Copy(sGUID,1,2)) = 'bm' then
		Result := '<a href="https://coord.info/'
				+ sGUID + '" target="_blank">' + ReplaceString(sBookmark,'"','&quot;') + '</a>'
	else
		Result := '<a href="https://www.geocaching.com/bookmarks/view.aspx?guid='
				+ sGUID + '" target="_blank">' + ReplaceString(sBookmark,'"','&quot;') + '</a>';
end;

function BookmarkComposer_Filter(txt:String; var sout:String):Boolean;
begin
	Result := False; sout := txt;
	if Pos('adopted by', Lowercase(sout)) > 1 then begin
		sout := Trim(Copy(sout,Pos('adopted by', Lowercase(sout))+10, 
			Length(sout)-(Pos('adopted by', Lowercase(sout))+10)+1)); Result := True;
	end;
	if Pos('adp', Lowercase(sout)) > 1 then begin 
		sout := Trim(Copy(sout,1,Pos('adp', Lowercase(sout))-1)); Result := True;
	end;
	if Pos('adop', Lowercase(sout)) > 1 then begin 
		sout := Trim(Copy(sout,1,Pos('adop', Lowercase(sout))-1)); Result := True;
	end;
	if Pos('puvod', Lowercase(sout)) > 1 then begin 
		sout := Trim(Copy(sout,1,Pos('puvod', Lowercase(sout))-1)); Result := True;
	end;
	if Pos('born', Lowercase(sout)) > 1 then begin 
		sout := Trim(Copy(sout,1,Pos('born', Lowercase(sout))-1)); Result := True;
	end;
	if Pos('prevz', Lowercase(sout)) > 1 then begin 
		sout := Trim(Copy(sout,1,Pos('prevz', Lowercase(sout))-1)); Result := True;
	end;
	if Pos('autor', Lowercase(sout)) > 1 then begin 
		sout := Trim(Copy(sout,1,Pos('autor', Lowercase(sout))-1)); Result := True;
	end;
	if Pos('made', Lowercase(sout)) > 1 then begin 
		sout := Trim(Copy(sout,1,Pos('made', Lowercase(sout))-1)); Result := True;
	end;
	if Pos('original', Lowercase(sout)) > 1 then begin 
		sout := Trim(Copy(sout,1,Pos('original', Lowercase(sout))-1)); Result := True;
	end;
	if Pos('pvod', Lowercase(sout)) > 1 then begin 
		sout := Trim(Copy(sout,1,Pos('pvod', Lowercase(sout))-1)); Result := True;
	end;
end;

function BookmarkComposer_DecodeAuthors(AuthorVar:String):String;
var
	Names				: array of string;
	Short,tmp,zal,sout	: string;
	i,j,cnt				: integer;
begin
	Result := AuthorVar; i := 0; cnt := 0;
	zal := AuthorVar; sout := '';
	while (AuthorVar <> '') do begin
		tmp := Fetch(AuthorVar,'|');
		Inc(cnt);
		//filtr-----------------------------------------------
		if BookmarkComposer_Filter(tmp,sout) then continue;
		//----------------------------------------------------
		SetLength(Names, Length(Names) + 1);
		Names[i] := tmp;
		Inc(i);
	end;
	//
	if i > 0 then begin
		if cnt > 1 then begin
			j := 65535;
			for i := 0 to High(Names) do begin
				if Length(Names[i]) < j then begin
					j := Length(Names[i]);
					Short := Names[i];				//nejkrat nzev
				end;
			end;
			Result := Short;
		end
		else Result := Names[0];
	end
	else begin
		if Pos('|', zal) > 0 then begin
			tmp := Fetch(zal,'|');
			if BookmarkComposer_Filter(tmp,sout) then 
				Result := Trim(ReplaceString(ReplaceString(sout,'(',''),',',''));
		end
		else begin
			tmp := zal;
			if BookmarkComposer_Filter(tmp,sout) then
				Result := Trim(ReplaceString(ReplaceString(sout,'(',''),',',''));
		end;
	end;
	//
	if Pos(',', Result) > 0 then
		Result := Trim(Copy(Result,1,Pos(',', Result)-1));	//finln prava v ppad vce autor oddlench rkou - veme se prvn
	SetLength(Names, 0);	//vymaze pamet
end;

function BookmarkComposer_ParseAuthors(tab:TSqliteTable):String;
var
	sHint, sOut: String;
	i,j, imax: integer;
begin
	sOut := ''; i := 0; j := 0;
	imax := tab.FieldAsInteger(0);
	while not tab.Eof do begin
		if imax = tab.FieldAsInteger(0) then begin
			if j > 2 then begin
				if j = 3 then
					sHint := BookmarkComposer_DecodeAuthors(UtfToAnsi(tab.FieldAsString(1)))
				else
					sHint := sHint + ', ' + BookmarkComposer_DecodeAuthors(UtfToAnsi(tab.FieldAsString(1)));
			end
			else begin
				if j = 0 then
					sOut := BookmarkComposer_DecodeAuthors(UtfToAnsi(tab.FieldAsString(1)))
				else
					sOut := sOut + ', ' + BookmarkComposer_DecodeAuthors(UtfToAnsi(tab.FieldAsString(1)));
			end;
			Inc(j);
		end
		else begin
			if (j > 2) and (sHint <> '') then
				sOut := sOut + ', <span title="' + ReplaceString(sHint,'"','&quot;') + '">...</span> (<b>' + IntToStr(imax) + '</b>)'
			else
				sOut := sOut + ' (<b>' + IntToStr(imax) + '</b>)';
			//
			Inc(i);
			if i = 3 then break;			//3 x max a dost
			j := 1; sHint := '';
			imax := tab.FieldAsInteger(0);
			sOut := sOut + ', ' + BookmarkComposer_DecodeAuthors(UtfToAnsi(tab.FieldAsString(1)));
		end;
		//
		tab.Next; 
	end;
	if i < 3 then begin
		if sHint <> '' then
			sOut := sOut + ', <span title="' + ReplaceString(sHint,'"','&quot;') + '">...</span> (<b>' + IntToStr(imax) + '</b>)'
		else
			sOut := sOut + ' (<b>' + IntToStr(imax) + '</b>)';
	end;
	Result := sOut;
end;
	
//hlavni funkce modulu
function BookmarkComposer_Run(aPar: TStringList):string;	
var
	BC_Bookmarks	: String;
	BC_Columns		: String;
	BC_ImageURL		: String;
	BC_Title		: String;
	BC_Guids		: String;
	BC_ShowText		: String;
	BC_AllCaches	: Boolean;
	BC_Results		: Boolean;
	BC_ResultsUp	: Boolean;
	BC_Expanded		: Boolean;
  BC_HeaderInfo : Boolean;
	//
	BC_All			: integer;
	BC_Found		: integer;
	BC_AFound		: integer;
	BC_MyOwn		: integer;
	BC_Status		: array[0..2] of integer;
	BC_Owners		: String;
	BC_FoundOwners	: String;
	//
	aTmpParams,aData: TStringlist;
	sBookmarkData	: String;
	sDistinct,sDis	: String;
	sTmp,sTagName	: String;
	sJoins			: String;
	aStr,bStr,sqlu	: String;
	sResultData		: String;
	colTmp,col,sql,s: String;
	sBook,sxBook	: String;
	fiBook			: String;
	i,j,k			: integer;
	n,idxCount,idxDate : integer;
	nCols, nRows	: integer;
	iFirst, nRest	: integer;
	//imax			: integer;
	//idi1, idi2		: integer;
	tab				: TSqliteTable;
		
begin
	Log('BookmarkComposer ver.: ' + BC_Version + ' - START');
	//-------------------------------------------------------------------------
	BC_Bookmarks	:= aPar.Values['Bookmarks'];
	BC_Columns		:= aPar.Values['Columns'];
	BC_ImageURL		:= aPar.Values['Image'];
	s := aPar.Values['ShowText'];
	BC_ShowText		:= Fetch(s,'-');
	BC_AllCaches	:= aPar.Values['AllCaches'] = 'Yes';
	BC_Results		:= aPar.Values['Results'] = 'Yes';
	BC_ResultsUp	:= aPar.Values['ResTableUp'] = 'Yes';
	BC_Expanded		:= aPar.Values['Expanded'] = 'Yes';
  BC_HeaderInfo := aPar.Values['InfoInHeader'] = 'Yes';
	BC_Guids		:= aPar.Values['BookmarkGUIDs'];
	//-------------TITLE-------------------------------------------------------
	if (aPar.Values['Title'] = '') and (BC_ImageURL = '') then
		BC_Title := ReplaceString(BC_Bookmarks, '|', ', ')
	else
		BC_Title := aPar.Values['Title'];
	Log('BOOKMARK: ' + BC_Title); 
	//-------------------------------------------------------------------------
	sBook := BC_Bookmarks; fiBook := ''; sxBook := ''; i:=0;
	//Doplnk klauzule IN-----------------------------------------------------------------------
	//zjist jestli se mus doplnit DISTINCT - jestli je vce BOOKMARK
	//a vytvo seznam bookmark
	//------------------------------------------------------------------------------------------
	sDistinct := ''; sDis := '';
	while (sBook <> '') do begin
		sxBook := sxBook + '"' + Fetch(sBook,'|') + '"';
		if sBook <> '' then sxBook := sxBook + ',';
		Inc(i);
	end;
	if BC_Guids = '' then begin
		fiBook := ReplaceString(ReplaceString(sxBook,'"',''),',',', ');
	end
	else begin
		sBook := BC_Bookmarks;
		sTmp := BC_Guids;
		//
		while (sBook <> '') do begin
			aStr := Fetch(sBook,'|');
			bStr := Fetch(sTmp,'|');
			fiBook := fiBook + BookmarkComposer_MakeLinkToBookmark(aStr,bStr);
			if sBook <> '' then fiBook := fiBook + ', ';
		end;
	end;
	//Log(fiBook);
	//Distinct
	if i > 1 then begin
		sDistinct := ' DISTINCT';		//ANO dopluji
	end;
	//------------------------------------------------------------------------------------------
	if i > 0 then aPar.Values['Columns'] := aPar.Values['Columns'] + '|tag-Bookmark=;Null;IN#%IN%'
	else begin
		Inc(nModuleErrors);
		iModuleError := 1;
		sModuleError := _('ERR: No Bookmarks!') + CRLF
					 + _('Does not defined any bookmark!');		//nen dn bookmark !!
		if(sModuleError <> '') then Log(sModuleError);
		exit;
	end;
	//
	if BC_AllCaches then
		aPar.Values['FoundOnly'] := 'No'
	else
		aPar.Values['FoundOnly'] := 'Yes';
	//
	i := 0; colTmp := BC_Columns;
	//
	while (colTmp <> '') do begin
		col := Fetch(colTmp,'|');
    if Pos('Found',col) > 0 then idxDate := i;
		if Fetch(col,'=') = 'Count' then idxCount := i;
		Inc(i);
	end;
	n := idxCount;
	//Vytvo SQL
	sql := TableListMakeSqlFromParams(aPar,true,'',n);
	//DISTINCT------------------------------------------------------------------
	//je-li nutn DISTINCT (vce spojench srii) tak mus upravit SELEKT
	//mus se vyhodit nzvy srii a sjednotit na jednom nzvu "SERIE"
	//--------------------------------------------------------------------------	
	if sDistinct <> '' then begin
		j := Pos('(%IN%)',sql); 
		k := j + Length('(%IN%)');
		//
		For i := (j-1) downto 1 do begin
			if sql[i] = '(' then begin
				j := i; 
				break;
			end;
		end;
		//
		For i := k to Length(sql) do begin
			if sql[i] = ')' then begin
				k := i+1; 
				break;
			end;
		end;
		sDis := Copy(sql,j,k-j);
		//----------------------------------------------------------------------------
		//zmna nzv rznch srii za jednotn "SERIE"- e problm spojovn srii 
		//----------------------------------------------------------------------------
		sql := ReplaceString(sql,sDis,'(CASE IFNULL(' + sDis + ',"") WHEN "" THEN null ELSE "SERIE" END)');
		sTmp := Fetch(sql, ' ');
		//dopln slovko DISTINCT do selektu
		sql := sTmp + sDistinct + ' ' + sql;
	end;	
	//UNION - pid vlastn kee je-li to poteba---------------------------------------------------
	if not BC_AllCaches then begin
		j := Pos('(%IN%)',sql);
		//zjist sprvn TAG
		For i := (j-1) downto 1 do begin
			if sql[i] = '=' then begin
				k := i+1; 
				break;
			end;
		end;
		sTmp := Trim(Copy(sql,k,10));
		sTagName := Fetch(sTmp,'.');
		//find start JOIN
		j := Pos(ReplaceString(sTagName,'g','TagCat_'),sql);
		k := Pos('JOIN',sql);
		For i := (j-1) downto 1 do begin
			if sql[i] = ')' then begin
				j := i+1; 
				break;
			end;
		end;
		sJoins := '';
		if j > k then
			sJoins := Copy(sql, k, j-k);
		//------------------je-li poteba vlo UNION pro vlastn kee
		aStr := ReplaceString(GlobalVarGet('OwnedAuthorsForInPhrase',false),'''','');
		bStr := GlobalVarGet('GeogetOwner',false);
		//
		sDis := Trim(Copy(sql,1,Pos(TEMP_TABLE, sql)-1));
		sqlu := CRLF + 'UNION' + CRLF;
		sqlu := sqlu + sDis + ' geocache gc';
		sqlu := sqlu + ' LEFT OUTER JOIN '+TEMP_TABLE+' st ON (gc.id=st.id) ';
		//another JOIN--------------------------------------------
		//dopln dal JOINy kterch se to netk ale mus tm bt
		if sJoins <> '' then
			sqlu := sqlu + CRLF + sJoins + CRLF;
		//--------------------------------------------------------
		//dopln JOIN pro vytaen vlastnch ke
		//--------------------------------------------------------
		sqlu := sqlu + ' LEFT OUTER JOIN geotag '+ sTagName
					 + ' ON (gc.id='+ sTagName
					 + '.id and '+ sTagName
					 + '.ptrkat IN (SELECT key FROM geotagcategory WHERE value=:'
					 + ReplaceString(sTagName,'g','TagCat_') +' COLLATE NOCASE))';
		sqlu := sqlu + ' WHERE '+ ReplaceString(sTagName,'g','val')
					 + ' IS NOT NULL AND';
		sqlu := sqlu + ' gc.[author] IN (';
		while Pos(',',aStr) > 0 do begin
			bStr := Fetch(aStr,',');
			sqlu := sqlu + '''' + bStr + ''',';
		end;
		sqlu := sqlu + '''' + aStr + '''';
		sqlu := sqlu + ')' + CRLF;
		//--------------------------------------------------------
		//pokud je azen tak ho dopln a seskld vsledek
		//--------------------------------------------------------
		if Pos('ORDER BY',sql) > 0 then begin
			k := Pos('ORDER BY',sql);
			aStr := Copy(sql,1, k-1) + sqlu + Copy(sql, k, Length(sql) - k + 1);
			sql := aStr;
		end
		else
			sql := sql + sqlu;
	end
	else begin
		//-----------------------------------------------------------------------
		//pokud je poteba pipojit temp tabulku mus to pedlat jinak
		//tabulka nesm bt ve FROM ale mus se najoinovat
		//-----------------------------------------------------------------------
		if Pos(', '+TEMP_TABLE+' st',sql) > 0 then begin
			sqlu := 'LEFT OUTER JOIN '+TEMP_TABLE+' st ON (gc.id=st.id) ';
			sql := ReplaceString(sql,', '+TEMP_TABLE+' st','');
			sql := ReplaceString(sql,'gc.id=st.id','1=1');
			//
			aStr := sql; i:= 0; j:=0; bStr := '';
			while Pos('WHERE',aStr) > 0 do begin
				i := Pos('WHERE',aStr);
				if j > 0 then
					bStr := bStr + ' WHERE ' + Copy(aStr,1,i-1)
				else
					bStr := bStr + Copy(aStr,1,i-1);
				aStr := Copy(aStr, i+Length('WHERE'), Length(aStr) - i + 1);
				Inc(j);
			end;
			//seskld vsledek------------------------------
			if i > 0 then
				sql := bStr + sqlu + CRLF + 'WHERE ' + aStr
			else
				sql := sql + sqlu;
		end;
	end;
	//----------------------------------------------------------------------------------------------
	//Doplnn klauzule IN
	Log(sxBook);
	sql := ReplaceString(sql,'%IN%',sxBook);
	//A te u data z tabulky-----------------------------------------------------------------------
	//Log(sql);
	tab := Geoget_DB.GetTable(sql, false);
	//Pvodn sloupce
	aPar.Values['Columns'] := BC_Columns;
	//----------------------------------------------------------------------------------------------
	aData := TStringList.Create;
	try
		nCols := tab.ColCount - 1;	//-1 vyhod sloupec s bookmarkem
		nRows := 0;
		while (not tab.Eof) do begin
			Inc(nRows);
			for i := 0 to nCols-1 do begin
				aData.Add(tab.FieldAsString(i));
				//Log(IntToStr(i)+': '+tab.FieldAsString(i));
			end;
			tab.Next();
		end;
		if(nRows <= 0) then begin
			Log(_('WARN: SQL does not return any valid data'));
			Log('BookmarkComposer - END');
			exit;
		end;
	finally
		if(tab <> nil) then tab.Free();
	end;
	//----------------------------------------------------------------------------------------------
	//Data pro vsledky-----------------------------------------------------------------------------
	//----------------------------------------------------------------------------------------------
	sql := 'SELECT COUNT(*) FROM (SELECT' + sDistinct + ' id FROM (SELECT gc.[id] id';
	sql := sql + ' FROM geocache gc';
	sql := sql + ' INNER JOIN geotag gt ON (gc.id = gt.id AND gt.ptrkat IN';
	sql := sql + ' (SELECT key FROM geotagcategory WHERE value = "Bookmark" COLLATE NOCASE))';
	sql := sql + ' WHERE gt.ptrvalue IN (SELECT key FROM geotagvalue WHERE value IN';
	sql := sql + ' (' + sxBook + '))))';
	//Poet ke v srii
	//Log(sql);
	BC_All := Geoget_DB.GetTableValue(sql);
	//
	sql := 'SELECT COUNT(*) FROM (SELECT' + sDistinct + ' id FROM (SELECT gc.[id] id';
	sql := sql + ' FROM geocache gc';
	sql := sql + ' INNER JOIN geotag gt ON (gc.id = gt.id AND gt.ptrkat IN';
	sql := sql + ' (SELECT key FROM geotagcategory WHERE value = "Bookmark" COLLATE NOCASE))';
	sql := sql + ' WHERE gc.dtfound > 0 AND gt.ptrvalue IN (SELECT key FROM geotagvalue WHERE value IN';
	sql := sql + ' (' + sxBook + '))))';
	//Poet ke v srii nalezench
	//Log(sql);
	BC_Found := Geoget_DB.GetTableValue(sql);
	//
	aStr := ReplaceString(GlobalVarGet('OwnedAuthorsForInPhrase',false),'''','');
	bStr := GlobalVarGet('GeogetOwner',false);
	//
	sql := 'SELECT COUNT(*) FROM (SELECT ' + sDistinct + ' gc.id,';
	sql := sql + ' (CASE IFNULL((SELECT value FROM geotagvalue WHERE key=gT0.ptrvalue AND value IN (';
	sql := sql + sxBook + ') COLLATE NOCASE),"") WHEN "" THEN null ELSE "SERIE" END) book';
	sql := sql + ' FROM geocache gc';
	sql := sql + ' JOIN geotag gT0 ON (gc.id=gT0.id and gT0.ptrkat IN (SELECT key FROM geotagcategory WHERE value = "Bookmark" COLLATE NOCASE))';
	sql := sql + ' WHERE book IS NOT NULL AND gc.[author] IN (';
	while Pos(',',aStr) > 0 do begin
			bStr := Fetch(aStr,',');
			sql := sql + '''' + bStr + ''',';
	end;
	sql := sql + '''' + aStr + '''';
	sql := sql + '))';
	//Poet ke vlastnch v srii
	//Log(sql);
	BC_MyOwn := Geoget_DB.GetTableValue(sql);
	//
	sql := 'SELECT COUNT(*) FROM (SELECT' + sDistinct + ' id FROM (SELECT gc.[id] id';
	sql := sql + ' FROM geocache gc';
	sql := sql + ' INNER JOIN geotag gt ON (gc.id = gt.id AND gt.ptrkat IN';
	sql := sql + ' (SELECT key FROM geotagcategory WHERE value = "Bookmark" COLLATE NOCASE))';
	sql := sql + ' WHERE gc.dtfound > 0 AND gc.[cachestatus] = 2 AND gt.ptrvalue IN (SELECT key FROM geotagvalue WHERE value IN';
	sql := sql + ' (' + sxBook + '))))';
	//Poet ke v srii nalezench ale ji archivovanch
	//Log(sql);
	BC_AFound := Geoget_DB.GetTableValue(sql);
	//
	for i := 0 to 2 do BC_Status[i] := 0;
	sql := 'select gc.[cachestatus] status';
	sql := sql + ' from geocache gc';
	sql := sql + ' inner join geotag gt on (gc.id = gt.id and gt.ptrkat IN';
	sql := sql + ' (select key from geotagcategory where value = ''Bookmark'' COLLATE NOCASE))';
	sql := sql + ' where gt.ptrvalue IN (select key from geotagvalue where value IN';
	sql := sql + ' (' + sxBook + '))';
	if sDistinct <> '' then
		sql := sql + ' group by gc.[id], gc.[cachestatus]'; 
	//Poet jednotlivch stav Archived, Disabled, Normal
	//Log(sql);
	tab := Geoget_DB.GetTable(sql, false);
	try
		while not tab.Eof do begin
			Inc(BC_Status[tab.FieldAsInteger(0)]);
			tab.Next;
		end;
	finally
		if(tab <> nil) then tab.Free();
	end;
	//owneri kteri maji nejvice kesi v serii
	sql := 'SELECT sum(t.ocnt) ownercnt, group_concat(t.owner,"|") ownernames';
	sql := sql + ' FROM (SELECT count(gc.[author]) ocnt, gc.[author] owner';
	sql := sql + ' FROM geocache gc';
	sql := sql + ' INNER JOIN geotag gt ON (gc.id = gt.id AND gt.ptrkat IN (SELECT key FROM geotagcategory WHERE value = "Bookmark" COLLATE NOCASE))';
	sql := sql + ' WHERE gt.ptrvalue IN (SELECT key FROM geotagvalue WHERE value IN (' + sxBook + '))';
	sql := sql + ' GROUP BY gc.[author]) t';
	sql := sql + ' GROUP BY t.owner';
	sql := sql + ' ORDER BY ownercnt DESC';
	//
	tab := Geoget_DB.GetTable(sql, false);
	//
	try
		BC_Owners := BookmarkComposer_ParseAuthors(tab);
	finally
		tab.Free();
	end;
	//owneri ktere mam nejvice odlovene
	sql := 'SELECT sum(t.ocnt) ownercnt, group_concat(t.owner,"|") ownernames';
	sql := sql + ' FROM (SELECT count(gc.[author]) ocnt, gc.[author] owner';
	sql := sql + ' FROM geocache gc';
	sql := sql + ' INNER JOIN geotag gt ON (gc.id = gt.id AND gt.ptrkat IN (SELECT key FROM geotagcategory WHERE value = "Bookmark" COLLATE NOCASE))';
	sql := sql + ' WHERE gt.ptrvalue IN (SELECT key FROM geotagvalue WHERE value IN (' + sxBook + ')) and gc.[dtfound]>0';
	sql := sql + ' GROUP BY gc.[author]) t';
	sql := sql + ' GROUP BY t.owner';
	sql := sql + ' ORDER BY ownercnt DESC';
	//
	tab := Geoget_DB.GetTable(sql, false);
	//
	try
		BC_FoundOwners := BookmarkComposer_ParseAuthors(tab);
	finally
		tab.Free();
	end;
	//----------------------------------------------------------------------------------------------
	//Tvorba vstupu--------------------------------------------------------------------------------
	//----------------------------------------------------------------------------------------------
	aTmpParams := TStringList.Create;
	try
		sResultData := '';
		//--------------------------------------------Result table
		if BC_Results then begin
			sResultData:=CRLF+'<br /><table style="%StyleTableNum%">'+CRLF;
			sResultData:=sResultData
				+'<tr style="%StyleTableNumTr%"><th colspan=2 style="%StyleTableNumTh%">'
				+_('Summary of bookmark: ') + ReplaceString(BC_Title,'"','&quot;') +'</th></tr>'+CRLF;
			sResultData:=sResultData
				+'<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'
				+_('All Caches in bookmark(s)')+'&nbsp;</td><td style="%StyleTableNumTd%"><b>'
				+ IntToStr(BC_All) + '</b> ('
				+ fiBook
				+ ')</td></tr>'+CRLF;
			sResultData:=sResultData
				+'<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'
				+_('Found Caches')+'&nbsp;</td><td style="%StyleTableNumTd%"><b>'
				+ IntToStr(BC_Found) + '</b> (' + IntToStr(BC_AFound) 
				+ ' ' + _('of them archived.') + ') '
				+ '</td></tr>'+CRLF;
			if BC_MyOwn > 0 then begin
				sResultData:=sResultData
					+'<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'
					+_('Own Caches')+'&nbsp;</td><td style="%StyleTableNumTd%"><b>'
					+ IntToStr(BC_MyOwn) + '</b> ('
					+ FlToStr(Round(((BC_MyOwn*100.00)/BC_All)*10)/10.0)
					+ ' %)</td></tr>'+CRLF;
			end;
			sResultData:=sResultData
				+'<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'
				+_('Found result')+'&nbsp;</td><td style="%StyleTableNumTd%">'
				+_('You found ') + '<b>' + IntToStr(BC_Found+BC_MyOwn) + '</b>'
				+_(' caches from ') + IntToStr(BC_All) + 
				+' (' + FlToStr(Round((((BC_Found + BC_MyOwn)*100.00)/BC_All)*10)/10.0) + ' % / <b>' 
				+ FlToStr(Round((((BC_Found+BC_MyOwn)*100.00)/(BC_All - BC_Status[2] + BC_AFound))*10)/10.0) + ' % </b>'
				+ _('without unavailable archived') +')</td></tr>'+CRLF;
			sResultData:=sResultData
				+'<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'
				+_('Live Caches')+'&nbsp;</td><td style="%StyleTableNumTd%"><b>'
				+ IntToStr(BC_Status[0]) + '</b> ('
				+ FlToStr(Round(((BC_Status[0]*100.00)/BC_All)*10)/10.0)
				+ ' %)</td></tr>'+CRLF;
			sResultData:=sResultData
				+'<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'
				+_('Disabled Caches')+'&nbsp;</td><td style="%StyleTableNumTd%"> <img src="%IconCacheStatus1%" /> <b>'
				+ IntToStr(BC_Status[1]) + '</b> ('
				+ FlToStr(Round(((BC_Status[1]*100.00)/BC_All)*10)/10.0)
				+ ' %)</td></tr>'+CRLF;
			sResultData:=sResultData
				+'<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'
				+_('Archived Caches')+'&nbsp;</td><td style="%StyleTableNumTd%"> <img src="%IconCacheStatus2%" /> <b>'
				+ IntToStr(BC_Status[2]) + '</b> ('
				+ FlToStr(Round(((BC_Status[2]*100.00)/BC_All)*10)/10.0)
				+ ' %)</td></tr>'+CRLF;
			if BC_Owners <> '' then begin
				sResultData:=sResultData
					+'<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'
					+_('The most frequent cache authors')+'&nbsp;</td><td style="%StyleTableNumTd%">'
					+ BC_Owners + '</td></tr>'+CRLF;
			end;
			if BC_FoundOwners <> '' then begin
				sResultData:=sResultData
					+'<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'
					+_('The most frequent found cache authors')+'&nbsp;</td><td style="%StyleTableNumTd%">'
					+ BC_FoundOwners + '</td></tr>'+CRLF;
			end;	
			sResultData:=sResultData+CRLF+'</table>';
		end;
		//--------------------------------------------------HEADER
		aTmpParams.Clear;
		if BC_Expanded then
			aTmpParams.Values['Open'] := 'Yes'					//Oteven
		else
			aTmpParams.Values['Open'] := 'No';					//Zaven
		//OBRAZEK
		//if (BC_ImageURL <> '') and (BC_ShowImg) then begin	//Hlavika
		if (BC_ImageURL = '') then BC_ShowText := 'Text only';
		aTmpParams.Values['ShowText'] := BC_ShowText;			//Obrzek vpravo
		aTmpParams.Values['Icon'] := BC_ImageURL;				//url obrzku
		//end;
    if (BC_HeaderInfo) then begin
      BC_Title := BC_Title + ' <span style="padding-left:10px; font-style:italic; font-size:80%; background:#%ColorFrameTitleBkg%; color:#%ColorTableScaleMaxText%;">' + _('You found ') + '<b>' + IntToStr(BC_Found+BC_MyOwn) + '</b>'
				+_(' caches from ') + IntToStr(BC_All) + 
				+' (<b>' + FlToStr(Round((((BC_Found + BC_MyOwn)*100.00)/BC_All)*10)/10.0) + ' % </b>)</span>';
        //Log(BC_Title);
    end;
		aTmpParams.Values['Title'] := BC_Title;					//Pokud je text tak i text
		//--------------------------------------------------
		//START SEKCE a DIV
		GlobalVarSet('IdElement',GlobalVarGet('IdElement',false));
		SaveWidth('Frame');
		//START HTML
		sBookmarkData := ProcessFrameStart(GlobalVarGet('IdElement',false), aTmpParams)
		sBookmarkData := sBookmarkData + '<div>' + CRLF;
		//Vysledky UP
		if BC_Results and BC_ResultsUp then
			sBookmarkData := sBookmarkData + sResultData + '<br />';
		//TABULKA	
		n := -1;
		s := aPar.Values['CountRow'];			//zjistime pocet radku do tabulky
		if(s <> '') then n := StrToInt(s);
		iFirst := 0;
		s := aPar.Values['FirstRow'];			//zjistime prvni radek tabulky
		if(s <> '') then iFirst := StrToInt(s);
		//Log('SSSS iFirst='+IntToStr(iFirst)+', n='+IntToStr(n));
    //PREPARE HIGHLIGHT ROWS
    if BC_AllCaches then begin
      if n < 0 then nRows := aData.Count/nCols
      else nRows := n;
      //
      for i := iFirst to nRows-1 do begin 
        if StrToInt(Trim(aData[i*nCols+idxDate])) > 0 then
          aData[i*nCols+0] := CONST_HIGHLIGHT + aData[i*nCols+0];
      end;
    end;
    //PREPARE ROWS	
		sBookmarkData := sBookmarkData
			+ OutputTableList(BC_Columns,aData,iFirst,n,idxCount,nRest) + CRLF;
		//Vysledky DOWN
		if BC_Results and not BC_ResultsUp then
			sBookmarkData := sBookmarkData + sResultData;
		//END DIV a SEKCE		
		sBookmarkData := sBookmarkData + '</div>';
		{sBookmarkData := sBookmarkData + '<div style="width:' + IntToStr(iWidth)
			+ 'px; text-align: right; font-size:xx-small; color:#%ColorTableScaleMinBkg%;">By DrakMrak, version: '
			+ BC_Version + '</div>';}
		sBookmarkData := sBookmarkData +  ProcessFrameEnd();
		//VYSTUP END - HTML
		Output(sBookmarkData);
		RestoreWidth('Frame');
		Log('BookmarkComposer - END');
	finally
		aTmpParams.Free;
		aData.Free;
	end;
	Result := '';
end;