//ulozi nactena data do docasne tabulky
procedure CalcTrackable_Free;
begin
  Log('Start CalcTrackable_Free()');
  //snazat docasnou tabulku
  Geoget_DB.ExecSQL('DROP TABLE IF EXISTS temp.StatorTrackable;');
end;

procedure  CalcTrackable_SaveData(aData:TStringList;sOwned:string);
//sOwnde je 'Owned' nebo 'Logged'
var i:integer;
    s,sSql:string;
begin
  for i:=0 to aData.Count-1 do begin
    s:=Trim(aData[i]);
    if(s<>'') then begin
      GEOGET_DB.AddParamText(':id',Fetch(s,','));
      GEOGET_DB.AddParamText(':ico',Fetch(s,','));
      GEOGET_DB.AddParamText(':km',Fetch(s,' '));
      Fetch(s,',');
      GEOGET_DB.AddParamText(':name',s);
      GEOGET_DB.AddParamText(':file',sOwned);
      sSql:='INSERT INTO temp.StatorTrackable (id,ico,km,name,file) VALUES (:id,:ico,:km,:name,:file);';
      Geoget_DB.ExecSQL(sSql);
    end;
  end;
end;

procedure CalcTrackable_MakeTmpTable(sType:string); //vytvori docasnou tabulku a naplni ji pozadovanym typem trackables
                                                    //Logged/Owned/All
var s,sPath,sOut,sOwned:string;
    n:integer;
    aData:TStringList;
    dt: TDateTime;
begin
  //modul vyuziva data stazena jinym pluginem, protoze k tomu je potreba GJ
  //a neni zadouci, aby GJ bylo primo pouzivano ze Statoru. S timto postupem
  //Geby souhlasi. Data jsou stahovana anonymnim pristupem GJ. Je vsap potreba
  //UID, ktere bez prihlaseni zjisti nejde. Samostatny plugin se prihlasi,
  //zjisti UID, to si ulozi a pri dalsim pozadavku jiz bude pouzivat drive
  //zjistene UID
  //////////////////////////////////////////////////////////////////////////////
  //zjistime, zda existuje plugin, ktery potrebujeme spustit pro ziskani dat
  sPath:=GetMyDir+'GetTrackList\';
  s:=sPath+'GetTrackList.ggp.pas';
  if(not FileExists(s)) then begin
    Log(_('ERR: Plugin GetTrackList does not exist.'));
    exit;
  end;
  //pripravime konfiguraci pro ziskani dat podle stari existujicich souboru
  n:=0;
  sOut:='';
  dt:=GetFileTime(sPath+'output\track-o.txt');
//Log('QQQQ stari track-o.txt: '+FloatToStr(Now()-dt));
  if(Now()-dt>1) and ((sType='Owned') or (sType='All')) then begin
    sOut:='getOwnedTracks=''1'';'+CRLF;
    Inc(n);
  end
  else sOut:='getOwnedTracks=''0'';'+CRLF;
  dt:=GetFileTime(sPath+'output\track-f.txt');
//Log('QQQQ stari track-f.txt: '+FloatToStr(Now()-dt));
  if(Now()-dt>1) and ((sType='Logged') or (sType='All')) then begin
    sOut:='getFoundTracks=''1'';'+CRLF;
    Inc(n);
  end
  else sOut:='getFoundTracks=''0'';'+CRLF;
//Log('QQQQ pocet souboru k nacteni: '+IntToStr(n));
  if(n>0) then begin
    sOut:='const'+CRLF+sOut;
    StringToFile(sOut,sPath+'GetTrackList.config.pas');
    //spustime plugin pro ziskani dat podle zadane konfigurace
    GeoCallGGP(s);
  end;
  //nacteme data podle pozadavku
  if(sType='All') then sType:='Logged,Owned';
  n:=0;
  aData:=TStringList.Create();
  try
    if(sType='All') then sType:='Logged,Owned';
    while(sType<>'') do begin // cyklime pro Logged a Owned
      sOwned:=Fetch(sType,',');
      if(sOwned='Logged') then s:='track-f.txt'
      else s:='track-o.txt';
      aData.Text:=FileToString(sPath+'output\'+s);
      n:=n+Adata.Count;
      CalcTrackable_SaveData(aData,sOwned);
    end;
  finally
    aData.Free();
  end;
end;

function CalcTrackable_Run(aPar:TStringList):string;
var s,sType,sSql:string;
    nTb,nAll,nKm:integer;
begin
  Result:='';
  //vytvorime docasnou tabulku pro ulozeni dat, abychom je mohli snadno seradit
  //podle potreby
  //Log('Temporary table for trackables ...');
  sSql:='DROP TABLE IF EXISTS temp.StatorTrackable;';
  Geoget_DB.ExecSQL(sSql);
  sSql:='CREATE TEMPORARY TABLE StatorTrackable (id TEXT, ico TEXT, km TEXT, name TEXT, file TEXT);'+CRLF;
  Geoget_DB.ExecSQL(sSql);
  //nastavime pocty TB a GC, k tomu sestavime 2x docasnou tabulku
  s:='Logged,Owned';
  while (s<>'') do begin
    sType:=Fetch(s,',');
    CalcTrackable_MakeTmpTable(sType);
    //pomoci SQL zjistime celkovy pocet a pocet TB (podle ikonky, 21.gif je TB)
    GEOGET_DB.AddParamText(':file',sType);
    GEOGET_DB.AddParamText(':tbIco','%21.gif');
    sSql:='SELECT count(ico) pocet FROM temp.StatorTrackable WHERE ico like :tbIco AND file=:file';
    nTb:=Geoget_DB.GetTableValue(sSql);
    GEOGET_DB.AddParamText(':file',sType);
    sSql:='SELECT count(ico) pocet FROM temp.StatorTrackable WHERE file=:file';
    nAll:=Geoget_DB.GetTableValue(sSql);
    sSql:='SELECT sum(km) pocet FROM temp.StatorTrackable WHERE file=:file';
    nKm:=Geoget_DB.GetTableValue(sSql);
    //ulozime hodnoty do promennych
    GlobalVarSet('CalcTrackable_Tb'+sType+'Count',IntToStr(nTb));
    GlobalVarSet('CalcTrackable_Gc'+sType+'Count',IntToStr(nAll-nTb));
    GlobalVarSet('CalcTrackable_All'+sType+'Count',IntToStr(nAll));
    GlobalVarSet('CalcTrackable_TotalDistance'+sType+'Count',IntToStr(nAll));
  end;
end;