{
problemy:
  - tlacitka radi podivne
  - na zacatku oznacit tucne tlacitko, podle ktereho je serazeno

  - v Start.html (profil i common) a StartPreview.html je potreba odpoznamkovat
    vlozeni jquerry knihovny (mozna to udelat pri generovani na zaklade toho,
    zda bude statistika vkadana na profil
  - kategorie cwg a CWG jsou sice pri hledani odliseny (COLLATE BINARY), ale
    v seznamu parametru je pri oznaceni vybranych polozek velikost pismen
    ignorovana
    !! vytvorit novy typ seznamu, kde bude zaviset na velikosti pismen?
  - poradi sloupcu v tabulce nebo polozek na karte jde menit jen rucni upravou
    ini souboru (content.ini nebo pro trvalou zmenu CwgList.Params.ini, ale
    to bude platne jen do aktualizace Statoru
  - styly jsou v programu, mozna by se daly dat do nastaveni jako polozky pro
    experty
}

const CWGLIST_DATALEN=14;
      CWGLIST_DBVER=5; //minimalni verze databaze CwgList, se kterou modul pracuje

var
    CwgList_sCardHeight:string;
    //CwgList_sImgSize:string;
    CwgList_sImgHeight,CwgList_sImgWidth:string;
    //CwgList_iImgSize:integer;
    CwgList_iImgHeight,CwgList_iImgWidth:integer;
    CwgList_bSortButtons:boolean;   //priznak vlozeni radicich tlacitek
    CwgList_iJsFunctions:integer;   //0 neinicializovano, 1=funkce nevlozeny, 2=funkce vlozeny

function CwgList_PrepareData(aPar:TStringList):TStringList;
var s,s1,sCategory,sSql,sTypes:string;
    MyDB:TSqliteDatabase;
    tab:TSQLiteTable;
    i:integer;
begin
  //pripravime seznam typu CWG
  sTypes:=AnsiToUtf('"'+ReplaceString(aPar.Values['CwgType'],'|','","')+'"');
  Result:=TStringList.Create();
  // Nick, <UrlNick>, DateSort, DateText, id_cwg, <img>, ID_kese, url_kese
  sSql:='SELECT my.NameUpAscii, my.Name, my.CacheId, my.DateFound, my.Category, my.Version, my.Id, my.Img, my.GUID'
    +', my.CommentName, my.CommentCacheId, my.CommentImg, my.CommentDate, my.Country '+CRLF
    +' FROM MyCWG my'+CRLF
    +'WHERE my.id=my.id'; //jen proto, abych mohl jen pridavat do fraze WHERE
    ;
  if(sTypes<>'""') then begin
    //abychom mohli odlisit CWG od cwg, testujeme to binarne (jinak se ignoruje velikost pismen)
    sSql:=ssQl+' AND my.Category IN ('+sTypes+') COLLATE BINARY'+CRLF;
  end;
  s:=aPar.Values['Groups'];
  if(s<>'') then begin     //jen z vybranych skupin, pokud je ma uzivatel definovane
    s:=AnsiToUtf('"'+ReplaceString(s,'|','","')+'"');
    sSql:=sSql+'  AND my.TabGroup IN ('+s+')'+CRLF;
  end;
  s:=aPar.Values['Country'];
  if(s<>'') then begin     //jen z vybranych statu
    s:=AnsiToUtf('"'+ReplaceString(s,'|','","')+'"');
    sSql:=sSql+'  AND my.Country IN ('+s+')'+CRLF;
  end;
  //pokud je pozadovano jen v kesi/mimo kes, doplnime podminku
  s:=aPar.Values['FromCache'];
  s1:=Fetch(s,'-');
  if(s1='FromCache') then sSql:=sSql+'   AND CacheID<>""'+CRLF;
  if(s1='OutOfCache') then sSql:=sSql+'   AND CacheID=""'+CRLF;
  //nastavime pozadovane implicitni razeni
  s:=aPar.Values['SortDefault'];
  s1:=Fetch(s,'-');
  case (s1) of
  'Date': sSql:=sSql+' ORDER BY DateFound';
  'Cache ID': sSql:=sSql+' ORDER BY CacheId';
  'CWG ID': sSql:=sSql+' ORDER BY Id';
  else {'Name':} sSql:=sSql+' ORDER BY Name COLLATE SYSTEM,(0+Version)';
  end;
//LDH('HHHHHHH vypis jen prvnich 5 CWG');
  //sSql:=sSql+' LIMIT 10';
  //otevrit databazi
  s1:=RelToAbsFilename(aPar.Values['DBFile'],GEOGET_SCRIPTDIR);
  if(not FileExists(s1)) then s1:=RelToAbsFilename(s1,GEOGET_DATADIR);
  if(not FileExists(s1)) then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('ERR: File does not exist:')+' '+s1);
    Log(_('ERR: File does not exist:')+' '+s1);
    exit;
  end;
  Log('SQL='+sSql);
  MyDB:=TSqliteDatabase.Create(s1); //otevreme databazi
  try
    //zkontrolujeme verzi databaze
    //...
    i:=MyDB.GetTableValue('SELECT Value FROM Settings WHERE ParamName=''DbVersion''');
{$ifdef DEBUG_HELPER} LDH('Verze databvaze: '+IntToStr(i)); {$endif}
    if(i<CWGLIST_DBVER) then begin
      //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
      //AddError(_('ERR: Unable to work with old database from CwgList plugin!')
      Log(_('ERR: Unable to work with old database from CwgList plugin!')
        +CRLF+'DbVer='+IntToStr(i)+' (<'+IntToStr(CWGLIST_DBVER)+')');
    end
    else begin
      MyDB.AddSystemCollate(); //razeni podle ceskych pravidel (pokud jsou ceska win)
      Tab:=MyDB.GetTable(sSql,false);
      try
        while not Tab.eof do begin
          s:=ReplaceString(Tab.FieldAsString(0),'''','`')
          //pokud je pozadavek na Stat, pridame ho
          //s1:=Tab.FieldAsString(13); //pokud bude NULL, nacte zde prazdny string?
          //if(aPar.Values['Country']<>'') and (s1<>'') then s:=s+' ['+s1+']';
          Result.Add(s);                                           //   0 ... ASCII nick
          s:=ReplaceString(Tab.FieldAsString(1),'''','`');
          i:=Tab.FieldAsInteger(5);
          if(i>1) then s:=s+' (v'+IntToStr(i)+')';
          //vyhazeme vsechny paznaky z nicku
          s:=ReplaceString(s,'''','`');
          //pokud je pozadavek na Stat, pridame ho
          //s1:=Tab.FieldAsString(13); //pokud bude NULL, nacte zde prazdny string?
          //if(aPar.Values['Country']<>'') and (s1<>'') then s:=s+' ['+s1+']';
          Result.Add(UtfToAnsi(s));                               //   1 ... Nick (verze)
          s:=Tab.FieldAsString(2);
  //LDH('OOOOO GC='+s);
          if(not IsValidGC(s)) then s:='';
  //LDH('OOOOO GC='+s);
          Result.Add(s);                                            //   2 ... GC kod kese
          if(IsValidGC(s)) then s:='https://www.geocaching.com/seek/cache_details.aspx?wp='+s;
          Result.Add(s);                                            //   3 ... URL kese
          s:=Tab.FieldAsString(4);
          sCategory:=Fetch(s,'-'); //jen kategorie bez pripadneho popisu
          //z cisla verze udelame pismenko
          i:=Tab.FieldAsInteger(5);
          s1:='';
          if(i>1) and (i<=27) then s1:=Chr(i-2+Ord('a'));
          if(i>27) and (i<=53) then s1:=Chr(i-28+Ord('A'));
          if(i>53) then s1:='?';
          i:=Tab.FieldAsInteger(6);
          if(i>0) then s:=sCategory+FormatFloat('00000',i)+s1
          //kdyz neni zname ID (neni v katalogu), doplnime nick
          else s:=sCategory+'-? '+ReplaceString(Tab.FieldAsString(1),'''','`');
          Result.Add(s);                                            //   4 ... ID CWG (napr. cle00058a)
          s:=Tab.FieldAsString(3); //   datum ziskani, pokud je jine nez datum nalezu
          Result.Add(s);                                           //   5 ... ziskano (RRRRMMDD, pro razeni)
          s:=copy(s,7,2)+'.'+copy(s,5,2)+'.'+copy(s,1,4); //prevedeme na lidsky format
          if(s='..') or (s='..0') then s:=''; //bez data
          Result.Add(s);                                           //   6 ... datum ziskani ve formatu pro vypis
          s:=Tab.FieldAsString(7);  //obrazek
          if(s='') then begin
            MyDB.AddParamText(':Cat',sCategory);
            MyDB.AddParamInt(':Id',Tab.FieldAsInteger(6));
            MyDB.AddParamInt(':Ver',Tab.FieldAsInteger(5));
            sSql:='SELECT Jpg FROM CatCWG WHERE Category=:Cat AND id=:Id AND version=:Ver';
            s:=MyDB.GetTableString(sSql);
          end;
          //if(s='') then s:='http://cwg.geog.cz/no_cwg.jpg'; //netusim, kam ten obrazek presunuli
          //if(s='') and (Pos('SQ',sCategory)=1) then s:='https://dl.dropboxusercontent.com/u/6589047/Geocaching/Images/SqMissing.jpg';
          //if(s='') then s:='https://dl.dropboxusercontent.com/u/6589047/Geocaching/Images/CwgMissing.jpg';
          if(s='') and (Pos('SQ',sCategory)=1) then s:='http://www.geocaching.cz/stator/img/SqMissing.jpg';
          if(s='') then s:='http://www.geocaching.cz/stator/img/CwgMissing.jpg';
          Result.Add(s);                                           //   7 ... URL obrazku s CWG
          s:=Trim(Tab.FieldAsString(8));
          if(s='') then begin
            MyDB.AddParamText(':Cat',sCategory);
            MyDB.AddParamInt(':Id',Tab.FieldAsInteger(6));
            MyDB.AddParamInt(':Ver',Tab.FieldAsInteger(5));
            sSql:='SELECT UserGuid FROM CatCWG WHERE Category=:Cat AND id=:Id AND version=:Ver';
            s:=MyDB.GetTableString(sSql);
          end;
          Result.Add(s);                                            //   8 ... GUID
          s:=Tab.FieldAsString(10);
          {
          //pokud neni komentar, pouzijeme tam jmeno kesky
          if(s='') then begin
            Geoget_DB.AddParamText(':id',Tab.FieldAsString(2));
            s:=Geoget_DB.GetTableString('SELECT Name FROM geocache WHERE id=:id');
          end;
          }
          Result.Add(UtfToAnsi(s));                                 //   9 ... Komentar ke kesi nebo jeji jmeno
          Result.Add(UtfToAnsi(Tab.FieldAsString(9)));              //  10 ... Komentar k nicku
          Result.Add(UtfToAnsi(Tab.FieldAsString(11)));             //  11 ... Komentar k obrazku
          Result.Add(UtfToAnsi(Tab.FieldAsString(12)));             //  12 ... Komentar k datu ziskani
          Result.Add(UtfToAnsi(Tab.FieldAsString(13)));             //  13 ... Stat
  {
          //naformatujeme string pro zobrazeni cele karty
          //!!! XMLEntityEncode pracuje v UTF !!!!
         s:=MakeStringCard(sNameTable,IntToStr(n),sObsah
            ,UtfToCharset(XMLEntityEncode(sNick),OUTHTML_OUTCODING)
            ,UtfToCharset(sCache,OUTHTML_OUTCODING)
            ,UtfToAnsi(sDate)               //Date v lidskem formatu
            ,UtfToAnsi(sJpg)                //Img
            ,UtfToAnsi(sGuid)               //GUID
            ,UtfToAnsi(sCacheUrl)           //odkaz na listing kese
            ,sIdCwg                         //kod CWG
            ,UtfToCharset(XMLEntityEncode(Tab.FieldAsString(9)),OUTHTML_OUTCODING)  //NickComment
            ,UtfToCharset(XMLEntityEncode(sCacheComment),OUTHTML_OUTCODING)         //CacheComment
            ,UtfToCharset(XMLEntityEncode(Tab.FieldAsString(11)),OUTHTML_OUTCODING) //ImgComment
            ,UtfToCharset(XMLEntityEncode(Tab.FieldAsString(12)),OUTHTML_OUTCODING) //DateComment
            );
          a.Add(s); //   4 ... cely obsah karty ve tvaru HTML textu
  }
          Tab.next();
        end;
      finally
        Tab.Free();
      end;
    end;
  finally
    MyDB.Free();
  end;
//LDH('AAAA priprava dat - stop');
end;

function CwgList_Style(sClass:string):string;
begin  //vypise tridu nebo primo styl pro zobrazeni prislusne tridy
  if(CwgList_bSortButtons) then Result:='class="'+sClass+'"'
  else begin
    case sClass of
    'cCwgCard': begin
                //pokud jsou karty oddeleny CRLF, je mezi ne pri interpretaci HTML vlozena
                //mezera, proto pak neni posledni radek vycentrovan uplne presne
                //stejne jako predchozi cely radek
                //Result:='display:inline-block; width:'+IntToStr(CwgList_iImgSize+12)+'px; '
                //  +'height:'+CwgList_sCardHeight+'px; '
                //  //pro pripad, ze bude zadana neplatna hodnota vysky karty (treba umyslne),
                //  //aby se vypisovalo vzdy vsechno - budou pak karty zarovnany na horni
                //  //hranu a budou mit ruznou vysku
                //  +'text-align:bottom;'
                //  +'overflow:hidden; text-align:center; margin:4px 2px 0px 2px; '
                //  +'background-color:#FFFFFF; border:1px #ccdce4 solid;';
                Result:=GlobalVarGet('StyleCwgListCardDiv',false);
                Result:=ReplaceString(Result,'width:00px','width:'+IntToStr(CwgList_iImgWidth+12)+'px');
                Result:=ReplaceString(Result,'height:00px','height:'+CwgList_sCardHeight+'px');
                end;
    'cCwgImg':  begin
                //odsazeni zvrchu je 10px protoze o stejnou velikost je 2x zvetsena
                //sirka karty proti velikosti obrazku
                //Result:='margin-top:10px; margin-bottom:5px; width:'+CwgList_sImgSize+'px; '
                //  +'height:'+CwgList_sImgSize+'px;';
                Result:=GlobalVarGet('StyleCwgListImg',false);
                //predpokladame stejnou vysku i sirku obrazku
                Result:=ReplaceString(Result,'width:00px','width:'+CwgList_sImgWidth+'px');
                if(CwgList_iImgHeight=0) then Result:=ReplaceString(Result,'height:00px','')
                else Result:=ReplaceString(Result,'height:00px','height:'+CwgList_sImgHeight+'px');
                end;
    'cCwgName': begin
                  Result:=GlobalVarGet('StyleCwgListName',false);
                  if(Result='StyleCwgListName') then Result:='';
                end;
    'cCwgType': begin
                  Result:=GlobalVarGet('StyleCwgListType',false);
                  if(Result='StyleCwgListType') then Result:='';
                end;
    'cCwgDate': begin
                  Result:=GlobalVarGet('StyleCwgListDate',false);
                  if(Result='StyleCwgListDate') then Result:='';
                end;
    'cCwgGcId': begin
                  Result:=GlobalVarGet('StyleCwgListGcId',false);
                  if(Result='StyleCwgListGcId') then Result:='';
                end;
    'cCwgCache':begin
                  Result:=GlobalVarGet('StyleCwgListCache',false);
                  if(Result='StyleCwgListCache') then Result:='';
                end;
    end;
    Result:='style="'+Result+'"';
  end;
end;

procedure CwgList_OutJsFunctions;  //zapise do vystupu funkci pro razeni karet CWG
var s,sClasses,sClass,sVal,sName,sStyle:string;
begin
  CwgList_iJsFunctions:=2;
  //funkce pro razeni karet tabulky CWG, cislo tabulky je parametrem
  s:=//'<img id="iCwgSpiffy" src="spiffygif_100x100.gif" style="position:absolute; z-index:1; display:none; left:auto; right:auto;" />'+CRLF+
       '<script type="text/javascript">'+CRLF
         +'var nCwgTab;'+CRLF
         +'    aCwg=Array();'+CRLF    //definice pole s CWG
         //funkce pro pridani obsluhy k eventu
         //zajistime uvodni zobrazeni CWG po nacteni stranky
         +'addEvent(window, "load", showCwgCards);'+CRLF+CRLF
         +'function addEvent(elm, evType, fn, useCapture){'+CRLF
         +'  if(elm.addEventListener){'+CRLF
         +'    elm.addEventListener(evType, fn, useCapture);'+CRLF
         +'    return true;'+CRLF
         +'  }'+CRLF
         +'  else if (elm.attachEvent){'+CRLF
         +'    var r = elm.attachEvent("on"+evType, fn);'+CRLF
         +'    return r;'+CRLF
         +'  }'+CRLF
         +'  else{ alert("Handler could not be removed");} '+CRLF
         +'}'+CRLF
{$ifdef A####} //[
         +'function setCwgCss(){'+CRLF
         +'  //funkce nastavi vlastnosti vsem kartam a jejich obsahu, aby nemusely'+CRLF //nemas ten komentar trochu jinde, nez chces? :)
         +'  //byt css styly v HTML kodu zopakovane vsude u kazdeho elementu'+CRLF
         ;
         //otestovat pritomnost JQuery
         s:=s+'if(typeof($)!="function"){ alert("Missing jquery library!"); exit;}'+CRLF;

         //doplnime prikazy pro nastaveni vsech vlastnosti vsech DIVu pro zobrazeni karty
         CwgList_bSortButtons:=false;                //nastavime, abychom ziskaly skutecne styly
         sClasses:='cCwgCard|cCwgImg|cCwgName|cCwgType|cCwgDate|cCwgGcId|cCwgCache';
         while (sClasses<>'') do begin
           sClass:=Fetch(sClasses,'|');
           sStyle:=ReplaceString(ReplaceString(CwgList_Style(sClass),'"',''),'style=','');
           while(sStyle<>'') do begin
             sName:=Fetch(sStyle,':');
             sVal:=Fetch(sStyle,';');
             s:=s+'  $(".'+sClass+'").css("'+sName+'","'+sVal+'");'+CRLF;
           end;
         end;
         s:=s+'}'+CRLF;
{$endif }   //A#### ]
        ;

         CwgList_bSortButtons:=true;                 //vratime zpet puvodni hodnotu
         //funkce pro prvni zobrazeni CWG
         s:=s+'function showCwgCards(){'+CRLF
           +'  var i,e;'+CRLF
           +'  nCwgTab=0;'+CRLF
           //+'  alert("!!!!!!!!!!!! showCwgCards() - start");'+CRLF
//A####           +'  setCwgCss();  //nastavit vlastnosti vsem prvkum zobrazujicim informace o CWG'+CRLF
           +'  //funkce najde vsechny tabulky s CWG a naplni jejich zobrazene karty'+CRLF
           //+'alert("Uvodni naplneni karet s CWG");'+CRLF
           +'  for(i=1;i<100;i++){        //zjistit pocet tabulek'+CRLF
           +'    e=$("#iCwgDiv_"+i).prop("tagName");'+CRLF
           +'    if(e) nCwgTab=i; else break;'+CRLF
           +'  }'+CRLF
           //+'alert("Pocet tabulek s CWG="+nCwgTab);'+CRLF
           //zobrazeni hodnot ve vsech tabulkach s CWG
           +'  for(i=0;i<nCwgTab;i++) sortCwg("",i+1);'+CRLF
           +'}'+CRLF

         //funkce pro nove serazeni karet s CWG
         +'function sortCwg(sortName,idTable){'+CRLF
         +'  var i,n,s;'+CRLF
         +'  var a=Array();'+CRLF
         +'  var b=Array();'+CRLF
         //zobrazime "hodiny", aby bylo videt, ze se neco deje
         //+'  $("#iCwgSpiffy").css("top","100px");'+CRLF
         //+'  $("#iCwgSpiffy").css("display","");'+CRLF
         +'  n=$("#iCwgDiv_"+idTable).children(".cCwgCard").length;'+CRLF
         //+'  //alert("pocet karet n="+n);'+CRLF
         +'  if(n<2) return;'+CRLF
         //vytvorime pole s prvkem pro razeni a indexem, pak pole seradime
         +'  for(i=0;i<n;i++){'+CRLF
         +'    if(sortName=="") b[0]=i; else b[0]=aCwg[idTable][i][sortName];'+CRLF
         +'    b[1]=i;'+CRLF
         +'    a[i]=[b[0],b[1]];'+CRLF
         +'  }'+CRLF
         //radime, pokud je jmeno pro razeni neprazdne, jinak uz je pole serazeno
         +'  if(sortName!=""){'+CRLF
         +'    a=a.sort(function(pol1,pol2){'+CRLF
         +'      if(pol1[0] > pol2[0]) return(1);'+CRLF
         +'      if(pol1[0] == pol2[0]) return(0);'+CRLF
         +'      return(-1);'+CRLF
         +'    });'+CRLF
         +'  };'+CRLF
         +'  i=0;'+CRLF
         //+'  alert("n="+n);'+CRLF
         +'  for(i=0;i<n;i++){'+CRLF
         //+'    alert("index zobrazeny na karte ["+i+"]="+a[i][1]);'+CRLF
         //projdeme vsechny vnorene elementy a vyplnime je
         +'    s="#iCwg_"+idTable+"_"+i;'+CRLF
         +'    $(s+" .cCwgImg").html(aCwg[idTable][a[i][1]]["Img"]);'+CRLF
         +'    $(s+" .cCwgName").html(aCwg[idTable][a[i][1]]["Name"]);'+CRLF
         +'    $(s+" .cCwgDate").html(aCwg[idTable][a[i][1]]["Date"]);'+CRLF
         +'    $(s+" .cCwgType").html(aCwg[idTable][a[i][1]]["Type"]);'+CRLF
         +'    $(s+" .cCwgGcId").html(aCwg[idTable][a[i][1]]["CacheId"]);'+CRLF
         +'    $(s+" .cCwgCacheInfo").html(aCwg[idTable][a[i][1]]["CacheInfo"]);'+CRLF
         +'  }'+CRLF
         //+'  alert(aCwg[1][0]["ASCII"]);'+CRLF
         //nastavit spravne styly
 //A####        +'  setCwgCss();'+CRLF

         +'  //na tucny text u zvoleneho tlacitka'+CRLF
         +'  if(sortName!=""){'+CRLF //implicitni razeni je zobrazeno
         +'    $("#iCwgDiv_"+idTable+" button").css("font-weight","normal");'+CRLF
         +'    $("#bCwg_"+idTable+"_"+sortName).css("font-weight","bold");'+CRLF
         +'  }'+CRLF
         //+'  $("#iCwgSpiffy").css("display","none");'+CRLF
         +'}'+CRLF
         +'</script>'+CRLF+CRLF;
  Output(s);
end;

procedure CwgList_OutputButtons(aPar:TStringList);
var sBut,sTab,sSort:string;
    i,n:integer;
    aData:TStringList;
begin
  //funkce zapise do vystupu tlacitka, ktera zajisti zmenu razeni karet
  //vzdycky zobrazujeme vsechna tlacitka bez ohledu na to, zda jsou prislusne
  //prvky zobrazeny (radit se podle nich da i v takovem pripade)
  aData:=TStringList.Create();
  try
    //pro kazde tlacitko jmeno s INI, jmeno v poli s daty o CWG, text na tlacitku
    aData.Text:='Date'+CRLF+    'Dat00'+CRLF+     _('Gain date')+CRLF //tady me momentalne lepsi slovo nenapada p1
               +'Name'+CRLF+    'ASCII'+CRLF+     _('Name')+CRLF
               +'CWG ID'+CRLF+  'IdCwg'+CRLF+     _('CWG ID')+CRLF
               +'Cache ID'+CRLF+'IdGc'+CRLF+      _('Cache ID')+CRLF   //
                ;
    sBut:=aPar.Values['SortDefault'];
    sSort:=Fetch(sBut,'-');
    n:=aData.Count/3;
    sTab:=GlobalVarGet('CwgList_TableCount',false);
    sBut:='<div style="'+GlobalVarget('StyleCwgListButtons',false)+'"> <!-- prepinaci tlacitka pro razeni CWG -->'+CRLF;
    for i:=0 to n-1 do begin
      sBut:=sBut+'<button id="bCwg_'+sTab+'_'+aData[i*3+1]+'" style="'+GlobalVarGet('StyleCwgListButton',false);
      if(sSort=aData[i*3+1]) then sBut:=sBut+' font-weight: bold;';
      sBut:=sBut+'" onclick="'
           //zmena kurzoru na presypaci hodiny po dobu razeni se zda neucinna,
           //asi se kurzor zmeni az dobehne javascript a to se pak hned zmeni zase zpet
           //+'$(''#bCwg_'+sTab+'_'+aData[i*3+1]+''').css(''cursor'',''wait''); '
           //se zobrazenim obrazku je to stejne, taky se zobrazi az po serazeni ...
           //+'$(''#iCwgSpiffy'').css(''height'',''100px''); ' //skryti nastavuje velikost na 0, proto ji nastavime zpet
           //+'$(''#iCwgSpiffy'').css(''width'',''100px''); '
           //+'$(''#iCwgSpiffy'').show(); ' //zobrazime hodiny
           +'sortCwg('''+aData[i*3+1]+''','+sTab+');'
           //+'$(''#bCwg_'+sTab+'_'+aData[i*3+1]+''').css(''cursor'',''pointer''); '
           //+'$(''#iCwgSpiffy'').hide(); ' //zmizime hodiny
           +'return(false);">'+aData[i*3+2]+'</button>'+CRLF;
    end;
    sBut:=sBut+'</div>'+CRLF;
    Output(sBut);
  finally
    aData.Free();
  end;
end;

procedure CwgList_OutputTable(aPar,aCwg:TStringList;sItems:string);
var s,s1:string;
    aTmpPar:TStringList;
    i,j,n:integer;
begin
  //funkce zapise do vystupu tabulku z pripravenych dat
  n:=aCwg.Count/CWGLIST_DATALEN;   //pocet polozek na jedno CWG
  if(n<=0) then exit;

//LDH('AAAA textova tabulka, pocet pripravenych polozek: '+IntToStr(aCwg.Count)+', pocet radku n='+IntToStr(n));
  sItems:=Trim(ReplaceString(sItems,'Img','')); //obrazek neni v seznamu
  aTmpPar:=TStringList.Create();
  try
    //pripravime data pro vytvoreni tabulky podle pozadovanych prvku
    for i:=0 to n-1 do begin
      s:=sItems;
      while(s<>'') do begin
        s1:=Fetch(s,CRLF);
        case (s1) of
        'Order row': aTmpPar.Add(IntToStr(i+1));
        //'Img':  //ignorujeme, obrazek v textovem seznamu nejde
        'Name': if(aCwg[i*CWGLIST_DATALEN+10]='') then aTmpPar.Add(AnsiToUtf(aCwg[i*CWGLIST_DATALEN+1]))
                else aTmpPar.Add('<abbr title="'+AnsiToUtf(aCwg[i*CWGLIST_DATALEN+10])
                  +'">'+AnsiToUtf(aCwg[i*CWGLIST_DATALEN+1])+'</abbr>');
        'Country': if(aCwg[i*CWGLIST_DATALEN+13]='') then aTmpPar.Add('')
                else aTmpPar.Add(AnsiToUtf(aCwg[i*CWGLIST_DATALEN+13]));
        'Category': begin
                  //najdeme prvni nepismenny znak v ID
                  s1:=aCwg[i*CWGLIST_DATALEN+4];
                  for j:=1 to length(s1)-1 do begin
                    if(s1[j]<'A') or ((s1[j]>'Z') and (s1[j]<'a')) or (s1[j]>'z') then
                      begin
                      s1:=copy(s1,1,j-1);
                    end;
                  end;
                  aTmpPar.Add(s1);
                end;
        'Date': if(aCwg[i*CWGLIST_DATALEN+6]='') then aTmpPar.Add('')
                else if(aCwg[i*CWGLIST_DATALEN+12]='') then aTmpPar.Add(aCwg[i*CWGLIST_DATALEN+6])
                     else aTmpPar.Add('<abbr title="'+aCwg[i*CWGLIST_DATALEN+12]+'">'+aCwg[i*CWGLIST_DATALEN+6]+'</abbr>');
        'Cache ID': if(aCwg[i*CWGLIST_DATALEN+2]='') then aTmpPar.Add('')
                 else if(aCwg[i*CWGLIST_DATALEN+9]='') then aTmpPar.Add(aCwg[i*CWGLIST_DATALEN+2])
                      else aTmpPar.Add('<abbr title="'+aCwg[i*CWGLIST_DATALEN+9]+'">'+aCwg[i*CWGLIST_DATALEN+2]+'</abbr>');
        'Cache Info': if(aCwg[i*CWGLIST_DATALEN+2]='') then aTmpPar.Add('')
                 else aTmpPar.Add(AnsiToUtf(MakeHtmlCacheInfoFromId(aCwg[i*CWGLIST_DATALEN+2])));
        end;
      end;
    end;
    //pripravime definici sloupcu
    sItems:=ReplaceString(sItems,'Cache ID','GC ID'); //aby byl spravne oznacen sloupec
    sItems:=ReplaceString(sItems,'Cache info short',_('Cache'));  //aby neprobehla konverze na Cache Info, dela se primo v modulu
    sItems:=ReplaceString(sItems,'Cache Info',_('Cache'));  //aby neprobehla konverze na Cache Info, dela se primo v modulu
    sItems:=ReplaceString(sItems,'Order row','Order row=Center;');  //zarovname na stred
    //vytvorime tabulku z pripravenych dat
    sItems:=ReplaceString(sItems,CRLF,'|');
    //nastavime vlastnosti sloupcu
    sItems:=ReplaceString(sItems,'Date|','Date=Center|');
    sItems:=ReplaceString(sItems,'Country|','Country flag|');
    sItems:=ReplaceString(sItems,'Category',_('CWG Type'));
    s:=OutputTableList(sItems,aTmpPar,0,-1,-1,i)+CRLF;
    s1:=aPar.Values['FontSize'];
    if(s1<>'') then begin
      if(Pos('%MainFontSize%',s)>0) then s:=ReplaceString(s,'%MainFontSize%',s+'px');
    end;
    Output(s);
  finally
    aTmpPar.Free();
  end;
end;

procedure CwgList_OutputCards(aPar,aCwg:TStringList;sItems:string);
var s,s1,sOut,sArr:string;
    i,j,n,iOutCount:integer;
begin
  //funkce zapise do vystupu vsechny karty s CWG
  n:=aCwg.Count/CWGLIST_DATALEN;   //pocet polozek na jedno CWG
  if(n<=0) then exit;

  //otestovat, zda generujeme prvni tabulku, abychom v pripade tlacitek
  //vlozili funkci pro razeni
    s:=GlobalVarGet('CwgList_TableCount',false);
    iOutCount:=StrToInt(s);
    //vlozime javascriptove funkce a zaroven pridame k eventu onload zavolani
    //funkce, ktera naplni zobrazene karty informacemi o CWG, a to pro vsechny
    //divy s CWG kartami, ktere jsou v HTML
//ShowMessage('UUUUUU iCoutCount='+s+', bSortButtons='+IntToStr(CwgList_bSortButtons as integer)+', iJsFunction='+IntToStr(CwgList_iJsFunctions));
  if(CwgList_bSortButtons) and (CwgList_iJsFunctions<2) then CwgList_OutJsFunctions();

  //pokud je potreba, vlozime tlacitka pro razeni karet
  if(CwgList_bSortButtons) then CwgList_OutputButtons(aPar);
  sArr:='aCwg['+IntTostr(iOutCount)+']={'+CRLF;
  for i:=0 to n-1 do begin   //vsechna cwg
    if(i<>0) then sArr:=sArr+'  ,'+CRLF;
    sArr:=sArr
      +'  '+IntToStr(i)+':{'+CRLF
      +'     "ASCII": ['''+aCwg[i*CWGLIST_DATALEN+0]+''']'+CRLF
      +'    ,"Dat00": ['''+aCwg[i*CWGLIST_DATALEN+5]+''']'+CRLF
      +'    ,"IdCwg": ['''+aCwg[i*CWGLIST_DATALEN+4]+''']'+CRLF
      +'    ,"IdGc": ['''+aCwg[i*CWGLIST_DATALEN+2]+''']'+CRLF
      ;
    //sOut:='<div id="iCwg_'+IntToStr(iOutCount)+'_'+IntToStr(i)+'" '+CwgList_Style('cCwgCard')+'>'+CRLF;
    sOut:='<div id="iCwg_'+IntToStr(iOutCount)+'_'+IntToStr(i)+'" class="cCwgCard">'+CRLF;
    s:=sItems;
    while(s<>'') do begin
      s1:=Fetch(s,CRLF);
//LDH('UUUUUU zobrazovane pole='+s1);
      case (s1) of
      'Img':  begin
                s1:='<img src="'+aCwg[i*CWGLIST_DATALEN+7]+'" title="'
                  +intToStr(i+1)+'. '+aCwg[i*CWGLIST_DATALEN+4]+'" />';
                sArr:=sArr+'     ,"Img":['''+s1+''']'+CRLF;
                if(CwgList_bSortButtons) then s1:='';
                //sOut:=sOut+'<div '+CwgList_Style('cCwgImgDiv')+'>'+s1+'</div>';
                sOut:=sOut+'<div class="cCwgImg">'+s1+'</div>';
              end;
      'Country': begin
                  if(aCwg[i*CWGLIST_DATALEN+13]<>'') then begin
                    //vlajka za jmenem
                    //s1:=s1+' <img src="'+GlobalVarGet('IconCountry'+aCwg[i*CWGLIST_DATALEN+13],false)
                    //  +'" title="'+aCwg[i*CWGLIST_DATALEN+13]+'" />';
                    //vlajka pred jmenem
                    s1:='<img src="'+GlobalVarGet('IconCountry'+aCwg[i*CWGLIST_DATALEN+13],false)
                      +'" title="'+aCwg[i*CWGLIST_DATALEN+13]+'" /> ';
                    sOut:=sOut+s1;
                  end;
                 end;
      'Name': begin     /////// doplnit odkaz na profil (GUID, index 8)
                s1:='';
                if(aCwg[i*CWGLIST_DATALEN+8]<>'') then begin
                  s1:='<a href="'+aCwg[i*CWGLIST_DATALEN+8]+'"';                               //odkaz na profil
                  if(aCwg[i*CWGLIST_DATALEN+10]<>'') then s1:=s1+' title="'+aCwg[i*CWGLIST_DATALEN+10]+'"'; //komentar
                  s1:=s1+'>'+aCwg[i*CWGLIST_DATALEN+1]+'</a>';                                 //nick
                end
                else begin
                  if(aCwg[i*CWGLIST_DATALEN+10]='') then s1:=aCwg[i*CWGLIST_DATALEN+1]                      //nick
                  else s1:='<abbr title="'+aCwg[i*CWGLIST_DATALEN+10]+'">'+aCwg[i*CWGLIST_DATALEN+1]+'</abbr>';  //nick + komentar
                end;
                {
                //pokud je treba zobrazit stat, pridame za nick jeste obrazek
                if(Pos('Country',s)>0) then begin
                  if(aCwg[i*CWGLIST_DATALEN+13]<>'') then begin
                    //vlajka za jmenem
                    //s1:=s1+' <img src="'+GlobalVarGet('IconCountry'+aCwg[i*CWGLIST_DATALEN+13],false)
                    //  +'" title="'+aCwg[i*CWGLIST_DATALEN+13]+'" />';
                    //vlajka pred jmenem
                    s1:='<img src="'+GlobalVarGet('IconCountry'+aCwg[i*CWGLIST_DATALEN+13],false)
                      +'" title="'+aCwg[i*CWGLIST_DATALEN+13]+'" /> '+s1;
                  end;
                end;
                }
                sArr:=sArr+'     ,"Name":['''+s1+''']'+CRLF;
                if(CwgList_bSortButtons) then s1:='';
                //sOut:=sOut+'<div '+CwgList_Style('cCwgName')+'>'+s1+'</div>';
                sOut:=sOut+'<div class="cCwgName">'+s1+'</div>';
              end;
      'Category': begin
                //najdeme prvni nepismenny znak v ID
                s1:=aCwg[i*CWGLIST_DATALEN+4];
                for j:=1 to length(s1)-1 do begin
                  if(s1[j]<'A') or ((s1[j]>'Z') and (s1[j]<'a')) or (s1[j]>'z') then
                    begin
                    s1:=copy(s1,1,j-1);
                  end;
                end;
                sArr:=sArr+'     ,"Type":['''+s1+''']'+CRLF;
                if(CwgList_bSortButtons) then s1:='';
                //sOut:=sOut+'<div '+CwgList_Style('cCwgType')+'>'+s1+'</div>';
                sOut:=sOut+'<div class="cCwgType">'+s1+'</div>';
              end;
      'Date': begin
                if(aCwg[i*CWGLIST_DATALEN+6]='') then s1:=''
                else begin
                  if(aCwg[i*CWGLIST_DATALEN+12]='') then s1:=aCwg[i*CWGLIST_DATALEN+6]
                  else s1:='<abbr title="'+aCwg[i*CWGLIST_DATALEN+12]+'">'+aCwg[i*CWGLIST_DATALEN+6]+'</abbr>';
                end;
                sArr:=sArr+'     ,"Date":['''+s1+''']'+CRLF;
                if(CwgList_bSortButtons) then s1:='';
                //sOut:=sOut+'<div '+CwgList_Style('cCwgDate')+'>'+s1+'</div>';
                sOut:=sOut+'<div class="cCwgDate">'+s1+'</div>';
              end;
      'Cache ID': begin
                 if(aCwg[i*CWGLIST_DATALEN+2]='') then s1:=''
                 else  begin
                  s1:='<a href="https://www.geocaching.com/seek/cache_details.aspx?wp='+aCwg[i*CWGLIST_DATALEN+2]+'"'; //odkaz na kesku
                  if(aCwg[i*CWGLIST_DATALEN+12]<>'') then s1:=s1+' title="'+aCwg[i*CWGLIST_DATALEN+12]+'"';  //komentar
                  s1:=s1+'>'+aCwg[i*CWGLIST_DATALEN+2]+'</a>';
                end;
                sArr:=sArr+'     ,"CacheId":['''+s1+''']'+CRLF;
                if(CwgList_bSortButtons) then s1:='';
                //sOut:=sOut+'<div '+CwgList_Style('cCwgGcId')+'>'+s1+'</div>';
                sOut:=sOut+'<div class="cCwgGcId">'+s1+'</div>';
               end;
      'Cache Info': begin
                 if(aCwg[i*CWGLIST_DATALEN+2]='') then s1:=''
                 else s1:=MakeHtmlCacheInfoFromId(aCwg[i*CWGLIST_DATALEN+2]);
                sArr:=sArr+'     ,"CacheInfo":['''+s1+''']'+CRLF;
                if(CwgList_bSortButtons) then s1:='';
                //sOut:=sOut+'<div '+CwgList_Style('cCwgCache')+'>'+s1+'</div>';
                sOut:=sOut+'<div class="cCwgCache">'+s1+'</div>';
               end;
      end;
    end;
    sOut:=sOut+'</div>'{+CRLF}; //CRLF narusi zarovnani posledniho radku, takze
                                //nejsou okraje karty stejne jako u predchoziho
                                //radku (misto CRLF se zobrazuje mezera)
    sArr:=sArr+'    }'+CRLF;
    s:=aPar.Values['FontSize'];
    if(s<>'') then begin
      //aby bylo mozne definovat velikost pisma pro kazdy styl samostatne, menime
      //jen hlavni velikost fontu, ktera by mela byt pro celou kartu
      //a ostatnich stylu se zmena felikosti nedotkne
      if(Pos('%MainFontSize%',sOut)>0) then sOut:=ReplaceString(sOut,'%MainFontSize%',s+'px')
      //else sOut:=RegexReplace('font-size[:]\s*\d+(px|%|em|pt)',sOut,'font-size:'+s+'px',false)
      ;
    end;
    Output(sOut);
  end;
  //pokud je to potreba, vypiseme inicializaci poli
  sArr:=CRLF+CRLF+'<script type="text/javascript">'+CRLF+sArr+'  }'+CRLF+'</script>'+CRLF;
  if(CwgList_bSortButtons) then Output(sArr);
end;

procedure CwgList_OutputHtml(aPar:TStringList);
var s,s1,s2,sItems,sListType:string;
    aCwg:TStringList;
begin
  //otevreme vystupni proud
  try
    //vystup nadpisu
    if(aPar.Values['Title']<>'') then begin
      s:=ProcessCommand('CmdTitle',aPar);
      Output(s);
    end;
    //pripravit seznam polozek, ktere maji byt vypsany
    s:=aPar.Values['ItemContent'];
    while (s<>'') do begin
      s1:=Fetch(s,'|');
      s2:=Fetch(s1,'-');
      if(s2='Type') then s2:='Category'; //aby se v tabulce nepletl typ CWG s typem kese
      sItems:=sItems+CRLF+s2;
    end;
//{$ifdef DEBUG_HELPER} LDH('JJJJ-1 sItems='+sItems);  {$endif}
    s:=aPar.Values['ListType'];
    sListType:=UpperCase(Fetch(s,'-'));

    //otestovat, zda generujeme prvni tabulku, abychom v pripade tlacitek
    //vlozili funkci pro razeni
//LDH('JJJJ-1 sListType='+sListType);
    if(sListType='CARD') then begin
      s:=GlobalVarGet('CwgList_TableCount',false);
//LDH('JJJJ-1 s='+s);
      if(s='CwgList_TableCount') then s:='1'
      else s:=IntToStr(StrToInt(s)+1);
//LDH('JJJJ-2 CwgList_TableCount='+s);
      GlobalVarSet('CwgList_TableCount',s);
    end;
    //zajistime cislovani tebulek s kartami CWG, aby bylo mozne pres javascript
    //plnit tu spravnou
    //s:='<div id="iCwgDiv_'+GlobalVarGet('CwgList_TableCount',false)+'" style="'
    s:='<div id="iCwgDiv_'+GlobalVarGet('CwgList_TableCount',false)+'" class="cCwgDiv'
    if(sListType='CARD') then s:=s+' cCenter';
    s:=s+'"';
    if(aPar.Values['DivHeight']<>'0') then s:=s+' style="max-height:'+aPar.Values['DivHeight']+'px;"';
    s:=s+'>'+CRLF;
    if(aPar.Values['DivHeight']<>'0') or (sListType='CARD') then Output(s);
    sItems:=Trim(sItems);
    //pripravit seznam CWG podle zadanych parametru
//LDH('CwgList_OutputHtml() - volam pripravu dat');
    aCwg:=CwgList_PrepareData(aPar);
//LDH('CwgList_OutputHtml() - vystup pripravenych dat');
    //pokud je jen textovy vystup, vygenerujeme tabulku standardnimi prostredky
    if(sListType='TEXT') then CwgList_OutputTable(aPar,aCwg,sItems);
    if(sListType='CARD') then CwgList_OutputCards(aPar,aCwg,sItems);
    s:='</div>'+CRLF;
    if(aPar.Values['DivHeight']<>'0') or (sListType='CARD') then Output(s);
  finally
    if(aCwg<>nil) then aCwg.Free();
  end;
end;


function CwgList_Run(aPar:TStringList):string;
begin
  Result:='';
  //ShowMessage('CwgList_iJsFunctions='+IntToStr(CwgList_iJsFunctions));
  if(CwgList_iJsFunctions=0) then CwgList_iJsFunctions:=1; //inicializujeme na hodnotu "funkce nevlozeny"
  //jinak tam zustava hodnota z predcoziho volani
  //prevezmeme parametry do nasich promennych, aby se nemusely nacitat znovu
  CwgList_sCardHeight:=aPar.Values['CardHeight'];
  CwgList_sImgWidth:=aPar.Values['ImgWidth'];
  CwgList_sImgHeight:=aPar.Values['ImgHeight'];
  CwgList_iImgWidth:=StrToInt(CwgList_sImgWidth);
  CwgList_iImgHeight:=StrToInt(CwgList_sImgHeight);
  CwgList_bSortButtons:=(UpperCase(aPar.Values['SortButton'])='YES');
  CwgList_OutputHtml(aPar);
end;