const FTF_BY_DISTANCE_MAX=100;

function FTFByDistance_Histogram(aDist,aMez:array of integer; nSteps:integer):string;
var i,iMinIdx,iMaxIdx:integer;
    sEData,sENames,sTooltip:string;
begin
  if(nSteps<1) then nSteps:=1;

  //zjistime nejvyssi a nejnizsi index s hodnotou
  iMinIdx:=-1;
  for i:=0 to nSteps-1 do begin
    if((aDist[i]>0) and (iMinIdx<0)) then iMinIdx:=i;
    if(aDist[i]>0) then iMaxIdx:=i;
  end;
  for i:=iMinIdx to iMaxIdx do begin
    sEData:=sEData+IntToStr(aDist[i])+CRLF;
    sENames:=sENames+IntToStr(aMez[i])+CRLF;
  end;
  sTooltip:='function(par){return("'+_('FTFs in distance <br/>from ')+'"+par[0].name+" km: "+par[0].value);}'+CRLF;
  Result:=EChartsBarChart('ID'+IntToStr(iItem),sEData,sENames,'',sTooltip,true,false,iWidth,200);
end;

//hlavni funkce modulu
function FTFByDistance_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    aData:TStringList;
    i,iMin,iMinIdx,iMaxIdx,nRows,nSteps,nSuma:integer;
    fd,fSuma:extended;
    s,sType,sSql:string;
    aMez,aDist:array of integer;
begin
  SetLength(aMez,FTF_BY_DISTANCE_MAX);
  SetLength(aDist,FTF_BY_DISTANCE_MAX);
  s:=aPar.Values['Steps'];
  nSteps:=ReadStepsToArray(s,aMez);
  Result:='';
  sSql:='SELECT st.Distance FROM '+TEMP_TABLE+' st, geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE gc.id=st.id'
    +'    AND gt.id=gc.id AND gc.dtfound>0'
    +'    AND gtc.key=gt.ptrkat'
    +'    AND gtc.value=''FTF'''
    +'    AND gtv.key=gt.ptrvalue and gtv.value like ''%FTF%'''
    +CONST_SQL_IGNORE_CACHETYPES;
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  sSql:=sSql+' ORDER BY (0+st.Distance) desc';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    fSuma:=0;
    nSuma:=0;
    while not tab.eof do begin
      fd:=StrToFloat(tab.FieldByName['Distance']);
      fSuma:=fSuma+fd;
      Inc(nSuma);
      iMin:=0;
      nRows:=0;
      for i:=0 to nSteps-1 do begin
        if(i=nSteps-1) and (fd>aMez[i]) then begin Inc(aDist[i]); break; end
        else if(fd>=aMez[i]) and (fd<aMez[i+1]) then begin
          Inc(aDist[i]);
//Log('XXXX fd='+floatToStr(fd)+', i='+IntToStr(i)+', H_mez='+IntToStr(aMez[i])+', pocet='+IntToStr(aDist[i]));
          break;
        end;
        iMin:=aMez[i];
      end;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  
  // pokud nejsou data, koncime bez grafu
  if nSuma=0 then exit;

  if(aPar.Values['Title']<>'') then
    //pokud je to potreba nahradime v titulku prumernou hodnotu
    Result:=
      ReplaceString(ProcessCommand('CmdTitle',aPar),'%AvgValue%',
      FormatFloatDot('0',ConvertFromKm(0.5+(fSuma/nSuma),sUnit)));
  //zjistime nejmensi a nejvetsi index s hodnotou
  iMinIdx:=-1;
  for i:=0 to nSteps-1 do begin
//Log('AAAA aDist['+IntToStr(i)+']='+IntToStr(aDist[i])+' (hodnoty od '+IntToStr(aMez[i])+')');
    if((aDist[i]>0) and (iMinIdx<0)) then iMinIdx:=i;
    if(aDist[i]>0) then iMaxIdx:=i;
  end;
//Log('AAAA iMinIdx='+IntToStr(iMinIdx)+', iMaxIdx='+IntToStr(iMaxIdx));
  aData:=TStringList.Create();
  try
    iMin:=-9999;
    nRows:=0;
    for i:=iMinIdx to iMaxIdx do begin
      //text prvniho a posledniho radku je jiny
      if(i=nSteps-1) then aData.Add('>'+IntToStr(aMez[i]))
      else if(i=iMinIdx) then aData.Add('<'+IntToStr(aMez[i+1]))
      else aData.Add(IntToStr(aMez[i])+' - '+IntToStr(aMez[i+1]));
      aData.Add(IntToStr(aDist[i]));
      aData.Add('?');
      aData.Add('?');
      iMin:=aMez[i];
    end;
    sType:=aPar.Values['OutputType'];
    s:=Fetch(sType,'-');
    case UpperCase(s) of
    'TABLE':  begin
                Result:=Result+OutputTableList(
                  '%ColumnHeaderDistance%=center|Count|Percent|Histogram'
                  ,aData,0,(aData.Count/4),1,i)+CRLF;
              end;
    'HISTOGRAM': begin
                 Output(Result);
                 Result:=FTFByDistance_Histogram(aDist,aMez,nSteps)+CRLF;
                 Output(Result);
                 Result:='';
                 end;
    end;
  finally
    aData.Free();
  end;  
end;