//hlavni funkce modulu
function FTFDifficultyTerrain_Run(aPar:TStringList):string;
var
  sOld,s,sStyle:string;
  tab: TSqliteTable;
  a:array [0..10*10-1] of integer;
  aDiffSuma:array[0..9] of integer;
  n,dif,ter,nMax,nMaxDiff,nMaxTerr:integer;
  bCond:boolean;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  // pepna zenho vpisu tabulky
  bCond:=((iWidth<700) or (StrToInt(GlobalVarGet('FoundCachesCount',false))>4000));
  //inicializace poli
  for n:=0 to 10*10-1 do a[n]:=0;
  for n:=0 to 9 do aDiffSuma[n]:=0;
  tab:=Geoget_DB.GetTable(
    'SELECT count(DT) pocet,DT FROM'
    +' (SELECT (2*gc.difficulty-2)||";"||(2*gc.terrain-2) as DT' 
    +'  FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'  WHERE gt.id=gc.id and gc.dtfound>0 AND '+sCachePrefixForSql
    +'    and gtc.key=gt.ptrkat'
    +'    and gtc.value=''FTF'''
    +'    and gtv.key=gt.ptrvalue and gtv.value like ''%FTF%'') x'
    +' GROUP BY DT'
    +' ORDER BY DT', false);
  try
    if(tab.eof) then begin
      Log(_('ERR: no FTF finds, module has no output'));
      exit;
    end;
    while not tab.eof do
    begin
      n:=tab.FieldAsInteger(0);
      if(n>nMax) then nMax:=n;
      s:=tab.FieldAsString(1);
      sOld:=Fetch(s,';');
      dif:=StrToInt(Fetch(sOld,'.'));
      ter:=StrToInt(Fetch(s,'.'));
      a[dif*10+ter]:=n;
      tab.Next();
    end;
  finally
    tab.free;
  end;

  //nastavime velikost pisma tabulky, pokud je to potreba
  sOld:=GlobalVarGet('StyleTableMatrix',false);
  s:=aPar.Values['FontSize'];
  if(s<>'') then begin
    sOld:=RegexReplace('font-size[:]\s*\d+(px|%|em|pt)',sOld,'font-size:'+s+'px',false);
  end;
  //protoze sirka muze byt dana i primo v px, musime nahradit styl a v nem sirku,
  //jinak pri globalni nahrade je pouzita sirka cele statistiky
  sOld:=ReplaceString(sOld,'%Width%',IntToStr(iWidth));
  Result:=Result+'<table style="'+sOld+'">'+CRLF;

  //vytvorime vystupni tabulku
  sOld:=GlobalVarGet('ColumnHeaderDifficulty',false);
  s:=sOld;
  if bCond then begin //udelame svisly text
    s:='';
    for n:=1 to Length(sOld) do begin
      s:=s+'&nbsp;'+sOld[n]+'&nbsp;<br />';
    end;
  end;
  Result:=Result
    +'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh1%">&nbsp;</th><th colspan=11 style="%StyleTableMatrixTh1%">%ColumnHeaderTerrain%</th></tr>'+CRLF
    +'  <tr style="%StyleTableMatrixTr%">'
    +'    <th rowspan=12 style="%StyleTableMatrixTh1Down%">'+s+'</th>'
    +'    <th style="%StyleTableMatrixTh2%">&nbsp;</th>'
    +'    <th style="%StyleTableMatrixTh2%">1</th>'
    +'    <th style="%StyleTableMatrixTh2%">1.5</th><th style="%StyleTableMatrixTh2%">2</th>'
    +'    <th style="%StyleTableMatrixTh2%">2.5</th><th style="%StyleTableMatrixTh2%">3</th>'
    +'    <th style="%StyleTableMatrixTh2%">3.5</th><th style="%StyleTableMatrixTh2%">4</th>'
    +'    <th style="%StyleTableMatrixTh2%">4.5</th><th style="%StyleTableMatrixTh2%">5</th>'
    +'<th style="%StyleTableMatrixTh2%">&sum;</th>'
    +'  </tr>'+CRLF;
  //vypocteme soucty radku a sloupcu
  nMaxDiff:=0;
  nMaxTerr:=0;
  for dif:=0 to 8 do begin
    n:=0;
    for ter:=0 to 8 do begin
      n:=n+a[dif*10+ter];
      aDiffSuma[ter]:=aDiffSuma[ter]+a[dif*10+ter];
      if(nMaxTerr<aDiffSuma[ter]) then nMaxTerr:=aDiffSuma[ter];
    end;
    aDiffSuma[9]:=aDiffSuma[9]+n;
    if(nMaxDiff<n) then nMaxDiff:=n;
  end;
  //ShowMessage('nMaxDiff='+IntToStr(nMaxDiff)+', nMaxTerr='+IntToStr(nMaxTerr));
  for dif:=0 to 8 do begin
    n:=0;
    Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">'+FormatFloatDot('0.#',(1.0+0.5*dif))+'</th>'+CRLF;
    for ter:=0 to 8 do begin
      n:=n+a[dif*10+ter];
      if(a[dif*10+ter]=0) then Result:=Result+'    <td style="%StyleTableMatrixTdEmpty%">&nbsp;</td>'+CRLF
      else begin
        if(a[dif*10+ter]=nMax) and (GlobalVarGet('StyleTableMatrixTdMaxValueText',true)<>'') then begin
          Result:=Result+'    <td style="%StyleTableMatrixTdMaxValue% background:#'
            +ScaleColor(a[dif*10+ter],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
            +'">'+IntToStr(a[dif*10+ter])+'</td>'+CRLF;
        end
        else begin Result:=Result+'    <td style="%StyleTableMatrixTd% background:#'
          +ScaleColor(a[dif*10+ter],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
          +'">'+IntToStr(a[dif*10+ter])+'</td>'+CRLF;
        end;
      end;
    end;
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(n=nMaxDiff) and (GlobalVarGet('StyleTableMatrixTh2Max',true)<>'')
      then sStyle:=GlobalVarGet('StyleTableMatrixTh2Max',false);
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(n)+'</th>'+CRLF+'  </tr>'+CRLF;
  end;
  //doplnime soucty poctu terenu
  Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">&sum;</th>'+CRLF;
  for ter:=0 to 9 do begin
    //ve stylu nahradime barvu textu za barvu maximalniho textu
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(aDiffSuma[ter]=nMaxTerr) and (GlobalVarGet('StyleTableMatrixTh2Max',true)<>'')
      then sStyle:=GlobalVarGet('StyleTableMatrixTh2Max',false);
    //Result:=Result+'    <th style="%StyleTableMatrixTh2%">'+IntToStr(aDiffSuma[ter])+'</th>'+CRLF
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(aDiffSuma[ter])+'</th>'+CRLF
  end;
  Result:=Result+'  </tr>'+CRLF;
  Result:=Result+'</table>'+CRLF;
  s:=aPar.Values['TextBottom'];
  if(s<>'') then begin
    //zjistime pocet kombinaci
    n:=0;
    for ter:=0 to 8 do begin
      for dif:=0 to 8 do begin
        if(a[dif*10+ter]>0) then Inc(n);
      end;
    end;
    s:=ReplaceString(s,'%FoundCount%',IntToStr(n));
    s:=ReplaceString(s,'%AllCount%',IntToStr(366));
    Result:=Result+'%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%'+CRLF;
  end;
end;