// asov ada msnch FTF nlez

function FTFTimelineMonthly_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    iY,iM,iMax,iYearMin,iYearMax,iMonthMin,iMonthMax,iStreak,iStreakMax:integer;
    s,ss,sData,sSql,sLab,sStreakFrom,sStreakTo,sStreakMaxFrom,sStreakMaxTo:string;
    sEData,sENames:string;
    aData:TStringList;
begin

  // pprava dat pro graf
  aData:=TStringList.Create();
  sSql:='SELECT dtfound/100 YearMonth, count(*) Count FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
       +'  WHERE gt.id=gc.id AND gc.dtfound>0 AND '+sCachePrefixForSql
       +'    AND gtc.key=gt.ptrkat'
       +'    AND gtc.value=''FTF'''
       +'    AND gtv.key=gt.ptrvalue and gtv.value like ''%FTF%'''
       +' GROUP BY YearMonth';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    if(tab.eof) then begin
      Log(_('ERR: missing FTF finds, no result generated.'));
      //tab.Free();
      exit;
    end;
    while not tab.eof do begin
      s:=tab.FieldByName['YearMonth'];
      iYearMax:=StrToInt(Copy(s,1,4));
      iMonthMax:=StrToInt(Copy(s,5,2));
      s:=IntToStr(iMonthMax)+'/'+IntToStr(iYearMax);
      if iYearMin=0 then iYearMin:=iYearMax;
      if iMonthMin=0 then iMonthMin:=iMonthMax;
      ss:=tab.FieldByName['Count'];
      if StrToInt(ss)>iMax then iMax:=StrToInt(ss);
      aData.Add(s+'='+ss);
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  // generovn datovch ad, popis a FTF streak
  iY:=iYearMin;
  iM:=iMonthMin;
  while true do begin
    sLab:=IntToStr(iM)+'/'+IntToStr(iY);
    s:=aData.Values[sLab];
    if s='' then begin
      s:='0';
      iStreak:=0; 
      sStreakFrom:='';
      sStreakTo:='';
    end else begin
      // v msci bylo FTF
      if iStreak=0 then sStreakFrom:=sLab;
      Inc(iStreak);
      sStreakTo:=sLab;
      if iStreak>iStreakMax then begin
        iStreakMax:=iStreak;
        sStreakMaxFrom:=sStreakFrom;
        sStreakMaxTo:=sStreakTo;
      end;
    end;
    sEData:=sEData+s+CRLF;
    sENames:=sENames+sLab+CRLF;
    if(sData='') then sData:=s else sData:=sData+','+s;
    Inc(iM);
    if iM>12 then begin
      iM:=1;
      Inc(iY);
    end;
    if ((iY=iYearMax) and (iM>iMonthMax)) or (iY>iYearMax) then break;
  end;

  // finln akce
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  //upravime typ grafu
  Result:=EChartsBarChart('ID'+IntToStr(iItem),sEData,sENames,'',
    +_('FTFs in month <br/>{b}: {c}'),false,true,iWidth,250);
  s:=aPar.Values['GraphType'];
  Result:=ReplaceString(Result,'type:''bar''','type:''bar'', markArea:{ silent: true, label:{ show: true, position: ''insideTopLeft'', backgroundColor: ''white'', color: ''black'', padding: [8,20,5,20], shadowColor: ''black'', shadowOffsetX: 1, shadowOffsetY: 3, shadowBlur: 10, borderRadius: 3}, data: [[{ name: '''+_('FTF streak')+': '+IntToStr(iStreakMax)+' '+_('months')+''', xAxis: '''+sStreakMaxFrom+'''}, { xAxis: '''+sStreakMaxTo+'''}]]}');
  if(Fetch(s,'-')='Line') then Result:=ReplaceString(Result,'type:''bar'',','type:''line'',');
  Output(Result);
  Result:='';
  // klid
  if(aData<>nil) then aData.Free();
end;