function FindsByAttribSequence(sSort,sFilter:string):string;
var tab: TSqliteTable;
    sSql:string;
    sDivStart,sDivEnd:string;
begin
  Result:='';
  sDivStart:='<div style="'+GlobalVarGet('StyleAttribDiv',false)+'">';
  sDivEnd:='</div>';
  sSql:='SELECT gtv.value attr, count(gtv.value) pocet'
    +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE gt.id=gc.id AND gc.dtfound>0 AND '+sCachePrefixForSql
    +'   AND gtc.key=gt.ptrkat AND gtc.value=''attribute'' and gtv.key=gt.ptrvalue'
    +sFilter
    +' GROUP BY gtv.value';
  if(sSort='Name') then sSql:=sSql+' ORDER BY gtv.value'  
  else  sSql:=sSql+' ORDER BY count(gtv.value) desc';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    while (not tab.eof) do begin
      Result:=Result+sDivStart
        +'<img src="https://www.geocaching.com/images/attributes/'
        +tab.FieldByName['attr']+'.gif" title="'+tab.FieldByName['attr']
        +': '+tab.FieldByName['pocet']+'" /><br />'+tab.FieldByName['pocet']+sDivEnd;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
end;

function FindsByAttribYesNo(sSort,sFilter:string):string;
var tab: TSqliteTable;
    sYes,sNo,sOther,s,sSql:string;
    sDivStart,sDivEnd:string;
begin
  Result:='';
  sDivStart:='<div style="'+GlobalVarGet('StyleAttribDiv',false)+'">';
  sDivEnd:='</div>';
  sSql:='SELECT gtv.value attr, count(gtv.value) pocet'
    +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE gt.id=gc.id AND gc.dtfound>0 AND '+sCachePrefixForSql
    +'   AND gtc.key=gt.ptrkat AND gtc.value=''attribute'' and gtv.key=gt.ptrvalue'
    +sFilter
    +' GROUP BY gtv.value';
  if(sSort='Name') then sSql:=sSql+' ORDER BY gtv.value'
  else  sSql:=sSql+' ORDER BY count(gtv.value) desc';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    while (not tab.eof) do begin
      s:=sDivStart+'<img src="https://www.geocaching.com/images/attributes/'
        +tab.FieldByName['attr']+'.gif" title="'+tab.FieldByName['attr']
        +': '+tab.FieldByName['pocet']+'" /><br />'+tab.FieldByName['pocet']+sDivEnd;
      sSql:=tab.FieldByName['attr'];
      if(Pos('-yes',sSql)>0) then sYes:=sYes+s
      else if(Pos('-no',sSql)>0) then sNo:=sNo+s
      else sOther:=sOther+s;
      tab.Next();
    end;
    Result:=Result+'<p style="'+GlobalVarGet('StyleAttribPara',false)+'">'+_('Positive attributes')+'</p>'+sYes
      +'<p style="'+GlobalVarGet('StyleAttribPara',false)+'">'+_('Negative attributes')+'</p>'+sNo;
    if(sOther<>'') then Result:=Result+'<p style="'+GlobalVarGet('StyleAttribPara',false)+'">'+_('Other attributes')+'</p>'+sOther;
  finally
    tab.Free();
  end;
end;

function FindsByAttribTable(sSort,sFilter:string):string;
var tab: TSqliteTable;
    sYes,sNo,sIcon,sOther,s,sSql:string;
    sTdLeft,sTdMiddle,sTdRight:string;
    aAttr,aName:TStringList;
    i,j,iWidthLeft,iMax:integer;
begin
  Result:=CRLF+'<table style="%StyleAttribTable%">';
  //vypocteme sirky krajnich sloupcu a nastavime je do stylu
  iWidthLeft:=(iWidth-48)/2; //42=sirka prostredniho sloupce s ikonama atributu
  sTdLeft:=ReplaceString(GlobalVarGet('StyleAttribTableTdLeft',false),'%Width%',IntToStr(iWidthLeft));
  sTdMiddle:=GlobalVarGet('StyleAttribTableTdMiddle',false);
  sTdRight:=ReplaceString(GlobalVarGet('StyleAttribTableTdRight',false),'%Width%',IntToStr(iWidthLeft));
  aName:=TStringList.Create();
  aAttr:=TStringList.Create();
  try
    sSql:='SELECT gtv.value attr, count(gtv.value) pocet'
      +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
      +' WHERE gt.id=gc.id AND gc.dtfound>0 AND '+sCachePrefixForSql
      +'   AND gtc.key=gt.ptrkat AND gtc.value=''attribute'' and gtv.key=gt.ptrvalue'
      +sFilter
      +' GROUP BY gtv.value';
    if(sSort='Name') then sSql:=sSql+' ORDER BY gtv.value'  
    else  sSql:=sSql+' ORDER BY count(gtv.value) desc';
    tab:=Geoget_DB.GetTable(sSql, false);
    try
      //vypocteme maximalni pocet atributu, abychom mohli vytvorit histogram
      while (not tab.eof) do begin
        aAttr.Add(tab.FieldByName['attr']+'='+tab.FieldByName['pocet']);
        s:=tab.FieldByName['attr'];
        sOther:=Fetch(s,'-no');
        s:=Fetch(sOther,'-yes');
        if(aName.IndexOf(s)<0) then aName.Add(s); //pridame jmeno atributu bez ohledu na yes/no
        i:=StrToInt(tab.FieldByName['pocet']);
        if(iMax<i) then iMax:=i;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    //vytvorime radky tabulky
    for i:=0 to aName.Count-1 do begin
      sIcon:='<img style="'+GlobalVarGet('StyleAttribTableImg',false)+' margin-right:1px;" src="https://www.geocaching.com/images/attributes/'+
        +aName[i]+'-yes'+'.gif" title="'+aName[i]+'-yes: '+aAttr.Values[aName[i]+'-yes']+'" />'
        +'<img style="'+GlobalVarGet('StyleAttribTableImg',false)+' margin-left:1px;" src="https://www.geocaching.com/images/attributes/'
        +aName[i]+'-no'+'.gif" title="'+aName[i]+'-no: '+aAttr.Values[aName[i]+'-no']+'" />'
        ;
      s:=aAttr.Values[aName[i]+'-yes'];
      if(s='') then j:=0 else j:=StrToInt(s);
      if(iMax=0) then j:=0
      else j:=Trunc(0.9+iWidthLeft*j/iMax);
      sYes:='<div style="position: absolute; width:'+IntToStr(iWidthLeft)+'px; height:20px;">'
        +'<div style="'+GlobalVarGet('StyleAttribTableTextLeft',false)+'">'+s+'</div>'
        +'<div style="width:'+IntToStr(j)+'px; '+GlobalVarGet('StyleAttribTableHistogramLeft',false)
        +';">&nbsp;</div>'
        +'</div>';
      s:=aAttr.Values[aName[i]+'-no'];
      if(s='') then j:=0 else j:=StrToInt(s);
      if(iMax=0) then j:=0
      else j:=Trunc(0.9+iWidthLeft*j/iMax);
      sNo:='<div style="position: absolute; width:'+IntToStr(iWidthLeft)+'px; height:20px;">'
        +'<div style="'+GlobalVarGet('StyleAttribTableTextRight',false)+'">'+s+'</div>'
        +'<div style="width:'+IntToStr(j)+'px; '+GlobalVarGet('StyleAttribTableHistogramRight',false)
        +';">&nbsp;</div>'
        +'</div>';
      Result:=Result+'<tr style="'+GlobalVarGet('StyleAttribTableTr',false)+'">'+CRLF
        +'  <td style="'+sTdLeft+'">'+sYes+'</td>'+CRLF
        +'  <td style="'+sTdMiddle+'">'+sIcon+'</td>'+CRLF
        +'  <td style="'+sTdRight+'">'+sNo+'</td>'+CRLF
        +'</tr>'+CRLF;
    end;
  finally
    aAttr.Free();
  end;
  aName.Free();
  Result:=Result+'</table>'+CRLF;
end;

//hlavni funkce modulu
function FindsByAttrib_Run(aPar:TStringList):string;
var s,sSort:string;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Result:=Result+'<div style="'+GlobalVarGet('StyleAttribsDiv',false)+'">';
  s:=aPar.Values['SortBy'];
  sSort:=Fetch(s,'-');
  s:=aPar.Values['OutputType'];
  case Fetch(s,'-') of
  'Sequence': Result:=Result+FindsByAttribSequence(sSort,SetSqlFilter(aPar));
  'Yes/No':   Result:=Result+FindsByAttribYesNo(sSort,SetSqlFilter(aPar));
  'Table':    Result:=Result+FindsByAttribTable(sSort,SetSqlFilter(aPar));
  else Log(_('ERR: unknown type of output.'));
  end;
  Result:=Result+'</div>'+CRLF;
end;