const FindsByBearing_DirectionsMax=60;
type  FindsByBearing_TypeInt=array[0..FindsByBearing_DirectionsMax] of integer;
      FindsByBearing_TypeExt=array[0..FindsByBearing_DirectionsMax] of extended;

// hlavni funkce modulu
function FindsByBearing_Run(aPar:TStringList):string;
var 
  tab: TSqliteTable;
  i,j,iDirections:integer;
  fd,fdd,fds,fAvgDist:extended;
  s,sSql,sType,sOutType,sHomeName,sSize:string;
  aDirCount:FindsByBearing_TypeInt;
  aDirDist:FindsByBearing_TypeExt;
  sEData,sEId,sOsa,sEData0:string;
  aData:TStringList;
begin
  // poet smr, pro kter bude ve generovno
  iDirections:=StrToInt(aPar.Values['Directions']);
{$ifdef DEBUG_HELPER} LDH('iDirections='+IntToStr(iDirections));{$endif}
  Result:='';
  if(aPar.Values['Title']<>'') then begin
    Result:=ProcessCommand('CmdTitle',aPar);
    Output(Result);
    Result:='';
  end;
  sSql:='SELECT st.Angle Angle, st.Distance Distance FROM '+TEMP_TABLE+' st, geocache gc'
    +' WHERE gc.id=st.id AND '+sCachePrefixForSql+CRLF
    +CONST_SQL_IGNORE_CACHETYPES
    +SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  sSql:=sSql+' ORDER BY Angle';
  i:=0;
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      Inc(i);
      fd:=StrToFloat(tab.FieldByName['Angle']);
      fds:=StrToFloat(tab.FieldByName['Distance']);
      fdd:=(fd+360/iDirections/2);
      if fdd>=360 then fdd:=fdd-360;          // modulo potebuje integer a zaokrouhlenm se interval zprava uzave
      j:=Trunc(fdd*iDirections/360);
      Inc(aDirCount[j]);
      aDirDist[j]:=aDirDist[j]+fds;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  //Log('Pocet selectem nactenych hodnot:'+IntToStr(i));
  // sestaven dat pro tabulku a vygenerovn vybranho typu vstupu
  s:=aPar.Values['ValueType'];
  sType:=Fetch(s,'-');
  s:=aPar.Values['HomeName'];
  sHomeName:=Fetch(s,'-');
  sSize:=IntToStr(iWidth*24/800+10);

  aData:=TStringList.Create();
  try
    for i:=0 to iDirections-1 do begin
      if aDirCount[i]>0 then fAvgDist:=aDirDist[i]/aDirCount[i] else fAvgDist:=0;
      //data pro graf
      sEData:=sEData+'[';
      case UpperCase(sType) of
        'DISTANCE': begin sEData:=sEData+FormatFloatDot('0',ConvertFromKm(0.5+fAvgDist,sUnit)); end;
        'COUNT': begin sEData:=sEData+IntToStr(aDirCount[i]); end;
      end;
      sEData:=sEData+','+IntToStr(i*360/iDirections)+']'+CRLF;
      if(i=0) then sEData0:=sEData;
      //data pro tabulku
      aData.Add(IntToStr(i*360/iDirections)+'&deg;');
      if aDirCount[i]>0 then fAvgDist:=aDirDist[i]/aDirCount[i] else fAvgDist:=0;
      case UpperCase(sType) of
        'DISTANCE': aData.Add(FormatFloatDot('0',ConvertFromKm(0.5+fAvgDist,sUnit)));
        'COUNT': begin
          aData.Add(IntToStr(aDirCount[i]));
          aData.Add('?');
        end;
      end;
      aData.Add('?');
    end;

    //Pid poten souadnice.
    sEData:=sEData+sEData0;
    //
    s:=aPar.Values['OutputType'];
    sOutType:=Fetch(s,'-');
    case UpperCase(sOutType) of
      'TABLE': begin
        case UpperCase(sType) of
          'DISTANCE': Result:=Result+OutputTableList(_('Azimuth')+'=center|'+sType+'|Histogram',aData,0,iDirections,1,i)+CRLF;
          'COUNT': Result:=Result+OutputTableList(_('Azimuth')+'=center|'+sType+'|Percent=right|Histogram',aData,0,iDirections,1,i)+CRLF;
        end;
      end;
      'RADAR': begin
              case UpperCase(sType) of
                'DISTANCE': sOsa:=_('Distance [')+sUnit+']';      //nechat kvuli prekladu i s tou hranatou zavorkou!
                'COUNT': sOsa:=_('Count');            
              end;
              sEId:='ID'+IntToStr(iItem);
              Result:='<div id="'+sEId+'" style="width:'+IntToStr(iWidth)+'px; height:'+IntToStr(iWidth)+'px;"></div>'+CRLF
                +'<script type="text/javascript">'+CRLF
                +'  var chart_'+sEId+'=echarts.init(document.getElementById('''+sEId+'''));'+CRLF
                +'  option={'+CRLF
                +'    color:''#'+GlobalVarGet('ColorTableScaleAvgBkg',false)+''','+CRLF
                +'    polar:{radius:''75%''},'+CRLF
                +'    title:{ text:'''+sHomeName+''', left:''center'', top:''middle'', '
                +'      textStyle:{ fontSize:'+sSize+', color:''#'+GlobalVarGet('ColorMainText',false)+'''}},'+CRLF
                +'    tooltip:{ trigger:''axis'', axisPointer:{ type:''cross''}, formatter:'+CRLF
                +'      function(par){'+CRLF
                +'          var val=par[0].value;'+CRLF
                +'          s=par[0].seriesName;'+CRLF
                +'          a=s.split(" ");'+CRLF
                +'          if(!(a[1])) a[1]="";'+CRLF
                +'          s='''+_('Angle:')+' ''+val[1]+''<br/>''+a[0]+'': ''+val[0]+'' ''+a[1].replace("[","").replace("]","");'+CRLF
                +'          return(s);'+CRLF
                +'        }},'+CRLF
                +'    angleAxis:{ type:''value'', startAngle: 90, min:0, max:360, interval:'+IntToStr(360/iDirections)+','+CRLF
                +'      axisLabel:{color:'+ColorToRGBA(GlobalVarGet('0',false),'0.8')+'},'+CRLF
                +'    },'+CRLF
                +'    radiusAxis:{ name:'''+sOsa+''', nameGap: 23,'+CRLF    //nameGap default = 15
                +'      nameTextStyle:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'1')+'},'+CRLF
                +'      axisLabel:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'1')+'},'+CRLF
                +'    },'+CRLF
                +'    series: [{ areaStyle:{}, coordinateSystem:''polar'', name:'''+sOsa+''','+CRLF
                +'      type:''line'', showSymbol: false,'+CRLF
                +'      data:['+ReplaceString(Trim(sEData),CRLF,',')+']}]};'+CRLF
                +'  chart_'+sEId+'.setOption(option);'+CRLF
                +'</script>'+CRLF+CRLF;
              Output(Result);
              Result:='';
            end;
    end;
  finally
    aData.Free();
  end;
end;