type  FindsByBearingChallenge_Type=array[0..360] of integer;

//hlavni funkce modulu
function FindsByBearingChallenge_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    i,j,iCount:integer;
    fd:extended;
    s,sSql,sChallenge,sEId,sELab,sEData,sSize:string;
    aDir:FindsByBearingChallenge_Type;
begin
  Result:='';
  
  sSql:='SELECT st.Angle Angle FROM '+TEMP_TABLE+' st, geocache gc'
    +' WHERE gc.id=st.id AND '+sCachePrefixForSql+CRLF
    +CONST_SQL_IGNORE_CACHETYPES
    +SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  sSql:=sSql+' ORDER BY Angle';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      fd:=StrToFloat(tab.FieldByName['Angle']);
      j:=Trunc(fd)+1;
      Inc(aDir[j]);
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  sELab:='[';
  sEData:='[';
  for i:=1 to 360 do begin
    sELab:=sELab+''''+IntToStr(i-1)+''',';
    if aDir[i]>0 then begin
      iCount:=iCount+1;
      sEData:=sEData+'1,'; 
    end 
    else sEData:=sEData+'0,';
  end;
  sELab:=sELab+']';
  sEData:=sEData+']';

  if iCount<360 then sChallenge:=IntToStr(iCount) else sChallenge:=_('Challenge completed!');
  if (UpperCase(aPar.Values['HideChallengeValue'])='YES') then sChallenge:='';
  sSize:=IntToStr(iWidth*24/800+10);

  sEId:='ID'+IntToStr(iItem);
  Result:=Result+'<div id="'+sEId+'" style="width:'+IntToStr(iWidth)+'px; height:'+IntToStr(iWidth)+'px;"></div>'+CRLF
    +'<script type="text/javascript">'+CRLF
    +'  var chart_'+sEId+'=echarts.init(document.getElementById('''+sEId+'''));'+CRLF
    +'  option={'+CRLF
    +'    color:''#'+GlobalVarGet('ColorTableScaleAvgBkg',false)+''','+CRLF
    +'    polar:{},'+CRLF
    +'    title:{ text:'''+sChallenge+''', left:''center'', top:''middle'', '
    +'      textStyle:{ fontSize:'+sSize+', color:''#'+GlobalVarGet('ColorMainText',false)+'''}},'+CRLF
    +'    tooltip:{ trigger:''axis'', axisPointer:{ type:''shadow'', shadowStyle:{ color: ''#'+GlobalVarGet('ColorMainText',false)+'''},},'+CRLF
    +'      formatter:'''+_('Sector')+': {b}''},'+CRLF
    +'    angleAxis:{ type:''category'', startAngle: 90, axisLine:{lineStyle:{color:''#'+GlobalVarGet('ColorMainText',false)+'''}},'
    +'      axisLabel:{ interval: 9}, axisTick:{ alignWithLabel: true}, data: '+sELab+'},'+CRLF
    +'    radiusAxis:{ show: false, min: -0.3, max: 1},'+CRLF
    +'    series: [{ coordinateSystem:''polar'', type:''bar'', barCategoryGap: ''-40%'', data:'+sEData+'}]};'+CRLF
    +'  chart_'+sEId+'.setOption(option);'+CRLF
    +'</script>'+CRLF+CRLF;
  Output(Result);
  Result:='';

  s:=aPar.Values['TextBottom'];
  if(s<>'') then begin
    s:=ReplaceString(s,'%FoundSectors%',IntToStr(iCount));
    s:=ReplaceString(s,'%AllSectors%',IntToStr(360));
    s:='%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%';
  end;
  Output(s+CRLF);
end;