const FindsByDirection_DirectionsMax=7;
type  FindsByDirection_TypeInt=array[0..FindsByDirection_DirectionsMax] of integer;
      FindsByDirection_TypeExt=array[0..FindsByDirection_DirectionsMax] of extended;

// hlavni funkce modulu
function FindsByDirection_Run(aPar:TStringList):string;
var 
  tab: TSqliteTable;
  i,j,iDirections,iHeight:integer;
  fd,fdd,fds:extended;
  fAvgDistTradi,fAvgDistMulti,fAvgDistMyst,fAvgDistOther,fAvgDistTotal:extended;
  s,sSql,sType,sOutType,sCacheType:string;
  aDirCountTradi,aDirCountMulti,aDirCountMyst,aDirCountOther,aDirCountTotal:FindsByDirection_TypeInt;
  aDirDistTradi,aDirDistMulti,aDirDistMyst,aDirDistOther,aDirDistTotal:FindsByDirection_TypeExt;
  sEDataTradi,sEDataMulti,sEDataMyst,sEDataOther,sEDataTotal:string;
  sEDataTradi0,sEDataMulti0,sEDataMyst0,sEDataOther0,sEDataTotal0:string;
  sEId,sOsa:string;
  sColorTradi,sColorMulti,sColorMyst,sColorOther,sColorTotal:string;
  aData:TStringList;
begin
  //ziskani barev
  sColorTradi:=ColorToRGBA(GlobalVarGet('ColorGraphCacheTraditional',false),'1');
  sColorMulti:=ColorToRGBA(GlobalVarGet('ColorGraphCacheMulti',false),'0.8');
  sColorMyst:=ColorToRGBA(GlobalVarGet('ColorGraphCacheUnknown',false),'0.8');
  sColorOther:=ColorToRGBA('ab0000','0.8');
  sColorTotal:=ColorToRGBA(GlobalVarGet('ColorTableScaleAvgBkg',false),'1');
  // poet smr, pro kter bude ve generovno
  iDirections:=8;

  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  s:=aPar.Values['ValueType'];
  sType:=Fetch(s,'-');
  if sType='' then sType:='Count';
  iHeight:=iWidth;
  if iHeight<600 then iHeight:=iHeight*5/4;
  if iHeight<300 then iHeight:=iWidth*2;
  
  sSql:='SELECT st.Angle Angle, st.Distance Distance, gc.cachetype Type FROM '+TEMP_TABLE+' st, geocache gc'
    +' WHERE gc.id=st.id AND '+sCachePrefixForSql+CRLF
    +CONST_SQL_IGNORE_CACHETYPES
    +SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  sSql:=sSql+' ORDER BY Angle';

  i:=0;
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      Inc(i);
      sCacheType:=tab.FieldByName['Type'];
      fd:=StrToFloat(tab.FieldByName['Angle']);
      fds:=StrToFloat(tab.FieldByName['Distance']);
      fdd:=(fd+360/iDirections/2);
      if fdd>=360 then fdd:=fdd-360;          // modulo potebuje integer a zaokrouhlenm se interval zprava uzave
      j:=Trunc(fdd*iDirections/360);
      case sCacheType of
        'Traditional Cache':  begin Inc(aDirCountTradi[j]); aDirDistTradi[j]:=aDirDistTradi[j]+fds; end;
        'Multi-cache':        begin Inc(aDirCountMulti[j]); aDirDistMulti[j]:=aDirDistMulti[j]+fds; end;
        'Unknown Cache':      begin Inc(aDirCountMyst[j]); aDirDistMyst[j]:=aDirDistMyst[j]+fds; end;
        else begin Inc(aDirCountOther[j]); aDirDistOther[j]:=aDirDistOther[j]+fds; end;
      end;
      Inc(aDirCountTotal[j]);
      aDirDistTotal[j]:=aDirDistTotal[j]+fds;
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  // sestaven dat pro tabulku a vygenerovn vybranho typu vstupu
  aData:=TStringList.Create();
  try
    for i:=0 to iDirections-1 do begin
      if aDirCountTradi[i]>0 then fAvgDistTradi:=aDirDistTradi[i]/aDirCountTradi[i] else fAvgDistTradi:=0;
      if aDirCountMulti[i]>0 then fAvgDistMulti:=aDirDistMulti[i]/aDirCountMulti[i] else fAvgDistMulti:=0;
      if aDirCountMyst[i]>0 then fAvgDistMyst:=aDirDistMyst[i]/aDirCountMyst[i] else fAvgDistMyst:=0;
      if aDirCountOther[i]>0 then fAvgDistOther:=aDirDistOther[i]/aDirCountOther[i] else fAvgDistOther:=0;
      if aDirCountTotal[i]>0 then fAvgDistTotal:=aDirDistTotal[i]/aDirCountTotal[i] else fAvgDistTotal:=0;
      //data pro graf
      case UpperCase(sType) of
        'DISTANCE': begin 
          sEDataTradi:=sEDataTradi+'['+FormatFloatDot('0',ConvertFromKm(0.5+fAvgDistTradi,sUnit)); 
          sEDataMulti:=sEDataMulti+'['+FormatFloatDot('0',ConvertFromKm(0.5+fAvgDistMulti,sUnit));
          sEDataMyst:=sEDataMyst+'['+FormatFloatDot('0',ConvertFromKm(0.5+fAvgDistMyst,sUnit));
          sEDataOther:=sEDataOther+'['+FormatFloatDot('0',ConvertFromKm(0.5+fAvgDistOther,sUnit));
          sEDataTotal:=sEDataTotal+'['+FormatFloatDot('0',ConvertFromKm(0.5+fAvgDistTotal,sUnit));
        end;
        'COUNT': begin 
          sEDataTradi:=sEDataTradi+'['+IntToStr(aDirCountTradi[i]); 
          sEDataMulti:=sEDataMulti+'['+IntToStr(aDirCountMulti[i]); 
          sEDataMyst:=sEDataMyst+'['+IntToStr(aDirCountMyst[i]); 
          sEDataOther:=sEDataOther+'['+IntToStr(aDirCountOther[i]); 
          sEDataTotal:=sEDataTotal+'['+IntToStr(aDirCountTotal[i]); 
        end;
      end;
      if(i=0) then begin 
        sEDataTradi0:=sEDataTradi;
        sEDataMulti0:=sEDataMulti;
        sEDataMyst0:=sEDataMyst;
        sEDataOther0:=sEDataOther;
        sEDataTotal0:=sEDataTotal;
      end;
      sEDataTradi:=sEDataTradi+','+IntToStr(i*45)+'],';
      sEDataMulti:=sEDataMulti+','+IntToStr(i*45)+'],';
      sEDataMyst:=sEDataMyst+','+IntToStr(i*45)+'],';
      sEDataOther:=sEDataOther+','+IntToStr(i*45)+'],';
      sEDataTotal:=sEDataTotal+','+IntToStr(i*45)+'],';
      //data pro tabulku
      aData.Add(GlobalVarGet('AbbrevDirection'+IntToStr(i*360/(FindsByDirection_DirectionsMax+1)),false));
      if aDirCountTotal[i]>0 then fAvgDistTotal:=aDirDistTotal[i]/aDirCountTotal[i] else fAvgDistTotal:=0;
      case UpperCase(sType) of
        'DISTANCE': aData.Add(FormatFloatDot('0',ConvertFromKm(0.5+fAvgDistTotal,sUnit)));
        'COUNT': begin
          aData.Add(IntToStr(aDirCountTotal[i]));
          aData.Add('?');
        end;
      end;
      aData.Add('?');
    end;
    //Pid poten souadnice.
    sEDataTradi:=sEDataTradi+sEDataTradi0+',360]';
    sEDataMulti:=sEDataMulti+sEDataMulti0+',360]';
    sEDataMyst:=sEDataMyst+sEDataMyst0+',360]';
    sEDataOther:=sEDataOther+sEDataOther0+',360]';
    sEDataTotal:=sEDataTotal+sEDataTotal0+',360]';
    //
    s:=aPar.Values['OutputType'];
    sOutType:=Fetch(s,'-');
    case UpperCase(sOutType) of
      'TABLE': begin
        case UpperCase(sType) of
          'DISTANCE': Result:=Result+OutputTableList(_('Azimuth')+'=center|'+sType+'|Histogram',aData,0,iDirections,1,i)+CRLF;
          'COUNT': Result:=Result+OutputTableList(_('Azimuth')+'=center|'+sType+'|Percent=right|Histogram',aData,0,iDirections,1,i)+CRLF;
        end;
      end;
      'RADAR': begin
              case UpperCase(sType) of
                'DISTANCE': sOsa:=_('Distance [')+sUnit+']'; //nechat kvuli prekladu i s tou hranatou zavorkou!
                'COUNT': sOsa:=_('Count');
              end;
              sEId:='ID'+IntToStr(iItem);
              Result:=Result+'<div id="'+sEId+'" style="width:'+IntToStr(iWidth)+'px; height:'+IntToStr(iHeight)+'px;"></div>'+CRLF
                +'<script type="text/javascript">'+CRLF
                +'  var chart_'+sEId+'=echarts.init(document.getElementById('''+sEId+'''));'+CRLF
                +'  option={'+CRLF
                +'    polar:{radius:''75%'', center: [''50%'', ''55%'']},'+CRLF
                +'    legend:{show: true, textStyle:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'0.8')+'}},'+CRLF
                +'    tooltip:{ trigger:''axis'', axisPointer:{ type:''cross''},'+CRLF
                +'      formatter: function(par){'+CRLF
                +'        s="";'+CRLF
                +'        for(i=0;i<6;i++){'+CRLF
                +'          if(par[i]) s=s+par[i].marker+" "+par[i].seriesName+": "+par[i].value[0]+"<br/>";'+CRLF
                +'        }'+CRLF
                +'        s=''<p style="text-align:center;">'+_('Angle:')+' ''+par[0].value[1]+'' </p><p style="text-align:left;">'''+CRLF
                +'           +s+"</p>"'+CRLF
                +'        return(s);'+CRLF
                +'      }},'+CRLF
                +'    angleAxis:{ type:''value'', startAngle: 90, min:0, max:360, interval:45,'+CRLF
                +'      axisLabel:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'0.8')+'},'+CRLF
                +'    },'+CRLF
                +'    radiusAxis:{ name:'''+sOsa+''', nameGap: 23,'+CRLF    //nameGap default = 15
                +'      nameTextStyle:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'1')+'},'+CRLF
                +'      axisLabel:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'1')+'},'+CRLF
                +'    },'+CRLF
                +'    series: ['+CRLF
                +'    { areaStyle:{}, coordinateSystem:''polar'', name:''Traditional Cache'', stack:''A'','+CRLF
                +'      color: '+sColorTradi+', type:''line'', showSymbol: false, symbol:"circle",'+CRLF
                +'      data:['+sEDataTradi+']},'+CRLF
                +'    { areaStyle:{}, coordinateSystem:''polar'', name:''Multi-cache'', stack:''A'','+CRLF
                +'      color: '+sColorMulti+', type:''line'', showSymbol: false, symbol:"circle",'+CRLF
                +'      data:['+sEDataMulti+']},'+CRLF
                +'    { areaStyle:{}, coordinateSystem:''polar'', name:''Unknown Cache'', stack:''A'','+CRLF
                +'      color: '+sColorMyst+', type:''line'', showSymbol: false, symbol:"circle",'+CRLF
                +'      data:['+sEDataMyst+']},'+CRLF
                +'    { areaStyle:{}, coordinateSystem:''polar'', name:'''+_('Other caches')+''', stack:''A'','+CRLF
                +'      color: '+sColorOther+', type:''line'', showSymbol: false, symbol:"circle",'+CRLF
                +'      data:['+sEDataOther+']},'+CRLF
                +'    { coordinateSystem:''polar'', name:'''+_('Total')+''','+CRLF
                +'      color: '+sColorTotal+', type:''line'', showSymbol: false, symbol:"circle",'+CRLF
                +'      data:['+sEDataTotal+']}]};'+CRLF
                +'  chart_'+sEId+'.setOption(option);'+CRLF
                +'</script>'+CRLF+CRLF;
              Output(Result);
              Result:='';
            end;
    end;
  finally
    aData.Free();
  end;
end;