const FINDS_BY_ELEVATION_MAX=100;

function FindsByElevation_Histogram(aData,aMez:array of integer; nSteps:integer):string;
var i,iMinIdx,iMaxIdx:integer;
    sEData,sENames:string;
begin
  //zjistime nejvyssi a nejnizsi index s hodnotou
  iMinIdx:=0;
  for i:=0 to nSteps-1 do begin
    if((aData[i]>0) and (iMinIdx<=0)) then iMinIdx:=i;
    if(aData[i]>0) then iMaxIdx:=i;
  end;

  for i:=iMinIdx to iMaxIdx do begin
    sEData:=sEData+IntToStr(aData[i])+CRLF;
    sENames:=sENames+IntToStr(aMez[i])+CRLF;
  end;
  Result:=EChartsBarChart('ID'+IntToStr(iItem),sEData,sENames,'',
    _('Number of finds in elevation<br/>from {b} meters: {c}'),true,false,iWidth,200); //Pocet nalezu s nadmorskou vyskou<br/>od {b} metru:
end;

//hlavni funkce modulu
function FindsByElevation_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    aStr:TStringList;
    i,iMin,iMinIdx,iMaxIdx,nSuma,nSteps:integer;
    fd,fSuma:extended;
    s,sType,sSql:string;
    aMez,aData:array of integer;
    bMissElev:boolean;
begin
  Result:='';
  SetLength(aMez,FINDS_BY_ELEVATION_MAX);
  SetLength(aData,FINDS_BY_ELEVATION_MAX);
  s:=aPar.Values['Steps'];
  nSteps:=ReadStepsToArray(s,aMez);
  fSuma:=0;
  nSuma:=0;
  bMissElev:=false;
  sSql:='SELECT gtv.value Elevation, gc.id Id'
     +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
     +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql+SetSqlFilter(aPar)
     +CONST_SQL_IGNORE_CACHETYPES
     +'     AND gc.dtfound>0'
     +'     AND gtc.key=gt.ptrkat AND gtc.value=''Elevation'' AND gtv.key=gt.ptrvalue';
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id NOT IN ('+sIgnoreCaches+')';
  sSql:=sSql+' ORDER BY (0+gtv.value) desc';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    //bErr:=false;
    while not tab.eof do begin
      s:=tab.FieldByName['Elevation'];
      if(s='') then begin
        Inc(iModuleError);
        Log(_('ERR: Elevation not defined')+' ('+tab.FieldByName['Id']+')');
        tab.Next();
        continue;
      end; 
      s:=ReplaceString(tab.FieldByName['Elevation'],',','.');
      if(s='') then bMissElev:=true
      else begin
        fd:=StrToFloat(s);
        fSuma:=fSuma+fd;
        Inc(nSuma);
        iMin:=0;
        for i:=0 to nSteps-1 do begin
          if(i=nSteps-1) and (fd>aMez[i]) then begin Inc(aData[i]); break; end
          else if(fd>=aMez[i]) and (fd<aMez[i+1]) then begin
            Inc(aData[i]);
  //Log('XXXX fd='+floatToStr(fd)+', i='+IntToStr(i)+', H_mez='+IntToStr(aMez[i])+', pocet='+IntToStr(aData[i]));
            break;
          end;
          iMin:=aMez[i];
        end;
      end;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  //pokud neni zadna kes nalezena, zkontrolujeme, zda existuje tag nebo je nulovy
  //pocet zpusobeny filtrem


  //zkontrolujeme existenci tagu
  i:=Geoget_DB.GetTableValue('SELECT count(key) FROM geotagcategory gtc WHERE gtc.value=''Elevation''');
  if(i<1) then begin
    s:=_('ERR: TAG Elevation missing. Start the plugin Elevation before running Stator!');
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(s);
    Log(s);
  end;
  if(nSuma=0) then nSuma:=1; //asi chybi tag nebo vlivem filtru neni nic nalezeno
  //pokud je to potreba nahradime v titulku prumernou hodnotu
  if(aPar.Values['Title']<>'') then Result:=
    ReplaceString(ProcessCommand('CmdTitle',aPar),'%AvgValue%',
    FormatFloatDot('0.0',(fSuma/nSuma)));
  //zjistime posledni index s nenulovou hodnotou
  iMinIdx:=0;
  iMaxIdx:=0;
  for i:=0 to nSteps-1 do begin
//Log('BBBB aData['+IntToStr(i)+']='+IntToStr(aData[i])+' (hodnoty od '+IntToStr(aMez[i])+')');
    if(aData[i]>0) and (iMinIdx<=0) then iMinIdx:=i;
    if(aData[i]>0) then iMaxIdx:=i;
  end;
  aStr:=TStringList.Create();
  try
//Log('BBB iMinIdx='+IntToStr(iMinIdx)+', iMaxIdx='+IntToStr(iMaxIdx));
    iMin:=-9999;
    for i:=iMinIdx to iMaxIdx do begin
      //text prvniho a posledniho radku je jiny
      if(i=nSteps-1) then aStr.Add('>'+IntToStr(aMez[i]))
      else if(i=iMinIdx) then aStr.Add('<'+IntToStr(aMez[i+1]))
      else aStr.Add(IntToStr(aMez[i])+' - '+IntToStr(aMez[i+1]));
      aStr.Add(IntToStr(aData[i]));
      aStr.Add('?');
      aStr.Add('?');
      iMin:=aMez[i];
    end;
    sType:=aPar.Values['OutputType'];
    s:=Fetch(sType,'-');
//Log('vystup: '+s);
    case UpperCase(s) of
    'TABLE':  begin
                Result:=Result+OutputTableList(
                  'tag-Elevation=center|Count|Percent|Histogram'
                  ,aStr,0,(aStr.Count/4),1,i)+CRLF;
              end;
    'HISTOGRAM': begin
                   Output(Result);
                   Result:=FindsByElevation_Histogram(aData,aMez,nSteps)+CRLF;
                 end;
    end;
  finally;
//    aStr.Free();
  end;
  if(bMissElev) then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('Some caches have no Elevation tag (or it''s empty). List of these caches can be find in Stator.log file in active profile folder.'));
    Log(_('ERR: Some caches have no Elevation tag (or it''s empty). List of these caches can be find in Stator.log file in active profile folder.'));
  end;
end;