// Histogram nlez podle asu a podl lovu za svtla a za tmy. Vyaduje mt daje o asu a tag SvetloTma.

function FindsByTime_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    i,iDarkCount,iAllFounds,iLightPerc,iDarkPerc:integer;
    s,sType,sSql:string;
    sEData,sENames:string;
    iPieMin,iPieMinLeg,iRectMin,iHeightPie,iLightWd,iHeightGr,iWidthGr:integer;
    aTime:array[0..23] of integer;
    //aData:TStringList;
begin
  Result:='';
  // rozmry a limitn hodnoty pro vykreslovn detail
  iHeightGr:=150;                   // vka grafu histogramu
  iWidthGr:=iWidth;
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then iWidthGr:=Trunc(MAX_GraphAreaSize/iHeightGr);
  iHeightPie:=100;                  // vka kole svtlo/tma
  iPieMinLeg:=500;                  // minimln ka pro vykreslen kole s legendou
  iPieMin:=400;                     // minimln ka pro vykreslen kole bez resize
  iRectMin:=80;                     // minimln ka obdlnku (aby se do nj veel text)

  sSql:='SELECT dtfoundtime/100 Time, count(*) Num FROM geocache gc WHERE gc.dtfound>0 AND '
    +sCachePrefixForSql+SetSqlFilter(aPar)+' GROUP BY Time';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      i:=StrToInt(tab.FieldByName['Time']);
      aTime[i]:=StrToInt(tab.FieldByName['Num']);
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  for i:=0 to 23 do begin
    sENames:=sENames+IntToStr(i)+CRLF;
    sEData:=sEData+IntToStr(aTime[i])+CRLF;
  end;

  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  Result:=EChartsBarChart('ID'+IntToStr(iItem)+'Bar',sEData,sENames,
    '',_('{c} finds after {b} o''clock'),true,false,iWidthGr,iHeightGr);               
  Output(Result);
  Result:='';

  // podl nlez za svtla a za tmy
  sSql:=' SELECT count(*) as Svetlo'+CRLF
       +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
       +' WHERE gt.id=gc.id and gc.dtfound>0 AND '+sCachePrefixForSql+CRLF+SetSqlFilter(aPar)
       +'   AND gtc.key=gt.ptrkat'+CRLF
       +'   AND gtc.value=''SvetloTma'''+CRLF
       +'   AND gtv.key=gt.ptrvalue and gtv.value=''Tma''';
//{$ifdef DEBUG_HELPER} LDH('SQL pro pocet nalezu za svetla a tmy'+sSql); {$endif}
//  Log('SQL pro pocet nalezu za svetla a tmy'+sSql);
  iDarkCount:=Geoget_DB.GetTableValue(sSql);
  if(iDarkCount=0) then begin
    {$ifdef DEBUG_HELPER} LDH('WARN: Nejsou hodnoty z tagu SvetloTma, potlaceno generovani grafu');{$endif}
    Log(_('WARN: Missing values from Light/Dark tags, chart not generated')); 
    exit;              // vykreslujeme jen pokud mme hodnoty z tagu SvetloTma
  end;

  // kvli SetFilter potme vechny nlezy znova (potebujeme vechny nlezy podle filtru)
  sSql:='SELECT count(*) Num FROM geocache gc WHERE gc.dtfound>0 AND '+CRLF
    +sCachePrefixForSql+CRLF+SetSqlFilter(aPar);
//{$ifdef DEBUG_HELPER} LDH('SQL pro pocet nalezu celkem'+sSql); {$endif}
//  Log('SQL pro pocet nalezu celkem'+sSql);
  iAllFounds:=Geoget_DB.GetTableValue(sSql);
  iDarkPerc:=Round(iDarkCount*100/iAllFounds);
  iLightPerc:=100-iDarkPerc;
  //----------------data pro ECharts
  sENames:=_('Night')+CRLF+_('Daylight')+CRLF;  
  sEData:=IntToStr(iDarkCount)+CRLF+IntToStr(iAllFounds-iDarkCount)+CRLF;
  s:=aPar.Values['LightDarkType'];
  sType:=Fetch(s,'-');
  //{$ifdef DEBUG_HELPER} LDH('sType='+sType);{$endif}
  case sType of
  'Pie':  begin
      Result:=EChartsPieChart('ID'+IntToStr(iItem)+'Pie',sEData,sENames,iWidthGr,iHeightPie)+CRLF;
      Output(Result);
      Result:='';
    end;
  'Rectangles': begin
      iLightWd:=iWidthGr*iLightPerc/100;
      if iLightWd<iRectMin then iLightWd:=iRectMin;
      if (iWidthGr-iLightWd)<iRectMin then iLightWd:=iWidthGr-iRectMin;
      Result:='<div style="%StyleLightDark%">'+CRLF
        +'<table width="'+IntToStr(iWidthGr)+'" style="%StyleLightDarkTable%">'+CRLF
        +'  <tr><td width="'+IntToStr(iLightWd)+'" style="%StyleLightDarkTdLight%">'
        +_('Daylight')+'<br />'+IntToStr(iAllFounds-iDarkCount)+' ('+IntToStr(iLightPerc)+' %)</td>'+CRLF
        +'    <td style="%StyleLightDarkTdDark%">'
        +_('Night')+'<br />'+IntToStr(iDarkCount)+' ('+IntToStr(iDarkPerc)+' %)'
        +'</td>'+CRLF+'  </tr>'+CRLF+'</table>'+CRLF+'</div>'+CRLF;
      end;
  end;
  //if(aData<>nil) then aData.Free();
end;