//hlavni funkce modulu
function FindsInIcons_Run(aPar:TStringList):string;
var sSql,s,sAlt,sBkg:string;
    aBkg:array [0..41] of string;    //od roku 2001 do 2020
    i,iRokMin,iRokMax,iLastYear:integer;
    tab: TSqliteTable;
    bSvetloTma,bTma,bRokySamostatne,bBarvyVLetech:boolean;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Result:=Result+'<div class="cIconList">'+CRLF;
  //nastavime barvy pro jednotlive roky, vzdy pro svetlo a pro tmu na kazdy rok
  bSvetloTma:=(aPar.Values['SvetloTma']='Yes');
  bRokySamostatne:=(aPar.Values['YearsSeparately']='Yes');
  iRokMin:=-1;
  s:=aPar.Values['ColorYears'];
  bBarvyVLetech:=(Fetch(s,'-')='Yes');

  //napred zjistime prvni a posledni rok, abychom mohli vytvorit hlavicku
  //a pak mohli kazdou ikonku hned zapsat a nemuseli porad pridavat ke stringu
  sSql:='SELECT MIN(dtfound) mi, MAX(dtfound) mx FROM geocache gc WHERE gc.dtfound>0 AND '
    +sCachePrefixForSql+SetSqlFilter(aPar);
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    iRokMin:=StrToInt(copy(tab.FieldByName['mi'],1,4))-2001;
    iRokMax:=StrToInt(copy(tab.FieldByName['mx'],1,4))-2001;
  finally
    tab.Free();
  end;
  Log('SQL - doplneni zahlavi');
  if(bBarvyVLetech) then begin //pokud jsou zobrazene roky s ruznym pozadim
    if(bSvetloTma) then Result:=Result+'<div class="cIconListNote">'+_('Finds at night have darker background.')+'</div>';
    Result:=Result+'<p class="cIconListBold">';
    for i:=iRokMin to iRokMax do begin
      sBkg:='cBkg_'+IntToStr(i+2001);
      if(not bSvetloTma) then begin
        Result:=Result
          +'&nbsp;&nbsp;<span class="cIconListSpan '+sBkg+'s">'+IntToStr(i+2001)+'</span>';
      end
      else begin
        Result:=Result
          +'<span  class="cIconListSpanS '+sBkg+'s">20</span>'
          +'<span  class="cIconListSpanT '+sBkg+'t">'+FormatFloatDot('0#',1.01+i)+'</span>&nbsp;&nbsp;';
      end;
    end;
    if(not bSvetloTma) then begin
      Result:=Result
        +'&nbsp;&nbsp;<span class="cIconListSpan cBkg_T5s">Terrain=5</span>';
    end
    else begin
      Result:=Result
        +'<span class="cIconListSpanS cBkg_T5s">Terr</span>'
        +'<span class="cIconListSpanT cBkg_T5t">ain=5</span>&nbsp;&nbsp;';
    end;
    Result:=Result+'</p><br /><br />';
  end;
  Output(Result);
  Result:='';

  //ziskame skutecna data, z kterych tvorit ikonky
  sSql:='SELECT st.rowid poradi, gc.id id'
    +', replace(replace(gc.name,">",">"),"''","&apos;") name' 
    +', gc.dtfound dtfound, substr(dtfound,7,2)||"."||substr(dtfound,5,2)||"."||substr(dtfound,1,4) dt'
    +', substr("000"||gc.dtfoundtime,-4,2)||":"||substr("000"||gc.dtfoundtime,-2,2) dtm'
    +', gc.cachetype cachetype, gc.difficulty difficulty, gc.terrain terrain';
  if(bSvetloTma) then sSql:=sSql+',tag.SvetloTma SvetloTma'
  else sSql:=sSql+',"?" SvetloTma';
  sSql:=sSql+' FROM geocache gc, '+TEMP_TABLE+' st';
  //SvetloTma MUSI byt v apostrofech, pokud to dam do uvozovek, dela to nesmysly
  if(bSvetloTma) then sSql:=sSql+',('
    +' SELECT gt.id,gtv.value SvetloTma, gtc.value category'
    +' FROM geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE gtc.key=gt.ptrkat and gtc.value=''SvetloTma'''
    +'   and gtv.key=gt.ptrvalue'
    +' ) tag';
  sSql:=sSql+' WHERE gc.id=st.id';
  if(bSvetloTma) then sSql:=sSql+' and tag.id=st.id';
  sSql:=sSql+SetSqlFilter(aPar)+' ORDER BY st.rowid';
  Log('SQL - Start');
  tab:=Geoget_DB.GetTable(sSql, false);
  Log('SQL - Zpracovani vysledku');
  iLastYear:=-1;
  try
    while not tab.eof do begin
      sAlt:='#'+tab.FieldByName['poradi']+' '+tab.FieldByName['id']+' - '
        +ReplaceString(UtfToAnsi(tab.FieldByName['name']),'"','&quot;')
        +' ('+tab.FieldByName['dt']+' '+tab.FieldByName['dtm'];
      if(bSvetloTma) then sAlt:=sAlt+' '+tab.FieldByName['SvetloTma'];
      sAlt:=sAlt+')';
      //index barvy pozadi podle roku
      i:=2*(StrToInt(copy(tab.FieldByName['dtfound'],1,4))-2001);
      //pokud mame oddelit roky a je novy rok, oddelime jej
      if(bRokySamostatne) and (i<>iLastYear) then begin
        //vytvorime novy nadpis
        aPar.Values['Title']:=IntToStr(2001+i/2);
        Output(ProcessCommand('CmdTitle',aPar));
        iLastYear:=i;
      end;
      //jmeno stylu s barvou pozadi
      sBkg:='';
      bTma:=(tab.FieldByName['SvetloTma']='Tma');
      //T5 ma nejvyssi prioritu
      if(tab.FieldByName['terrain']='5') then begin
        if(bTma) then sBkg:='cBkg_T5t' else sBkg:='cBkg_T5s';
      end
      else begin
        if(bBarvyVLetech) then begin      //odlisime roky, pokud je pozadovano
          sBkg:='cBkg_'+Copy(tab.FieldByName['dtfound'],1,4);
          //pokud je potreba, odlisime svetlo a tmu
          if(bTma) then sBkg:=sBkg+'t' else sBkg:=sBkg+'s';
        end
        else if(bTma) then sBkg:='cBkg_t'; //jen odlisime tmu bez ohledu na rok
      end;
      if(sBkg<>'') then sBkg:=' class="'+sBkg+'"';
      //pokud si nahradu delam sam a rovnou i prevedu kazdou kesku do vystupniho
      //kodovani a zapisu do vystupu, je to 20x rychlejsi nez kdyz vratim
      //cely vysledek v Result a pak se zpracuje funkci Output()
      s:='<a href="https://coord.info/'+tab.FieldByName['id']+'" target="StatorCache">'
        +'<img src="'
        +GlobalVarGet('IconCacheTypeSmall'+tab.FieldByName['cachetype'],false)+'"'
        +CRLF+'  Title="'+sAlt+'"'+sBkg
        +' /></a>';
      //pro usporu casu si vystup udelame sami, aby nebylo potreba prevadet a kopirovat
      //stringy mnohokrat
      if(UpperCase(sOutCoding)<>'ANSI') then s:=UtfToCharset(AnsiToUtf(s),sOutcoding);
      if(fOut<>nil) then fOut.Write(s,Length(s));
      tab.Next();
    end;
  finally
    tab.free;
  end;
  s:=CRLF+'</div>'+CRLF;
  fOut.Write(s,Length(s));
end;