function MapGenFromCountry_Run(aPar:TStringList):string;
var s,sMap,sStat,sShowValues,sShowLabels,sRegionLabels,sValueSize,sLabelSize,
      sTitle,sChd1,sChld,sChm,sChldEmpty,sSql:string;
    ix:integer;
    tab:TSQLiteTable;
    aVal:TStringList;
    ini:TMemIniFile;  //pro prevod jmena oblasti na zkratku
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  s:=aPar.Values['Map'];
  sStat:=Fetch(s,'-');
  //prevedeme stat na typ mapy
  {
  case sStat of
  'Europe':         sMap:='Europe';
  'World':          sMap:='World';
  end;
  }
  sMap:=sStat;
  if(sMap='') then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('ERR: unknown continent for MapGenerator:')+' '+sStat);
    Log(_('ERR: unknown continent for MapGenerator:')+' '+sStat);
    exit;
  end;
  s:=aPar.Values['ShowValues'];        sShowValues:=Fetch(s,'-');
  s:=aPar.Values['ShowLabels'];        sShowLabels:=Fetch(s,'-');
  s:=aPar.Values['RegionLabels'];      sRegionLabels:=Fetch(s,'-');
  s:=aPar.Values['ValueSize'];         sValueSize:=Fetch(s,'-');
  s:=aPar.Values['LabelSize'];         sLabelSize:=Fetch(s,'-');
  sChm:=sShowValues+','+sShowLabels+','+sRegionLabels+','+sValueSize+','+sLabelSize;
  Log('sMap='+sMap+', sChm='+sChm);
  sTitle:=aPar.Values['Title'];
  //otevreme ini soubor pro zjisteni seznamu zkratek statu na mape, a zjistime prvni
  //hodnotu pro pripad, ze pro mapu nejsou zadna data, tak abychom neco predali
  ini:=TMemIniFile.Create(GetModulesDir()+'MapGenFromCountry.Abbrev.ini');
  try
    aVal:=TStringList.Create();
    try
      ini.ReadSectionValues(sMap,aVal);
      if(aVal.Count>0) then begin
        sChldEmpty:=aVal[0];
        Fetch(sChldEmpty,'=');
      end;
    finally
      aVal.Free();
    end;
  finally
  end;
  Geoget_DB.AddParamText(':Prefix',sCachePrefix+'%');
  Geoget_DB.AddParamText(':country',sStat);
  //pro Evropu je jiny dotaz a nikdy nedelame procenta
  sSql:='SELECT count(gc.country) Nalezene,gc.country Jmeno'+CRLF
          +' FROM geocache gc'+CRLF
          +' WHERE gc.dtfound>0 AND '+sCachePrefixForSql+CRLF
          +SetSqlFilter(aPar)
          +' group by gc.country'+CRLF //seskupime podle podle hodnoty tagu
          +' order by gc.country'+CRLF
          ;
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    ix:=0;
    while (not tab.eof) and (ix<1) do begin
      //Inc(ix);  //pro ladeni a hledani chybneho zaznamu
      //protoze ne vsechny znaky z jinych statu jdou prevest na ANSI, prevedeme je na ASCII
      s:=UtfToAscii(tab.FieldAsString(1));
      //prevedeme na zkratku
      sTitle:=ini.ReadString(sMap,s,'??');
      //pokud stat patri do tohoto kontinentu, zaradime jej
      if(sTitle<>'??') then begin
        if(sChd1<>'') then begin
          sChd1:=sChd1+',';
        end;
        sChd1:=sChd1+tab.FieldAsString(0);
        sChld:=sChld+sTitle;
      end
      else begin
        if(sMap='World') then begin
          //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
          //AddError(_('ERR: unknown abbreviation for')+' '+s);
          Log(_('ERR: unknown abbreviation for')+' '+s);
        end;
      end;
      //Log('sMap='+sMap+', s='+s+'('+ini.ReadString(sMap,s,'??')+'), Nalezene='+tab.FieldAsString(0));
      tab.Next();
    end;
  finally
    if(tab<>nil) then tab.Free();
  end;
  ini.Free();
  //kontrola hodnot a pripadne varovani pri nesmyslech
  if(iWidth<300) then begin
    Log(_('WARN: The width of the map is less than the minimum will be adjusted to 300.'));
  end;
  if(iWidth<400) and (Pos('None,None',sChm)<1) then begin
    Log(_('WARN: The map is too small, the text on it probably will not be displayed.'));
  end;
  if(sModuleError<>'') then Log(sModuleError);
  s:=CONST_MAPGEN_URL+'mapgen.php?'
    +'cht=t,Finds&'
    +'chm='+sChm
    +'&chs=wx'+IntToStr(iWidth)
    +'&chtm='+sMap
    +'&chf=bg,s,%ColorMainBkg%'
    +'&chco=%ColorMapRegionDNF%,%ColorMapMinBkg%,%ColorMapAvgBkg%,%ColorMapMaxBkg%';
    //+'&chco=%ColorMapMinBkg%,%ColorMapAvgBkg%,%ColorMapMaxBkg%';
  //barvy podle potreby, pokud sLabels obsahuje carku, predavame 2 barvy
  if(Pos('Finds',sShowValues)>=1) then s:=s+',%ColorMapCountText%';
  //if(Pos('Perc',sShowValues)>=1) then s:=s+',%ColorMapPercText%';
  if(Pos('None',sShowLabels)<1) then s:=s+',%ColorMapAbbrevText%';
  //datove sady podle potreby
  s:=s+'&chd='+sChd1;
  s:=s+'&chld='+sChld;
  Result:=Result
    +'<a href="'+ReplaceString(s,'=wx'+IntToStr(iWidth),'=wx9999')+'" '
    //takto definovany kurzor chodi jen v Chromu
    //+'target="_blank" style="cursor:url('+sUrlMapgen+'images/Lupa2.png), -webkit-zoom-in;">'
    //takto definovany chodi v Chromu i FireFoxu
    +'target="_blank" style="cursor:url('+CONST_MAPGEN_URL+'images/Lupa2.png) 7 7, auto;">'
    +'<img src="'+s+'" /></a>'+CRLF;
end;