function MapGenFromState_Run(aPar:TStringList):string;
var s,sMap,sStat,sShowValues,sShowLabels,sRegionLabels,sValueSize,sLabelSize,sTitle,
      sCht,sChm,sChd1,sChd2,sChld,sChf,sChldEmpty,
      sSql
      :string;
    ix, iEmptyState:integer;
    tab:TSQLiteTable;
    aVal:TStringList;
    ini:TMemIniFile;  //pro prevod jmena oblasti na zkratku
    bUseTag:boolean;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  bUseTag:=(UpperCase(aPar.Values['UseTag'])<>'NO');
  s:=aPar.Values['Map'];
  sStat:=Fetch(s,'-');
  //prevedeme stat na typ mapy
  case sStat of
  'Austria':        begin sMap:='ATkraj'; end;
  'Belgium':        begin sMap:='BEkraj'; end;
  'Czechia':        begin sMap:='CZkraj'; end;
  'France':         begin sMap:='FRkraj'; end;
  'Germany':        begin sMap:='DEkraj'; end;
  'Hungary':        begin sMap:='HUkraj'; end;
  'Ireland':        begin sMap:='IEkraj'; end;
  'Italy':          begin sMap:='ITkraj'; end;
  'Netherlands':    begin sMap:='NLkraj'; end;
  'Norway':         begin sMap:='NOkraj'; end;
  'Poland':         begin sMap:='PLkraj'; end;
  'Slovakia':       begin sMap:='SKkraj'; end;
  'Spain':          begin sMap:='ESkraj'; end;
  'Sweden':         begin sMap:='SEkraj'; end;
  'Switzerland':    begin sMap:='CHkraj'; end;
  //'Switzerland':    begin sMap:='CHkraj_GS'; end;
  'United States':  begin sMap:='USA'; end;
  end;
  if(sMap='') then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('ERR: unknown country for MapGenerator:')+' '+sStat);
    Log(_('ERR: unknown country for MapGenerator:')+' '+sStat);
    exit;
  end;
  s:=aPar.Values['Data'];              sCht:=Fetch(s,'-');
  s:=aPar.Values['ShowValues'];        sShowValues:=Fetch(s,'-');
  s:=aPar.Values['ShowLabels'];        sShowLabels:=Fetch(s,'-');
  s:=aPar.Values['RegionLabels'];      sRegionLabels:=Fetch(s,'-');
  s:=aPar.Values['ValueSize'];         sValueSize:=Fetch(s,'-');
  s:=aPar.Values['LabelSize'];         sLabelSize:=Fetch(s,'-');
  s:=aPar.Values['HideNeighborhood'];
  if(UpperCase(s)<>'YES') then sChf:=''
  else sChf:='&chf=bg,s,%ColorMainBkg%';
  sChm:=sShowValues+','+sShowLabels+','+sRegionLabels+','+sValueSize+','+sLabelSize;
  sTitle:=aPar.Values['Title'];
  //otevreme ini soubor pro prevod jmena oblasti na zkratku, a zjistime prvni
  //hodnotu pro pripad, ze pro mapu nejsou zadna data
  ini:=TMemIniFile.Create(GetModulesDir()+'MapGenFromState.Abbrev.ini');
  try
    aVal:=TStringList.Create();
    try
      ini.ReadSectionValues(sMap,aVal);
      if(aVal.Count>0) then begin
        sChldEmpty:=aVal[0];
        Fetch(sChldEmpty,'=');
      end;
    finally
      aVal.Free();
    end;
    iEmptyState:=0;
    Geoget_DB.AddParamText(':Prefix',sCachePrefix+'%');
    Geoget_DB.AddParamText(':country',sStat);
    sSql:='SELECT A.pocet Dostupne,B.pocet Nalezene, A.Jmeno, 100*B.pocet/A.pocet Procent from'+CRLF
          // dostupne nebo nalezene kese s danym prefixem ('GC'/'OC'/'WM'/...) se
          // zadanou kategorii tagu
          +' (SELECT count(gc.state) as pocet,gc.state as Jmeno'+CRLF
            +' FROM geocache gc'+CRLF
            +' WHERE '+sCachePrefixForSql+SetSqlFilter(aPar)+CRLF
            +'   AND (gc.cachestatus<2 or gc.dtfound>0)'+CRLF
            +'   AND gc.country=:country'+CRLF

            +' group by gc.state'+CRLF //seskupime podle podle hodnoty tagu
            +' order by gc.state'+CRLF
          +') A'+CRLF
          +','+CRLF
          // pocet nalezenych kesi se zadanym prefixem ('GC'/'OC'/'WM'/...)
          // a se zadanou kategorii tagu
          +'(select count(gc.state) as pocet,gc.state as Jmeno' +CRLF
            +' from geocache gc'+CRLF
            +' where gc.dtfound>0 AND '+sCachePrefixForSql+SetSqlFilter(aPar)+CRLF
            +'   AND gc.country=:country'+CRLF
            +' group by gc.state'+CRLF
            +' order by gc.state'+CRLF
          +') B' +CRLF
        +' where A.Jmeno=B.Jmeno'+CRLF
        +' order by Nalezene'+CRLF
        ;
    Log('SQL='+sSql);
    tab:=Geoget_DB.GetTable(sSql,false);
    try
      ix:=0;
      while (not tab.eof) and (ix<1) do begin
        //Inc(ix);  //pro ladeni a hledani chybneho zaznamu
        //protoze ne vsechny znaky z jinych statu jdou prevest na ANSI, prevedeme je na ASCII
        s:=UtfToAscii(tab.FieldAsString(2));
        //prevedeme na zkratku
        sTitle:=ini.ReadString(sMap,s,'??');
        if(sTitle='??') then begin
          if(Trim(s)='') then begin
            //Inc(iEmptyState);
            iEmptyState:=iEmptyState+tab.FieldAsInteger(1);
          end
          else begin
            //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
            //AddError(_('ERR: unknown abbreviation for state')+' "'+s+'" ('+_('country')+': '+sStat+')');
            Log(_('ERR: unknown abbreviation for state')+' "'+s+'" ('+_('country')+': '+sStat+')');
          end;
        end
        else begin
          if(sChd1<>'') then begin
            sChd1:=sChd1+',';
            sChd2:=sChd2+',';
          end;
          sChd1:=sChd1+tab.FieldAsString(1);
          sChd2:=sChd2+tab.FieldAsString(3);
          sChld:=sChld+sTitle;
        end;
        Log('sMap='+sMap+', s='+s+'('+ini.ReadString(sMap,s,'??')+'), Dostupne='+tab.FieldAsString(0)+', Nalezene='+tab.FieldAsString(1)+', Procent='+tab.FieldAsString(3));
        tab.Next();
      end;
    finally
      if(tab<>nil) then tab.Free();
    end;
    //--- end;
  finally
    ini.Free();
  end;
  //kontrola hodnot a pripadne varovani pri nesmyslech
  if(iWidth<300) then begin
    Log(_('WARN: The width of the map is less than the minimum will be adjusted to 300.'));
  end;
  if(iWidth<400) and (Pos('None,None',sChm)<1) then begin
    Log(_('WARN: The map is too small, the text on it probably will not be displayed.'));
  end;
  if(sModuleError<>'') then Log(sModuleError);
  s:=CONST_MAPGEN_URL+'mapgen.php?'
    +'cht=t,'+sCht
    +'&chm='+sChm
    +'&chs=wx'+IntToStr(iWidth)
    +'&chtm='+sMap
    +sChf
    +'&chco=%ColorMapRegionDNF%,%ColorMapMinBkg%,%ColorMapAvgBkg%,%ColorMapMaxBkg%';
  //barvy podle potreby, pokud sLabels obsahuje carku, predavame 2 barvy
  if(sShowValues='Finds') then s:=s+',%ColorMapCountText%';
  if(sShowValues='Perc') then s:=s+',%ColorMapPercentText%';
  if(sShowValues='FindsPerc') then s:=s+',%ColorMapCountText%,%ColorMapPercentText%';
  if(sShowLabels<>'None') then s:=s+',%ColorMapAbbrevText%';
  //datove sady podle potreby
  if(sCht='Finds') then s:=s+'&chd='+sChd1;
  if(sCht='Perc') then s:=s+'&chd='+sChd2;
  if(sCht='FindsPerc') then s:=s+'&chd='+sChd1+'|'+sChd2;
  s:=s+'&chld='+sChld;
  Result:=Result
    +'<a href="'+ReplaceString(s,'=wx'+IntToStr(iWidth),'=wx9999')+'" '
    //takto definovany kurzor chodi jen v Chromu
    //+'target="_blank" style="cursor:url('+sUrlMapgen+'images/Lupa2.png), -webkit-zoom-in;">'
    //takto definovany chodi v Chromu i FireFoxu
    +'target="_blank" style="cursor:url('+CONST_MAPGEN_URL+'images/Lupa2.png) 7 7, auto;">'
    +'<img src="'+s+'" /></a>'+CRLF;
  if(iEmptyState>0) then begin
    //Result:=Result+'<p>'+_('Pocet kesi, ktere nemaji prirazen region a na mape tedy nejsou zapocteny:')
    Result:=Result+'<p>'+_('Number of caches with no associated region and not shown on the map:')
      +' '+IntToStr(iEmptyState)+'</p>';
  end;
end;