function MapGenFromTag_Run(aPar:TStringList):string;
var s,sMap,sShowValues,sShowLabels,sRegionLabels,sValueSize,sLabelSize,sTitle,
      sTag,sTagVal,sTagNad,sTagValNad,
      sCht,sChm,sChd1,sChd2,sChld,sChf,sChldEmpty,
      sSql,sSqlPom
      :string;
    ix:integer;
    nPrahaNalezene,nPrahaDostupne,
      //nBlavaNalezene,nBlavaDostupne,
      //nKosiceNalezene,nKosiceDostupne,
      nWienNalezene,nWienDostupne:integer;
    bPraha,bBlava,bKosice,bWien:boolean;
    tab:TSQLiteTable;
    aVal:TStringList;
    ini:TMemIniFile;  //pro prevod jmena oblasti na zkratku
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  s:=aPar.Values['Map'];
  sMap:=Fetch(s,'-');
  s:=aPar.Values['Data'];              sCht:=Fetch(s,'-');
  s:=aPar.Values['ShowValues'];        sShowValues:=Fetch(s,'-');
  s:=aPar.Values['ShowLabels'];        sShowLabels:=Fetch(s,'-');
  s:=aPar.Values['RegionLabels'];      sRegionLabels:=Fetch(s,'-');
  s:=aPar.Values['ValueSize'];         sValueSize:=Fetch(s,'-');
  s:=aPar.Values['LabelSize'];         sLabelSize:=Fetch(s,'-');
  s:=aPar.Values['HideNeighborhood'];
  if(UpperCase(s)<>'YES') then sChf:=''
  else sChf:='&chf=bg,s,%ColorMainBkg%';
  sChm:=sShowValues+','+sShowLabels+','+sRegionLabels+','+sValueSize+','+sLabelSize;
  sTitle:=aPar.Values['Title'];
  //podle typu mapy zjistime tag
  sTag:='';
  sTagVal:='';
  sTagNad:='';    //nadradrazeny tag pro identifikaci mestskych casti
  sTagValNad:=''; //hodnota nadradrazeneho tagu pro identifikaci mestskych casti
  CalcRegionTagSupport_TagFromMap(sMap,false,sTag,sTagVal,sTagNad,sTagValNad);
  if(sTag='') then exit;
  //otevreme ini soubor pro prevod jmena oblasti na zkratku
  ini:=TMemIniFile.Create(GetModulesDir()+'MapGenFromTag.Abbrev.ini');
  try
    aVal:=TStringList.Create();
    try
      ini.ReadSectionValues(sMap,aVal);
      if(aVal.Count>0) then begin
        sChldEmpty:=aVal[0];
        Fetch(sChldEmpty,'=');
      end;
    finally
      aVal.Free();
    end;
    //zjistime hodnoty pro mapku
    if(sTagVal<>'') then begin
      Geoget_DB.AddParamText(':TagVal',sTagVal);
      sSqlPom:='   AND gtv.value like :TagVal';
    end;
    if(sTagNad<>'') and (sTagValNad<>'') then begin
      Geoget_DB.AddParamText(':TagCatNad',sTagNad);
      Geoget_DB.AddParamText(':TagValNad',sTagValNad);
      sSqlPom:='   AND gt.id IN ('+CRLF
              +'   SELECT gc.id'+CRLF
              +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
              +'     WHERE gc.id=gt.id'+CRLF
              +'       AND gtc.key=gt.ptrkat and gtc.value=:TagCatNad and gtv.key=gt.ptrvalue'+CRLF
              +'       AND gtv.value LIKE :TagValNad'+CRLF
              +'   )'
              +CRLF;
    end;
    Geoget_DB.AddParamText(':Prefix',sCachePrefix+'%');
    Geoget_DB.AddParamText(':TagCat',sTag);
    sSql:='SELECT A.pocet Dostupne,B.pocet Nalezene, A.Jmeno, 100*B.pocet/A.pocet Procent from'+CRLF
        // dostupne nebo nalezene kese s danym prefixem ('GC'/'OC'/'WM'/...) se
        // zadanou kategorii tagu
        +' (SELECT count(gtv.value) as pocet,gtv.value as Jmeno'+CRLF
          +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
          +' WHERE '+sCachePrefixForSql+SetSqlFilter(aPar)+CRLF
          +'   AND gt.id=gc.id'+CRLF
          +'   AND (gc.cachestatus<2 or gc.dtfound>0)'+CRLF
          +'   AND gtc.key=gt.ptrkat and gtc.value=:TagCat and gtv.key=gt.ptrvalue'+CRLF
          + sSqlPom+CRLF      //pokud je treba, doplnime jeste hodnotu tagu
          +' group by gtv.value COLLATE NOCASE'+CRLF //seskupime podle podle hodnoty tagu
          +' order by gtv.value COLLATE NOCASE'+CRLF
        +') A'+CRLF
        +','+CRLF
        // pocet nalezenych kesi se zadanym prefixem ('GC'/'OC'/'WM'/...)
        // a se zadanou kategorii tagu
        +'(select count(gtv.value) as pocet,gtv.value as Jmeno' +CRLF
          +' from geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
          +' where gc.dtfound>0 AND '+sCachePrefixForSql+SetSqlFilter(aPar)+CRLF
          +'   AND gt.id=gc.id'+CRLF
          +'   and gc.id like :Prefix'+CRLF
          +'   and gtc.key=gt.ptrkat and gtc.value=:TagCat and gtv.key=gt.ptrvalue'+CRLF
          +sSqlPom+CRLF
          +' group by gtv.value COLLATE NOCASE'+CRLF
          +' order by gtv.value COLLATE NOCASE'+CRLF
        +') B' +CRLF
      +' where A.Jmeno=B.Jmeno'+CRLF
      +' order by Nalezene'+CRLF
      ;
    //Log('SQL='+sSql);
    nPrahaNalezene:=0; nPrahaDostupne:=0;
    tab:=Geoget_DB.GetTable(sSql,false);
    try
      ix:=0;
      while (not tab.eof) and (ix<1) do begin
        //Inc(ix);  //pro ladeni a hledani chybneho zaznamu
        //protoze ne vsechny znaky z jinych statu jdou prevest na ANSI, prevedeme je na ASCII
        s:=UtfToAscii(tab.FieldAsString(2));
        if(s<>'') and (s<>'-') then begin //pokud tag existuje a ma smysluplnou hodnotu
          //pro okresy Praha 1 az Praha 10 pocitame soucet a pak vysledek jako
          //pro samostatnou Prahu
          bPraha:=false;   bBlava:=false;   bKosice:=false;    bWien:=false;
          if(sMap='CZokres') then begin
            //Log('HHHHH 1 s='+s+', Dostupne='+tab.FieldAsString(0)+', Nalezene='+tab.FieldAsString(1));
            if(RegexFind('(?i)^Praha [0-9]{1,2}$',s)) then begin
              nPrahaNalezene:=nPrahaNalezene+tab.FieldAsInteger(1);
              nPrahaDostupne:=nPrahaDostupne+tab.FieldAsInteger(0);
              //Log('HHHHH 2 s='+s+', Dostupne='+IntToStr(nPrahaDostupne)+', Nalezene='+IntToStr(nPrahaNalezene));
              bPraha:=true;
            end;
          end;
          { pro mapgen 4.4 neni potreba, kraje jsou rozdelene
          if(sMap='SKokres') then begin
            //Log('HHHHH s='+s+', Dostupne='+tab.FieldAsString(0)+', Nalezene='+tab.FieldAsString(1));
            if(s='Kosice I') or (s='Kosice II') or (s='Kosice III') or (s='Kosice IV') then begin
              nKosiceNalezene:=nKosiceNalezene+tab.FieldAsInteger(1);
              nKosiceDostupne:=nKosiceDostupne+tab.FieldAsInteger(0);
              //Log('HHHHH s='+s+', Dostupne='+IntToStr(nPrahaDostupne)+', Nalezene='+IntToStr(nPrahaNalezene));
              bKosice:=true;
            end;
            if(s='Bratislava I') or (s='Bratislava II') or (s='Bratislava III') or (s='Bratislava IV') or (s='Bratislava V') then begin
              nBlavaNalezene:=nBlavaNalezene+tab.FieldAsInteger(1);
              nBlavaDostupne:=nBlavaDostupne+tab.FieldAsInteger(0);
              //Log('HHHHH s='+s+', Dostupne='+IntToStr(nPrahaDostupne)+', Nalezene='+IntToStr(nPrahaNalezene));
              bBlava:=true;
            end;
          end;
          }

          if(sMap='ATokres') then begin
            //Log('HHHHH s='+s+', Dostupne='+tab.FieldAsString(0)+', Nalezene='+tab.FieldAsString(1));
            if(s='Wien-Umgebung-Gerasdorf') or (s='Wien-Umgebung-KlosterNeuburg') then begin
              nWienNalezene:=nWienNalezene+tab.FieldAsInteger(1);
              nWienDostupne:=nWienDostupne+tab.FieldAsInteger(0);
              bWien:=true;
            end;
          end;
          //prevedeme na zkratku vse ostatni nez okres Praha
          if(not bPraha) {and (not bBlava) and (not bKosice)} and (not bWien) then begin
            sTitle:=ini.ReadString(sMap,s,'??');
            if(sTitle='??') then begin
              sTitle:='tag:'+sTag;
              //if(sTagVal='') and (sTagValNad='') then sTitle:='tag:'+sTag
              //else begin
              //  if(sTag='') then sTitle:='tag1:'+sTag+' + tag2:'+sTagNad+'='+UtfToAnsi(sTagValNad)
              //  else sTitle:='tag:'+sTag+' like '+UtfToAnsi(sTagVal);
              //end;
              //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
              //AddError(_('ERR: unknown abbreviation for')+' "'+s+'" ('+sTitle+', '+_('map')+': '+sMap+')');
              Log(_('ERR: unknown abbreviation for')+' "'+s+'" ('+sTitle+', '+_('map')+': '+sMap+')');
            end
            else begin
              if(sChd1<>'') then begin
                sChd1:=sChd1+',';
                sChd2:=sChd2+',';
              end;
              sChd1:=sChd1+tab.FieldAsString(1);
              sChd2:=sChd2+tab.FieldAsString(3);
              sChld:=sChld+sTitle;
            end;
          end;
          //Log('sMap='+sMap+', s='+s+' (zkratka '+ini.ReadString(sMap,s,'??')+'), Dostupne='+tab.FieldAsString(0)+', Nalezene='+tab.FieldAsString(1)+', Procent='+tab.FieldAsString(3));
          //Log('sChld='+sChld+', sChd1='+sChd1);
        end;
        tab.Next();
      end;
    finally
      if(tab<>nil) then tab.Free();
    end;
    //pokud je treba, doplnime soucty za celou Prahu
    if(sMap='CZokres') then begin
      if(sChd1<>'') and (nPrahaDostupne>0) then begin
        sChd1:=sChd1+',';
        sChd2:=sChd2+',';
      end;
      if(nPrahaDostupne>0) then begin
        sChd1:=sChd1+IntToStr(nPrahaNalezene);
        sChd2:=sChd2+IntToStr(100*nPrahaNalezene/nPrahaDostupne);
        sChld:=sChld+'AP'; //zkratka pro Hlavni mesto Praha
      end;
      //Log('Po Praha: sChld='+sChld+', sChd1='+sChd1);
    end;
    if(sMap='SKokres') then begin
      { pro mapgen 4.4 jiz neni potreba, okresy jsou na mape oddelne
      if(nBlavaDostupne>0) then begin
        if(sChd1<>'') then begin
          sChd1:=sChd1+',';
          sChd2:=sChd2+',';
        end;
        sChd1:=sChd1+IntToStr(nBlavaNalezene);
        sChd2:=sChd2+IntToStr(100*nBlavaNalezene/nBlavaDostupne);
        sChld:=sChld+'BA'; //zkratka pro Bratislavu jako celek
      end;
      if(nKosiceDostupne>0) then begin
        if(sChd1<>'') then begin
          sChd1:=sChd1+',';
          sChd2:=sChd2+',';
        end;
        sChd1:=sChd1+IntToStr(nKosiceNalezene);
        sChd2:=sChd2+IntToStr(100*nKosiceDostupne/nKosiceDostupne);
        sChld:=sChld+'KO'; //zkratka pro Kosice jako celek
      end;
      }
    end;
    if(sMap='ATokres') then begin
      if(sChd1<>'') and (nWienDostupne>0) then begin
        sChd1:=sChd1+',';
        sChd2:=sChd2+',';
      end;
      if(nWienDostupne>0) then begin
        sChd1:=sChd1+IntToStr(nWienNalezene);
        sChd2:=sChd2+IntToStr(100*nWienNalezene/nWienDostupne);
        sChld:=sChld+'AP'; //zkratka pro Hlavni mesto Praha
      end;
    end;
  finally
    if(ini<>nil) then ini.Free();
  end;
  //kontrola hodnot a pripadne varovani pri nesmyslech
  if(iWidth<300) then begin
    Log(_('WARN: The width of the map is less than the minimum will be adjusted to 300.'));
  end;
  if(iWidth<400) and (Pos('None,None',sChm)<1) then begin
    Log(_('WARN: The map is too small, the text on it probably will not be displayed.'));
  end;
  if(sModuleError<>'') then Log(sModuleError);

  s:=CONST_MAPGEN_URL+'mapgen.php?'
    +'cht=t,'+sCht
    +'&chm='+sChm
    +'&chs=wx'+IntToStr(iWidth)
    +'&chtm='+sMap
    +sChf
    +'&chco=%ColorMapRegionDNF%,%ColorMapMinBkg%,%ColorMapAvgBkg%,%ColorMapMaxBkg%';
  //barvy podle potreby, pokud sLabels obsahuje carku, predavame 2 barvy
  if(sShowValues='Finds') then s:=s+',%ColorMapCountText%';
  if(sShowValues='Perc') then s:=s+',%ColorMapPercentText%';
  if(sShowValues='FindsPerc') then s:=s+',%ColorMapCountText%,%ColorMapPercentText%';
  if(sShowLabels<>'None') then s:=s+',%ColorMapAbbrevText%';
  //datove sady podle potreby
  if(sCht='Finds') then s:=s+'&chd='+sChd1;
  if(sCht='Perc') then s:=s+'&chd='+sChd2;
  //Log('OOOOO sCht='+sCht+CRLF+'OOOOO sChd1='+sChd1+CRLF+'OOOOO sChd2='+sChd2);
  if(sCht='FindsPerc') then s:=s+'&chd='+sChd1+'|'+sChd2;
  s:=s+'&chld='+sChld;
  Result:=Result
    +'<a href="'+ReplaceString(s,'=wx'+IntToStr(iWidth),'=wx9999')+'" '
    //takto definovany kurzor chodi jen v Chromu
    //+'target="_blank" style="cursor:url('+sUrlMapgen+'images/Lupa2.png), -webkit-zoom-in;">'
    //takto definovany chodi v Chromu i FireFoxu
    +'target="_blank" style="cursor:url('+CONST_MAPGEN_URL+'images/Lupa2.png) 7 7, auto;">'
    +'<img src="'+s+'" /></a>'+CRLF;
end;