function MapGenSwitchCountries_MapName(sMainModule:string;idxMap:integer):string;
begin
  Result:=sMainModule+'_Map'+IntToStr(idxMap/3);
end;

function MapGenSwitchCountries_Run(aPar:TStringList):string;
var s,sDiv,sMap,sMaps,sIdElemOld,sSql,sCountry,sOrder:string;
    i,j,k:integer;
    tab:TSqliteTable;
    aMapsState,aMapsTag,aList,aPom:TStringList;
    ini:TMemIniFile;

begin
  Result:='';
  if(aPar.Values['Title']<>'') then Output(ProcessCommand('CmdTitle',aPar));
  s:=aPar.Values['IncludeMaps'];
  sMap:=Fetch(s,'-');
  s:=aPar.Values['SortBy'];
  sOrder:=Fetch(s,'-');
  if(sOrder='Finds') then sOrder:=sOrder+' DESC, Country';

  aList:=TStringList.Create();
  aMapsState:=TStringList.Create();
  aMapsTag:=TStringList.Create();
  //zjistime seznam map, ktere umi MapGenFromState
  s:=ParamValueFromIni('MapGenFromState','Map','Values','');
  aMapsState.Text:=ReplaceString(s,'|',CRLF);
  //Log('UUUUU 1 pocet statu modulu State: '+IntToStr(aMapsState.Count)+', '+ReplaceString(aMapsState.Text,CRLF,','));

  //zjistime seznam map, ktere umi MapGenFromTag, nechame jen jmeno mapy
  s:=ParamValueFromIni('MapGenFromTag','Map','Values','');
  aMapsTag.Text:=ReplaceString(s,'|',CRLF);
  j:=aMapsTag.Count-1;
  for i:=j downto 0 do begin
    s:=aMapsTag[i];
    aMapsTag[i]:=Fetch(s,'-');
    if(aMapsTag[i]='') then aMapsTag.Delete(i);
  end;
  //Log('UUUUU 2 pocet statu modulu Tag: '+IntToStr(aMapsTag.Count)+', '+ReplaceString(aMapsTag.Text,CRLF,','));

  //podle pozadovane mapy naplnime seznam moznych statu z prislusneho INI souboru
  s:=GetModulesDir()+'MapGenFromCountry.Abbrev.ini';
  ini:=TMemIniFile.Create(s);
  try
    if(sMap='All') then s:='World' else s:='Europe';
    ini.ReadSectionValues(s,aList);
  finally
    ini.Free();
  end;
  //ze jmen odstranime diakritiku a zkratku
  for i:=0 to aList.Count-1 do begin
    //s:=UtfToAscii(AnsiToUtf(aMapsState[i]));
    s:=aList[i];
    aList[i]:=Fetch(s,'=');
  end;
  //Log('UUUUU 3 pocet statu kontinentu: '+IntToStr(aList.Count)+', '+ReplaceString(aList.Text,CRLF,','));
  //udelame prunik obou seznamu (mapa musi byt na spravnem kontinentu a musi ji modul umet)
  j:=aMapsState.Count-1;
  for i:=j downto 0 do begin
    if(aList.IndexOf(aMapsState[i])<0) then begin
      //Log('UUU '+aMapsState[i]+' neni mezi staty kontinentu');
      aMapsState.Delete(i);
    end;
  end;
  //Log('UUUUU 4 pocet statu v obou seznamech (Country/State): '+IntToStr(aMapsState.Count)+', '+aMapsState.Text);
  //-------------------------------
  //pripravime seznam statu, pro ktere muzeme mit otagovane kraje
  if(UpperCase(aPar.Values['UseTags'])<>'NO') then begin
    s:=GetModulesDir()+'MapGenFromCountry.Abbrev.ini';
    ini:=TMemIniFile.Create(s);
    try
      if(sMap='All') then s:='World' else s:='Europe';
      ini.ReadSectionValues(s,aList);
    finally
      ini.Free();
    end;
    //Log('UUUUU 5 pocet statu kontinentu ('+s+'): '+IntToStr(aList.Count));
    //ke zkratce pridame 'kraj' (mapy jou XXkraj) a na miste '=' polozku rozdelime na 2
    aList.Text:=ReplaceString(ReplaceString(Trim(aList.Text),CRLF,'kraj'+CRLF),'=',CRLF);
    //Log('UUUUU 5a pocet statu/mapa kontinentu ('+s+'): '+IntToStr(aList.Count));
    j:=aMapsTag.Count-1;
    for i:=j downto 0 do begin
      k:=aList.IndexOf(aMapsTag[i]);
      if(k<0) then begin
        //Log('UUU '+aMapsTag[i]+' neni mezi staty kontinentu');
        aMapsTag.Delete(i);
      end
      else aMapsTag[i]:=aMapsTag[i]+'|'+aList[k-1]; //pridame jmeno statu
    end;
    //Log('UUUUU 6 pocet statu v obou seznamech (Country/Tag): '+IntToStr(aMapsTag.Count/2)+', '+aMapsTag.Text);
    aList.Free();
    //jmeno statu oddelime na druhy radek seznamu
    aMapsTag.Text:=ReplaceString(aMapsTag.Text,'|',CRLF);
  end;
  // sestaven seznamu map
  sMaps:='';
  Geoget_DB.AddParamText(':Prefix',sCachePrefix+'%');
  sSql:='SELECT Country, count(*) Finds FROM geocache gc'
       +'  WHERE id like :Prefix'
       +'    AND dtfound>0'
       +SetSqlFilter(aPar)
       +'  GROUP BY Country'
       +'  ORDER BY '+sOrder;
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      sCountry:=tab.FieldByName['Country'];
      //zjistime, zda je stat mezi tagy a pokud ano, pouzijeme prislusny modul a mapu
      //do pole sMaps skladame ID mapy, jmeno statu pro zobrazeni a jmeno modulu
      k:=aMapsTag.IndexOf(sCountry);
      if(k>0) then begin
        sMaps:=sMaps+aMapsTag[k-1]+','+sCountry+',MapGenFromTag,';
      end
      else if(aMapsState.IndexOf(sCountry)>=0) then begin
        sMaps:=sMaps+sCountry+','+sCountry+',MapGenFromState,';
      end;
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  //parsujeme parametry jednotlivych map a modulu, ktere ji kresli
  aMapsState.Text:=ReplaceString(sMaps,',',CRLF);
  i:=aMapsState.Count;
  //Log('UUUUU aMapsState: '+aMapsState.CommaText);
  //vygenerujeme prepinaci tlacitka
  sIdElemOld:=GlobalVarGet('IdElement',false);
  //vygenerujeme div s tlacitky pro kazdou mapu, prvni je zobrazena
  //pripravime pole pro funkci k vytvoreni tlacitek
  aPom:=TStringList.Create();
  try
    for j:=0 to aMapsState.Count-1 do begin
      s:=aMapsState[j+1];
      s:='<img src="%IconCountry'+s+'%" />&nbsp;'+s;
      aPom.Add(s); //text na tlacitko
      aPom.Add('i'+MapGenSwitchCountries_MapName(sIdElemOld,j)); //prepinany element
      Inc(j);                  //preskocit zobrazovane jmeno statu
      Inc(j);                  //preskocit jmeno modulu, ktery mapu kresli
    end;
    Output(OutputSwitchButtons(sIdElemOld,aPar.Values['SwitchType'],5,true,aPom));
  finally
    aPom.Free();
  end;
  sDiv:='';
  aPar.Values['Title']:='';
  for j:=0 to aMapsState.Count-1 do begin
    if(aMapsState[j]='') then continue;
    aPar.Values['Map']:=aMapsState[j]; //jmeno mapy
    GlobalVarSet('IdElement',MapGenSwitchCountries_MapName(sIdElemOld,j)); //nove jmeno modulu
    //vytvorime identifikaci volaneho modulu
    sDiv:='<div id="i'+MapGenSwitchCountries_MapName(sIdElemOld,j)+'"';
    if(j=0) then sDiv:=sDiv+' style=""'
    else sDiv:=sDiv+' style="display:none;"';
    sDiv:=sDiv+'>'+CRLF;
    Output(sDiv);
    //najdeme a zavolame funkci pro generovani mapy
    for k:=0 to MAX_MODULES do begin
      if(k=MAX_MODULES) then begin
        //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
        //AddError(_('ERR: unknown module for')+' '+aMapsState[j]);
        Log(_('ERR: unknown module for')+' '+aMapsState[j]);
        break;
      end;
      if(aFce[k]=nil) then continue;
      //Log('HHHHH j='+IntToStr(j)+', k='+IntToStr(k)+', '+aModuleName[k]+' ? '+aMapsState[j+1]);
      if(aModuleName[k]=aMapsState[j+2]) then begin
        //Log('-- spoustim modul '+IntToStr(j)+'/'+IntToStr(aMapsState.Count)+': '+aMapsState[j+1]+' ('+aMapsState[j]+')');
        Output(aFce[k](aPar));
        break;
      end;
    end;
    Output('</div>'+CRLF+CRLF);
    Inc(j); //preskocit zobrazovane jmeno statu
    Inc(j); //ukazujeme na jmeno funkce modulu
  end;
  aMapsState.Free();
  aMapsTag.Free();
  GlobalVarSet('IdElement',sIdElemOld);
end;