function MapGenSwitchRegions_MapName(sMainModule:string;idxMap:integer):string;
begin
  Result:=sMainModule+'_Map'+IntToStr(idxMap/2);
end;

function MapGenSwitchRegions_Run(aPar:TStringList):string;
var s,sDiv,sMap,sMaps,sIdElemOld,sLabels:string;
    i,j,k:integer;
    aMaps:Array of string;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Output(ProcessCommand('CmdTitle',aPar));
  s:=aPar.Values['Map'];
  sMap:=Fetch(s,'-');

  //definice generovanych map a modulu, ktere je generuji
  sMaps:='';
  case sMap of
  'CZ kraj/okres': begin sMaps:='CZkraj,MapGenFromTag | CZokres, MapGenFromTag';  sLabels:=_('State|County'); end;
  'SK kraj/okres': begin sMaps:='SKkraj,MapGenFromTag | SKokres, MapGenFromTag';  sLabels:=_('State|County'); end;
  'AT kraj/okres': begin sMaps:='ATkraj,MapGenFromTag | ATokres, MapGenFromTag';  sLabels:=_('Land|County'); end;
  end;
  if(sMaps='') then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('ERR: unknown type of map:')+' '+sMap);
    Log(_('ERR: unknown type of map:')+' '+sMap);
    exit;
  end;
  //parsujeme parametry jednotlivych map
  i:=0;
  while (sMaps<>'') do begin
    SetLength(aMaps,i+2);
    s:=Fetch(sMaps,'|');            //zjistime mapu a jeji modul
    aMaps[i]:=Fetch(s,',');         //jmeno mapy
    aMaps[i+1]:=Trim(s);     //funkce, ktera ji vygeneruje
    i:=i+2;
  end;
  //vygenerujeme prepinaci tlacitka
  sIdElemOld:=GlobalVarGet('IdElement',false);
  //vygenerujeme div s tlacitky pro kazdou mapu, prvni je zobrazena
  //text na tlacitka je v sLabels
  sDiv:='<div style="text-align:center; margin:15px;">'+CRLF;
  for j:=0 to i-1 do begin
    //----- zobrazeni jako Button
    //sDiv:=sDiv+'<button id="b'+MapGenSwitchRegions_MapName(sIdElemOld,j)+'" style="cursor:pointer; margin:2px 2px 5px 2px; font-weight:';
    //if(j=0)then sDiv:=sDiv+'bold;' else sDiv:=sDiv+'normal;';
    //sDiv:=sDiv+';" onclick="';
    //----- zobrazeni jako Radiobutton
    sDiv:=sDiv+'<span style="white-space:nowrap;"><input type="radio" id="iSwitch'+MapGenSwitchRegions_MapName(sIdElemOld,j)+'"'
      +' name="switch'+sIdElemOld+'"'
      ;
    if(j=0) then sDiv:=sDiv+' checked';
    sDiv:=sDiv+' onclick="'+CRLF;
    //if j=0 then sDiv:=sDiv+'color:'+COLOR_BUT_ACTIVE_TXT else sDiv:=sDiv+'color:'+COLOR_BUT_INACTIVE_TXT;
    for k:=0 to i-1 do begin
      //nastavime barvu tlacitka
      //zobrazime zobrazeni divu s mapou div
      if(k=j) then  
        sDiv:=sDiv+'document.getElementById(''i'+MapGenSwitchRegions_MapName(sIdElemOld,k)+''').style.display=''block''; '+CRLF
                  //jen pro Button
                  //+'document.getElementById(''b'+MapGenSwitchRegions_MapName(sIdElemOld,k)+''').style.fontWeight=''bold''; '
      else
        sDiv:=sDiv+'document.getElementById(''i'+MapGenSwitchRegions_MapName(sIdElemOld,k)+''').style.display=''none''; '+CRLF
                  //jen pro Button
                  //+'document.getElementById(''b'+MapGenSwitchRegions_MapName(sIdElemOld,k)+''').style.fontWeight=''normal''; '
      ;
      Inc(k);
    end;
    s:=Fetch(sLabels,'|');
    //pro Button
    //sDiv:=sDiv+' return false;">'+s+'</button>'+CRLF;
    //pro Radiobutton
    sDiv:=sDiv+'" />'+s+'</span>'+CRLF;
    Inc(j);
  end;
  //Output(CRLF+sDiv+'</form></div>'+CRLF);
  Output(CRLF+sDiv+'</div>'+CRLF);
  sDiv:='';
  aPar.Values['Title']:='';
  for j:=0 to i-1 do begin
    aPar.Values['Map']:=aMaps[j]; //jmeno mapy
    GlobalVarSet('IdElement',MapGenSwitchRegions_MapName(sIdElemOld,j)); //nove jmeno modulu
    //vytvorime identifikaci volaneho modulu
    sDiv:='<div id="i'+MapGenSwitchRegions_MapName(sIdElemOld,j)+'"';
    if(j=0) then sDiv:=sDiv+' style=""'
    else sDiv:=sDiv+' style="display:none;"';
    sDiv:=sDiv+'>'+CRLF;
    Output(sDiv);
    Inc(j); //ukazujeme na jmeno funkce modulu
    //najdeme a zavolame funkci pro generovani mapy
    for k:=0 to MAX_MODULES do begin
      if(k=MAX_MODULES) then begin
        //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
        //AddError(_('ERR: unknown module for')+' '+aMaps[j]);
        Log(_('ERR: unknown module for')+' '+aMaps[j]);
        break;
      end;
      if(aFce[k]=nil) then continue;
      if(aModuleName[k]=aMaps[j]) then begin
        Log('-- Spoustim modul: '+aMaps[j]+', aPar: '+ReplaceString(aPar.Text,CRLF,', '));
        Output(aFce[k](aPar));
        break;
      end;
    end;
    Output(CRLF+'</div>'+CRLF);
  end;
  GlobalVarSet('IdElement',sIdElemOld);
  SetLength(aMaps,0);
end;