// nejsevernejsi, nejjiznejsi, nejzapadnejsi, nejvyssi a nejnizsi kes ve state

function MarginalCachesInCountry_AddDoubleRow(sLabel,sValue,sComment:string):string;
begin
  Result:='<tr style="%StyleTableNumTr%">'
    +'<td style="%StyleTableNumLabelTd%">'+sLabel+'&nbsp;</td>'
    +'<td style="%StyleTableNumTd%">'+sValue+'</td>'
    +'<td style="%StyleTableNumTd%">'+sComment+'</td></tr>'+CRLF;
end;

function MarginalCachesInCountry_Output(aPar:TStringList):string;
var 
  s,ss,sCountry,sStyle,sChm,sMarkers,sSql,sL,sV,sC,sBorder,sScale,sUrl:string;
  iMapWidth,iMapHeight:integer;
  tab: TSqliteTable;
  ini:TMemIniFile;
begin
  sCountry:=aPar.Values['Country'];
  // tabulka s kesemi
  Result:='<table style="%StyleTableNum%">'+CRLF
      +'<tr style="%StyleTableNumTr%"><th colspan=3 style="%StyleTableNumTh%">'
      +_('Most northerly, southerly, ... cache in')
      +' <img src="%IconCountry'+sCountry+'%" />&nbsp;'+sCountry
      +'</th></tr>'+CRLF;
      
  //Nejsevernejsi kes
  sL:=_('Most northerly cache');
  sSql:='SELECT max(0+gc.x) coordx, gc.y coordy, gc.id cacheid FROM'
    +' geocache gc WHERE gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +' AND gc.country="'+sCountry+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    sV:='<b>'+Fetch(s,' ')+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:blue|label:N|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInCountry_AddDoubleRow(sL,sV,sC);

  //Nejjiznejsi kes
  sL:=_('Most southerly cache');
  sSql:='SELECT min(0+gc.x) coordx, gc.y coordy, gc.id cacheid FROM'
    +' geocache gc WHERE gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +' AND gc.country="'+sCountry+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    sV:='<b>'+Fetch(s,' ')+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:blue|label:S|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInCountry_AddDoubleRow(sL,sV,sC);

  //Nejzapadnejsi kes
  sL:=_('Most westerly cache');
  sSql:='SELECT min(0+gc.y) coordy, gc.x coordx, gc.id cacheid FROM'
    +' geocache gc WHERE gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +' AND gc.country="'+sCountry+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    ss:=Fetch(s,' ');
    sV:='<b>'+s+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:blue|label:W|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInCountry_AddDoubleRow(sL,sV,sC);

  //Nejvychodnejsi kes
  sL:=_('Most easterly cache');
  sSql:='SELECT max(0+gc.y) coordy, gc.x coordx, gc.id cacheid FROM'
    +' geocache gc WHERE gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +' AND gc.country="'+sCountry+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    ss:=Fetch(s,' ');
    sV:='<b>'+s+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:blue|label:E|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInCountry_AddDoubleRow(sL,sV,sC);

  //Nejvyssi kes nad morem
  sL:=_('Highest cache');
  sSql:='SELECT max(0.+gtv.value) mx, gc.y coordy, gc.x coordx, gt.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.country="'+sCountry+'" '+SetSqlFilter(aPar)
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''Elevation'' AND gtv.key=gt.ptrvalue';
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id NOT IN ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    sV:='<b>'+InsertThousSep(tab.FieldByName['mx'])+'</b>&nbsp;'+_('m a.s.l.');
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:yellow|label:H|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInCountry_AddDoubleRow(sL,sV,sC);

  //Nejnizsi kes nad morem
  sL:=_('Lowest cache');
  sSql:='SELECT min(0.+gtv.value) mx, gc.y coordy, gc.x coordx, gt.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.country="'+sCountry+'" '+SetSqlFilter(aPar)
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''Elevation'' AND gtv.key=gt.ptrvalue';
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id NOT IN ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    sV:='<b>'+InsertThousSep(tab.FieldByName['mx'])+'</b>&nbsp;'+_('m a.s.l.');
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:yellow|label:L|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInCountry_AddDoubleRow(sL,sV,sC);

  // konec tabulky
  Result:=Result+CRLF+'</table>'+CRLF;

  if(aPar.Values['ShowMap']<>'Yes') then exit;
  
  // mapa
  if aPar.Values['Border']='Yes' then 
    sBorder:='border:1px solid #7B7B7B'
  else
    sBorder:='border:1px solid #'+GlobalVarGetColor('ColorMainBkg','FFFFFF');
  s:=aPar.Values['MapStyle']; 
  sStyle:=Fetch(s,'-');
  ini:=TMemIniFile.Create(GetModulesDir()+'MapPinboard.Style.ini');
  try
    sChm:=ini.ReadString(sStyle,'Style',sStyle);
  finally
    ini.Free();
  end;

  iMapWidth:=iWidth-2;         //misto na ramecek
  iMapHeight:=round(480.0*iMapWidth/640);
  if iMapWidth>640 then sScale:='2' else sScale:='1';

  sUrl:='size=640x480&scale='+sScale+sChm+sMarkers;
  sUrl:=CONST_MAPGEN_URL+'mapgen.php?cht=t,MapRed&chm='+EncodeBase64(sUrl);
  Result:=Result
      +'<div style="margin-top:10px; line-height:0; '+sBorder+'">'
      +'<img width="'+IntToStr(iMapWidth)+'" height="'+IntToStr(iMapHeight)+'" '
      +'src="'+sUrl+'" ></div>';
end;

// hlavni funkce modulu
function MarginalCachesInCountry_Run(aPar:TStringList):string;
var 
  s,sCountry,sSql,sOrder:string;
  i:integer;
  aCountries,aPom:TStringList;
  tab: TSqliteTable;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);

  s:=aPar.Values['SortBy']; sOrder:=Fetch(s,'-');
  if(sOrder='Finds') then sOrder:=sOrder+' DESC, Country';

  s:=aPar.Values['Country']; sCountry:=Fetch(s,'-');
  if (sCountry='All') or (sCountry='Switch') then begin
    // pripravime seznam zemi
    aCountries:=TStringList.Create();
    sSql:='SELECT Country, count(*) Finds FROM geocache gc'
        +' WHERE gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES+SetSqlFilter(aPar);
    if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
    sSql:=sSql+' GROUP BY Country ORDER BY '+sOrder;
    tab:=Geoget_DB.GetTable(sSql,false);
    try
      while not tab.eof do begin
        aCountries.Add(tab.FieldByName['Country']);
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    // prepinaci logika
    if sCountry='Switch' then begin
      aPom:=TStringList.Create();
      try
        for i:=0 to aCountries.Count-1 do begin
          s:=aCountries[i];
          s:='<img src="%IconCountry'+s+'%" />&nbsp;'+s;
          aPom.Add(s); //text na tlacitko
          aPom.Add('i-'+IntToStr(iItem)+'-'+IntToStr(i)); //prepinany element
        end;  
        Result:=Result+OutputSwitchButtons(IntToStr(iItem),aPar.Values['SwitchType'],5,true,aPom);
      finally
        aPom.Free();
      end;
    end;
    // vystup pro vsechny zeme
    for i:=0 to aCountries.Count-1 do begin
      if sCountry='Switch' then begin
        Result:=Result+'<div id="i-'+IntToStr(iItem)+'-'+IntToStr(i)+'"';
        if i<>0 then Result:=Result+' style="display:none;"';
        Result:=Result+'>';
      end;
      aPar.Values['Country']:=aCountries[i];
      Result:=Result+MarginalCachesInCountry_Output(aPar);  
      if sCountry='Switch' then Result:=Result+'</div>';
      if sCountry='All' then Result:=Result+'<div style="margin-bottom:25px"></div>';  
    end;
    aCountries.Free();
  end else begin
    Result:=Result+MarginalCachesInCountry_Output(aPar);  
  end;
end;