//modul pro generovani statistiky vlastnich kesi.
//vytvoreno podle pluginu MyOwnStat (autor DrakMrak)
type MyOwnMinistat_TCacheData = Record //---------------------------------------------
  sID        : String;      //ID cache - GC....
  dCreate    : TDateTime;   //datum vytvoreni
  dArchive   : TDateTime;   //datum archivace (-1 = neni do ted)
  sGuid      : String;      //guid
  sType      : String;      //typ kese
  bEvent     : Boolean;     //priznak, zda jde o event
  sName      : String;      //jmeno kese
  sOwnerID   : String;      //ID autora kese
  bArchived  : Boolean;     //archivovana  (neni to duplikovani? dArchive a iStatus to obsahuji taky)
  iStatus    : Integer;     //stav kese
  sDifficult : String;      //difficulty
  sTerrain   : String;      //terrain
  sSize      : String;      //size
  sElevation : String;      //elevation
  sFoundIt   : String;      //found it / attended
  //dopocitane ------------------------------------------------------
  dPublic    : TDateTime;   //datum publikacniho logu
  dLastFound : TDateTime;   //datum posledniho nalezu
  nExistDays : Integer;     //delka existence cache ve dnech
  nLogs      : Integer;     //pocet logu celkem
  nFoundIt   : Integer;     //pocet nalezu
  nDNF       : Integer;     //pocet nenalezenych
  nWillAttend: Integer;     //pocet prihlasek na event
  sFTF       : String;      //FTFkari
  sSTF       : String;      //STFkari
  sTTF       : String;      //TTFkari
  //Favorite points--------------------------------------------------
  nFP        : integer;     //pocet FP
  //GCVote-----------------------------------------------------------
  nGcVoteCount : integer;
  fGcVoteMedian: Extended;
  //logy-------------------------------------------------------------
  nWordsTotal: integer;     //celkovy pocet slov na vsech nalezovych lozich
                            //(a vsech nasledujicich WN logach pro pripad, ze
                            //se autor nevesel do dane delky textu)
  nWordsMin,nWordsMax: integer;  //nejkratsi a nejdelsi log
  sWordsMinLID,sWordsMaxLID: string; //odkaz na logy
  sWordsMinFinder,sWordsMaxFinder:string;  //a jejich autori
end; //--------------------------------------------------------------

var
  MyOwnMinistat_Param: record
      sCaches:string;     	// seznam GC kodu kesi, ktere statistika ma zpracovavat
      sCachesSQL:string;  	// totez, ale v SQL formatu pro frazi IN
  end;
  MyOwnMinistat_aCacheData:array of MyOwnMinistat_TCacheData;
  MyOwnMinistat_dGraphFrom:TDateTime; // globalni minimum data zalozeni pro skalovani osy grafu
  MyOwnMinistat_nCaches:integer;
  MyOwnMinistat_iMax:integer;    // globalni maximum nalezu pro skalovani osy grafu (jen kese, ktere nejsou Eventy)

function MyOwnMinistat_IsChar(ch:char):boolean;
begin
  Result:=( ((ch>='a') AND (ch<='z'))
           OR ((ch>='A') AND (ch<='Z'))
           OR ((ch>='0') AND (ch<='9'))
	         OR (ch='_') OR (ch='[') OR (ch=']') OR (ch='(') OR (ch=')')
           OR (ch=':') OR (ch=';') OR (ch='!') OR (ch='?') OR (ch='/')
           OR (ch='{') OR (ch='}') OR (ch='|')  OR (ch='#')OR (ch='^'));
end;
  
function MyOwnMinistat_CountWords(str:string):integer; //spocita pocet slov textu
var  i: integer;
     bChar:boolean;
begin
  Result:=0;
  bChar:=FALSE;
  for i:=1 to Length(str) do begin
    if(MyOwnMinistat_IsChar(str[i])) then begin
      if(not bChar) then begin
        Inc(Result);
        bChar:=TRUE;
      end;
    end
    else bChar:=FALSE;
  end;
end;  

procedure MyOwnMinistat_PrepareLogs;    //pripravi pocty slov z logu pro vsechny kese
var i,n:integer;
    sSql,s:string;
    tab:TSQLiteTable;
begin
  StatorBusy(_('Counting words in logs ...'));
  for i:=Low(MyOwnMinistat_aCacheData) to High(MyOwnMinistat_aCacheData) do begin
    //precteme vsechny nalezove logy pro zadanou kes
    //asi by bylo spravne pocitat vsechny logy, ne jen nalezove!!!!
    sSql:='SELECT dt, logtext, finder, gs_logid '
      +'FROM geolog WHERE id='''+MyOwnMinistat_aCacheData[i].sId+''''
      +'  AND (type=''Found it'' OR type=''Attended'' OR type=''Webcam Photo Taken'') ORDER BY dt ASC';
    tab:=GEOGET_DB.GetTable(sSql, false);
    try
      while (not tab.Eof) do begin
        s:=UtfToAnsi(zDecompress(tab.FieldAsBlobText(1)));
        n:=MyOwnMinistat_CountWords(s);
        if(n>MyOwnMinistat_aCacheData[i].nWordsMax) then begin
          MyOwnMinistat_aCacheData[i].nWordsMax:=n;
          MyOwnMinistat_aCacheData[i].sWordsMaxFinder:=UtfToAnsi(tab.FieldAsBlobText(2));
          MyOwnMinistat_aCacheData[i].sWordsMaxLID:=tab.FieldAsBlobText(3);
        end;
        if(n<MyOwnMinistat_aCacheData[i].nWordsMin) then begin
          MyOwnMinistat_aCacheData[i].nWordsMin:=n;
          MyOwnMinistat_aCacheData[i].sWordsMinFinder:=UtfToAnsi(tab.FieldAsBlobText(2));
          MyOwnMinistat_aCacheData[i].sWordsMinLID:=tab.FieldAsBlobText(3);
        end;
        MyOwnMinistat_aCacheData[i].nWordsTotal:=MyOwnMinistat_aCacheData[i].nWordsTotal+n;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    if(MyOwnMinistat_aCacheData[i].nWordsMax=0) then begin
	  Log(_('WARN: number of LogWords=0 for')+' '+MyOwnMinistat_aCacheData[i].sId
        +', '+_('start Logator plugin!'));		
      //AddError(_('WARN: number of LogWords=0 for')+' '+MyOwnMinistat_aCacheData[i].sId
      //  +', '+_('start Logator plugin!'));
    end;
    //Log('IIIIII Name='+MyOwnMinistat_aCacheData[i].sName
    //  +': suma='+IntToStr(+MyOwnMinistat_aCacheData[i].nWordsTotal)
    //  +': min='+IntToStr(+MyOwnMinistat_aCacheData[i].nWordsMin)
    //  +': max='+IntToStr(+MyOwnMinistat_aCacheData[i].nWordsMax)
    //  );
  end;
end;
  
function MyOwnMinistat_PrepareData(): integer; //vraci pocet nactenych kesi
var
  sSql:string;
  tab:TSQLiteTable;
begin
  Result:=0;
  StatorBusy(_('Preparing owned caches ...'));
  Log(_('Processing owned caches: ')+MyOwnMinistat_Param.sCaches);
  if(MyOwnMinistat_Param.sCaches='') then exit; //neni co zpracovavat
  MyOwnMinistat_dGraphFrom:=Now();
  sSql:='SELECT gc.id '                                             //%0
        //+'replace(replace(gc.name,'''',''>''),"''","") ' //nevim, proc tam mel Drak tuto nahradu
        +', name, gc.guid, gc.gs_ownerid, gc.cachetype, gc.dthidden'+CRLF //%1-%5
        +', gc.cachestatus'+CRLF                                           //%6
        +', CASE WHEN cachestatus=2 THEN '+CRLF                            //%7
        +  '(SELECT CAST(gl.dt AS integer) FROM geolog gl '+CRLF
        +    'WHERE gl.id=gc.id and gl.type=''Archive'' '+CRLF
        +  'ORDER BY CAST(gl.dt AS integer) DESC LIMIT 1)'+CRLF
        +' ELSE -1'+CRLF
        +' END enddatetime'+CRLF
        +', gc.difficulty, gc.terrain, gc.cachesize'+CRLF                 //%8-%10
        +', IFNULL((SELECT value FROM geotagvalue WHERE key=gt.ptrvalue),0) elevation'+CRLF //%11
        +', MIN(CASE WHEN ifnull(gl.dt,'''') = '''' '+CRLF              //%12
        +'   THEN (select glx.dt from geolog glx where gc.id = glx.id and glx.type = ''Found it'' order by glx.dt ASC LIMIT 1)'+CRLF
        +'   ELSE gl.dt'+CRLF
        +' END) dtpublish'+CRLF
        +', (SELECT count(*) FROM geolog glx WHERE glx.id = gc.id AND '+CRLF //%13
        +'   (glx.type=''Found it'' OR glx.type=''Attended'' OR glx.type=''Webcam Photo Taken'')) FoundIt'+CRLF
        +', (SELECT count(*) FROM geolog glx WHERE glx.id = gc.id AND '+CRLF //%14
        +'   (glx.type=''Didn''''t find it'')) DNF'+CRLF
        +', IFNULL((SELECT value FROM geotagvalue WHERE key=gtFav.ptrvalue),0) fp'+CRLF //%15
        +', IFNULL((SELECT value FROM geotagvalue WHERE key=gtFTF.ptrvalue),'''') FTF'+CRLF //%16
        +', IFNULL((SELECT value FROM geotagvalue WHERE key=gtSTF.ptrvalue),'''') STF'+CRLF //%17
        +', IFNULL((SELECT value FROM geotagvalue WHERE key=gtTTF.ptrvalue),'''') TTF'+CRLF //%18
        +', IFNULL((SELECT replace(value,''x'','''') FROM geotagvalue WHERE key=gt1.ptrvalue),0) GcVoteCount'+CRLF //%19
        +', IFNULL((SELECT value FROM geotagvalue WHERE key=gt2.ptrvalue), 0) GcVoteMedian'+CRLF    //%20
{       // Hodnoceni na geocaching.cz je zruseno, nema smysl jej tu zpracovavat
        //+', IFNULL((SELECT value FROM geotagvalue WHERE key=gt3.ptrvalue),''0x'') CZCount'+CRLF  //%21
        //+', IFNULL((SELECT value FROM geotagvalue WHERE key=gt4.ptrvalue), 0) CZValue '+CRLF;     //%22
}
        +' FROM geocache gc'+CRLF
        //pokud bude vice publikacnich logu, bude keska pridana do seznamu vicekrat!!!
        //zatim neni osetreno
        +' LEFT JOIN geolog gl ON (gc.id=gl.id and gl.type=''Publish Listing'')'+CRLF
        +' LEFT JOIN geotag gt ON (gc.id=gt.id and gt.ptrkat IN (SELECT key FROM geotagcategory WHERE value=''Elevation'' COLLATE NOCASE))'+CRLF
        +' LEFT JOIN geotag gtFav ON (gc.id=gtFav.id and gtFav.ptrkat IN (SELECT key FROM geotagcategory WHERE value=''favorites'' COLLATE NOCASE))'+CRLF
        +' LEFT JOIN geotag gt1 ON (gc.id=gt1.id and gt1.ptrkat IN (SELECT key FROM geotagcategory WHERE value=''GCvote-Count'' COLLATE NOCASE))'+CRLF
        +' LEFT JOIN geotag gt2 ON (gc.id=gt2.id and gt2.ptrkat IN (SELECT key FROM geotagcategory WHERE value=''GCvote-median'' COLLATE NOCASE))'+CRLF
{        // Hodnoceni na geocaching.cz je zruseno, nema smysl jej tu zpracovavat
        //+' LEFT JOIN geotag gt3 ON (gc.id=gt3.id and gt3.ptrkat IN (SELECT key FROM geotagcategory WHERE value=''Hodnoceni-Pocet'' COLLATE NOCASE))'
        //+' LEFT JOIN geotag gt4 ON (gc.id=gt4.id and gt4.ptrkat IN (SELECT key FROM geotagcategory WHERE value=''Hodnoceni'' COLLATE NOCASE))'
}
		//sem jeste pridame tabulku pro FTF, STF a TTF
        +' LEFT JOIN geotag gtFTF ON (gc.id=gtFTF.id and gtFTF.ptrkat IN (SELECT key FROM geotagcategory WHERE value='''+ReplaceString('OnMyCache???','???','FTF')+''' COLLATE NOCASE))'+CRLF
        +' LEFT JOIN geotag gtSTF ON (gc.id=gtSTF.id and gtSTF.ptrkat IN (SELECT key FROM geotagcategory WHERE value='''+ReplaceString('OnMyCache???','???','STF')+''' COLLATE NOCASE))'+CRLF
        +' LEFT JOIN geotag gtTTF ON (gc.id=gtTTF.id and gtTTF.ptrkat IN (SELECT key FROM geotagcategory WHERE value='''+ReplaceString('OnMyCache???','???','TTF')+''' COLLATE NOCASE))'+CRLF
        +' WHERE gc.id IN ('+MyOwnMinistat_Param.sCachesSQL+')'+CRLF
//        +' WHERE gc.id IN ('+GlobalVarGet('OwnedIDsForInPhrase',false)+')'
        +' GROUP BY gc.id'+CRLF
        +' ORDER BY dtpublish ASC'+CRLF
        ;
  //Log('WWWWW SQL='+sSql);
  tab:=GEOGET_DB.GetTable(sSql, false);
  try
    while (not tab.Eof) do begin
      SetLength(MyOwnMinistat_aCacheData,Result+1);
      MyOwnMinistat_aCacheData[Result].nWordsTotal:=0;
      MyOwnMinistat_aCacheData[Result].nWordsMin:=999999;
      MyOwnMinistat_aCacheData[Result].nWordsMax:=0;
      MyOwnMinistat_aCacheData[Result].sWordsMinLID:='';
      MyOwnMinistat_aCacheData[Result].sWordsMaxLID:='';
      MyOwnMinistat_aCacheData[Result].sWordsMinFinder:='';
      MyOwnMinistat_aCacheData[Result].sWordsMinFinder:='';
      MyOwnMinistat_aCacheData[Result].sId:=tab.FieldAsString(0);
      MyOwnMinistat_aCacheData[Result].sName:=Trim(UtfToAnsi(tab.FieldAsString(1)));
      //Log('sId='+MyOwnMinistat_aCacheData[Result].sId+', sName='+MyOwnMinistat_aCacheData[Result].sName);
      MyOwnMinistat_aCacheData[Result].sGuid:=tab.FieldAsString(2);
      MyOwnMinistat_aCacheData[Result].sOwnerID:=tab.FieldAsString(3);
      //Log('sGuid='+MyOwnMinistat_aCacheData[Result].sGuid+', sOwnerID='+MyOwnMinistat_aCacheData[Result].sOwnerID);
      MyOwnMinistat_aCacheData[Result].sType:=tab.FieldAsString(4);
      case MyOwnMinistat_aCacheData[Result].sType of
        'Event Cache',
        'Cache In Trash Out Event',
        'Mega-Event Cache',
        'Giga-Event Cache',
        'Lost and Found Event Cache': MyOwnMinistat_aCacheData[Result].bEvent:=true;
        else MyOwnMinistat_aCacheData[Result].bEvent:=false;
      end;
      MyOwnMinistat_aCacheData[Result].dCreate:=IntToDate(tab.FieldAsString(5));
      //do meritka osy X nepocitame eventy, protoze ty nemaji grafy
      if(MyOwnMinistat_dGraphFrom>MyOwnMinistat_aCacheData[Result].dCreate) and (not MyOwnMinistat_aCacheData[Result].bEvent)
        then MyOwnMinistat_dGraphFrom:=MyOwnMinistat_aCacheData[Result].dCreate;
      //Log('sType='+MyOwnMinistat_aCacheData[Result].sType+', dCreate='+DateToStr(MyOwnMinistat_aCacheData[Result].dCreate));
      MyOwnMinistat_aCacheData[Result].iStatus:=tab.FieldAsInteger(6);
      if(tab.FieldAsInteger(7)<0) then begin  //pokud neni archivacni log, povazujeme ji za enabled
        MyOwnMinistat_aCacheData[Result].dArchive:=Now();
        MyOwnMinistat_aCacheData[Result].bArchived:=false;
      end
      else begin
        MyOwnMinistat_aCacheData[Result].dArchive:=IntToDate(tab.FieldAsString(7));
        MyOwnMinistat_aCacheData[Result].bArchived:=true;
      end;
      //Log('iStatus='+IntToStr(MyOwnMinistat_aCacheData[Result].iStatus)+', dArchive='+DateToStr(MyOwnMinistat_aCacheData[Result].dArchive)
      //  +', bArchived='+IntToStr(MyOwnMinistat_aCacheData[Result].bArchived as integer));
      MyOwnMinistat_aCacheData[Result].sDifficult:=tab.FieldAsString(8);
      MyOwnMinistat_aCacheData[Result].sTerrain:=tab.FieldAsString(9);
      //Log('sDifficult='+MyOwnMinistat_aCacheData[Result].sDifficult+', sTerrain='+MyOwnMinistat_aCacheData[Result].sTerrain);
      MyOwnMinistat_aCacheData[Result].sSize:=tab.FieldAsString(10);
      MyOwnMinistat_aCacheData[Result].sElevation:=tab.FieldAsString(11);
      //Log('sSize='+MyOwnMinistat_aCacheData[Result].sSize+', sElevation='+MyOwnMinistat_aCacheData[Result].sElevation);
      MyOwnMinistat_aCacheData[Result].dPublic:=IntToDate(tab.FieldAsString(12));//pokud nejsou logy v DB muze to byt chybne
      MyOwnMinistat_aCacheData[Result].nFoundIt:=tab.FieldAsInteger(13);
      //pocet nalezu jen pro neeventove kese, pro eventy se graf nekresli
      if(MyOwnMinistat_aCacheData[Result].nFoundIt>MyOwnMinistat_iMax) and (not MyOwnMinistat_aCacheData[Result].bEvent) then
        MyOwnMinistat_iMax:=MyOwnMinistat_aCacheData[Result].nFoundIt;
      MyOwnMinistat_aCacheData[Result].nDNF:=tab.FieldAsInteger(14);
      //MyOwnMinistat_aCacheData[Result].nFP:=StrToInt(tab.FieldAsString(15));   //takto to mel drak
      MyOwnMinistat_aCacheData[Result].nFP:=tab.FieldAsInteger(15);
      //Log('nFoundIt='+IntToStr(MyOwnMinistat_aCacheData[Result].nFoundIt)+', dPublic='+DateToStr(MyOwnMinistat_aCacheData[Result].dPublic)
      //  +', nDNF='+IntToStr(MyOwnMinistat_aCacheData[Result].nDNF)+', nFP='+IntToStr(MyOwnMinistat_aCacheData[Result].nFP));
      MyOwnMinistat_aCacheData[Result].sFTF:=UtfToAnsi(tab.FieldAsString(16));
      MyOwnMinistat_aCacheData[Result].sSTF:=UtfToAnsi(tab.FieldAsString(17));
      MyOwnMinistat_aCacheData[Result].sTTF:=UtfToAnsi(tab.FieldAsString(18));
      //Log('FTF='+MyOwnMinistat_aCacheData[Result].sFTF+', STF='+MyOwnMinistat_aCacheData[Result].sSTF
      //  +', TTF='+MyOwnMinistat_aCacheData[Result].sTTF);
      MyOwnMinistat_aCacheData[Result].nGcVoteCount:=tab.FieldAsInteger(19);
      MyOwnMinistat_aCacheData[Result].fGcVoteMedian:=StrToFl(tab.FieldAsString(20));
      //Log('nGcVoteCount='+IntToStr(MyOwnMinistat_aCacheData[Result].nGcVoteCount)+', fGcVoteMedian='+FloatToStr(MyOwnMinistat_aCacheData[Result].fGcVoteMedian));
      //dopocitame nektere hodnoty
      MyOwnMinistat_aCacheData[Result].nExistDays:=
        //1+Trunc(MyOwnMinistat_aCacheData[Result].dArchive-MyOwnMinistat_aCacheData[Result].dCreate);
        1+Trunc(MyOwnMinistat_aCacheData[Result].dArchive-MyOwnMinistat_aCacheData[Result].dPublic);
      //Log('nExistDays='+IntToStr(MyOwnMinistat_aCacheData[Result].nExistDays));
      //doplnime pocet logu
      MyOwnMinistat_aCacheData[Result].nLogs:=GEOGET_DB.GetTableValue(
        'SELECT count(gs_logid) FROM geolog WHERE id='''+MyOwnMinistat_aCacheData[Result].sId+'''');
      //doplnime datum posledniho nalezu
      MyOwnMinistat_aCacheData[Result].dLastFound:=IntToDate(IntToStr(
        GEOGET_DB.GetTableValue(
          'SELECT max(dt) FROM geolog WHERE id='''+MyOwnMinistat_aCacheData[Result].sId+''''
          +'  AND (type=''Found it'' OR type=''Attended'' OR type=''Webcam Photo Taken'')')
        ));
      MyOwnMinistat_aCacheData[Result].nWillAttend:=GEOGET_DB.GetTableValue(
        'SELECT count(gs_logid) FROM geolog WHERE id='''+MyOwnMinistat_aCacheData[Result].sId+''''
          +'  AND type=''Will Attend''');

      Inc(Result);
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  Log('Pocet pripravenych kesi: '+IntToStr(Result));
end;

function MyOwnMinistat_Run(aPar:TStringList):string; //generuje ministatistiku
var s,s1,sSql,sIds:string;
    i,nArch,nCelk,nEvent,nFinds,nDays,nDNF,idxMostFinds,nMostDNF,nMostFinds,nUniqueDays:integer;
    idxMostFreq,idxMostDnf,idxMostFp,nMostFp,nFPTotal:integer;
    nWordsTotal,nWordsMin,nWordsMax,idxWordsMin,idxWordsMax:integer;
    fMostFreq:extended;
	bWordLogs:boolean;  // pocitat slova v logach
	bFP:boolean;        // informace o Favorit points
begin
  //Clear---------------------------------
  SetLength(MyOwnMinistat_aCacheData,0);
  MyOwnMinistat_Param.sCaches:='';
  MyOwnMinistat_Param.sCachesSQL:='';
  MyOwnMinistat_nCaches:=0;
  MyOwnMinistat_iMax:=0;	
  //StatorBusy('MyOwnMinistat ...');
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  //-------------------------------------------------------------------------
  bWordLogs:=(UpperCase(aPar.Values['WordLogs'])='YES');
  bFP:=(UpperCase(aPar.Values['FavoritPoints'])='YES');
  //vlastn kee-------------------------------------------------------------
  Log(_('INFO: Loading all caches...'));
  //ziskame SQL prikaz z parametru (to aby byl urcite stejny)
  s:=GlobalVarget('OwnedIDsForInPhrase',false);
  s:=ReplaceString(ReplaceString(s,'''',''),'"',''); //zbavime se uvozovek/apostrofu
  s:=ReplaceString(s,',',CRLF);
  //-----------------------------------------------------------------------------		
  while(s<>'') do begin
    s1:=Fetch(s,CRLF);
    if(MyOwnMinistat_Param.sCaches<>'') then MyOwnMinistat_Param.sCaches:=MyOwnMinistat_Param.sCaches+',';
    MyOwnMinistat_Param.sCaches:=MyOwnMinistat_Param.sCaches+Fetch(s1,'-'); //jen GC kod bez jmena kese
  end;
  //-----------------------------------------------------------------------------
  Log('INFO: caches for MyOwnMinistat='+MyOwnMinistat_Param.sCaches);
  MyOwnMinistat_Param.sCachesSQL:=''''+ReplaceString(MyOwnMinistat_Param.sCaches,',',''',''')+'''';
  //ShowMessage('Seznam vlastnich kesi:'+CRLF+CRLF+MyOwnMinistat_Param.sCaches+CRLF+CRLF+MyOwnMinistat_Param.sCachesSQL);
  MyOwnMinistat_nCaches:=MyOwnMinistat_PrepareData();
  if(bWordLogs) then MyOwnMinistat_PrepareLogs();
  //zkontrolujeme, zda jsou vubec nejake vlastni kesky
  if(Length(MyOwnMinistat_aCacheData)=0) then begin
    AddError(_('ERR: No owned caches found!'));
		exit;
  end;
  //Result:=ProcessCommand('CmdTitle',_('Ministatistika vlastnich kesi'))+CRLF;
  nCelk:=0;
  nFinds:=0;
  nDays:=0;
  nDNF:=0;
  nArch:=0;
  nMostFinds:=0;         idxMostFinds:=0;
  fMostFreq:=999999;     idxMostFreq:=0;
  nMostFp:=0;            idxMostFp:=0;          nFPTotal:=0;
  nMostDNF:=0;           idxMostDNF:=0;
  nWordsTotal:=0;        nWordsMin:=999999;     nWordsMax:=0;
  idxWordsMin:=0;        idxWordsMax:=0;
  for i:=Low(MyOwnMinistat_aCacheData) to High(MyOwnMinistat_aCacheData) do begin
    sIds:=sIds+MyOwnMinistat_aCacheData[i].sId+CRLF; //vytvorime seznam kesi
    if(not MyOwnMinistat_aCacheData[i].bEvent) then begin      //eventy nepocitame do nejcasteji navstevovanych kesi
      if(MyOwnMinistat_aCacheData[i].nFoundIt>0) then begin
        if(fMostFreq>((0.+MyOwnMinistat_aCacheData[i].nExistDays)/MyOwnMinistat_aCacheData[i].nFoundIt)) then begin
          fMostFreq:=(0.+MyOwnMinistat_aCacheData[i].nExistDays)/MyOwnMinistat_aCacheData[i].nFoundIt;
          idxMostFreq:=i; 
         end;  
      end;
    end else Inc(nEvent);
    if(MyOwnMinistat_aCacheData[i].bArchived) then Inc(nArch);
    if(nMostFinds<MyOwnMinistat_aCacheData[i].nFoundIt) then begin
      nMostFinds:=MyOwnMinistat_aCacheData[i].nFoundIt;
      idxMostFinds:=i;
    end;
    if(nMostFP<MyOwnMinistat_aCacheData[i].nFP) then begin
      nMostFP:=MyOwnMinistat_aCacheData[i].nFP;
      idxMostFP:=i;
    end;
    if(nMostDNF<MyOwnMinistat_aCacheData[i].nDNF) and (not MyOwnMinistat_aCacheData[i].bEvent) then begin
      nMostDNF:=MyOwnMinistat_aCacheData[i].nDNF;
      idxMostDNF:=i;
    end;
    nWordsTotal:=nWordsTotal+MyOwnMinistat_aCacheData[i].nWordsTotal;
    if(nWordsMin>MyOwnMinistat_aCacheData[i].nWordsMin) then begin
      nWordsMin:=MyOwnMinistat_aCacheData[i].nWordsMin;
      idxWordsMin:=i;
    end;
    if(nWordsMax<MyOwnMinistat_aCacheData[i].nWordsMax) then begin
      nWordsMax:=MyOwnMinistat_aCacheData[i].nWordsMax;
      idxWordsMax:=i;
    end;
    nFinds:=nFinds+MyOwnMinistat_aCacheData[i].nFoundIt;
    nDNF:=nDNF+MyOwnMinistat_aCacheData[i].nDNF;
    nFPTotal:=nFPTotal+MyOwnMinistat_aCacheData[i].nFP;
    Inc(nCelk);
  end;
  if(fMostFreq>=999998) then fMostFreq:=0;
  if(nWordsMin=999999) then nWordsMin:=0;
  if(nCelk=0) then exit;
  sIds:=''''+ReplaceString(Trim(sIds),CRLF,''',''')+'''';
  sSql:='SELECT count(dt) FROM '
    +'(SELECT distinct dt FROM geolog WHERE id IN ('+sIds+') '
    +'  AND (type=''Found it'' OR type=''Attended'' OR type=''Webcam Photo Taken''))'
  //Log('MMMMMM SQL='+sSql);
  nUniqueDays:=Geoget_DB.GetTableValue(sSql);
  Result:=Result+'<table style="margin-top:5px; %StyleTableNum%">'+CRLF
  //Result:=Result
    +'<tr style="%StyleTableNumTr%">'
      +'<td style="%StyleTableNumLabelTd%">'+_('Owned')+'</td>'
      +'<td style="%StyleTableNumTd%"><b>'+_('Total:')+' '+IntToStr(nCelk)+'</b>, '
        +IntToStr(nArch)+' '+_('archived')+' ('+FormatFloatDot('0.00',(100.*nArch)/nCelk)+' %), '
        +_('caches:')+' '+IntToStr(nCelk-nEvent)+', '+_('events:')+' '+IntToStr(nEvent)
      +'</td></tr>'+CRLF;
  Result:=Result
    +'<tr style="%StyleTableNumTr%">'
      +'<td style="%StyleTableNumLabelTd%">'+_('Total finds on my caches')+'</td>'
      +'<td style="%StyleTableNumTd%"><b>'+IntToStr(nFinds)+'</b> '
        +_('finds in')+' <b>'+IntToStr(nUniqueDays)+'</b> '+_('unique days')
      +'</td></tr>'+CRLF;
  Result:=Result
    +'<tr style="%StyleTableNumTr%">'
      +'<td style="%StyleTableNumLabelTd%">'+_('Caching karma')+'</td>'
      +'<td style="%StyleTableNumTd%"><b>'
        +FormatFloatDot('0.00',((0.+nFinds)/(StrToInt(GlobalVarReplace('%FoundCachesCount%')))))+'</b> '
        +' ('+IntToStr(nFinds)+'/'+GlobalVarReplace('%FoundCachesCount%')+')'
      +'</td></tr>'+CRLF;
  Result:=Result
    +'<tr style="%StyleTableNumTr%">'
      +'<td style="%StyleTableNumLabelTd%">'+_('Cache with the most founds')+'</td>'
      +'<td style="%StyleTableNumTd%"><div style="width:100px; display:inline-block;"><b>'+IntToStr(nMostFinds)+'</b></div>'
      +MakeHtmlCacheInfo(MyOwnMinistat_aCacheData[idxMostFinds].sId,
        MyOwnMinistat_aCacheData[idxMostFinds].sType,
        MyOwnMinistat_aCacheData[idxMostFinds].sName,'',IntToStr(MyOwnMinistat_aCacheData[idxMostFinds].iStatus))
      +'</td></tr>'+CRLF;
  Result:=Result
    +'<tr style="%StyleTableNumTr%">'
      +'<td style="%StyleTableNumLabelTd%">'+_('Cache with the most DNFs')+'</td>'
      +'<td style="%StyleTableNumTd%"><div style="width:100px; display:inline-block;"><b>'
      +IntToStr(nMostDNF)+'</b></div>'
      +MakeHtmlCacheInfo(MyOwnMinistat_aCacheData[idxMostDNF].sId,
        MyOwnMinistat_aCacheData[idxMostDNF].sType,
        MyOwnMinistat_aCacheData[idxMostDNF].sName,'',IntToStr(MyOwnMinistat_aCacheData[idxMostDNF].iStatus))
      +'</td></tr>'+CRLF ;
  Result:=Result
    +'<tr style="%StyleTableNumTr%">'
      +'<td style="%StyleTableNumLabelTd%">'+_('Cache found most frequently')+'</td>'
      +'<td style="%StyleTableNumTd%"><div style="width:100px; display:inline-block;">'+_('Every')
      +' <b>'+FormatFloatDot('0.00',fMostFreq)+'.</b> '+_('day')+'</div>'
      +MakeHtmlCacheInfo(MyOwnMinistat_aCacheData[idxMostFreq].sId,
        MyOwnMinistat_aCacheData[idxMostFreq].sType,
        MyOwnMinistat_aCacheData[idxMostFreq].sName,'',IntToStr(MyOwnMinistat_aCacheData[idxMostFreq].iStatus))
      +'</td></tr>'+CRLF;
    if(bFP) then begin
      Result:=Result
        +'<tr style="%StyleTableNumTr%">'
          +'<td style="%StyleTableNumLabelTd%">'+_('Cache with the most favorite points')+'</td>'
          +'<td style="%StyleTableNumTd%"><div style="width:100px; display:inline-block;"><b>'+IntToStr(nMostFP)+'</b></div>'
          +MakeHtmlCacheInfo(MyOwnMinistat_aCacheData[idxMostFP].sId,
            MyOwnMinistat_aCacheData[idxMostFP].sType,
            MyOwnMinistat_aCacheData[idxMostFP].sName,'',IntToStr(MyOwnMinistat_aCacheData[idxMostFP].iStatus))
          +'</td></tr>'+CRLF
        +'<tr style="%StyleTableNumTr%">'
          +'<td style="%StyleTableNumLabelTd%">'+_('Total favorite points recieved')+'</td>'
          +'<td style="%StyleTableNumTd%"><b>'+IntToStr(nFPTotal)+'</b>'
          +'</td></tr>'+CRLF
        ;
    end;
  // ministatistiku o potech slov v logch vypisujeme jen pokud je potn povoleno
  if(bWordLogs) then begin
    if(nFinds=0) then nFinds:=1;
    Result:=Result
    +'<tr style="%StyleTableNumTr%">'
      +'<td style="%StyleTableNumLabelTd%">'+_('Logs length, count of words')+'</td>'
      +'<td style="%StyleTableNumTd%">'+_('Average')+' <b>'
        +FormatFloatDot('# ##0.0',(0.+nWordsTotal/nFinds))+'</b>'
      +'</td></tr>'+CRLF
    +'<tr style="%StyleTableNumTr%">'
      +'<td style="%StyleTableNumLabelTd%">&nbsp;</td>'
      +'<td style="%StyleTableNumTd%"><div style="width:100px; display:inline-block;">'
      +_('Maximum')+' <b>'+IntToStr(nWordsMax)+'</b></div>'
      //+', '
      +MakeHtmlCacheInfo(MyOwnMinistat_aCacheData[idxWordsMax].sId,
        MyOwnMinistat_aCacheData[idxWordsMax].sType,
        MyOwnMinistat_aCacheData[idxWordsMax].sName,'',IntToStr(MyOwnMinistat_aCacheData[idxWordsMax].iStatus))
      +' <a href="https://www.geocaching.com/seek/log.aspx?LID='+MyOwnMinistat_aCacheData[idxWordsMax].sWordsMaxLID+'" target="_blank">'
      +'(log: '+MyOwnMinistat_aCacheData[idxWordsMax].sWordsMaxFinder+'</a>)'
      +'</td></tr>'+CRLF
    +'<tr style="%StyleTableNumTr%">'
      +'<td style="%StyleTableNumLabelTd%">&nbsp;</td>'
      +'<td style="%StyleTableNumTd%"><div style="width:100px; display:inline-block;">'
      +_('Minimum')+' <b>'+IntToStr(nWordsMin)+'</b></div>'
      //+', '
      +MakeHtmlCacheInfo(MyOwnMinistat_aCacheData[idxWordsMin].sId,
        MyOwnMinistat_aCacheData[idxWordsMin].sType,
        MyOwnMinistat_aCacheData[idxWordsMin].sName,'',IntToStr(MyOwnMinistat_aCacheData[idxWordsMin].iStatus))
      +' <a href="https://www.geocaching.com/seek/log.aspx?LID='+MyOwnMinistat_aCacheData[idxWordsMin].sWordsMinLID+'" target="_blank">'
      +'(log: '+MyOwnMinistat_aCacheData[idxWordsMin].sWordsMinFinder+'</a>)'
      +'</td></tr>'+CRLF
    ;
  end;
  Result:=Result+'</table>'+CRLF
  //Free memory
  SetLength(MyOwnMinistat_aCacheData,0);
end;
