const
  NUMBERS_CachersStatLink = 'http://www.cacherstats.com/cgi-bin/GeocacherLocations.pl?Language=EN&Image=1&Font=LUCON&FontSize=0&WM=0&Scale=0&UserGUID=';
  NUMBERS_CachersStatLinkNick = 'http://www.cacherstats.com/cgi-bin/GeocacherLocations.pl?Language=EN&Image=1&Font=LUCON&FontSize=0&WM=0&Scale=0&CacherName=';

function Numbers_AddSectionHeader(sSubTitle:string):string;
begin
  Result:='<tr style="%StyleTableNumTr%">'
    +'<th colspan=3 style="%StyleTableNumTh%">'+sSubTitle+'</th></tr>'+CRLF;
end;

function Numbers_AddSimpleRow(sLabel,sValue:string):string;
begin
  Result:='<tr style="%StyleTableNumTr%">'
    +'<td style="%StyleTableNumLabelTd%">'+sLabel+'&nbsp;</td>'
    +'<td colspan=2 style="%StyleTableNumTd%">'+sValue+'</td></tr>'+CRLF;
end;

function Numbers_AddDoubleRow(sLabel,sValue,sComment:string):string;
begin
  Result:='<tr style="%StyleTableNumTr%">'
    +'<td style="%StyleTableNumLabelTd%">'+sLabel+'&nbsp;</td>'
    +'<td style="%StyleTableNumTd%">'+sValue+'</td>'
    +'<td style="%StyleTableNumTd%">'+sComment+'</td></tr>'+CRLF;
end;

function Numbers_NextMilestone(i,iFinds:integer;fPerDay,fPerCDay:extended):string;
var
  iD,iCD,iMil:integer;
begin
  if(fPerDay>0) and (fPerCDay>0) then begin
    iMil:=((Trunc(iFinds/i)+1)*i);
    iD:=Round((iMil-iFinds)/fPerDay);
    iCD:=Round((iMil-iFinds)/fPerCDay);
    Result:='<b>'+InsertThousSep(IntToStr(iMil))+'</b> '+_('will be reached in')
        +' <b>'+InsertThousSep(IntToStr(iD))+'</b> '+_('days')
        +', <b>'+InsertThousSep(IntToStr(iCD))+'</b> '+_('caching days')
        +' ('+FormatDateTime('d.m.yyyy',Now()+iD)+')';
  end;
end;

function Numbers_FastestFinds(sFinds:string):string;
var
  sL,sV,sSql,sFC: string;
  tab: TSqliteTable;
begin
  // nejrychlejsich sFinds  nalezu
  sL:=_('Fastest')+' '+InsertThousSep(sFinds)+' '+_('finds')
  sSql:='SELECT substr(fromdate.dtfound,7,2)||"."||substr(fromdate.dtfound,5,2)||"."||substr(fromdate.dtfound,1,4) dtOd,'
       +' substr(todate.dtfound,7,2)||"."||substr(todate.dtfound,5,2)||"."||substr(todate.dtfound,1,4) dtDo,'
       +' CAST(julianday(substr(todate.dtfound,1,4)||"-"||substr(todate.dtfound,5,2)||"-"||substr(todate.dtfound,7,2))'
       +' - julianday(substr(fromdate.dtfound,1,4)||"-"||substr(fromdate.dtfound,5,2)||"-"||substr(fromdate.dtfound,7,2))+1 AS INTEGER) AS dni'+CRLF
       +' FROM (SELECT st.rowid rowid, gc.id id, gc.dtfound dtfound FROM '+TEMP_TABLE+' st, geocache gc'
       +' WHERE st.id=gc.id AND '+sCachePrefixForSql+') AS todate,'
       +' (SELECT st.rowid rowid, gc.id id, gc.dtfound dtfound FROM '+TEMP_TABLE+' st, geocache gc'
       +' WHERE st.id=gc.id AND '+sCachePrefixForSql+') AS fromdate'
       +' WHERE todate.rowid = (fromdate.rowid + '+sFinds+'-1)'
       +' AND dni>0 ORDER BY dni LIMIT 1'
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    //sV:='<b>'+InsertThousSep(tab.FieldByName['dni'])+'</b> ';
    if tab.FieldByName['dni']='1' then sV:=_('during')+' <b>'+' 1 '+_('day</b> on')+' <b>'+tab.FieldByName['dtOd']+'</b>' //sV:=sV+_('day on')+' <b>'+tab.FieldByName['dtOd']+'</b>'
      else sV:=_('during')+'<b> '+InsertThousSep(tab.FieldByName['dni'])+' '+_('days')+'</b> '+_('from')+' <b>'+tab.FieldByName['dtOd']+'</b> '+_('to')+' <b>'+tab.FieldByName['dtDo']+'</b>';
  finally
      tab.Free();
  end;
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // poslednich sFinds nalezu
  sFC:=GlobalVarGet('FoundCachesCount',false);
  sL:=_('Last')+' '+InsertThousSep(sFinds)+' '+_('finds')
  sSql:='SELECT substr(fromdate.dtfound,7,2)||"."||substr(fromdate.dtfound,5,2)||"."||substr(fromdate.dtfound,1,4) dtOd,'
       +' substr(todate.dtfound,7,2)||"."||substr(todate.dtfound,5,2)||"."||substr(todate.dtfound,1,4) dtDo,'
       +' CAST(julianday(substr(todate.dtfound,1,4)||"-"||substr(todate.dtfound,5,2)||"-"||substr(todate.dtfound,7,2))'
       +' - julianday(substr(fromdate.dtfound,1,4)||"-"||substr(fromdate.dtfound,5,2)||"-"||substr(fromdate.dtfound,7,2))+1 AS INTEGER) AS dni'+CRLF
       +' FROM (SELECT st.rowid rowid, gc.id id, gc.dtfound dtfound FROM '+TEMP_TABLE+' st, geocache gc'
       +' WHERE st.id=gc.id AND '+sCachePrefixForSql+') AS todate,'
       +' (SELECT st.rowid rowid, gc.id id, gc.dtfound dtfound FROM '+TEMP_TABLE+' st, geocache gc'
       +' WHERE st.id=gc.id AND '+sCachePrefixForSql+') AS fromdate'
       +' WHERE todate.rowid = '+sFC
       +' AND fromdate.rowid = ('+sFC+'-'+sFinds+'+1)';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    sV:='<b>'+InsertThousSep(tab.FieldByName['dni'])+'</b> ';
    if tab.FieldByName['dni']='1' then sV:=sV+_('day') else sV:=sV+_('days');
  finally
      tab.Free();
  end;
  Result:=Result+Numbers_AddSimpleRow(sL,sV);
end;

procedure Numbers_AddPersonal;
var aRows,aSec:TStringList;
    ini:TMemIniFile;
    s:string;
    i:integer;
begin
  aSec:=TStringList.Create();
  try
    ini:=TMemIniFile.Create(GetProfileDir()+'NumbersAdd.ini');
    try
      ini.ReadSections(aSec);
      for i:=0 to aSec.Count-1 do begin
        aRows:=TStringList.Create();
        try
          ini.ReadSectionValues(aSec[i],aRows);
          s:=Trim(aRows.Text);
          while(s<>'') do begin
            aNumbersPersonal.Add(aSec[i]+'|'+ReplaceString(Fetch(s,CRLF),'=','|'));
          end;
        finally
          aRows.Free();
        end;
      end;
    finally
      ini.Free();
    end;
  finally
    aSec.Free();
  end;
end;

function Numbers_OutPersonalRows(sSecName:string):string;
var i:integer;
    sSec,s:string;
begin
  Result:='';
  for i:=0 to aNumbersPersonal.Count-1 do begin
    s:=aNumbersPersonal[i];
    sSec:=Fetch(s,'|');
    if(sSec<>SSecName) then continue;
    sSec:=Fetch(s,'|');
    Result:=Result+Numbers_AddSimpleRow(sSec,s);
  end;
end;

function Numbers_OutPersonalSections(aPar:TStringList):string;
var aSec:TStringList;
    s,sSec:string;
    i:integer;
begin
  Result:='';
  //do uzivatelskych radku pridame vsechny, ktere jsou v INI
  //zpracujeme vsechny dosud nezpracovane sekce zajimavych cisel
  aSec:=TStringList.Create();
  try
    //vytvorime seznam jiz zpracovanych (a ignorovanych) sekci
    aSec.Add('Summary');
    aSec.Add('BestDays');
    aSec.Add('Milestones');
    aSec.Add('Locations');
    aSec.Add('Age');
    aSec.Add('Logs');
    aSec.Add('Other');
    for i:=0 to aNumbersPersonal.Count-1 do begin
      s:=aNumbersPersonal[i];
      sSec:=Fetch(s,'|');
      if(aSec.IndexOf(sSec)>=0) then continue; //sekce je uz zpracovana
      //vytvorime nadpis, pridame vsechny radky
      if aPar.Values['ShowSectionHeaders']='Yes' then Result:=Result+Numbers_AddSectionHeader(sSec);
      Result:=Result+Numbers_OutPersonalRows(sSec);
      aSec.Add(sSec); //poznacime sekci za zpracovanou
    end;
  finally
    aSec.Free();
  end;
end;

function Numbers_Summary(aPar:TStringList):string;
var 
  sL,sV,sC,sSql: string;
  iFinds:integer;
  fd:extended;
  tab: TSqliteTable;
begin
  if aPar.Values['ShowSectionHeaders']='Yes' then Result:=Numbers_AddSectionHeader(_('Summary'));

  // Celkem nlez
  sL:=_('Total finds');
  sV:='<b>'+InsertThousSep(GlobalVarGet('FoundCachesCount',false))+'</b> '+_('in')
      +' <b>'+InsertThousSep(GlobalVarGet('Calc_DaysCaching',false))+'</b> '
      +_('caching days over')+' <b>'+InsertThousSep(GlobalVarGet('Calc_DaysTotal',false))+'</b> '
      +_('total days')+' ('
      +FormatFloatDot('#',(100.*StrToInt(GlobalVarGet('Calc_DaysCaching',false)))/StrToInt(GlobalVarGet('Calc_DaysTotal',false)))+' % '+_('days')+')';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);
  
  // Celkov prmry
  sL:=_('Total averages');
  sV:='<b>%Calc_AvgPerCachingDayRound2%</b> '+_('finds per caching day')
      +', <b>%Calc_AvgPerDayRound2%</b>/'+_('day')
      +', <b>%Calc_AvgPerWeekRound2%</b>/'+_('week')
      +', <b>%Calc_AvgPerMonthRound2%</b>/'+_('month')
      +', <b>%Calc_AvgPerYearRound2%</b>/'+_('year');
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  if StrToInt(GlobalVarGet('Calc_DaysTotal',false))>=365 then begin
    // Poslednch 365 dn
    sL:=_('Last 365 days');
    sV:='<b>'+InsertThousSep(GlobalVarGet('Calc_OtherLast365DaysCount',false))+'</b> '+_('finds in')
        +' <b>'+InsertThousSep(GlobalVarGet('Calc_OtherLast365DaysCaching',false))+'</b> '
        +_('caching days')+' ('
        +FormatFloatDot('#',(100.*StrToInt(GlobalVarGet('Calc_OtherLast365DaysCaching',false))/365))+' % '+_('days')+')';
    Result:=Result+Numbers_AddSimpleRow(sL,sV);
    
    // Poslednch 365 dn - prmry
    sL:=_('Last 365 days averages');
    sV:='<b>'+FormatFloatDot('0.00',(0.+StrToInt(GlobalVarGet('Calc_OtherLast365DaysCount',false)))/StrToInt(GlobalVarGet('Calc_OtherLast365DaysCaching',false)))
        +'</b> '+_('finds per caching day')
        +', <b>'+FormatFloatDot('0.00',(0.+StrToInt(GlobalVarGet('Calc_OtherLast365DaysCount',false)))/365)+'</b>/'+_('day')
        +', <b>'+FormatFloatDot('0.00',(0.+StrToInt(GlobalVarGet('Calc_OtherLast365DaysCount',false)))/365*7)+'</b>/'+_('week')
        +', <b>'+FormatFloatDot('0.00',(0.+StrToInt(GlobalVarGet('Calc_OtherLast365DaysCount',false)))/12)+'</b>/'+_('month');
    Result:=Result+Numbers_AddSimpleRow(sL,sV);
  end;
  
  // Nejvce po sob jdoucch dn s nlezem
  sL:=_('Most consecutive days with finds');
  sV:='<b>%Calc_FoundStreakDaily%</b> '+_('days from')+' <b>%Calc_FoundStreakDailyFrom%</b> '
    +_('to')+' <b>%Calc_FoundStreakDailyTo%</b>';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // Nejvce po sob jdoucch dn bez nlezu
  sL:=_('Most consecutive days without a find');
  sV:='<b>%Calc_EmptyStreakDaily%</b> '+_('days from')+' <b>%Calc_EmptyStreakDailyFrom%</b> '
    +_('to')+' <b>%Calc_EmptyStreakDailyTo%</b>';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);
  
  // Nejvce nlez bhem dne
  sL:=_('Best day');
  sV:='<b>'+InsertThousSep(GlobalVarGet('Calc_SumFindsMaxPerDayCount1',false))+'</b> ('
      +GlobalVarGet('Calc_SumFindsMaxPerDay1',false)+'), '
      +'<b> '+InsertThousSep(GlobalVarGet('Calc_SumFindsMaxPerDayCount2',false))+'</b> ('
      +GlobalVarGet('Calc_SumFindsMaxPerDay2',false)+'), '
      +'<b> '+InsertThousSep(GlobalVarGet('Calc_SumFindsMaxPerDayCount3',false))+'</b> ('
      +GlobalVarGet('Calc_SumFindsMaxPerDay3',false)+')';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);
  
  // Nejvce nlez o vkendu
  sL:=_('Best weekend');
  sV:='<b>'+InsertThousSep(GlobalVarGet('Calc_SumMaxInWeekendCount',false))+'</b> '+_('finds during weekend from')+' <b>'
      +GlobalVarGet('Calc_SumMaxInWeekendFrom',false)+'</b>';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);
  
  // Nejvce nlez bhem tdne
  sL:=_('Best week');
  sV:='<b>'+InsertThousSep(GlobalVarGet('Calc_SumMaxInWeekCount',false))+'</b> '+_('finds from Monday')+' <b>'
      +GlobalVarGet('Calc_SumMaxInWeekFrom',false)+'</b> '+_('to Sunday')+' <b>'+GlobalVarGet('Calc_SumMaxInWeekTo',false)+'</b>';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // Nejvce nlez bhem msce
  sL:=_('Best month');
  sV:='<b>'+InsertThousSep(GlobalVarGet('Calc_SumMaxInMonthCount',false))+'</b>'+_(' finds in ')+'<b>'+ //mezery tam mm zmrn kvli pekladu! nemnit!
      +GlobalVarGet('Calc_SumMaxInMonth',false)+' '+GlobalVarGet('Calc_SumMaxInMonthYear',false)+'</b>';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // Nejvce nlez bhem roku
  sL:=_('Best year');
  sV:='<b>'+InsertThousSep(GlobalVarGet('Calc_SumMaxInYearCount',false))+'</b> '+_('finds in year')+' <b>'
      +GlobalVarGet('Calc_SumMaxInYear',false)+'</b>';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // pocet nalezu
  iFinds:=StrToInt(GlobalVarGet('FoundCachesCount',false));
  
  // Nejrychlejsich 100 nalezu
  if iFinds>=100 then Result:=Result+Numbers_FastestFinds('100');
  
  // Nejrychlejsich 1 000 nalezu
  if iFinds>=1000 then Result:=Result+Numbers_FastestFinds('1000');

  // Nejrychlejsich 10 000 nalezu
  if iFinds>=10000 then Result:=Result+Numbers_FastestFinds('10000');

  // Matrix
  sL:=_('Difficulty/Terrain');
  sV:='<b>'+GlobalVarGet('Calc_MatrixDifficultyTerrain',false)+'</b> '+_('combinations from total 81 completed');
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // Prmr D
  sL:=_('Average difficulty');
  sSql := 'SELECT "<img src=%IconCacheDiff"||REPLACE(CAST((ROUND((AVG(gc.[difficulty])*10)/5,0)*5)/10 AS NVARCHAR),".0","")||"%>" img,';
  sSql := sSql + ' CAST(AVG(gc.[difficulty]) AS NVARCHAR) value';
  sSql := sSql + ' FROM geocache gc';
  sSql := sSql + ' WHERE gc.[dtfound]>0;';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    sV:='<b>'+FormatFloatDot('0.00',StrToFl(tab.FieldByName['value']))+'</b> '+tab.FieldByName['img'];
  finally
      tab.Free();
  end;
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // Prmr T
  sL:=_('Average terrain');
  sSql := 'SELECT "<img src=%IconCacheTerr"||REPLACE(CAST((ROUND((AVG(gc.[terrain])*10)/5,0)*5)/10 AS NVARCHAR),".0","")||"%>" img,';
  sSql := sSql + ' CAST(AVG(gc.[terrain]) AS NVARCHAR) value';
  sSql := sSql + ' FROM geocache gc';
  sSql := sSql + ' WHERE gc.[dtfound]>0;';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    sV:='<b>'+FormatFloatDot('0.00',StrToFl(tab.FieldByName['value']))+'</b> '+tab.FieldByName['img'];
  finally
      tab.Free();
  end;
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // Celkova vzdalenost od kese ke kesi
  sL:=_('Total cache-to-cache distance');
  fd:=StrToFl(GlobalVarGet('TotalDistance',false));
  sV:='<b>'+FormatFloatDot('# ##0',ConvertFromKm(fd,sUnit))+'</b>&nbsp;'+GetLengthAbbr(sUnit);
  sC:='<b>'+FormatFloatDot('# ##0.00',fd/40075)+'</b>&times; '+_('Earth Circumnavigation')+'<br>';
  sC:=sC+'<b>'+FormatFloatDot('# ##0.000',fd/384403)+'</b>&times; '+_('Distance to the Moon');
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  // pridame uzivatelem definovane radky
  Result:=Result+Numbers_OutPersonalRows('Summary');
end;

function Numbers_Milestones(aPar:TStringList):string;
var 
  sL,sV:string;
  i,iFinds:integer;
  fPerDay,fPerCDay:extended;
begin
  if aPar.Values['ShowSectionHeaders']='Yes' then Result:=Numbers_AddSectionHeader(_('Milestones'));

  iFinds:=StrToInt(GlobalVarGet('FoundCachesCount',false));
  fPerDay:=StrToFl(GlobalVarGet('Calc_AvgPerDay',false));
  fPerCDay:=StrToFl(GlobalVarGet('Calc_AvgPerCachingDay',false));

  // Dal 100. nlez
  sL:=_('Next 100. milestone');
  sV:=_('Find #')+Numbers_NextMilestone(100,iFinds,fPerDay,fPerCDay);
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // Dal 1 000. nlez
  if iFinds>500 then begin
    sL:=_('Next 1000. milestone');
    sV:=_('Find #')+Numbers_NextMilestone(1000,iFinds,fPerDay,fPerCDay);
    Result:=Result+Numbers_AddSimpleRow(sL,sV);
  end;

  // Dal 10 000. nlez
  if iFinds>5000 then begin
    sL:=_('Next 10 000. milestone');
    sV:=_('Find #')+Numbers_NextMilestone(10000,iFinds,fPerDay,fPerCDay);
    Result:=Result+Numbers_AddSimpleRow(sL,sV);
  end;

  // Dal 100 000. nlez ;-)
  if iFinds>50000 then begin
    sL:=_('Next 100 000. milestone');
    sV:=_('Find #')+Numbers_NextMilestone(100000,iFinds,fPerDay,fPerCDay);
    Result:=Result+Numbers_AddSimpleRow(sL,sV);
  end;

  iFinds:=StrToInt(GlobalVarGet('Calc_FTFCount',false));
  if(iFinds>0) then begin
    fPerDay:=1.0*iFinds/StrToInt(GlobalVarGet('Calc_DaysTotal',false));
    fPerCDay:=1.0*iFinds/StrToInt(GlobalVarGet('Calc_DaysCaching',false));

    // Dal 10. FTF nlez
    sL:=_('Next 10. FTF milestone');
    sV:=_('FTF #')+Numbers_NextMilestone(10,iFinds,fPerDay,fPerCDay);
    Result:=Result+Numbers_AddSimpleRow(sL,sV);

    // Dal 100. FTF nlez
    if iFinds>50 then begin
      sL:=_('Next 100. FTF milestone');
      sV:=_('FTF #')+Numbers_NextMilestone(100,iFinds,fPerDay,fPerCDay);
      Result:=Result+Numbers_AddSimpleRow(sL,sV);
    end;

    // Dal 1 000. FTF nlez - pro Benja :-)  to aby sis zacal chystat i 10 000. FTF :D
    if iFinds>500 then begin
      sL:=_('Next 1000. FTF milestone');
      sV:=_('FTF #')+Numbers_NextMilestone(1000,iFinds,fPerDay,fPerCDay);
      Result:=Result+Numbers_AddSimpleRow(sL,sV);
    end;
  end;
  iFinds:=StrToInt(GlobalVarGet('FoundCachesCount',false));
  fPerDay:=StrToFl(GlobalVarGet('Calc_AvgPerDay',false));
  fPerCDay:=StrToFl(GlobalVarGet('Calc_AvgPerCachingDay',false));

  // Do konce roku	342 dn 434 ke, (4 143 ke celkem)
  sL:=_('To the end of year');
  i:=Round(IntToDate(FormatDateTime('yyyy',Now())+'1231')+1-Now());
  sV:=_('During')+' <b>'+InsertThousSep(IntToStr(i))+'</b> '
      +_('days remaining until the end of the year we can find')
      +' <b>'+FormatFloatDot('# ##0',i*fPerDay)+'</b> '+_('caches')
      +' '+_('and finaly reach')+' <b>'+FormatFloatDot('# ##0',iFinds+(i*fPerDay))+'</b> '+_('total finds');
  Result:=Result+Numbers_AddSimpleRow(sL,sV);
        
  // pridame uzivatelem definovane radky
  Result:=Result+Numbers_OutPersonalRows('Milestones');
end;

function Numbers_BestDays(aPar:TStringList):string;
var 
  s,ss,sL,sV,sD,sC,sLast,sSql: string;
  tab: TSqliteTable;
begin
  if aPar.Values['ShowSectionHeaders']='Yes' then Result:=Numbers_AddSectionHeader(_('Best days'));
  
  // Most Cache Types in a day
  sL:=_('Most cache types in a day');
  sSql:='SELECT COUNT(DISTINCT cachetype) as pocet, dtfound FROM geocache gc WHERE gc.dtfound>0'
    +' AND '+sCachePrefixForSql
    +' GROUP BY gc.dtfound ORDER BY pocet DESC LIMIT 1';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=tab.FieldByName['dtfound'];
    sD:=FormatDateTime('d.m.yyyy',IntToDate(s));
    sV:='<b> '+tab.FieldByName['pocet']+'</b> '+_('cache types on')+' <b>'+sD+'</b>';
  finally
    tab.Free();
  end;
  sSql:='SELECT cachetype, id, name FROM geocache gc WHERE gc.dtfound='+s
    +' AND '+sCachePrefixForSql
    +' GROUP BY cachetype ORDER BY gc.dtfoundtime';
  tab:=Geoget_DB.GetTable(sSql, false);
  sC:='';
  try
    while not tab.eof do begin
      sC:=sC+'<a href="https://coord.info/'+tab.FieldByName['id']+'" target="_blank">'
            +'<img src="%IconCacheTypeSmall'+tab.FieldByName['cachetype']+'%" '
            +'title="'+tab.FieldByName['name']+'"></a> ';
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);
  
  // Most Countries in a day
  sL:=_('Most countries in a day');
  sSql:='SELECT COUNT(DISTINCT country) as pocet, dtfound FROM geocache gc WHERE gc.dtfound>0'
    +' AND '+sCachePrefixForSql
    +' GROUP BY gc.dtfound ORDER BY pocet DESC LIMIT 1';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=tab.FieldByName['dtfound'];
    sD:=FormatDateTime('d.m.yyyy',IntToDate(s));
    sV:='<b> '+tab.FieldByName['pocet']+'</b> '+_('countries on')+' <b>'+sD+'</b>';
  finally
    tab.Free();
  end;
  sSql:='SELECT country FROM geocache gc WHERE gc.dtfound='+s
    +' AND '+sCachePrefixForSql
    +' GROUP BY country ORDER BY gc.dtfoundtime';
  tab:=Geoget_DB.GetTable(sSql, false);
  sC:='';
  try
    while not tab.eof do begin
      ss:=UtfToAscii(tab.FieldByName['country']);
      sC:=sC+'<img src="%IconCountry'+ss+'%">&nbsp;'
            +ss+', ';
      tab.Next();
    end;
  finally
    tab.Free();
    sC:=copy(sC,1,length(sC)-2);
  end;
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);
  
  // Most States in a day
  sL:=_('Most states in a day');
  sSql:='SELECT COUNT(DISTINCT state) as pocet, dtfound FROM geocache gc WHERE gc.dtfound>0'
    +' AND '+sCachePrefixForSql
    +' GROUP BY gc.dtfound ORDER BY pocet DESC LIMIT 1';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=tab.FieldByName['dtfound'];
    sD:=FormatDateTime('d.m.yyyy',IntToDate(s));
    sV:='<b> '+tab.FieldByName['pocet']+'</b> '+_('states on')+' <b>'+sD+'</b>';
  finally
    tab.Free();
  end;
  sSql:='SELECT state, country FROM geocache gc WHERE gc.dtfound='+s
    +' AND '+sCachePrefixForSql
    +' GROUP BY state ORDER BY gc.dtfoundtime';
  tab:=Geoget_DB.GetTable(sSql, false);
  sC:=''; sLast:='';
  try
    while not tab.eof do begin
      s:=UtfToAscii(tab.FieldByName['state']);
      ss:=UtfToAscii(tab.FieldByName['country']);
      if s='' then s:='???';
      if ss=sLast then
        sC:=sC+s+', '
      else
        sC:=sC+ss+':&nbsp;'+s+', ';
      sLast:=ss;
      tab.Next();
    end;
  finally
    tab.Free();
    sC:=copy(sC,1,length(sC)-2);
  end;
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  // Most FTFs in a day
  s:='';
  sL:=_('Most FTFs in a day');
  sSql:='SELECT count(*) pocet, gc.dtfound datum'
     +'  FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
     +'  WHERE gt.id=gc.id and gc.dtfound>0 AND '+sCachePrefixForSql
     +'    AND gtc.key=gt.ptrkat'
     +'    AND gtc.value=''FTF'''
     +'    AND gtv.key=gt.ptrvalue and gtv.value like ''%FTF%'''
     +'  GROUP BY datum ORDER BY pocet DESC LIMIT 1';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=tab.FieldByName['datum'];
    sD:=FormatDateTime('d.m.yyyy',IntToDate(s));
    sV:='<b> '+tab.FieldByName['pocet']+'</b> '+_('FTFs on')+' <b>'+sD+'</b>';
  finally
    tab.Free();
  end;
  if(s<>'') then begin
    sSql:='SELECT gc.cachetype, gc.id, gc.name'
       +'  FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
       +'  WHERE gt.id=gc.id and gc.dtfound='+s+' AND '+sCachePrefixForSql
       +'    AND gtc.key=gt.ptrkat'
       +'    AND gtc.value=''FTF'''
       +'    AND gtv.key=gt.ptrvalue and gtv.value like ''%FTF%'''
       +'  ORDER BY gc.dtfoundtime';
    tab:=Geoget_DB.GetTable(sSql, false);
    sC:='';
    try
      while not tab.eof do begin
        sC:=sC+'<a href="https://coord.info/'+tab.FieldByName['id']+'" target="_blank">'
              +'<img src="'+GlobalVarGet('IconCacheTypeSmall'+tab.FieldByName['cachetype'],false)+'" '
              +'title="'+tab.FieldByName['name']+'"></a>';
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);
  end;
  
  // pridame uzivatelem definovane radky
  Result:=Result+Numbers_OutPersonalRows('BestDays');
end;

function Numbers_Locations(aPar:TStringList):string;
var
  s,ss,sL,sV,sC,sID,sSql,sUrl:string;
  tab: TSqliteTable;
  fd,fx,fy:extended;
begin
  if aPar.Values['ShowSectionHeaders']='Yes' then Result:=Numbers_AddSectionHeader(_('Locations'));
    
  //Nejblizsi kes 
  sL:=_('Nearest cache');
  sID:=GlobalVarGet('Calc_LocNearestID',false);
  if(aPar.Values['ShowMinDistance']='Yes') then begin
    sSql:='SELECT (0+st.Distance) dist, st.Angle angle FROM '+TEMP_TABLE+' st WHERE st.id="'+sID+'"';
    tab:=Geoget_DB.GetTable(sSql, false);
    try
      fd:=ConvertFromKm(StrToFl(tab.FieldByName['dist']),sUnit);
      sV:='<img src="'+DirectionToIcon(StrToFloat(tab.FieldByName['angle']))+'">'
        +'<b>'+FormatFloatDot('0.00',fd)+'</b>&nbsp;'+GetLengthAbbr(sUnit);
    finally
      tab.Free();
    end;
  end;
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  //Nejvzdalenejsi kes
  sL:=_('Furthest cache');
  sID:=GlobalVarGet('Calc_LocFurthestID',false);
  sSql:='SELECT (0+st.Distance) dist, st.Angle angle FROM '+TEMP_TABLE+' st WHERE st.id="'+sID+'"';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    fd:=ConvertFromKm(StrToFl(tab.FieldByName['dist']),sUnit);
    sV:='<img src="'+DirectionToIcon(StrToFloat(tab.FieldByName['angle']))+'">'
      +'<b>'+FormatFloatDot('# ##0',fd)+'</b>&nbsp;'+GetLengthAbbr(sUnit);
  finally
    tab.Free();
  end;
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  //Nejvzdalenejsi FTF
  sL:=_('Furthest FTF');
  sID:=GlobalVarGet('Calc_LocFurthestFTFID',false);
  sSql:='SELECT (0+st.Distance) dist, st.Angle angle FROM '+TEMP_TABLE+' st WHERE st.id="'+sID+'"';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    if(tab.FieldByName['dist']='') then fd:=-1. //neni zadny FTF nalez, nic nevytvaret!
    else begin
      fd:=ConvertFromKm(StrToFl(tab.FieldByName['dist']),sUnit);
      sV:='<img src="'+DirectionToIcon(StrToFloat(tab.FieldByName['angle']))+'">'
        +'<b>'+FormatFloatDot('# ##0',fd)+'</b>&nbsp;'+GetLengthAbbr(sUnit);
    end;
  finally
    tab.Free();
  end;
  if(fd>=0) then begin
    sC:=MakeHtmlCacheInfoFromId(sID);
    Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);
  end;

  //Nejsevernejsi kes
  sL:=_('Most northerly cache');
  sID:=GlobalVarGet('Calc_LocNortherlyID',false);
  sSql:='SELECT (0+st.Distance) dist, gc.x coordx, gc.y coordy FROM '+TEMP_TABLE+' st, geocache gc'
    +' WHERE st.id=gc.id AND st.id="'+sID+'"';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    sV:='<b>'+Fetch(s,' ')+'</b><br>';
    fd:=ConvertFromKm(StrToFl(tab.FieldByName['dist']),sUnit);
    sV:=sV+'<img src="%IconDirectionN%">'+FormatFloatDot('# ##0',fd)+'&nbsp;'+GetLengthAbbr(sUnit);
  finally
    tab.Free();
  end;
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  //Nejjiznejsi kes
  sL:=_('Most southerly cache');
  sID:=GlobalVarGet('Calc_LocSoutherlyID',false);
  sSql:='SELECT (0+st.Distance) dist, gc.x coordx, gc.y coordy FROM '+TEMP_TABLE+' st, geocache gc'
    +' WHERE st.id=gc.id AND st.id="'+sID+'"';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    sV:='<b>'+Fetch(s,' ')+'</b><br>';
    fd:=ConvertFromKm(StrToFl(tab.FieldByName['dist']),sUnit);
    sV:=sV+'<img src="%IconDirectionS%">'+FormatFloatDot('# ##0',fd)+'&nbsp;'+GetLengthAbbr(sUnit);
  finally
    tab.Free();
  end;
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  //Nejzapadnejsi kes
  sL:=_('Most westerly cache');
  sID:=GlobalVarGet('Calc_LocWesterlyID',false);
  sSql:='SELECT (0+st.Distance) dist, gc.x coordx, gc.y coordy FROM '+TEMP_TABLE+' st, geocache gc'
    +' WHERE st.id=gc.id AND st.id="'+sID+'"';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    ss:=Fetch(s,' ');
    sV:='<b>'+s+'</b><br>';
    fd:=ConvertFromKm(StrToFl(tab.FieldByName['dist']),sUnit);
    sV:=sV+'<img src="%IconDirectionW%">'+FormatFloatDot('# ##0',fd)+'&nbsp;'+GetLengthAbbr(sUnit);
  finally
    tab.Free();
  end;
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  //Nejvychodnejsi kes
  sL:=_('Most easterly cache');
  sID:=GlobalVarGet('Calc_LocEasterlyID',false);
  sSql:='SELECT (0+st.Distance) dist, gc.x coordx, gc.y coordy FROM '+TEMP_TABLE+' st, geocache gc'
    +' WHERE st.id=gc.id AND st.id="'+sID+'"';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    ss:=Fetch(s,' ');
    sV:='<b>'+s+'</b><br>';
    fd:=ConvertFromKm(StrToFl(tab.FieldByName['dist']),sUnit);
    sV:=sV+'<img src="%IconDirectionE%">'+FormatFloatDot('# ##0',fd)+'&nbsp;'+GetLengthAbbr(sUnit);
  finally
    tab.Free();
  end;
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);
  
  //Nejvyssi kes nad morem
  sL:=_('Highest cache');
  sID:=GlobalVarGet('Calc_LocHighestID',false);
  sV:='<b>'+InsertThousSep(GlobalVarGet('Calc_LocHighestAlt',false))+'</b>&nbsp;'+_('m a.s.l.');
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  //Nejnizsi kes nad morem
  sL:=_('Lowest cache');
  sID:=GlobalVarGet('Calc_LocLowestID',false);
  sV:='<b>'+InsertThousSep(GlobalVarGet('Calc_LocLowestAlt',false))+'</b>&nbsp;'+_('m a.s.l.');
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  // Centroid tj. geometricky stred nalezu
  if aPar.Values['ShowDetails']='Yes' then s:='block' else s:='none';
  if ParseWgsStr(GlobalVarGet('CentroidCoord',false),fx,fy) then begin
    sL:=_('Centroid of finds');
    sV:='<a style="cursor:help" onclick="'
        +'if(document.getElementById(''iCentroidMap'').style.display==''block''){'
        +'document.getElementById(''iCentroidMap'').style.display=''none'';}'
        +'else{document.getElementById(''iCentroidMap'').style.display=''block'';}'
        +';return(false);"><img src="%IconLayoutMap%" title="'+_('Show on map')+'"></a>'
        +' <b>'+GlobalVarGet('CentroidCoord',false)+'</b> '
        +_('at a distance of')
        +' <img src="'+DirectionToIcon(StrToFloat(GlobalVarGet('CentroidAngle',false)))+'">'
        +InsertThousSep(GlobalVarGet('CentroidDistance',false))+'&nbsp;'+GetLengthAbbr(sUnit)+' '
        +_('from home');
    // mapka
    sUrl:='size='+IntToStr(70*iWidth/100)+'x'+IntToStr(70*iWidth/100)+'&markers=color:red|label:C|'+FlToStr(fx)+','+FlToStr(fy);
    // pokud neni kacer paranoidni, doplnit HC
    if(aPar.Values['ShowMinDistance']='Yes') then sUrl:=sUrl+'&markers=color:green|label:H|'+FlToStr(fHomeX)+','+FlToStr(fHomeY)
    else sUrl:=sUrl+'&zoom=8';
    sUrl:=sUrl+'&sensor=false';
    sUrl:=CONST_MAPGEN_URL+'mapgen.php?cht=t,MapRed&chm='+EncodeBase64(sUrl);

    sV:=sV+'<div id="iCentroidMap" style="%StyleTableNumLabelTd%; display:'+s+'; margin:10px; padding:10px; ">'
      +'<center><a target="_blank" href="https://maps.google.com/maps?q=Centroid\@'+FlToStr(fx)+','+FlToStr(fy)+'&amp;z=8">'
      +'<img src="'+sUrl+'"></a></center></div>';
    Result:=Result+Numbers_AddSimpleRow(sL,sV);
  end;
  
  // pridame uzivatelem definovane radky
  Result:=Result+Numbers_OutPersonalRows('Locations');
end;

function Numbers_Age(aPar:TStringList):string;
var
  s,sL,sV,sC,sID,sSql:string;
  iFinds:integer;
  tab: TSqliteTable;
begin
  if aPar.Values['ShowSectionHeaders']='Yes' then Result:=Numbers_AddSectionHeader(_('Age'));
    
  //Nejstarsi kes
  sL:=_('Oldest cache');
  sID:=GlobalVarGet('Calc_AgeOldestID',false);
  sSql:='SELECT dthidden datum FROM geocache WHERE id="'+sID+'"';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    sV:='<b>'+FormatDateTime('d.m.yyyy',IntToDate(tab.FieldByName['datum']))+'</b>';
  finally
    tab.Free();
  end;
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  //Nejmladsi kes
  sL:=_('Youngest cache');
  sID:=GlobalVarGet('Calc_AgeYoungestID',false);
  sSql:='SELECT dthidden datum FROM geocache WHERE id="'+sID+'"';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    sV:='<b>'+FormatDateTime('d.m.yyyy',IntToDate(tab.FieldByName['datum']))+'</b>';
  finally
    tab.Free();
  end;
  sC:=MakeHtmlCacheInfoFromId(sID);
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  //Archivovanych kesi:
  iFinds:=StrToInt(GlobalVarGet('FoundCachesCount',false));

  sL:=_('Archived caches');
  s:=GlobalVarGet('Calc_AgeArchivedCount',false);
  sV:='<img src="%IconCacheStatus2%"> <b>'+s+'</b> '+_('of found caches')+' ('+FormatFloatDot('0.00',StrToFl(s)/iFinds*100)+' %) '
      +_('are now archived');
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  //Kesi mimo provoz:
  sL:=_('Disabled caches')
  s:=GlobalVarGet('Calc_AgeDisabledCount',false);
  sV:='<img src="%IconCacheStatus1%"> <b>'+s+'</b> '+_('of found caches')+' ('+FormatFloatDot('0.00',StrToFl(s)/iFinds*100)+' %) '
      +_('are now disabled');
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // pridame uzivatelem definovane radky
  Result:=Result+Numbers_OutPersonalRows('Age');
end;

function Numbers_Logs(aPar:TStringList):string;
var
  s,sL,sV,sC:string;
begin
  if aPar.Values['ShowSectionHeaders']='Yes' then Result:=Numbers_AddSectionHeader(_('Logs'));
  // Celkovy pocet slov
  sL:=_('Total length of find logs');
  s:=GlobalVarGet('Calc_LogsSum',false);
  //pokud neni nastaven pocet logu, vypiseme varovani
  if(s='0') then Result:=Result+Numbers_AddSimpleRow('<b>!!!!</b>',
    _('<b>Missing tags with number of words - plugin Logator or module CalcMain did not run</b>'));  // Chybi tag s pocty slov logu - nebyl spusten plugin Logator nebo Statorovy modul CalcMain

  sV:='<b>'+InsertThousSep(s)+'</b> '+_('words total')
      +', <b>'+GlobalVarGet('Calc_LogsAvg',false)+'</b> '+_('words average log length')+'<br>'
      +'<b>'+FormatFloatDot('0.00',StrToFl(s)/38262)+'</b>&times; '+_('length of Genesis book')+', '
      +'<b>'+FormatFloatDot('0.0',StrToFl(s)/570542*100)+'</b> % '+_('length of the whole Old Testament')+'<br>';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // Nejdelsi log
  sL:=_('Longest log');
  sV:='<a href="https://www.geocaching.com/seek/log.aspx?LID='+GlobalVarGet('Calc_LogsMaxLogId',false)+'" target="_blank">'
      +'<b>'+GlobalVarGet('Calc_LogsMaxCount',false)+'</b> '+_('words')+'</a>';
  sC:=MakeHtmlCacheInfoFromId(GlobalVarGet('Calc_LogsMaxID',false));
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  // Nejkratsi log
  sL:=_('Shortest log')
  sV:='<a href="https://www.geocaching.com/seek/log.aspx?LID='+GlobalVarGet('Calc_LogsMinLogId',false)+'" target="_blank">'
      +'<b>'+GlobalVarGet('Calc_LogsMinCount',false)+'</b> '+_('words')+'</a>';
  sC:=MakeHtmlCacheInfoFromId(GlobalVarGet('Calc_LogsMinID',false));
  Result:=Result+Numbers_AddDoubleRow(sL,sV,sC);

  // pridame uzivatelem definovane radky
  Result:=Result+Numbers_OutPersonalRows('Logs');

end;

function Numbers_Other(aPar:TStringList):string;
var
  s,sL,sV:string;
  iFinds:integer;
begin
  if aPar.Values['ShowSectionHeaders']='Yes' then Result:=Numbers_AddSectionHeader(_('Other'));
  if aPar.Values['ShowDetails']='Yes' then s:='block' else s:='none';
    
  // mdCachingPoints
  sL:=_('mdCachingPoints');
  sV:='<a style="cursor:help" onclick="'
    //obsluha kliknuti na ikonku - zobrazi nebo skryje vysvetlujici informace
    //k vypoctu hodnoty
    +'if(document.getElementById(''iMdCachingPointsHelp'').style.display==''block''){'
    +'document.getElementById(''iMdCachingPointsHelp'').style.display=''none'';}'
    +'else{document.getElementById(''iMdCachingPointsHelp'').style.display=''block'';}'
    +';return(false);'
    +'">';
  //ikonka pro vysvetlivky - pokud neni definovana, zobrazi se misto ni otaznicky
  if(GlobalVarGet('StyleIconQuestion',false)<>'StyleIconQuestion') then
    sV:=sV+'<img src="%StyleIconQuestion%" title="'+_('Show legend')+'">'
  else sV:=sV+'???';
  sV:=sV+'</a> ';
  sV:=sV+' <b>'+InsertThousSep(GlobalVarGet('Calc_OtherMdCachingPoints',false))+'</b> '+_('total points')+', <b>%Calc_OtherAverageMdCachingPoints%</b> '+_('cache average')
    +', '+_('best day')+': <b>'+GlobalVarGet('Calc_OtherDayMaxMdCachingPoints',false)+'</b> '+_('points on')
    +' <b>%Calc_OtherDayMaxDateMdCachingPoints%</b>';
  // blok s napovedou
  sV:=sV+'<div id="iMdCachingPointsHelp" style="%StyleTableNumLabelTd%; display:'+s+'; margin:10px; padding:10px; padding-left:20px; ">'
    +'<a href="http://macdefender.org/products/GCStatistic/mdCachingPoints.html" target="_blank">'
    +_('mdCachingPoints')+'</a>=('+_('Coefficient of cache type')+')&times;('
    +_('Difficulty')+')&times;('+_('Terrain')+')<br/><br/>'
    +_('Coefficient of cache type')+': <br/>'
    +'<div style=''display:inline-block; width:35px; margin-left:15px;''>0.5</div>'
      +'<img title=''Virtual'' src="%IconCacheTypeSmallV%" />'
      +'<img title=''Locationless'' src="%IconCacheTypeSmallLocationless (Reverse) Cache%" />'
      +'<br/>'
    +'<div style=''display:inline-block; width:35px; margin-left:15px;''>1</div>'
      +'<img title=''Traditional'' src="%IconCacheTypeSmallT%" />'
      +'<img title=''Webcam'' src="%IconCacheTypeSmallW%" />'
      +'<br/>'
    +'<div style=''display:inline-block; width:35px; margin-left:15px;''>1.5</div>'
      +'<img title=''Letterbox'' src="%IconCacheTypeSmallH%" />'
      +'<img title=''Earth'' src="%IconCacheTypeSmallG%" />'
      +'<img title=''Event'' src="%IconCacheTypeSmallE%" />'
      +'<img title=''CITO'' src="%IconCacheTypeSmallC%" />'
      +'<br/>'
    +'<div style=''display:inline-block; width:35px; margin-left:15px;''>1.75</div>'
      +'<img title=''Mega event'' src="%IconCacheTypeSmallZ%" />'
      +'<br/>'
    +'<div style=''display:inline-block; width:35px; margin-left:15px;''>2</div>'
      +'<img title=''Multi'' src="%IconCacheTypeSmallM%" />'
      +'<img title=''Mystery'' src="%IconCacheTypeSmallU%" />'
      +'<img title=''Wherigo'' src="%IconCacheTypeSmallI%" />'
      +'<img title=''Giga event'' src="%IconCacheTypeSmallX%" />'
      +'<img title=''GPS Adventures Exhibit'' src="%IconCacheTypeSmallA%" />'
      +'<img title=''Lost and found Celebration'' src="%IconCacheTypeSmallGroundspeak Lost and Found Celebration%" />'
      +'<br/>'
    +'<div style=''display:inline-block; width:35px; margin-left:15px;''>4</div>'
      +'<img title=''A.P.E.'' src="%IconCacheTypeSmallP%" />'
    +'</div>';
  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // CacherStats Ranking
  if GlobalVarGet('Calc_CacherStatCountryRanking',false) <> 'ERR' then begin
    sL:=_('CacherStats Ranking');
    sV:='<a style="cursor:help" href="'+NUMBERS_CachersStatLink+sGuidCom+'" target="_blank">';
    //sV:='<a style="cursor:help" href="'+NUMBERS_CachersStatLinkNick+EncodeUrlElement(GEOGET_OWNER)+'" target="_blank">';
    //ikonka pro vysvetlivky - pokud neni definovana, zobrazi se misto ni otaznicky
    if(GlobalVarGet('StyleIconQuestion',false)<>'StyleIconQuestion') then
      sV:=sV+'<img src="%StyleIconQuestion%" title="'+_('Show actual CacherStats')+'">'
    else sV:=sV+'???';
    sV:=sV+'</a> ';
    sV:=sV+' <b>'+InsertThousSep(GlobalVarGet('Calc_CacherStatCountryRanking',false))+'</b>'
      +_('<sup>th</sup> in')+' '+GlobalVarGet('Calc_CacherStatCountry',false)+', '
      +'<b>'+InsertThousSep(GlobalVarGet('Calc_CacherStatContinentRanking',false))+'</b>'
      +_('<sup>th</sup> in')+' '+GlobalVarGet('Calc_CacherStatContinent',false)+', '
      +'<b>'+InsertThousSep(GlobalVarGet('Calc_CacherStatWorldRanking',false))+'</b>'
      +_('<sup>th</sup> ')+' '+_('in the World');
    Result:=Result+Numbers_AddSimpleRow(sL,sV);
  end;
      
  // Jaro, leto, podzim, zima (ovsem bereme to vzhledem k nasim souradnicim!)
  iFinds:=StrToInt(GlobalVarGet('FoundCachesCount',false));
  sL:=_('Finds in seasons');
  sV:='<a style="cursor:help" onclick="'
      +'if(document.getElementById(''iSeasonChart'').style.display==''block''){'
      +'document.getElementById(''iSeasonChart'').style.display=''none'';}'
      +'else{document.getElementById(''iSeasonChart'').style.display=''block'';}'
      +';return(false);"><img src="%IconLayoutChartPie%" title="'+_('Show chart')+'"></a>';
  sV:=sV+' <b>'+InsertThousSep(GlobalVarGet('Calc_FindsInSpring',false))+'</b> '+_('in spring');
  sV:=sV+', <b>'+InsertThousSep(GlobalVarGet('Calc_FindsInSummer',false))+'</b> '+_('in summer');
  sV:=sV+', <b>'+InsertThousSep(GlobalVarGet('Calc_FindsInAutumn',false))+'</b> '+_('in autumn');
  sV:=sV+', <b>'+InsertThousSep(GlobalVarGet('Calc_FindsInWinter',false))+'</b> '+_('in winter');

  sV:=sV+CRLF
      +'<div id="iSeasonChart" style="%StyleTableNumLabelTd%; display:'+s+'; '
        +'width:'+IntToStr(70*iWidth/100)+'px; height:'+{IntToStr(15*iWidth/100)+}'95px; '
        +'margin:10px; padding:10px 10px 0px 20px; "></div>'
      +CRLF
      +'<script type="text/javascript">'+CRLF
      //+'  var chart_iSeasonChart=echarts.init(document.getElementById(''iSeasonChart''), StatorTheme);'+CRLF
      +'  var chart_iSeasonChart=echarts.init(document.getElementById(''iSeasonChart''));'+CRLF
         +'  option={'+CRLF+
         +'  tooltip:{},'+CRLF
         +'  animation:false,'+CRLF
         +'  legend:{ orient:''vertical'', right:30, top:20,'
         +'    data: ['''+_('Spring')+''','''+_('Summer')+''','''+_('Autumn')+''','''+_('Winter')+''']},'+CRLF
         +'  series:[{'+CRLF
         +'    label:{show:false},'+CRLF
         +'    center:[''30%'',''50%''],'+CRLF
         +'    radius:[0,''95%''],'+CRLF
         +'    type:''pie'','+CRLF
         +'    data:['+
         +'{name:'''+_('Spring')+''', value:'+GlobalVarGet('Calc_FindsInSpring',false)+', itemStyle:{color:''#87EF25''}},'+CRLF
         +'{name:'''+_('Summer')+''', value:'+GlobalVarGet('Calc_FindsInSummer',false)+', itemStyle:{color:''#FAE62E''}},'+CRLF
         +'{name:'''+_('Autumn')+''', value:'+GlobalVarGet('Calc_FindsInAutumn',false)+', itemStyle:{color:''#FD7F09''}},'+CRLF
         //+'{name:'''+_('Winter')+''', value:'+GlobalVarGet('Calc_FindsInWinter',false)+', itemStyle:{color:''#CCF0FE''}},'+CRLF
         +'{name:'''+_('Winter')+''', value:'+GlobalVarGet('Calc_FindsInWinter',false)+', itemStyle:{color:''#33F0FE''}},'+CRLF
         +'    ],'+CRLF
         +'  }],'+CRLF   //konec series
         +'  };'+CRLF    //konec options
         //vytvoreni grafu s potrebnymi parametry a definovanym tematem
         +'  chart_iSeasonChart.setOption(option);'+CRLF
         +'</script>'+CRLF+CRLF
     // +'</a></center></div>'+CRLF;

  Result:=Result+Numbers_AddSimpleRow(sL,sV);

  // pridame uzivatelem definovane radky
  Result:=Result+Numbers_OutPersonalRows('Other');
end;

function Numbers_Run(aPar:TStringList):string;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Numbers_AddPersonal(); //pridame vsechny radky v INI souboru

  Result:=Result+CRLF+'<table style="%StyleTableNum%">'+CRLF;
  if(Pos('Summary',aPar.Values['Groups'])>0) then Result:=Result+CRLF+Numbers_Summary(aPar);
  if(Pos('Milestones',aPar.Values['Groups'])>0) then Result:=Result+CRLF+Numbers_Milestones(aPar);
  if(Pos('BestDays',aPar.Values['Groups'])>0) then Result:=Result+CRLF+Numbers_BestDays(aPar);
  if(Pos('Locations',aPar.Values['Groups'])>0) then Result:=Result+CRLF+Numbers_Locations(aPar);
  if(Pos('Age',aPar.Values['Groups'])>0) then Result:=Result+CRLF+Numbers_Age(aPar);
  if(Pos('Logs',aPar.Values['Groups'])>0) then Result:=Result+CRLF+Numbers_Logs(aPar);
  if(Pos('Other',aPar.Values['Groups'])>0) then Result:=Result+CRLF+Numbers_Other(aPar);
  
  Result:=Result+CRLF+Numbers_OutPersonalSections(aPar)+'</table>'+CRLF;
end;