function SummaryByTypeInRegion_Run(aPar:TStringList):string;
var aTmpPar,aTypes:TStringList;
    tab: TSqliteTable;
    sSort,sRegionSource,sCountry,sSql,sColumns,s:string;
    i:integer;
    nTypes:array[0..500] of integer;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  sSql:=aPar.Values['OrderBy'];
  sSort:=Fetch(sSql,'-');
  sSql:=aPar.Values['RegionSource'];
  sRegionSource:=Fetch(sSql,'-');
  sCountry:=aPar.Values['Country'];
  if(sCountry='') then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('ERR: There''s no country selected for creating table'));
    Log(_('ERR: There''s no country selected for creating table'));
    exit;
  end;
  aTmpPar:=TStringList.Create();
  try
    aTypes:=TStringList.Create();
    try
      //zjistime seznam typu kesi v databazi, abychom mohli sestavit spravny SQL
      sSql:='SELECT cachetype FROM geocache gc WHERE dtfound>0 AND country='''+sCountry+''''
        +' AND '+sCachePrefixForSql+SetSqlFilter(aPar)
        +' GROUP BY cachetype ORDER BY count(cachetype) desc';
      Geoget_DB.GetTableStrings(sSql,aTypes);
      //vytvorime SQL a zaroven seznam sloupcu tak, aby se jmena typu kesi nahradily ikonami
      if(sRegionSource='State') then sSql:='SELECT state'
      else begin
        sSql:='SELECT gtv.value';
        CalcRegionTagSupport_TagFromCountry(sCountry,false,sRegionSource); //pro TAG zjistime kategorii
      end;
      sColumns:='Region';
      for i:=0 to aTypes.Count-1 do begin
        sSql:=sSql+CRLF+'  ,sum(case when cachetype='''+aTypes[i]+''' then 1 else 0 end) as '''+aTypes[i]+'''';
        sColumns:=sColumns+'|<img src&eq;"%IconCacheTypeSmall'+aTypes[i]+'%" title&eq;"'+aTypes[i]+'" />=Center';
      end;
      sColumns:=sColumns+'|&sum;=Right';
      if(sRegionSource='State') then begin
        sSql:=sSql+CRLF+'  ,count(state)'+CRLF+'FROM geocache gc';
        sSql:=sSql+' WHERE dtfound>0 AND country='''+sCountry+''''
          +' AND '+sCachePrefixForSql+SetSqlFilter(aPar)
          +' GROUP BY state ORDER BY ';
        if(sSort<>'Region') then sSql:=sSql+'count(state) desc, ';
        sSql:=sSql+'state';
      end
      else begin
        sSql:=sSql+CRLF+'  ,count(gtv.value)'+CRLF+'FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
        +' WHERE dtfound>0 AND gc.id=gt.id '+CRLF
        +'   AND gtc.key=gt.ptrkat and gtc.value='''+sRegionSource+''' COLLATE NOCASE AND gtv.key=gt.ptrvalue'
        +'   AND '+sCachePrefixForSql+SetSqlFilter(aPar)
        +' GROUP BY gtv.value ORDER BY ';
        if(sSort<>'Region') then sSql:=sSql+'count(gtv.value) desc, ';
        sSql:=sSql+'gtv.value';
      end;
      aTmpPar.Text:='';
      Log('SQL='+sSql);
      tab:=Geoget_DB.GetTable(sSql, false);
      try
        while not tab.eof do begin
          s:=(tab.FieldAsString(0)); //region
          if(s='') then s:='??'; //polozka State nemusi byt vyplnena
          aTmpPar.Add(s);
          for i:=1 to aTypes.Count do begin
            s:=tab.FieldAsString(i); //pocty nalezu jednotlivych typu
            if(s='0') then 
              aTmpPar.Add('<img src="%IconCacheTypeSmall'+aTypes[i-1]+' (gray)%" />')
            else begin
              aTmpPar.Add('<img src="%IconCacheTypeSmall'+aTypes[i-1]+'%" title="'+s+' x" />');
              //pocitame celkove soucty za typ kese
              nTypes[i-1]:=nTypes[i-1]+StrToInt(s);
              nTypes[aTypes.Count]:=nTypes[aTypes.Count]+StrToInt(s);
            end;
          end;
          aTmpPar.Add('<b>'+tab.FieldAsString(i)+'</b>');  //soucet nalezu za stat
          tab.Next();
        end;
      finally
        tab.Free();
      end;
      //pridame celkove pocty typu kesi
      aTmpPar.Add('<b>&sum;</b>'); //region
      for i:=0 to aTypes.Count do begin
        aTmpPar.Add('<b>'+IntToStr(nTypes[i])+'</b>');
      end;
      Result:=Result+OutputTableList(sColumns,aTmpPar,0,-1,-1,i);
    finally
      aTypes.Free();
    end;
  finally
    aTmpPar.Free();
  end;
end;
