function SummaryByTypeSwitchRegions_TabName(sMainModule:string;idxTab:integer):string;
begin
  Result:=sMainModule+'_Tab'+IntToStr(idxTab);
end;

function SummaryByTypeSwitchRegions_Run(aPar:TStringList):string;
var s,sSql,sDiv,sIdElemOld:string;
    sSort:string;
    i,k:integer;
    aTabs,aPom:TStringList;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Output(ProcessCommand('CmdTitle',aPar));
  s:=aPar.Values['OrderBy'];
  sSort:=Fetch(s,'-');
  sIdElemOld:=GlobalVarGet('IdElement',false);
  //zjistime seznam vsech statu, mezi kterymi budeme prepinat
  sSql:='SELECT country FROM geocache gc WHERE dtfound>0'
    +' AND '+sCachePrefixForSql+SetSqlFilter(aPar)
    +' GROUP BY country ORDER BY ';
  if(sSort<>'Finds') then sSql:=sSql+'country'
  else sSql:=sSql+'count(country) desc';
  aTabs:=TStringList.Create();
  try
    Geoget_DB.GetTableStrings(sSql,aTabs);
    Log('Seznam statu: '+aTabs.Text);
    aPom:=TStringList.Create();
    try
      for i:=0 to aTabs.Count-1 do begin
        //na tlacitko dame vlajku statu se jmenem nebo jen jmeno
        if(aPar.Values['SwitchType']='Button') then
          aPom.Add('<img src="%IconCountry'+aTabs[i]+'%" title="'+aTabs[i]+'" />')
        else aPom.Add(aTabs[i]);
        aPom.Add('i'+SummaryByTypeSwitchRegions_TabName(sIdElemOld,i)); //id divu s tabulkou
      end;
      //vygenerujeme div s tlacitky
      Output(OutputSwitchButtons(sIdElemOld,aPar.Values['SwitchType'],5,false,aPom));
    finally
      aPom.Free();
    end;
    aPar.Values['Title']:='';
    //vygenerujeme jednotlive divy s tabulkami
    for i:=0 to aTabs.Count-1 do begin
      aPar.Values['Country']:=aTabs[i];
      if(CalcRegionTagSupport_TagFromCountry(aTabs[i],false,s)) then
        aPar.Values['RegionSource']:='TAG'
      else aPar.Values['RegionSource']:='State';
      sDiv:='<div id="i'+SummaryByTypeSwitchRegions_TabName(sIdElemOld,i)+'"';
      if(i=0) then sDiv:=sDiv+' style=""'
      else sDiv:=sDiv+' style="display:none;"';
      sDiv:=sDiv+'>'+CRLF;
      Output(sDiv);
      //pokud je checkbox, ktery muze zobrazovat vice tabulek najednou,
      //zobrazime jmeno statu
      if(aPar.Values['SwitchType']='Checkbox') then
        Output('<p style="text-align:center; margin:10px 0px 3px 0px; font-weight:bold;">'+aTabs[i]+'</p>'+CRLF);
      //najdeme a zavolame funkci pro generovani mapy
      for k:=0 to MAX_MODULES do begin
        if(k=MAX_MODULES) then begin
          //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
          //AddError(_('ERR: unknown module for')+' SummaryByTypeInRegion');
          Log(_('ERR: unknown module for')+' SummaryByTypeInRegion');
          break;
        end;
        if(aFce[k]=nil) then continue;
        //Log('HHHHH j='+IntToStr(j)+', k='+IntToStr(k)+', '+aModuleName[k]+' ? '+aMapsState[j+1]);
        if(aModuleName[k]='SummaryByTypeInRegion') then begin
          //Log('-- spoustim modul '+IntToStr(j)+'/'+IntToStr(aMapsState.Count)+': '+aMapsState[j+1]+' ('+aMapsState[j]+')');
          Output(aFce[k](aPar));
          break;
        end;
      end;
      Output('</div>'+CRLF+CRLF);
    end;
  finally
    aTabs.Free();
  end;
  GlobalVarSet('IdElement',sIdElemOld);
end;