// Graf souctu hodnot v tagu (po mesicich za cele keskovaci obdobi,
// od prvniho nalezu do soucasnosti)

function TimelineBySumaTag_Run(aPar:TStringList):string;
var tab:TSqliteTable;
    iYear,iMonth,iNum:integer;
    idx:integer;
    s,sSql:string;
    sColorTotal,sColorYearly:string;
    //pro ECharts
    sEX,sEY,sEData,sENames,sETotal,sETradi,sEMulti,sEMyst,sEOther,sEYearly,sEOption,sEId:string;
    nETotal,nEYearly,iEMonOld,iEYearOld,iEidx:integer;
begin
  if(aPar.Values['TagCategory']='') then begin
    Log(_('ERR: TagCategory not set'));
    exit;
  end;
  // definice prhlednost a barev
  sColorTotal:='''#'+GlobalVarGet('ColorGraphCacheTraditional',false)+'''';  //celkova barva
  sColorYearly:='''#'+GlobalVarGet('ColorGraphYearlyTotals',false)+'''';     //rocni barva
  //sColorYearly:='''#'+GlobalVarGet('ColorGraphCacheUnknown',false)+'''';     //rocni barva
  //definice prvniho bodu dat
  sENames:=''' '''+CRLF; //prvni bod na ose X je neoznacen
  sETradi:='0'+CRLF; sEMulti:=sETradi; sEMyst:=sETradi; sEOther:=sETradi;
  //rocni krivka obsahuje X i Y souradnice, aby bylo mozne na konci roku
  //nastavit 0 pro dalsi rok
  sEYearly:='[0,0]'+CRLF;  ////////////////
  sETotal:='0'+CRLF;
  Geoget_DB.AddParamText(':TagCat',aPar.Values['TagCategory']);
  sSql:='SELECT gc.dtfound/100 YearMonth, CAST(sum(100*gtv.value) AS integer) Value FROM'
    +' geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE gc.dtfound>0 AND '+sCachePrefixForSql+SetSqlFilter(aPar)
    +'   AND gt.id=gc.id AND gtc.key=gt.ptrkat AND gtc.value=:TagCat AND gtv.key=gt.ptrvalue'
    +' GROUP BY YearMonth';
  idx:=0;
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      s:=tab.FieldByName['YearMonth'];
      iYear:=StrToInt(Copy(s,1,4));
      iMonth:=StrToInt(Copy(s,5,2));
      if(iEidx=0) then begin
        iEYearOld:=iYear;
        iEMonOld:=iMonth;
        Inc(iEidx);
      end;
      if(iMonth<>iEMonOld) then begin
        sETotal:=sEtotal+FormatFloatDot('0.00',0.01*nETotal)+CRLF;
        sEYearly:=sEYearly+'['+IntToStr(iEidx)+','+FormatFloatDot('0.00',0.01*nEYearly)+'],';
        sENames:=sENames+''''+IntToStr(iEMonOld)+'/'+IntToStr(iEYearOld)+''''+CRLF; //bod na ose X
        if(iYear<>iEYearOld) then begin
          //pro rocni krivku vytvorime i pocatecni bod v dalsim roce
          sEYearly:=sEYearly+'['+IntToStr(iEidx)+',0],';
          nEYearly:=0;
          iEYearOld:=iYear;
        end;
        iEMonOld:=iMonth;
        Inc(iEidx);
      end;
      //pricteme aktualni data
      iNum:=StrToInt(tab.FieldByName['Value']); //stonasobek cisla
      nETotal:=nETotal+iNum;
      nEYearly:=nEYearly+iNum;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  //zapiseme posledni hodnotu
  sETotal:=sEtotal+FormatFloatDot('0.00',0.01*nETotal)+CRLF;
  sEYearly:=sEYearly+'['+IntToStr(iEidx)+','+FormatFloatDot('0.00',0.01*nEYearly)+'],';
  sENames:=sENames+''''+IntToStr(iEMonOld)+'/'+IntToStr(iEYearOld)+''''+CRLF; //bod na ose X

  sEData:='series:['+CRLF
    +'  { name: '''+_('Total')+''', type:''line'', symbolSize:1, areaStyle:{normal:{}}, yAxisIndex:0,'+CRLF   
    +'    color:'+sColorTotal+', data:['+ReplaceString(Trim(sETotal),CRLF,',')+']},'+CRLF
    +'  { name: '''+_('From beginning of the year')+''', type:''line'', symbolSize:1, yAxisIndex:1,'+CRLF 
    +'    color:'+sColorYearly+', lineStyle:{type:''dotted''},'+CRLF
    +'    data:['+ReplaceString(Trim(sEYearly),CRLF,',')+']}],'+CRLF
    ;
  // vlastn vstup modulu
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  //ECharts --------------------
  sEId:='ID'+IntToStr(iItem);
  //vykresleni grafu
  Result:='<div id="'+sEId+'" style="width:'+IntToStr(iWidth)+'px; height:'+IntToStr(400)+'px;"></div>'+CRLF
    //+'%StyleTableBottomTextStartHtml%'+
    //  +'<i>'+_('You can zoom by scrolling or using sliders under the chart.')+'</i>'
    //  +'%StyleTableBottomTextEndHtml%'+CRLF
    +'<script type="text/javascript">'+CRLF
    +'  var chart_'+sEId+'=echarts.init(document.getElementById('''+sEId+'''));'+CRLF
    +'  option={'+CRLF
    +'    xAxis:[{ type:''category'', boundaryGap:false,'+CRLF
    +'      axisLabel:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'0.8')+'},'+CRLF
    +'      data:['+ReplaceString(Trim(sENames),CRLF,',')+']}],'+CRLF
    +'    yAxis:[{type:''value'',name:'''+_('Total')+'''' 
    +' ,position:''left'',splitLine:{lineStyle:{color:'+sColorTotal+'}}, axisLine:{lineStyle:{color:'+sColorTotal+'}}},'+CRLF
    +'    {type:''value'', position:''right'',name:'''+_('In year')+''', splitLine:{lineStyle:{color:'+sColorYearly+'}}, axisLine:{lineStyle:{color:'+sColorYearly+'}}, splitArea:{show: true}}' 
    +'],'+CRLF
    +'    dataZoom: [{type: ''inside''}, {type: ''slider''}],'+CRLF
    +'    tooltip:{show:true, trigger:''axis'',axisPointer:{ type:''cross''},'+CRLF
    +'    formatter: function(par){'+CRLF
    +'      s=''<p style="text-align:center; margin:0px;">''+par[0].name+''</p><p style="text-align:left; margin:0px;">'''+CRLF
    +'        +par[0].marker+" "+par[0].seriesName+": "+par[0].value+"<br/>"'+CRLF
    +'        +par[1].marker+" "+par[1].seriesName+": "+par[1].value[1]+"</p>"'+CRLF
    +'      ;'+CRLF
    +'      return s;'+CRLF
    +'    }},'+CRLF
    +'    grid:{ left:5, right:10, bottom:40, top:30, containLabel:true },'+CRLF
    +sEData+'};'+CRLF
    //vytvoreni grafu s potrebnymi parametry a definovanym tematem
    +'  chart_'+sEId+'.setOption(option);'+CRLF
    +'</script>'+CRLF+CRLF;
  Output(Result);
  Result:='';

end;