// Kumulativn graf nlez podle typu ke

function TimelineByTypeCumulative_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    iYear,iMonth,iNum:integer;
    s,sType,sSql:string;
    sColorTradi,sColorMulti,sColorMyst,sColorOther,sColorTotal,sColorYearly,sColorMain:string;
    //pro  ECharts
    sEX,sEY,sEData,sENames,sETotal,sETradi,sEMulti,sEMyst,sEOther,sEYearly,sEOption,sEId:string;
    nETradi,nEMulti,nEMyst,nETotal,nEYearly,nEOther,iEMonOld,iEYearOld,iEidx:integer;
begin
  //ziskani barev
  sColorTradi:=ColorToRGBA(GlobalVarGet('ColorGraphCacheTraditional',false),'1');
  sColorMulti:=ColorToRGBA(GlobalVarGet('ColorGraphCacheMulti',false),'0.8');
  sColorMyst:=ColorToRGBA(GlobalVarGet('ColorGraphCacheUnknown',false),'0.8');
  sColorOther:=ColorToRGBA('ab0000','0.8');
  sColorTotal:=ColorToRGBA(GlobalVarGet('ColorTableScaleAvgBkg',false),'1');
  sColorYearly:=ColorToRGBA(GlobalVarGet('ColorGraphYearlyTotals',false),'1');
  sColorMain:=ColorToRGBA(GlobalVarGet('ColorMainText',false),'0.8');
  //define os
  sEX:='xAxis:[{ type:''category'', boundaryGap:false,axisLabel:{color:'+sColorMain+'}}],';
  sEY:='yAxis:['
    +'{type:''value'',name:'''+_('Total')+'''' 
    +' ,position:''left'',splitLine:{lineStyle:{color:'+sColorMain+'}},'
    +' axisLine:{lineStyle:{color:'+sColorMain+'},axisLabel:{color:'+sColorMain+'}}},'
    +'{type:''value'', position:''right'',name:'''+_('In year')+''',' 
    +' axisLine:{lineStyle:{color:'+sColorMain+'}},'
    +' axisLabel:{color:'+sColorMain+'},'
    +' splitArea:{show: true}}'
    +'],';
  //definice prvniho bodu dat
  sENames:=''' '''+CRLF; //prvni bod na ose X je neoznacen
  sETradi:='0'+CRLF; sEMulti:=sETradi; sEMyst:=sETradi; sEOther:=sETradi;
  //rocni krivka obsahuje X i Y souradnice, aby bylo mozne na konci roku
  //nastavit 0 pro dalsi rok
  sEYearly:='[0,0]'+CRLF;
  sETotal:='0'+CRLF;
  Result:='';

  sSql:='SELECT dtfound/100 YearMonth, cachetype Type, count(*) Num FROM geocache gc WHERE gc.dtfound>0 AND '
    +sCachePrefixForSql+SetSqlFilter(aPar)+' GROUP BY YearMonth, Type';
  iEMonOld:=0;
  iEYearOld:=0;
  iEidx:=0; //index mesice
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      s:=tab.FieldByName['YearMonth'];
      iYear:=StrToInt(Copy(s,1,4));
      iMonth:=StrToInt(Copy(s,5,2));
      sType:=tab.FieldByName['Type'];
      iNum:=StrToInt(tab.FieldByName['Num']);
      if(iEidx=0) then begin
        iEYearOld:=iYear;
        iEMonOld:=iMonth;
        Inc(iEidx);
      end;
      //pro ECharts
      //zapiseme hodnoty z predchoziho mesice
{$ifdef DEBUG_HELPER}
LDH('iEidx='+IntToStr(iEidx)+', '+IntToStr(iMonth)+'/'+IntToStr(iYear)
  +' [old='+IntToStr(iEMonOld)+'/'+IntToStr(iEYearOld)+']: '+intToStr(iNum)
  +', total='+IntToStr(nETotal)+', nEYearly='+IntToStr(nEYearly)
  //+', sEYarly=['+ReplaceString(Trim(sEYearly),CRLF,',')+']'
  );
{$endif}
      if(iMonth<>iEMonOld) then begin
        sETradi:=sETradi+IntToStr(nETradi)+CRLF;
        sEMulti:=sEMulti+IntToStr(nEMulti)+CRLF;
        sEMyst:=sEMyst+IntToStr(nEMyst)+CRLF;
        sETotal:=sEtotal+IntToStr(nETotal)+CRLF;
        sEOther:=sEOther+IntToStr(nEOther)+CRLF;
        sEYearly:=sEYearly+'['+IntToStr(iEidx)+','+IntToStr(nEYearly)+'],';
        sENames:=sENames+''''+IntToStr(iEMonOld)+'/'+IntToStr(iEYearOld)+''''+CRLF; //bod na ose X
        if(iYear<>iEYearOld) then begin
          //pro rocni krivku vytvorime i pocatecni bod v dalsim roce
          sEYearly:=sEYearly+'['+IntToStr(iEidx)+',0],';
          nEYearly:=0;
          iEYearOld:=iYear;
        end;
        iEMonOld:=iMonth;
        Inc(iEidx);
      end;
      //pricteme aktualni data
      case sType of
        'Traditional Cache':  nETradi:=nETradi+iNum;
        'Multi-cache':        nEMulti:=nEMulti+iNum;
        'Unknown Cache':      nEMyst:=nEMyst+iNum;
        else nEOther:=nEOther+iNum;
      end;
      nETotal:=nETotal+iNum;
      nEYearly:=nEYearly+iNum;
      //konec ECharts
      tab.Next();
    end;
    //ECharts -- zapiseme data z posledniho mesice
    sETradi:=sETradi+IntToStr(nETradi)+CRLF;
    sEMulti:=sEMulti+IntToStr(nEMulti)+CRLF;
    sEMyst:=sEMyst+IntToStr(nEMyst)+CRLF;
    sETotal:=sEtotal+IntToStr(nETotal)+CRLF;
    sEOther:=sEOther+IntToStr(nEOther)+CRLF;
    sEYearly:=sEYearly+'['+IntToStr(iEidx)+','+IntToStr(nEYearly)+'],';
    sENames:=sENames+''''+IntToStr(iEMonOld)+'/'+IntToStr(iEYearOld)+''''+CRLF; //bod na ose X
  finally
    tab.Free();
  end;
  //EChar graf  ---------------
  sETotal:=sETotal+IntToStr(nETotal); //doplnime hodnotu za posledni mesic
  sEX:=ReplaceString(sEX,'}],',', data:['+ReplaceString(Trim(sENames),CRLF,',')+']}],');
  sEData:='series:['+CRLF
    +'  { name: ''Traditional Cache'', type:''line'', symbolSize:1, symbol:"circle", stack:''typ'',areaStyle:{normal:{}}, yAxisIndex:0,'+CRLF
    +'    color:'+sColorTradi+', data:['+ReplaceString(Trim(sETradi),CRLF,',')+']},'+CRLF
    +'  { name: ''Unknown Cache'', type:''line'', symbolSize:1, symbol:"circle", stack:''typ'',areaStyle:{normal:{}}, yAxisIndex:0,'+CRLF
    +'    color:'+sColorMyst+', data:['+ReplaceString(Trim(sEMyst),CRLF,',')+']},'+CRLF
    +'  { name: ''Multi-cache'', type:''line'', symbolSize:1, symbol:"circle", stack:''typ'',areaStyle:{normal:{}}, yAxisIndex:0,'+CRLF
    +'    color:'+sColorMulti+', data:['+ReplaceString(Trim(sEMulti),CRLF,',')+']},'+CRLF
    +'  { name: '''+_('Other caches')+''', type:''line'', symbolSize:1, symbol:"circle", stack:''typ'',areaStyle:{normal:{}}, yAxisIndex:0,'+CRLF
    +'    color:'+sColorOther+', data:['+ReplaceString(Trim(sEOther),CRLF,',')+']},'+CRLF
    +'  { name: '''+_('Total')+''', type:''line'', symbolSize:1, symbol:"circle", stack:''Total'', yAxisIndex:0,'+CRLF
    +'    color:'+sColorTotal+', lineStyle:{type:''dotted''},'+CRLF
    +'    data:['+ReplaceString(Trim(sETotal),CRLF,',')+']},'+CRLF
    +'  { name: '''+_('From beginning of the year')+''', type:''line'', symbol:"circle", symbolSize:1, stack:''Yearly'', yAxisIndex:1,'+CRLF
    +'    color:'+sColorYearly+', lineStyle:{type:''dotted''},'+CRLF
    +'    data:['+ReplaceString(Trim(sEYearly),CRLF,',')+']}],'+CRLF
  sEOption:='option={'+CRLF
    +'  dataZoom: [{type: ''inside''}, {type: ''slider''}],'+CRLF
    +'  tooltip:{show:true, trigger:''axis'',axisPointer:{ type:''cross''},'+CRLF
    +'  formatter: function(par){'+CRLF
    +'    idx0=idx1=idx2=idx3=idx4=idx5=-1;'+CRLF
    +'    for(i=0;i<6;i++){'+CRLF
    +'      if(!par[i]) break;'+CRLF
    +'      if(par[i].seriesIndex==0) idx0=i;'+CRLF
    +'      if(par[i].seriesIndex==1) idx1=i;'+CRLF
    +'      if(par[i].seriesIndex==2) idx2=i;'+CRLF
    +'      if(par[i].seriesIndex==3) idx3=i;'+CRLF
    +'      if(par[i].seriesIndex==4) idx4=i;'+CRLF
    +'      if(par[i].seriesIndex==5) idx5=i;'+CRLF
    +'    }'+CRLF
    +'    s0=s1=s2=s3=s4=s5="";'+CRLF
    +'    if(idx0>-1) s0=par[idx0].marker+" "+par[idx0].seriesName+": "+par[idx0].value;'+CRLF
    +'    if(idx1>-1) s1=par[idx1].marker+" "+par[idx1].seriesName+": "+par[idx1].value+"<br/>";'+CRLF
    +'    if(idx2>-1) s2=par[idx2].marker+" "+par[idx2].seriesName+": "+par[idx2].value+"<br/>";'+CRLF
    +'    if(idx3>-1) s3=par[idx3].marker+" "+par[idx3].seriesName+": "+par[idx3].value+"<br/>";'+CRLF
    +'    if(idx4>-1) s4=par[idx4].marker+" "+par[idx4].seriesName+": "+par[idx4].value+"<br/>";'+CRLF
    +'    if(idx5>-1) s5=par[idx5].marker+" "+par[idx5].seriesName+": "+par[idx5].value[1]+"<br/>";'+CRLF
    +'    s=''<p style="text-align:center; margin:0px;">''+par[0].name+''</p>'''+CRLF
    +'      +''<p style="text-align:left; margin:0px;">''+s4+s5+s3+s2+s1+s0+"</p>";'+CRLF
    +'    return s;'+CRLF
    +'  }},'+CRLF
    +'  grid:{ left:5, right:10, bottom:40, top:50, containLabel:true },'+CRLF
    //vlozime toolbox s ikonou pro ulozeni grafu jako obrazek a pro vypnuti stacku
    //(pricita i celkovy pocet nalezu a nalezy za rok)
    //je potreba posunout top:70
    //+'  toolbox:{show:true, top:15, feature:{'+CRLF
    //+'    magicType:{show:true, type:[''stack'',''tiled''],title:{tiled:''Vse od nuly'', stack:''Kumulativni''}},'+CRLF
    //+'    saveAsImage:{show: true}'+CRLF
    //+'  }},'+CRLF
    +sEX+CRLF+sEY+CRLF
    +'  legend:{textStyle:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'0.8')+'},'+CRLF
    +' data:[''Traditional Cache'',''Unknown Cache'',''Multi-cache'','
    +''''+_('Other caches')+''','''+_('Total')+''','''+_('From beginning of the year')+''']},'+CRLF
    +sEData+'};'+CRLF
    ;
  // konec EChar -------------
  // vlastn vstup modulu
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  //ECharts --------------------
  sEId:='ID'+IntToStr(iItem);
  //vykresleni grafu
  Result:='<div id="'+sEId+'" style="width:'+IntToStr(iWidth)+'px; height:'+IntToStr(440)+'px;"></div>'+CRLF
    //+'%StyleTableBottomTextStartHtml%'+
    //  +'<i>'+_('You can zoom by scrolling or using sliders under the chart.')+'</i>'
    //  +'%StyleTableBottomTextEndHtml%'+CRLF
    +'<script type="text/javascript">'+CRLF
    +'  var chart_'+sEId+'=echarts.init(document.getElementById('''+sEId+'''));'+CRLF
    +sEOption
    //vytvoreni grafu s potrebnymi parametry a definovanym tematem
    +'  chart_'+sEId+'.setOption(option);'+CRLF
    +'</script>'+CRLF+CRLF;
  Output(Result);
  Result:='';
end;