type TCat = record
	Name:String;
	Gx: String;
	Gy: Integer;
	GSort: Integer;
	Guid: String;
	mGuid: String;
	Img: String;
end;

type TDBCat = record
	wmtype:String;
	wmfound, wmown, wmall: Integer;
end;

var
	Cats : array of TCat;				//Seznam relevantnch kategorii
	DBobj: array of TDBCat;				//Seznam naten z DB
	Idx : Integer;
	DruhaDB : TSqliteDatabase;			//Druha DB (Waymarking);


const
	XFILE = 'WMCategories.xml';
	sModuleTmp = '\Stator\Tmp\';
	hrefCat = 'http://www.waymarking.com/cat/details.aspx?f=1&guid=';
	hrefCatVisit = 'http://www.waymarking.com/cat/details.aspx?f=1&guid=**cat**&wft=3&uid=**acc**&st=2&uguid=**acc**';
	hrefCatPost = 'http://www.waymarking.com/cat/details.aspx?f=1&guid=**cat**&wft=2&uid=**acc**&st=2&uguid=**acc**';
	hrefImg = 'http://www.waymarking.com/images/cat_icons/';
	icoNO = 'http://www.waymarking.com/images/icons/blankblue.gif';
	icoFree = 'http://www.waymarking.com/images/icons/blankgray.gif';
	//
	XMLCat = 'http://www.geotrebic.cz/b/WMCategories.xml';
	XMLCat2 = 'http://www.drakmrak.cz/b/WMCategories.xml';
	

procedure swap(var a,b:TCat);
var
  temp : TCat;
begin
  temp := a;
  a := b;
  b := temp;
end;

procedure BubbleSort(var a:array of TCat);
var
  n, newn, i:integer;
begin
  Log('Sort start');
  n := high(a);
  repeat
    newn := 0;
    for i := 1 to n   do
      begin
        if a[i - 1].GSort > a[i].GSort then
          begin
            swap( a[i - 1], a[i]);
            newn := i ;
          end;
      end ;
    n := newn;
  until n = 0;
  Log('Sort end');
end;

function SearchCat(name:String):TCat;
var
	i:Integer;
	sName:String;
begin
  //Result := nil;
  sName := ReplaceString(name,'  ',' ');
  for i := 0 to high(Cats) do begin
	if Cats[i].Name = sName then begin
		Result := Cats[i];
		break;
	end;
  end;
end;

function SearchDBCat(name:String):TDBCat;
var
	i:Integer;
	sName:String;
begin
  //Result := nil;
  for i := 0 to high(DBobj) do begin
	sName := ReplaceString(DBobj[i].wmtype,'  ',' ');
	if DBobj[i].wmtype = name then begin
		Result := DBobj[i];
		break;
	end;
  end;
end;	

procedure AddElementsToData(TE:TJclSimpleXMLElem);
var
	TEx: TJclSimpleXMLElem;
	i: Integer;
begin	
	For i:=0 to TE.Items.Count-1 do begin
		TEx:=TE.Items[i];
		//Log(TEx.Properties.ItemNamed['name'].Value);
		if Assigned(TEx.Properties.ItemNamed['use']) then begin
			AddElementsToData(TEx);
		end
		else begin
			SetLength(Cats, Length(Cats) + 1);
			Cats[Idx].Name :=  XMLEntityDecode(TEx.Properties.ItemNamed['name'].Value);
			Cats[Idx].Gx :=  TEx.Properties.ItemNamed['gx'].Value;
			Cats[Idx].Gy :=  StrToInt(TEx.Properties.ItemNamed['gy'].Value);
			Cats[Idx].GSort :=  ((Cats[Idx].Gy*20)-20) + 
				(Ord(Uppercase(Cats[Idx].Gx)[1])-65);
			Cats[Idx].Guid :=  TEx.Properties.ItemNamed['guid'].Value;
			Cats[Idx].mGuid :=  TEx.Properties.ItemNamed['mguid'].Value;
			Cats[Idx].Img :=  TEx.Properties.ItemNamed['img'].Value;
			Inc(Idx);
		end;
	end;
end;
	
procedure LoadXMLData;
var
	Xml: TJclSimpleXML;							//xml
	TargetEls: TJclSimpleXMLNamedElems;
	TargetEl: TJclSimpleXMLElem;
	xml_text,msg: String;
	//PathProp, ItemProp: 														TJclSimpleXMLProp;
	i: Integer;
begin
	Idx := 0;
	Xml := TJclSimpleXML.Create();
	try
		if HttpAsk('GET', XMLCat, '', '', xml_text) then begin
			//ulozi data
			if FileExists(GEOGET_SCRIPTDIR + sModuleTmp + XFILE) then begin
				if DeleteFile(GEOGET_SCRIPTDIR + sModuleTmp + XFILE) then
					StringToFile(xml_text,GEOGET_SCRIPTDIR + sModuleTmp + XFILE);
			end
			else
				StringToFile(xml_text,GEOGET_SCRIPTDIR + sModuleTmp + XFILE);
		end
		else begin
			if HttpAsk('GET', XMLCat2, '', '', xml_text) then begin
				//ulozi data
				if FileExists(GEOGET_SCRIPTDIR + sModuleTmp + XFILE) then begin
					if DeleteFile(GEOGET_SCRIPTDIR + sModuleTmp + XFILE) then
						StringToFile(xml_text,GEOGET_SCRIPTDIR + sModuleTmp + XFILE);
				end
				else
					StringToFile(xml_text,GEOGET_SCRIPTDIR + sModuleTmp + XFILE);
			end
			else begin
				if not FileExists(GEOGET_SCRIPTDIR + sModuleTmp + XFILE) then begin
					msg :='ERR: '+_('Could not download or open: ') + XFILE;
					Log(msg);
					exit;
				end;
			end;
		end;
		//
		Xml.loadfromfile(GEOGET_SCRIPTDIR + sModuleTmp + XFILE, seAuto, 0);
		TargetEls := Xml.Root.Items.NamedElems['Category'];
		For i:=0 to TargetEls.Count-1 do begin
			TargetEl := TargetEls.Item[i];
			if TargetEl.Items.Count > 0 then begin
				//
				//Log(TargetEl.Properties.ItemNamed['name'].Value);			//zaloguj se hlavn kategorie
				AddElementsToData(TargetEl);
				//
			end;
		end;
	finally
		Xml.free();
	end;
end;

//hlavni funkce modulu
function WMCategoryStat_Run(aPar:TStringList):string;
var
	sSQL,msg,s,sTableData,sOdd:String;
	sWaymarkingDB,sNewDB,sType,sData:String;
	table: TSQLiteTable;
	sumA,sumB,sumC: integer;
	obj:TCat; objDB:TDBCat;
	i,j,k,m,n,cnt,tabcnt:integer;
	cnty:array[1..20] of Integer;
begin
	LoadXMLData;
	log('XML data loaded');
	BubbleSort(Cats);
	//----------------------------
	//Zpracovn------------------
	//----------------------------
	sumA := 0; sumB := 0; sumC := 0;
	sWaymarkingDB := aPar.Values['WaymarkingDB'];
	sType := aPar.Values['Type'];
	sData := aPar.Values['Data'];
	//Log(sType+','+sData);
	s := Fetch(sData,'-');
	sData := s;
	s := Fetch(sType,'-');
	sType := s;
	//Log(sType+','+sData);
	//----------------------------
	sNewDB := Fetch(sWaymarkingDB,'.');
	if not (FileExists(GEOGET_DATADIR + '\' + sNewDB + '.db3')) then begin
		msg := 'ERR: There is no database for Waymarking: ' + sWaymarkingDB
			+ ' badges for waymarking will not be created!';
		Log(msg);
		Exit;
	end;
	DruhaDB := TSqliteDatabase.Create(GEOGET_DATADIR + '\' + sNewDB + '.db3');
	//----------------------------
	sSQL := 'SELECT wmtype, SUM(wmfound) wmfound, SUM(wmown) wmown, SUM(wmfound)+SUM(wmown) wmall';
	sSQL := sSQL + ' FROM(SELECT gc.cachetype wmtype, count(gc.id) wmfound, 0 wmown';
	sSQL := sSQL + ' FROM Geocache gc';
	sSQL := sSQL + ' WHERE gc.dtfound <> 0';
	sSQL := sSQL + ' GROUP BY gc.cachetype';
	sSQL := sSQL + ' UNION ALL';
	sSQL := sSQL + ' SELECT gc.cachetype wmtype, 0 wmfound, count(gc.id) wmown';
	sSQL := sSQL + ' FROM Geocache gc';
	sSQL := sSQL + ' WHERE gc.author LIKE "%' + GlobalVarGet('GeogetOwner',false) + '%"';
	sSQL := sSQL + ' GROUP BY gc.cachetype)';
	sSQL := sSQL + ' GROUP BY wmtype';
	Case sData of
		'0': sSQL := sSQL + ' ORDER BY wmfound DESC, wmtype ASC;';
		'1': sSQL := sSQL + ' ORDER BY wmown DESC, wmtype ASC;';
		'2': sSQL := sSQL + ' ORDER BY wmall DESC, wmtype ASC;';
		'3': sSQL := sSQL + ';';
	end;
	//Log(sSQL);
	table := DruhaDB.GetTable(sSQL, false);
	log('SQL data prepared');
	//----------------------------
	//Nate data z DB-------------
	//----------------------------
	i:=0;
	while not table.Eof do begin
		SetLength(DBobj, Length(DBobj) + 1);
		DBobj[i].wmtype := table.FieldAsString(0);
		DBobj[i].wmfound := table.FieldAsInteger(1);
		DBobj[i].wmown := table.FieldAsInteger(2);
		DBobj[i].wmall := table.FieldAsInteger(3);
		//log('T:'+DBobj[i].wmtype+'|'+IntToStr(DBobj[i].wmfound)+'|'+IntToStr(DBobj[i].wmown));
		Inc(i);
		table.Next;
	end;
	//----------------------------
	//Vstup----------------------
	//----------------------------
	if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
	//
	//log('Title:'+Result);
	//
	if sType = '0' then begin	//List
		sTableData := CRLF+'<br /><table style="%StyleTableNum%">'+CRLF;
		sTableData := sTableData+'<tr style="%StyleTableNumTr%">';
		//
		if sData = '3' then exit;
		//HEADER
		Case sData of
			'0','1': begin
					sTableData := sTableData+'<th style="%StyleTableNumTh%">'+_('Icon')+'</th><th style="%StyleTableNumTh%">'+_('Category name')+'</th>';
					if sData = '0' then begin
						sTableData := sTableData+'<th style="%StyleTableNumTh%">'+_('Visited')+'</th>';
					end
					else begin
						sTableData := sTableData+'<th style="%StyleTableNumTh%">'+_('Posted')+'</th>';
					end;
			end;
			'2': sTableData := sTableData + '<th style="%StyleTableNumTh%">'+_('Icon')+
						'</th><th style="%StyleTableNumTh%">'+_('Category name')+'</th><th style="%StyleTableNumTh%">'+_('Visited')+'</th>'+
						'<th style="%StyleTableNumTh%">'+_('Posted')+'</th><th style="%StyleTableNumTh%">'+_('Total')+'</th>';
			else exit;
		end;
		sTableData := sTableData + '</tr>'+CRLF;
		//DATA
		j := 1;
		For i:=0 to high(DBobj) do begin
			//DATA
			if (sData = '0') or (sData = '1') then begin
				//log('sData:'+sData);
				if sData = '0' then begin
			  		if DBobj[i].wmfound = 0 then continue;
				end
				else begin
			  		if DBobj[i].wmown = 0 then continue;
				end;
			end;
			//
			obj := SearchCat(DBobj[i].wmtype);
			sOdd := '';
			if j mod 2 = 0 then sOdd := 'Odd';
			sTableData := sTableData + '<tr style="%StyleTableListTr'+sOdd+'%">';
			//if Assigned(obj) then begin
				Case sData of
					'0','1': begin
						sTableData := sTableData+'<td style="text-align:center; %StyleTableListTd'+sOdd+'%"><img src="'+hrefImg+obj.Img+'" width="24"></td>'+
									'<td style="%StyleTableListTd'+sOdd+'%"><a href="'+hrefCat+obj.Guid+'" target="_blank">'+obj.Name+'</a></td>';
						if sData = '0' then begin
							if sGuidCom <> '' then begin
								sTableData := sTableData+'<td style="text-align:center; %StyleTableListTd'+sOdd+'%">'+
									'<a href="'+ReplaceString(ReplaceString(hrefCatVisit,'**acc**',sGuidCom),'**cat**',obj.Guid)+'" target="_blank">'+
									IntToStr(DBobj[i].wmfound)+'</a></td>';
							end
							else begin
								sTableData := sTableData+'<td style="text-align:center; %StyleTableListTd'+sOdd+'%">'+
									IntToStr(DBobj[i].wmfound)+'</td>';
							end;
							sumA := sumA + DBobj[i].wmfound;
						end
						else begin
							if sGuidCom <> '' then begin
								sTableData := sTableData+'<td style="text-align:center; %StyleTableListTd'+sOdd+'%">'+
									'<a href="'+ReplaceString(ReplaceString(hrefCatPost,'**acc**',sGuidCom),'**cat**',obj.Guid)+'" target="_blank">'+
									IntToStr(DBobj[i].wmown)+'</a></td>';
							end
							else begin
								sTableData := sTableData+'<td style="text-align:center; %StyleTableListTd'+sOdd+'%">'+
									IntToStr(DBobj[i].wmown)+'</td>';
							end;
							sumA := sumA + DBobj[i].wmown;
						end;
					end;
					'2': begin
						sTableData := sTableData + '<td style="text-align:center; %StyleTableListTd'+sOdd+'%"><img src="'+hrefImg+obj.Img+'" width="24"></td>'+
						'<td style="%StyleTableListTd'+sOdd+'%"><a href="'+hrefCat+obj.Guid+'" target="_blank">'+obj.Name+'</a></td>';
						if sGuidCom <> '' then begin
							sTableData := sTableData + '<td style="text-align:center; %StyleTableListTd'+sOdd+'%"><a href="'+ReplaceString(ReplaceString(hrefCatVisit,'**acc**',sGuidCom),'**cat**',obj.Guid)+
								'" target="_blank">'+IntToStr(DBobj[i].wmfound)+'</a></td>'+
								'<td style="text-align:center; %StyleTableListTd'+sOdd+'%"><a href="'+ReplaceString(ReplaceString(hrefCatPost,'**acc**',sGuidCom),'**cat**',obj.Guid)+
								'" target="_blank">'+IntToStr(DBobj[i].wmown)+'</a></td>';
						end
						else begin
							sTableData := sTableData + '<td style="text-align:center; %StyleTableListTd'+sOdd+'%">'+
								IntToStr(DBobj[i].wmfound)+'</td>'+
								'<td style="text-align:center; %StyleTableListTd'+sOdd+'%">'+
								IntToStr(DBobj[i].wmown)+'</td>';
						end;
						sTableData := sTableData + '<td style="text-align:center; %StyleTableListTd'+sOdd+'%">'+IntToStr(DBobj[i].wmall)+'</td>';
						sumA := sumA + DBobj[i].wmfound;
						sumB := sumB + DBobj[i].wmown;
						sumC := sumC + DBobj[i].wmall;
					end;
				end;
			//end;
			sTableData := sTableData + '</tr>'+CRLF;
			Inc(j);
		end;
		if aPar.Values['CategorySum'] = 'Yes' then begin
			sTableData := sTableData+'<tr style="%StyleTableNumTr%">';
			Case sData of
				'0','1': begin
					sTableData := sTableData+'<th style="%StyleTableNumTh%">'+_('Total:')+'</th><th style="%StyleTableNumTh%">'+IntToStr(j-1)+
						'</th><th style="text-align:center; %StyleTableNumTh%">'+IntToStr(sumA)+'</th>';
				end;
				'2': begin
				  	sTableData := sTableData+'<th style="%StyleTableNumTh%">'+_('Total:')+'</th><th style="%StyleTableNumTh%">'+IntToStr(j-1)+
						'</th><th style="text-align:center; %StyleTableNumTh%">'+IntToStr(sumA)+'</th>'+
						'<th style="text-align:center; %StyleTableNumTh%">'+IntToStr(sumB)+'</th>'+
						'<th style="text-align:center; %StyleTableNumTh%">'+IntToStr(sumC)+'</th>';
				end;
			end; 
			sTableData := sTableData + '</tr>'+CRLF;  
		end;
		sTableData := sTableData + '</table>'+CRLF;
		//log(sTableData);
	end
	else begin							//Table
		j := 0; k:=0; n:=0; cnt:=0;
		sTableData := '';
		//
		if (Length(Cats) mod 20) > 0 then
			tabcnt := (Length(Cats) div 20)*20 + 20
		else
			tabcnt := (Length(Cats) div 20)*20;
		//
		
		For m:=0 to high(DBobj) do begin
			if DBobj[m].wmfound > 0 then sumA := sumA + 1;
			if DBobj[m].wmown > 0 then sumB := sumB + 1;
			if DBobj[m].wmall > 0 then sumC := sumC + 1;
		end;
		//
		if aPar.Values['CategorySum'] = 'Yes' then begin
			sTableData := sTableData+'<p><b>'+_('Grid Count %1 of %2')+'</b></p>'+CRLF;
			Case sData of
				'0': sTableData := ReplaceString(ReplaceString(sTableData,'%1',IntToStr(sumA)),'%2',IntToStr(Length(Cats)));
				'1': sTableData := ReplaceString(ReplaceString(sTableData,'%1',IntToStr(sumB)),'%2',IntToStr(Length(Cats)));
				'2': sTableData := ReplaceString(ReplaceString(sTableData,'%1',IntToStr(sumC)),'%2',IntToStr(Length(Cats)));
				else sTableData := '';
			end;
		end;
		//
		sTableData := sTableData + '<p align="center">'+CRLF;
		//
		For m:=1 to 20 do cnty[m] := 0;
		//
		for i := 0 to tabcnt-1 do begin
			if j = 0 then begin	//Header + Table
			  sTableData := sTableData+'<p><table align="center"><thead>'+
			  	'<th style="text-align:center; padding:1px;"></th><th style="text-align:center; padding:1px;">A</th><th style="text-align:center; padding:1px;">B</th>'+
            	'<th style="text-align:center; padding:1px;">C</th><th style="text-align:center; padding:1px;">D</th><th style="text-align:center; padding:1px;">E</th>'+
				'<th style="text-align:center; padding:1px;">F</th><th style="text-align:center; padding:1px;">G</th><th style="text-align:center; padding:1px;">H</th>'+
                '<th style="text-align:center; padding:1px;">I</th><th style="text-align:center; padding:1px;">J</th><th style="text-align:center; padding:1px;">K</th>'+
                '<th style="text-align:center; padding:1px;">L</th><th style="text-align:center; padding:1px;">M</th><th style="text-align:center; padding:1px;">N</th>'+
                '<th style="text-align:center; padding:1px;">O</th><th style="text-align:center; padding:1px;">P</th><th style="text-align:center; padding:1px;">Q</th>'+
                '<th style="text-align:center; padding:1px;">R</th><th style="text-align:center; padding:1px;">S</th><th style="text-align:center; padding:1px;">T</th>'+
                '<th style="text-align:center; padding:1px;"></th></thead>'+CRLF;
				Inc(j);
			end;
			//row start
			if k = 0 then begin
				sTableData := sTableData + '<tr><th style="text-align:center; padding:1px 3px 1px 3px;">'+IntToStr(j+n*20)+'</th>';
				Inc(k);
			end;
			//
			sTableData := sTableData + '<td style="text-align:center; padding:1px;">';
			if sData <> '3' then begin
				objDB.wmtype := '*';
				if i < Length(Cats) then begin
					objDB := SearchDBCat(Cats[i].Name);
					Case sData of
						'0': begin
							if objDB.wmfound = 0 then objDB.wmtype := '*';
						end;
						'1':begin
							if objDB.wmown = 0 then objDB.wmtype := '*';
						end;
					end;
				end;
				if objDB.wmtype = '*' then begin
					if i < Length(Cats) then
						sTableData := sTableData + '<img src="'+icoNO+'" title="'+Cats[i].Name+'" width="24" alt="'+Cats[i].Name+
							'" style="vertical-align: middle; border-style:solid; border-width: 1px" />'
					else 
						sTableData := sTableData + '<img src="'+icoFree+'" title="'+_('Nothing')+'" width="24" alt="'+_('Nothing')+
							'" style="vertical-align: middle; border-style:solid; border-width: 1px" />'
				end
				else begin
					sTableData := sTableData + '<a href="http://www.waymarking.com/cat/details.aspx?f=1&guid='+Cats[i].Guid+'" target="_blank">';
					sTableData := sTableData + '<img src="'+hrefImg+Cats[i].Img+'" title="'+Cats[i].Name+'" width="24" alt="'+Cats[i].Name+
						'" style="vertical-align: middle; border-style:solid; border-width: 1px" />';
					sTableData := sTableData + '</a>';
					Inc(cnt);
					Inc(cnty[k]);
				end;
			end
			else begin
				if i < Length(Cats) then begin
			  		sTableData := sTableData + '<a href="http://www.waymarking.com/cat/details.aspx?f=1&guid='+Cats[i].Guid+'" target="_blank">';
					sTableData := sTableData + '<img src="'+hrefImg+Cats[i].Img+'" title="'+Cats[i].Name+'" width="24" alt="'+Cats[i].Name+
						'" style="vertical-align: middle; border-style:solid; border-width: 1px" />';
					sTableData := sTableData + '</a>';
				end
				else begin
					sTableData := sTableData + '<img src="'+icoFree+'" title="'+_('Nothing')+'" width="24" alt="'+_('Nothing')+
							'" style="vertical-align: middle; border-style:solid; border-width: 1px" />'
				end;
				Inc(cnt);
				if i < Length(Cats) then Inc(cnty[k]);
			end;
			sTableData := sTableData + '</td>';
			Inc(k);
			if k>20 then begin
			  k:=0;
			  Inc(j);
			  sTableData:=sTableData+'<th style="text-align:center; padding:1px 3px 1px 3px;">'+IntToStr(cnt)+'</th></tr>'+CRLF;
			  cnt:=0;
			end;
			if (j>20) then begin
				if (i <> tabcnt-1) then sTableData:=sTableData+'</table></p>'+CRLF;
				j:=0;
				Inc(n);
			end;
			if (i=tabcnt-1) then begin
				sTableData:=sTableData+'<thead>'+
			  	'<th style="text-align:center; padding:1px;"></th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[1])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[2])+'</th>'+
            	'<th style="text-align:center; padding:1px;">'+IntToStr(cnty[3])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[4])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[5])+'</th>'+
				'<th style="text-align:center; padding:1px;">'+IntToStr(cnty[6])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[7])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[8])+'</th>'+
                '<th style="text-align:center; padding:1px;">'+IntToStr(cnty[9])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[10])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[11])+'</th>'+
                '<th style="text-align:center; padding:1px;">'+IntToStr(cnty[12])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[13])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[14])+'</th>'+
                '<th style="text-align:center; padding:1px;">'+IntToStr(cnty[15])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[16])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[17])+'</th>'+
                '<th style="text-align:center; padding:1px;">'+IntToStr(cnty[18])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[19])+'</th><th style="text-align:center; padding:1px;">'+IntToStr(cnty[20])+'</th>'+
                '<th style="text-align:center; padding:1px;"></th></thead>'+CRLF;
			  	sTableData:=sTableData+'</table></p>'+CRLF;
			end;
		end;
		sTableData:=sTableData+'</p>'+CRLF;
	end;
	Result := Result + sTableData;
	Output(Result);
  	sTableData:=''; Result := '';
	//----------------------------
	//END-------------------------
	//----------------------------
	SetLength(Cats, 0); 						//Totln vmaz pole kategorii
	SetLength(DBobj, 0); 						//Totln vmaz pole DB kategorii
	if (DruhaDB <> nil) then DruhaDB.Free();	//Zrum koneknu druh databze
end;