// Ron statistiky nlez - grafy po mscch a ron sla - vetn pepnac logiky

procedure YearlyStats_OutputYear(iYear,iMonthRange:integer);
var 
  tab:TSqliteTable;
  s,sSql,sPerMonth,sPerWeek,sOut,sFTFindex:string;
  sEData,sENames,sELabels:string;
  i,iHeight,iGraphWd,iTotalDays,iTotalFounds,iCachingDays,iFTF,iCountries:integer;
  iY,iM,iD:word;
  aMonth,aMDays:array[0..12] of integer;
  aMonthName:array [0..12] of string;
begin
  // rozmry grafu s msnmi nlezy
  iGraphWd:=Round(2*iWidth/3);
  iHeight:=180;
  //aktuln rok a msc
  DecodeDate(Now,iY,iM,iD);
  // zkratky msc
  aMonthName[1]:='Jan';   aMonthName[2]:='Feb';     aMonthName[3]:='Mar';
  aMonthName[4]:='Apr';   aMonthName[5]:='Ma';      aMonthName[6]:='Jun';
  aMonthName[7]:='Jul';   aMonthName[8]:='Aug';     aMonthName[9]:='Sep';
  aMonthName[10]:='Oct';  aMonthName[11]:='Nov';    aMonthName[12]:='Dec';
  
  // sestaven dat pro graf
  //Geoget_DB.AddParamText(':Prefix',sCachePrefix+'%');
  sSql:='SELECT count(*) MonthCount, dtfound/100 Month, count(distinct dtfound) MonthDays'
       +'  FROM geocache gc'
       +'  WHERE '+sCachePrefixForSql
//       +'  WHERE id like :Prefix'
       +'    AND dtfound/10000='+IntToStr(iYear)
       +'  GROUP BY Month';
  //Log('XXXXXX '+sSql);
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      i:=StrToInt(Copy(tab.FieldByName['Month'],5,2));
      aMonth[i]:=StrToInt(tab.FieldByName['MonthCount']);
      aMDays[i]:=StrToInt(tab.FieldByName['MonthDays']);
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  for i:=1 to 12 do begin
    //vytvarime data jako pole 2 prvku: [pocet nalezu, pocet dni s nalezy]
    sEData:=sEData+'['+IntToStr(i-1)+','+IntToStr(aMonth[i])+','+IntToStr(aMDays[i])+']'+CRLF;
    //protoze mesic jde do URL, musime ho prevest na znaky povolene v URL
    s:=GlobalVarGet('Month'+aMonthName[i],false);
    sENames:=sENames+s+CRLF;
    if((iYear>=iY) and (i>iM)) then begin
      sELabels:=sELabels+CRLF;
    end
    else begin
      sELabels:=sELabels+IntToStr(aMonth[i])+'/'+IntToStr(aMDays[i])+CRLF;
    end;
  end;
  // hodnoty pro statistick sla do tabulky vpravo
  sSql:='SELECT 100*avg(MonthCount)+0.5 FROM ('
       +'  SELECT count(*) MonthCount, dtfound/100 Month'
       +'    FROM geocache gc'
       +'    WHERE gc.dtfound/10000='+IntToStr(iYear)+' AND '+sCachePrefixForSql
       +'    GROUP BY Month)';
  sPerMonth:=FormatFloatDot('0.0',Geoget_DB.GetTableValue(sSql)/100.0);
  sSql:='SELECT 100*avg(WeekCount)+0.5 FROM ('
       +'  SELECT count(*) WeekCount, (strftime("%W",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2))) Week'
       +'    FROM geocache gc'
       +'    WHERE gc.dtfound/10000='+IntToStr(iYear)+' AND '+sCachePrefixForSql
       +'    GROUP BY Week)';
  sPerWeek:=FormatFloatDot('0.0',Geoget_DB.GetTableValue(sSql)/100.0);
  sSql:='SELECT count(*)'
       +'    FROM geocache gc'
       +'    WHERE gc.dtfound/10000='+IntToStr(iYear)+' AND '+sCachePrefixForSql;
  iTotalFounds:=Geoget_DB.GetTableValue(sSql);
  sSql:='SELECT count(distinct dtfound)'
       +'  FROM geocache gc'
       +'  WHERE gc.dtfound/10000='+IntToStr(iYear)+' AND '+sCachePrefixForSql;
  iCachingDays:=Geoget_DB.GetTableValue(sSql);
  sSql:='SELECT count(distinct country)'
       +'  FROM geocache gc'
       +'  WHERE gc.dtfound/10000='+IntToStr(iYear)+' AND '+sCachePrefixForSql;
  iCountries:=Geoget_DB.GetTableValue(sSql);
  sSql:='SELECT count(*)'
       +'  FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
       +'  WHERE gt.id=gc.id and gc.dtfound/10000='+IntToStr(iYear)+' AND '+sCachePrefixForSql
       +'    AND gtc.key=gt.ptrkat'
       +'    AND gtc.value=''FTF'''
       +'    AND gtv.key=gt.ptrvalue and gtv.value like ''%FTF%''';
  iFTF:=Geoget_DB.GetTableValue(sSql);
  sFTFindex:='';
  if iTotalFounds>0 then sFTFindex:=FormatFloatDot('0.0',100.0*iFTF/iTotalFounds);
  if iYear>=iY then 
    iTotalDays:=Trunc(Now-EncodeDate(iYear,1,1))+1
  else 
    iTotalDays:=Trunc(EncodeDate(iYear,12,31)-EncodeDate(iYear,1,1))+1;

  Log('Rok: '+IntToStr(iYear)+', Total Days: '+IntToStr(iTotalDays)+', Caching Days: '+IntToStr(iCachingDays));

  sOut:='<table style="%StyleTableNum%"><tr><th colspan="3" style="%StyleTableNumTh%">'+IntToStr(iYear)+'</th></tr>'+CRLF;
  sOut:=sOut+'  <tr><td rowspan="10"><div style="width-max:'+IntToStr(iGraphWd)+'px; width:'+IntToStr(iGraphWd)+'px;">';
  Output(sOut);
  // sestaven vstupu
  s:=EChartsBarChart('ID'+IntToStr(iItem)+'_'+IntToStr(iYear),sEData,sENames,
    //doplnime options o fomatovani labelu
    +'    label:{show:true, formatter:function(par){'+CRLF
    +'      var s=""+par.value;'+CRLF
    +'      a=s.split(",");'+CRLF   //preskocime X souradnici
    +'      s=a[1]+"/"+a[2];'+CRLF  //vezmeme odu Y a dalsi hodnotu (pocet dni)
    +'      return(s);'+CRLF
    +'    }},'+CRLF
    ,'function(par){'+CRLF           //funkce pro formatovani tooltipu
    +'      var s=""+par[0].value;'+CRLF
    +'      a=s.split(",");'+CRLF   //preskocime X souradnici
    +'      s=a[1]+"/"+a[2];'+CRLF  //vezmeme odu Y a dalsi hodnotu (pocet dni)
    +'      s="'+_('Finds in month:')+' "+a[1]+"<br/>'+_('Caching days:')+' "+a[2];'+CRLF 
    +'      return(s);'+CRLF
    +'    }'
    ,true,false,iGraphWd,iHeight);
  //pokud ma byt spolecne meritko, nastavime velikost osy Y
  //nastavime to vzdy, ale uplatni se to jen kdyz mazimalni hodnota je mensi nez
  //zadany rozsah
  if iMonthRange<>0 then s:=ReplaceString(s,'yAxis:[{type:''value'',','yAxis:[{type:''value'', max:'+IntToStr(iMonthRange)+',');
  Output(s);
  //sOut:='</div></td><td>&nbsp;</td></tr>'+CRLF;
  sOut:='</div></td><td colspan="2">&nbsp;</td></tr>'+CRLF;
  //sOut:='</div></td><td colspan="2" width="'+IntToStr(iWidth-iGraphWd-3)+'">&nbsp;</td></tr>'+CRLF;
  sOut:=sOut+'  <tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'+_('Total finds')+'</td><td style="%StyleTableNumTd%"><b>'+IntToStr(iTotalFounds)+'</b></td></tr>'+CRLF
 +'  <tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'+_('Caching days')+'</td><td style="%StyleTableNumTd%"><b>'+IntToStr(iCachingDays)+'</b></td></tr>'+CRLF;
  //oeten situace, kdy za cel rok nen ani jeden nlez
  if iCachingDays=0 then iCachingDays:=1;
  sOut:=sOut+'  <tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'+_('Average finds per caching day')+'</td><td style="%StyleTableNumTd%"><b>'+FormatFloatDot('0.00',1.0*iTotalFounds/iCachingDays)+'</b></td></tr>'+CRLF
            +'  <tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'+_('Overall finds per day')+'</td><td style="%StyleTableNumTd%"><b>'+FormatFloatDot('0.00',1.0*iTotalFounds/iTotalDays)+'</b></td></tr>'+CRLF
            +'  <tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'+_('Overall finds per week')+'</td><td style="%StyleTableNumTd%"><b>'+sPerWeek+'</b></td></tr>'+CRLF
            +'  <tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'+_('Overall finds per month')+'</td><td style="%StyleTableNumTd%"><b>'+sPerMonth+'</b></td></tr>'+CRLF
            +'  <tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'+_('First to finds')+'</td><td style="%StyleTableNumTd%"><b>'+IntToStr(iFTF)+'</b></td></tr>'+CRLF
            +'  <tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'+_('Yearly FTF index [%]')+'</td><td style="%StyleTableNumTd%"><b>'+sFTFindex+'</b></td></tr>'+CRLF
            +'  <tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">'+_('Countries cached')+'</td><td style="%StyleTableNumTd%"><b>'+IntToStr(iCountries)+'</b></td></tr>'+CRLF;
  sOut:=sOut+'  <tr><td>&nbsp;</td></tr>'+CRLF;
  sOut:=sOut+'</table>'+CRLF;
  Output(sOut);
end;

function YearlyStats_Run(aPar:TStringList):string;
var
  i,iMonthMaxFounds,iYearMin,iYearMax:integer;
  s,ss,sID,sButtID,sIDall,sButtAll,sHideYears:string;
begin
  Result:='';
  // rozsah osy msnch nlaz a intervalu let
  iMonthMaxFounds:=Geoget_DB.GetTableValue('SELECT COUNT(*) Num FROM geocache gc WHERE gc.dtfound>0 AND '
    +sCachePrefixForSql+' GROUP BY gc.dtfound/100 ORDER BY Num DESC LIMIT 1');
  iYearMin:=Geoget_DB.GetTableValue('SELECT MIN(dtfound/10000) FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql);
  iYearMax:=Geoget_DB.GetTableValue('SELECT MAX(dtfound/10000) FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql);

  // parametr pro vchoz skryt vybranch rok
  sHideYears:=aPar.Values['HideYears'];
  
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  
  // pepnac tlatka pro skryt/zobrazen sekc
  sIDall:='ID'+IntToStr(iItem)+'all';
  sButtAll:='B'+IntToStr(iItem)+'all';
  Result:=Result+'<div id="'+sIDall+'" style="display: ;"></div>'+CRLF;
  Result:=Result+'<div style="text-align:center; margin:15px;">'+CRLF;
  for i:=iYearMin to iYearMax do begin
    sID:='ID'+IntToStr(iItem)+'Y'+IntToStr(i);
    sButtID:='B'+IntToStr(iItem)+'Y'+IntToStr(i);
    Result:=Result+'<button id="'+sButtID+'" style="cursor:pointer; margin:2px 2px 5px 2px; ';
    if(Pos(IntToStr(i),sHideYears)>0) then Result:=Result+'font-weight:normal; " ' else Result:=Result+'font-weight:bold;" ';
    Result:=Result+'onclick="'
                  +'document.getElementById('''+sID+''').style.display=(getElementById('''+sID+''').style.display!=''none''?''none'':'''');'
                  +'document.getElementById('''+sButtID+''').style.fontWeight=(getElementById('''+sID+''').style.display!=''none''?''bold'':''normal'');'
                  +'return false;">'+IntToStr(i)+'</button>'+CRLF;
  end;
  Result:=Result+'<button id="'+sButtAll+'" style="cursor: pointer;" '
                +'onclick="'
                +'var s=(getElementById('''+sIDall+''').style.display!=''none''?''none'':''''); '
                +'var b=(getElementById('''+sIDall+''').style.display!=''none''?''normal'':''bold''); '
                +'var t=(getElementById('''+sIDall+''').style.display!=''none''?'''+_('Show all')+''':'''+_('Hide all')+'''); ';
  for i:=iYearMin to iYearMax do begin
    sID:='ID'+IntToStr(iItem)+'Y'+IntToStr(i);
    sButtID:='B'+IntToStr(iItem)+'Y'+IntToStr(i);
    Result:=Result+'document.getElementById('''+sID+''').style.display=s; ';
    Result:=Result+'document.getElementById('''+sButtID+''').style.fontWeight=b; ';
  end; 
  Result:=Result+'document.getElementById('''+sIDall+''').style.display=s; '
                +'document.getElementById('''+sButtAll+''').innerHTML=t; '
                +'return false;">'+_('Hide all')+'</button>'+CRLF;
  Result:=Result+'</div>'+CRLF;
  Output(Result);
  Result:='';
  
  // mtko svislch os graf
  s:=aPar.Values['Yscale'];
  ss:=Fetch(s,'-');
  case ss of
  'One':  iMonthMaxFounds:=0;     // pokud m bt mtko lokln, sta procedue poslat nulu
  end;

  // pro vechny roky od poslednho vygeneruj statistiky
  for i:=iYearMax downto iYearMin do begin
    sID:='ID'+IntToStr(iItem)+'Y'+IntToStr(i);
    if(Pos(IntToStr(i),sHideYears)>0) then
      Output('<div id="'+sID+'" style="display:none;">'+CRLF)
    else
      Output('<div id="'+sID+'" style="display:;">'+CRLF);
    YearlyStats_OutputYear(i,iMonthMaxFounds);
    Output('</div>'+CRLF);
  end;
  //Log('RRRRRR 0z iWidth='+IntToStr(iWidth));
end;
