//funkce pro obsluhu vymazanych modulu (RemovedModules.ini)

{$ifdef STATOR_GGI}      ///////// funkce pouzivane v ggi.pas
  //definujeme funkce pro ziskani adresaru, ktere jsou jinak v lib.pas
function GetMyDir:string;
begin
  Result:=RegExSubstitute('(.*\\)(.*)$',GEOGET_SCRIPTFULLNAME,'$1');
end;

  function GetModulesDir:string;
  begin
    Result:=GetMyDir()+'Modules\';
  end;

  function GetProfilesDir:string;
  begin
    Result:=GetMyDir()+'Profiles\';
  end;
{$endif}

//vymazani souboru starych modulu (pouziva Stator.ggi.pas)
procedure GGI_RemoveModules;
var ini:TMemIniFile;
    aList:TStringList;
    i:integer;
    sActions,sFiles,sDir,s:string;
begin
{$ifdef DEBUG_HELPER} LDH('GGI_RemoveModules() - start'); {$endif}
  s:=GetMyDir()+'RemovedModules.ini';
  ini:=TMemIniFile.Create(s);
  try
{$ifdef DEBUG_HELPER} LDH('GGI_RemoveModules() - ini='+s); {$endif}
    //zjistime seznam sekci=seznam modulu ke sazani
    aList:=TStringList.Create();
    try
{$ifdef DEBUG_HELPER} LDH('GGI_RemoveModules() - 2'); {$endif}
      ini.ReadSections(aList);
      //pro kazdy modul, ktery ma v Actions hodnotu DEL, nacteme adresar a postupne
      for i:=0 to aList.Count-1 do begin
{$ifdef DEBUG_HELPER} LDH('Sekce: '+aList[i]); {$endif}
        sActions:=ini.ReadString(aList[i],'Actions','');
        while (sActions<>'') do begin
          s:=Fetch(sActions,',');
          if(UpperCase(s)<>'DEL') then continue;
          //smazeme vsechny soubory podle zadanych jmen nebo masek
          sDir:=ini.ReadString(aList[i],'Dir','');
          if(sDir<>'') then sDir:=sDir+'\';
          sDir:=GetModulesDir()+sDir;
          sFiles:=ini.ReadString(aList[i],'Files','');
          while(sFiles<>'') do begin
            s:=Fetch(sFiles,',');
{$ifdef DEBUG_HELPER} LDH('Mazu (potlaceno): '+sDir+s); {$endif}
            DeleteFiles(sDir+s);
          end;
        end;
      end;
    finally
      aList.Free();
    end;
  finally
    ini.Free();
  end;
end;
{$ifndef STATOR_GGI}  ///////////////// funkce pouzivane mimo ggi.pas
//funkce vraci priznak toho, zda je modul mezi zrusenymi, a pokud ano,
//tak vraci i string s informativni zpravou
function GetActionsModuleRemoved(sModule:string;var sMessage:string):integer;
var ini:TMemIniFile;
    s,sActions:string;
begin
{$ifdef DEBUG_HELPER} LDH('AAAAA 1');{$endif}
  sMessage:='';
  Result:=MODULE_ERR; //nebyl nalezen mezi zrusenymi moduly
  ini:=TMemIniFile.Create(GetMyDir()+'RemovedModules.ini');
  try
    sActions:=ini.ReadString(sModule,'Actions','?');
{$ifdef DEBUG_HELPER} LDH('AAAAA sActions='+sActions);{$endif}
    while(sActions<>'') do begin
      s:=UpperCase(Fetch(sActions,','));
{$ifdef DEBUG_HELPER} LDH('AAAAA s='+s);{$endif}
      case (s) of
      'DEL': Result:=Result OR MODULE_DEL;
      'IGNORE': Result:=Result OR MODULE_IGNORE;
      'INFO': begin//ziskame text pro zobrazeni
                sMessage:=ini.ReadString(sModule,'Text_'+sLang,'');
                if(sMessage='') then sMessage:=ini.ReadString(sModule,'Text_EN','');
                sMessage:=ReplaceString(sMessage,'\n',CRLF);
              end;
      end;
    end;
  finally
    ini.Free();
  end;
end;
{$endif}
