//Installation script for GIP packages
{$define STATOR_GGI}
{$include StringFunc.lib.pas}
{$include Stator.CopyDefault.pas}
{$include Stator.RemovedModules.pas}

function InstallWork: string;
var aList:TStringList;
    i:integer;
    sDir,s:string;
begin
  //prejmenujeme vsechny docasne zmenene *.meta.ini.Stator (kvuli instalatoru,
  //aby se nepokousel instalovat jiz nainstalovane balicky modulu)
  //na spravne *.meta.ini
{$ifdef DEBUG_HELPER} LDH('InstallWork() - start'); {$endif}
  aList:=TStringList.Create();
  sDir:=GEOGET_SCRIPTDIR+'\Stator';
  FileList(sDir+'\Modules',aList);
  for i:=0 to aList.Count-1 do begin
    if(RegexFind('(i?)\.meta\.ini\.Stator',aList[i])) then begin
      RenameFile(aList[i],copy(aList[i],1,Length(aList[i])-7));
    end;
  end;
{$ifdef DEBUG_HELPER} LDH('Smazani starych modulu'); {$endif}
  GGI_RemoveModules();  //smazeme stare soubory jiz neexistujicich modulu
{$ifdef DEBUG_HELPER} LDH('Smazani starych modulu - expost'); {$endif}
  //smazeme vsechny ggp.pas soubory ze vsech profilu
  FileList(sDir+'\Profiles',aList);
  for i:=0 to aList.Count-1 do begin
    s:=aList[i];
    if(s[Length(s)]='\') then begin
      //ShowMessage('Mazu: '+s+'StatorGen.*.pas');
      //DeleteFiles(s+'StatorGen.*.pas');
      DeleteFile(s+'StatorGen.ggp.pas');
    end;
  end;

  aList.Free();
  //zkontrolujeme, zda existuje v profilu adresar aktualniho uzivatele,
  //pokud ne, vytvorime ho
  s:=sDir+'\Profiles\'+StringCompress(GEOGET_OWNER);
  //ShowMessage(_('Copying Default profile to:')+CRLF+s);
  if(not DirectoryExists(s)) then begin
    CopyDefaultProfile(GEOGET_OWNER,true);    //nabizet i SK
    CopyDefaultProfile('Diagnostic',false);   //nenabizet SK
  end;

  //zkontrolujeme, zda existuji soubory s prihlasovacimi udaji na gc.com/cz
  //protoze nemuzeme vyzadovat zavislost na GJ, soubory vytvorime prazdne
  //aby alespon nebyla hlasena chyba pri kompilaci Statoru
  s:=GEOGET_SCRIPTDIR+'\groundspeak.default.pas';
  if(not FileExists(s)) then begin
    StringToFile(
      'const'+CRLF
      +'  gsUsername = ''''; //Groundspeak username (Geocaching.com, Waymarking.com, ...)'+CRLF
      +'  gsPassword = ''''; //Groundspeak password (Geocaching.com, Waymarking.com, ...)'+CRLF
      ,s
      );
  end;
  //ShowMessage(_('Instalation completed. We recommend to open Stator configuration and save (using OK button) all used profiles. This may reduce most of errors caused by module update.'));

  s:=GEOGET_SCRIPTDIR+'\Stator\VersionInfo_'
    +UpperCase(copy(GetCurrentLanguage(),1,2))+'.html';
  if(not FileExists(s)) then s:=GEOGET_SCRIPTDIR+'\Stator\VersionInfo_EN.html';
  s:=FileToString(s);
  ShowHTMLMessageSize('Stator Installation Info',s,700,500);
  Result:='';
end;

function UninstallWork: string;
begin
  // Do Uninstall tasks here.
  Result:='';
end;