// soubor obsahuje promenne pouzite v pluginech Stator.ggp.pas (nastaveni statistik)
// i Stator_run.ggp.pas (generovani statistik)
const
  MODE_BEGINNER=0;
  MODE_EXPERT=1;
  MODE_DEBUG=2;
  MAX_MODULES=500;
  MAX_GraphAreaSize=300000;           //maximln plocha graf (Google Image Charts)
  //barvy textu na systemovem tlacitku, napr pri prepinani zobrazovanych roku,
  //  zmene razeni, zobrazeni archivovanych kesi, zobrazeni neziskanych odznacku, ...
  COLOR_BUT_INACTIVE_TXT='darkgray';   //barva textu na neaktivnim tlacitku
  COLOR_BUT_ACTIVE_TXT='black';        //barva textu na aktivnim tlacitku
  MAX_GlobalVar=3000;
  TEMP_TABLE_TMP='temp.Stator';        //jmeno docasne vytvarene tabulky
  TEMP_TABLE_SAVE='Stator';            //jmeno docasne vytvarene tabulky
{$ifdef GENERATOR}
  CONST_NOICON='#_no_icon_#';          //text, ktery potlaci hledani ikony
  CONST_HIGHLIGHT='#_highlight_#';     //text pro zvyrazneni radku
  CONST_SQL_IGNORE_CACHETYPES=' AND gc.cachetype <> "Locationless (Reverse) Cache"' //seznam ignorovanych typu kesi
//     +' AND gc.cachetype<>"Virtual Cache"'
    ;
  //CONST_ECHARTS_URL='https://cdnjs.cloudflare.com/ajax/libs/echarts/4.1.0/echarts-en.min.js';
  CONST_ECHARTS_URL='https://geocaching.cz/stator/js/echarts.min.js';
{$endif}
  //odkaz na adresar generatoru map, aby nebyl kazdy modul omylem jinde
  //CONST_MAPGEN_URL='http://www.geocaching.cz/mapgen/4.3/'; //na gc.cz
  CONST_MAPGEN_URL='http://www.geocaching.cz/mapgen/4.5/'; //na gc.cz
  //CONST_MAPGEN_URL='http://gord.8u.cz/Geocaching/Mapgen_45/'; //pro ladeni na mem serveru

var
  sProfile:string;           //profil, podle ktereho jsou tvoreny statistiky
  sLang,sLangOut:string;     //jazyk pluginu a jazyk generovane statistiky
  sCachePrefix:string;       //prefic kesi, ktere maji byt zpracovany do statistik (implicitne GC)
  sCachePrefixForSql:string;   //cast SELECTu pro vyber bodu se spravnym prefixem
  sPreviewWidth,sPreviewHeight:string; //parametry pro vytvoreni nahledu pro obrazek odkazu na statistiku
{$ifdef GENERATOR}
  TEMP_TABLE:string;         //skutecne jmeno pracovni tabulky s ohledem na jeji zachovani v databazi
  sOutCoding:string;         //vystupni kodovani statistik
  sGuidCom:string;           //GUIID uzivatele na geocaching.com
  sRefCodeCom:string;        //referencni kod uzivatele na geocaching.com (PRxxxx)
  sGcCzId:string;            //ID uzivatele na geocaching.cz (pouziva se pro puntikate mapy)
  bEChartsTheme:boolean;     //priznak "exportovani a registrace" pouziteho tematu pro ECharts knihovnu
  sFtpUser,sFtpPwd,sFtpUrl:string; //parametry pro prenos souboru na vlastni FTP server
  sUploadPreviewImg:string;  //priznak uploadu nahledu na statistiku
  sBrowserUrl:string;        //odkaz na statistiku na vlastnim serveru (pro jeji zobrazeni)
  iTargetForStat:integer;    //kam kopirovat statistiku (0=gc.cz, 1=FTP, 2=nikam)
  sUnit:string;              //vystupni jednotky do tabulek, grafu, ...
  fLog:TFileStream;          //protokol o provadeni statistiky
  aTabs:TStringList;         //zeznam indexu zalozek, '' je oddelovac skupin zalozek
  iTabIdx:integer;           //index prave zpracovavane zalozky
  bTabDefault:boolean;       //priznak zobrazeneho obsahu zalozky
  aSwitch:TStringList;       //seznam indexu prepinacich tlacitek, '' je oddelovac skupin prepinacich tlacitek
  iSwitchIdx:integer;        //index prave zpracovavaneho prepinaciho tlacitka
  iSwitchLevel:integer;      //uroven, v ktere je nalezena prvni Switch polozka ze skupiny
  aNumbersPersonal:TstringList; //zeznam uzivatelem definovanych radku do tabulky zajimavych cisel
  nMaxElem:integer;          //(pro StatorBusy()) pocet znaku polozky Content pro Root element
                             //pocet polozek ve vsech "modulovych" sekcich ini souboru
  //iRootElem:integer;         //(pro StatorBusy()) pocet znaku, ktere v polozce Root elementu popisuji jiz zpracovane elementy
  iCurrentElem:integer;      //(pro StatorBusy()) poradi aktualni polozky
  iItem:integer;             //poradi zpracovavane polozky (elementu)

  dtMilestoneLastFound:TDateTime; //datum nalezu posledniho zpracovaneho milniku
  fHomeX,fHomeY:extended;    //domovske souradnice pro vypocty

  aModuleName:TStringList;   //jmena zpracovavanych modulu (pro volani funkce <modul>_Run()
  aModuleSubDir:TStringList; //podadresar s modulem (vnoreni do Modules\)
  sModuleName:string;        //jmeno aktualne provadeneho modulu

  iModuleError:integer;      //cislo chyby, kterou modul hlasi
  nModuleErrors:integer;     //pocet chyb, ktere modul hlasi
  sModuleError:string;       //popis chyby, kterou modul hlasi

  iAlignTitles:integer;      //zarovnani nadpisu sloupcu tabulek
{$else}
  aModulesAll: array[0..MAX_MODULES] of REC_MODULE_ALL; //seznam vsech sablon a zalozek
  nModulesAll: integer;      //pocet nactenych modulu
  fceSave: TNotifyEvent;     //funkce pro ulozeni nastaveni
{$endif}

  aGlobVarName:array[0..MAX_GlobalVar] of String;  //seznam jmen globalnich promennych
  aGlobVarValue:array[0..MAX_GlobalVar] of String; //seznam hodnot globalnich promennych
  nGlobalVar:integer;        //pocet vyuzitych globalnich promennych
  aContent:TStringList;      //obsah konfigurece (cely strom: vsechny ramce, sloupce, moduly)
  fOut:TFileStream;          //vystupni stream pro souborStatorGen.ggp.pas
  iWidth:integer;            //aktualni sirka statistiky/sloupce, do ktere modul generuje vystup
  aReplaceValName:TStringList;  //seznam jmen Replace hodnot
  aReplaceValValue:TStringList; //seznam hodnot Replace hodnot
{$ifdef GENERATOR}
  aReplaceCellValue:TStringList;//seznam hodnot pro nahradu v bunkach tabulky
{$endif}
  aReplaceFunctions:REC_REPLACE_FUNCTIONS; //funkce registrovane moduly pro nahradu specifickych globalnich promennych
