// soubor obsahuje funkce pouzite v pluginech Stator.ggp.pas (nastaveni statistik)
// i StatorGen.ggp.pas (generovani statistik)
function GetMyDir:string;
begin
  //univerzalni nejde pouzit, protoze generovani se spousti v adresari profilu
  //a ne v adresari Statoru
  // Result:=RegExSubstitute('(.*\\)(.*)$',GEOGET_SCRIPTFULLNAME,'$1');
  Result:=GEOGET_SCRIPTDIR+'\Stator\';
end;

function GetModulesDir:string;
begin
  Result:=GetMyDir()+'Modules\';
end;

function GetProfilesDir:string;
begin
  Result:=GetMyDir()+'Profiles\';
end;

function GetProfileDir:string;
begin
  Result:=GetProfilesDir()+sProfile+'\';
end;

function GetCommonDir:string;
begin
  Result:=GetMyDir()+'Common\';
end;

function GetThemesDir:string;
begin
  Result:=GetMyDir()+'Patterns\Themes\';
end;
//function GetIniPathname:string;
//begin
//  Result:=GetMyDir+'GgStatTemplate.ini';
//end;

function GetModuleDirFromName(name:string):string;
var i:integer;
begin
{$ifdef PROFILER}ProfileStart('GetModuleDirFromName');{$endif}
  //prvni znak muze byt ! nebo #
  if(name[1]='!') or (name[1]='#') then name:=Copy(name,2,Length(name));
  //kvuli modulum, ktere nemaji provadeci cast (organizacni, ...)
  //hledame napred primo soubor v adresari s moduly, tim se vyresi
  //drtiva cast modulu, protoze tam jsou vsechny standardni moduly
  Result:=GetModulesDir();
  if(FileExists(Result+name+'.ini')) then begin
    {$ifdef PROFILER}ProfileStop();{$endif}
    exit;
  end;
{$ifdef GENERATOR}       //generator nema naplnene moduly, ale zase ma pole s podadresarema
  for i:=0 to aModuleName.Count-1 do begin
    if(aModuleName[i]=name) then begin
      Result:=GetModulesDir()+aModuleSubDir[i];
      break;
    end;
  end;
{$else}
  //modul neni ve standardim adresari, zkusime jej najit mezi definovanymi moduly
  for i:=0 to nModulesAll-1 do begin
    if(aModulesAll[i].sName=name) then begin
      Result:=Result+aModulesAll[i].sDir;
      break;
    end;
  end;
{$endif}
{$ifdef PROFILER}ProfileStop();{$endif}
end;

{$ifndef GENERATOR}
function GetModuleTypeFromName(name:string):string;
var i:integer;
begin
{$ifdef PROFILER}ProfileStart('GetModuleTypeFromName');{$endif}
  Result:='';
  if(name='') then begin
    {$ifdef PROFILER}ProfileStop();{$endif}
    exit; //modul nema jmeno, to je asi mozne jen pri nepojmenovanem Column
  end;
  //prvni znak muze byt ! nebo #
  if(name[1]='!') or (name[1]='#') then name:=Copy(name,2,Length(name));
  //modul neni ve standardim adresari, zkusime jej najit mezi definovanymi moduly
  for i:=0 to nModulesAll-1 do begin
    if(aModulesAll[i].sName=name) then begin
      Result:=aModulesAll[i].sCategory;
      break;
    end;
  end;
{$ifdef PROFILER}ProfileStop();{$endif}
end;
{$endif}

function GetMetaIniPath(sModule,sDir:string):string;
begin
  Result:=GetModulesDir()+sDir+sModule+'.meta.ini';
  if(not FileExists(Result)) then Result:=GetModulesDir()+sDir+sModule+'.ini';
end;

function IsGuid(str:string):boolean;
begin
  Result:=RegexFind('^(\{){0,1}[0-9a-fA-F]{8}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{12}(\}){0,1}$',str);
end;

function EncodeRegElement(str:string):string;
var c:string;
    i:Integer;
begin //nahradi vsechny pro regularni vyrazy nebezpecne znaky
  c:='\[]()#-+*.|/{}';   // \ musi byt prvni, aby nedoslo k opakovane nahrade
  Result:=str;
  for i:=0 to length(c) do begin
    Result:=ReplaceString(Result,copy(c,i,1),'\'+copy(c,i,1));
  end;
end;

procedure FreeGlobal;
begin
  if(aContent<>nil) then begin aContent.Free(); aContent:=nil; end;
  if(aReplaceValName<>nil) then begin aReplaceValName.Free(); aReplaceValName:=nil; end;
  if(aReplaceValValue<>nil) then begin aReplaceValValue.Free(); aReplaceValValue:=nil; end;
{$ifdef GENERATOR}
  if(aTabs<>nil) then begin aTabs.Free(); aTabs:=nil; end;
  if(aSwitch<>nil) then begin aSwitch.Free(); aSwitch:=nil; end;
  if(aNumbersPersonal<>nil) then begin aNumbersPersonal.Free(); aNumbersPersonal:=nil; end;
  if(aReplaceCellValue<>nil) then begin aReplaceCellValue.Free(); aReplaceCellValue:=nil; end;
{$endif}
end;

{ $include KodovanyModul.pas}

procedure InitGlobal;
begin
{$ifndef GENERATOR}
  GeoBusyStart;
  GeoBusyCaption(_('Main settings'));      
  GeoBusyKind('');
{$endif}
  nGlobalVar:=0;
  aReplaceValName:=TStringList.Create();
  aReplaceValValue:=TStringList.Create();
  sLang:=UpperCase(copy(GetCurrentLanguage(),1,2));
  sLangOut:=sLang;
{$ifdef GENERATOR}
  aTabs:=TStringList.Create();
  aSwitch:=TStringList.Create();
  aNumbersPersonal:=TStringList.Create();
  aReplaceCellValue:=TStringList.Create();
  bEChartsTheme:=false;
{$endif}
end;

{$ifdef GENERATOR}
procedure Log(message:string);  //zaznam zpravy do protokolu
var str:string;
begin
  if(Pos('ERR:',message)>=1) or (Pos('WARN:',message)>=1) then message:='['+sModuleName+']  '+message;
  str:=FormatDateTime('hh:nn:ss.zzz',Now())+'  '+message+CRLF
  fLog.Write(str,Length(str));
end;

procedure AddError(sMsg:string);
begin
  Inc(nModuleErrors);
  iModuleError:=1;
  if(nModuleErrors>1) then sModuleError:=sModuleError+CRLF;
  sModuleError:=sModuleError+sMsg;
  Log(sMsg);
end;
{$endif}

function GlobalVarIndex(name:string):integer;
var i:integer;
begin
  Result:=-1;
  for i:=0 to nGlobalVar-1 do begin
    if(UpperCase(aGlobVarName[i])=UpperCase(name)) then begin
      Result:=i;
      break;
    end;
  end;
end;

function GlobalVarGet(name:string;bEmpty:boolean):string; //vraci hodnotu globalni promenne
var i:integer;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarGet');{$endif}
  Result:=name;
//{$ifdef DEBUG_HELPER}
//  LDH('Cteni globalni promenne '+name);
//{$endif}
  i:=GlobalVarIndex(name);
  if(i>=0) then Result:=aGlobVarValue[i]
  //pokud neni promenna nalezena a je pozadavek na vraceni prazdne hodnoty
  //vynulujeme
  else if(bEmpty) then Result:='';
{$ifdef PROFILER}ProfileStop();{$endif}
end;

function GlobalVarGetColor(name,defaultColor:string):string;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarGetColor');{$endif}
  Result:=GlobalVarGet(name,false);
  if(Result=name) then Result:=defaultColor;
{$ifdef PROFILER}ProfileStop();{$endif}
end;

function GlobalVarSet(name,value:string):boolean; //nastavi nebo prida globalni promennou
var i:integer;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarSet');{$endif}
  Result:=false;
  i:=GlobalVarIndex(name);
  if(i>=0) then begin
    aGlobVarValue[i]:=value;
    {$ifdef PROFILER}ProfileStop();{$endif}
    exit;
  end;
  if(nGlobalVar+1>MAX_GlobalVar) then
    ShowMessage(_('ERR: Too many global vars')+CRLF
      +_('var:')+' '+name+CRLF
      +_('value:')+' '+value)
  else begin
    aGlobVarName[nGlobalVar]:=name;
    aGlobVarValue[nGlobalVar]:=value;
    Inc(nGlobalVar);
//{$ifdef DEBUG_HELPER}
//  LDH('Nastavena globalni promenna (#='+IntToStr(aGlobVarName.Count)+'): '+name);
//{$endif}
  end;
{$ifdef PROFILER}ProfileStop();{$endif}
end;

procedure GlobalVarSetUndefByOther(sName,sName1:string);
begin
  //pokud globalni promenna neexistuje nebo nema nastavenou zadnou hodnotu,
  //priradi ji hodnotu jine promenne
  if(GlobalVarGet(sname,false)=sName) or (GlobalVarGet(sName,false)='') then
    GlobalVarSet(sName,GlobalVarGet(sName1,false));
end;

procedure GlobalVarRemove(name:string);
var i:integer;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarRemove');{$endif}
  i:=GlobalVarIndex(name);
  if(i>=0) then begin
    aGlobVarName[i]:='';
    aGlobVarValue[i]:='';
  end;
{$ifdef PROFILER}ProfileStop();{$endif}
end;

procedure GlobalVarRemoveMask(mask:string);
//odstrani promenne, ktere odpovidaji masce
//  to muze byt uzitecne treba pro nacteni zkratek novych kraju (jineho statu)
var i:integer;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarRemoveMask');{$endif}
  for i:=0 to nGlobalVar-1 do begin
    if(RegexFind(mask,aGlobVarName[i])) then begin
      aGlobVarName[i]:='';
      aGlobVarValue[i]:='';
    end;
  end;
{$ifdef PROFILER}ProfileStop();{$endif}
end;

{$ifdef GENERATOR}
procedure LogGlobalVar;
var i:integer;
begin
  for i:=0 to nGlobalVar-1 do begin
    Log('Variable: %'+aGlobVarName[i]+'%='+aGlobVarValue[i]);
  end;
end;
{$endif}

function ReplaceReplaceVar(str:string):string;
var i:integer;
begin
{$ifdef PROFILER}ProfileStart('ReplaceReplaceVar');{$endif}
  Result:=str;
  for i:=0 to aReplaceValName.Count-1 do begin
    Result:=ReplaceString(Result,aReplaceValName[i],aReplaceValValue[i]);
  end;
{$ifdef PROFILER}ProfileStop();{$endif}
end;


function GlobalVarReplaceFunction(idx:integer;str:string):string;
var sName,s,sPar,s1:string;
    iPos,iEnd:integer;
    aPar:TStringList;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarReplaceFunction');{$endif}
  Result:=str;
  //funkce zkontroluje, zda ve vstupnim textu je pouzita idx-ta registrovana
  //funkce pro nahradu a pokud ano, precte jeji parametry a zavola ji
  aPar:=TStringList.Create();
  try
    sName:=aReplaceFunctions.aNames[idx];
    iPos:=Pos('%'+sName+'(',Result);
//{$ifdef GENERATOR}
//Log('Nahrada promennych '+IntToStr(idx)+'. funkci, sName='+sName+', iPos='+IntToStr(iPos));
//{$endif}
    while(iPos>0) do begin     //pro pripad, ze je funkce pouzita v textu vicekrat
      s:=Copy(Result,iPos+Length('%'+sName+'('),Length(Result));
      iEnd:=Pos(')%',s);       //hledame konec volani funkce
      sPar:=Copy(s,1,iEnd-1);
      while(sPar<>'') do begin //vytvorime pole parametru
        s1:=Fetch(sPar,',');
        aPar.Add(s1);
//{$ifdef GENERATOR}
//Log('    s1='+s1+', aPar='+aPar.Text);
//{$endif}
      end;
      s1:=aReplaceFunctions.aFunctions[idx](aPar); //ziskame hodnotu z funkce
      Result:=Copy(Result,1,iPos-1)+s1+Copy(s,iEnd+2,Length(s)); //prepiseme hodnotu do vystupu
      iPos:=Pos('%'+sName+'(',Result); //najdeme dalsi vyskyt teto funkce
      aPar.Text:=''; //vymazeme seznam vsech parametru
//{$ifdef GENERATOR}
//Log('Result='+Result);
//{$endif}
    end;
  finally
    aPar.Free();
  end;
{$ifdef PROFILER}ProfileStop();{$endif}
end;

function GlobalVarReplace1(str:string):string;
var i:integer;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarReplace1');{$endif}
  Result:=str;
  for i:=0 to nGlobalVar-1 do begin
    Result:=ReplaceString(Result,'%'+aGlobVarName[i]+'%',aGlobVarValue[i]);
  end;
  //zavolame vsechny registrovane funkce pro nahradu
  for i:=0 to aReplaceFunctions.nFunctions-1 do begin
    Result:=GlobalVarReplaceFunction(i, Result);
  end;
{$ifdef PROFILER}ProfileStop();{$endif}
end;

function GlobalVarReplace(str:string):string;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarReplace');{$endif}
  Result:=GlobalVarReplace1(str);
  //pokud je jeste neco nenahrazeno (nahradou se vlozila dalsi promenna),
  //projdeme nahradu jeste jednou
  if(Pos('%',Result)>=1) then Result:=GlobalVarReplace1(Result);
  //provedeme zaverecnou nahradu (ceske znaky, ...)
  Result:=ReplaceReplaceVar(Result);
{$ifdef PROFILER}ProfileStop();{$endif}
end;

procedure GlobalVarRegisterReplaceFunction(sName:string; pFce:TModuleReplaceFunction);
var s:string;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarRegisterReplaceFunction');{$endif}
  //zkontrolujeme pocet registrovanych funkci
  if(aReplaceFunctions.nFunctions>=MAX_REPLACE_FUNCTIONS) then begin
    s:=_('ERR: Function has not been registered (too many functions):')+' '+sName;
{$ifdef GENERATOR}
    Log(s);
{$endif}
    ShowMessage(s);
    {$ifdef PROFILER}ProfileStop();{$endif}
    exit;
  end;
  aReplaceFunctions.aNames[aReplaceFunctions.nFunctions]:=sName;
  aReplaceFunctions.aFunctions[aReplaceFunctions.nFunctions]:=pFce;
  Inc(aReplaceFunctions.nFunctions);
{$ifdef GENERATOR}
  Log(_('Registered function:')+' '+sName);
{$endif}
{$ifdef PROFILER}ProfileStop();{$endif}
end;

procedure GlobalVarFromFile(path,section,prefix:string);
//prida vsechny promene z INI souboru a zadane sekce mezi globalni promenne
var ini:TMemIniFile;
    aList:TStringList;
    s,sName:string;
    i:integer;
begin
{$ifdef PROFILER}ProfileStart('GlobalVarFromFile');{$endif}
  if(not FileExists(path)) then begin
{$ifdef GENERATOR}
    Log(_('ERR: File does not exist:')+' '+path);
{$else}
    ShowMessage(_('ERR: File does not exist:')+CRLF+CRLF+path);
{$endif}
    {$ifdef PROFILER}ProfileStop();{$endif}
    exit;
  end;
{$ifdef GENERATOR}
    Log(_('Get global variables from file:')+' '+path+', ['+section+']');
{$endif}
  ini:=TMemIniFile.Create(path);
  aList:=TStringList.Create();
  //je otazka, zda vymazat vsechny promenne se zadanym prefixem, prozatim to
  //nedelam
  ini.ReadSectionValues(section,aList);
  for i:=0 to aList.Count-1 do begin
    s:=aList[i];
    //sName:=StringCompress(Fetch(s,'='));
    sName:=Fetch(s,'=');
    GlobalVarSet(prefix+sName,s);
{$ifndef GENERATOR}
    //doplnime do seznamu promennych
    //if(GGForm_lMode.ItemIndex=MODE_DEBUG) then begin
      s:=prefix+sName+'|'+ReplaceString(path,GetMyDir(),'')+'|'+section+'|'+s;
      if(GGForm_lVariables.Items.indexOf(s)<0) then
        GGForm_lVariables.Items.Add(s);
    //end;
{$endif}
//{$ifdef DEBUG_HELPER}
//  LDH('Z INI nastavena globalni promenna: '+prefix+sName+'='+s);
//{$endif}
  end;
  aList.Free();
  ini.Free();
{$ifdef PROFILER}ProfileStop();{$endif}
end;

procedure GlobalVarFromTag(category,prefix:string);
//prida vsechny hodnoty tagu zadane kategorie
//(kazdou hodnotu zvlas nebo jako frazi pro SQL.IN nebo jako strin oddelney | nebo ...?
begin
{$ifdef PROFILER}ProfileStart('GlobalVarFromTag');{$endif}
{$ifndef GENERATOR}
    //doplnime do seznamu promennych
    //GGForm_lVariables.Items.Add(sName+'|Tag: '+category+'|');
{$endif}
{$ifdef PROFILER}ProfileStop();{$endif}
end;

{$ifdef GENERATOR}
procedure ReadReplaceCellValueFile(sFile:string);
var ini:TMemIniFile;
    aList,aSec:TStringList;
    i,j:integer;
    s,s1:string;
begin
  //Log('BBBB nacteni souboru '+sFile);
  aSec:=TStringList.Create()
  try
    aList:=TStringList.Create();
    try
      //zjistime vsechny sekce
      ini:=TMemIniFile.Create(sFile);
      try
        ini.ReadSections(aSec);
  //Log('BBBB pocet sekci: '+IntToStr(aSec.Count));
        for i:=0 to aSec.Count-1 do begin //pro kazdou sekci nacteme vsechny jeji hodnoty
          ini.ReadSectionValues(aSec[i],aList);
  //Log('BBBB sekce '+aSec[i]+', pocet polozek: '+IntToStr(aList.Count));
          for j:=0 to aList.Count-1 do begin
            //ke jmenu hodnoty pridame jeste sekci, aby byla hodnota jednoznacna
            //vysledek ulozime
            s:=aSec[i]+'|'+aList[j];
            s1:=Fetch(s,'=');
            aReplaceCellValue.Values[s1]:=s;
          end;
        end;
      finally
        ini.Free();
      end;
    finally
      aList.Free();
    end;
  finally
    aSec.Free();
  end;
end;

procedure ReadReplaceCellValueFiles;
begin
  ReadReplaceCellValueFile(GetCommonDir()+'ReplaceCellValue.ini');
  ReadReplaceCellValueFile(GetProfileDir()+'ReplaceCellValue.ini');
  //Log('BBBB Nahrada obsahu bunek tabulky:'+CRLF+aReplaceCellValue.Text);
end;

function ReplaceColumnValue(sColumn,sValue:string):string;
//v zavislosti na sloupci vraci text, kterym ma byt hodnota nahrazena
begin
  Result:=aReplaceCellValue.Values[sColumn+'|'+ReplaceString(sValue,'=','&eq;')];
  if(Result='') then Result:=sValue;
  //Log('ReplaceColumnValue(): sColumn='+sColumn+', sValue='+sValue+', Result='+Result);
end;
{$endif}

//nacteni souradnice HC pro statistiky (zkousi v poradi INI, ref. bod HOME, prvni referencni bod)
function GetHomeCoord(var x,y:extended):boolean;
var s:string;
    ini:TMemIniFile;
    aList:TStringList;
begin
  x:=0; y:=0; Result:=false;
  ini:=TMemIniFile.Create(GetProfileDir()+'Config.ini');
  try
    s:=Trim(ini.ReadString('Main','HomeCoord',''));
  finally
    ini.Free();
  end;
  if(s<>'') then begin
    if ParseWgsStr(s,x,y) then Result:=true;
    exit;
  end;
  //bod neni nalezen, zkusime najit referenci bod 'Home'
  //Result:=ReferencePointCoord('Home',x,y);
  Result:=RefPointGet('Home',x,y);
  if(Result) then exit;
  //nacteme prvni bod ze seznamu referencnich bodu
  aList:=TStringList.Create();
  try
    RefPointNames(aList);
    if(aList.Count>0) then Result:=RefPointGet(aList[0],x,y);
  finally
    aList.Free();
  end;
end;

function LevelToInt(sType:string):integer;
begin
  case sType of
  'B': Result:=MODE_BEGINNER;
  'X': Result:=MODE_EXPERT;
  'D': Result:=MODE_DEBUG;
  else Result:=MODE_BEGINNER;
  end;
end;

function TypeToInt(sType:string):integer;
begin
  case sType of
  'R': Result:=-1; //Root
  'S': Result:=0;
  'T': Result:=0;
  'F': Result:=1;
  'W': Result:=2;
  'C': Result:=3;
  'M': Result:=4;
  'P': Result:=5;
  else Result:=0;
  end;
end;

function ParamValueFromIni(modul,param,variable,defaultValue:string):string;
var ini:TMemIniFile;
    s,sSection:string;
begin
  ini:=TMemIniFile.Create(GetModuleDirFromName(modul)+modul{ParForm_eModule.Caption}+'.params.ini');
  try
    sSection:=param+'_'+sLang;
    s:=ini.ReadString(sSection,'TYPE','');
    if(s='') then sSection:=param+'_EN';     //implicitni je anglictina
    Result:=ini.ReadString(sSection,variable,defaultValue);
  finally
    ini.Free();
  end;
end;

function PrepareParams(sItem,sModule:string):TStringList; //pripravi parametry z INI a Content
var ini:TMemIniFile;
    s,sParams,sPar:string;
begin
  Result:=TStringList.Create();
  //kombinuje parametry z nastaveni v Content.ini a parametry z modul.ini, pripadne modul.params.ini
  ini:=TMemIniFile.Create(GetModuleDirFromName(sModule)+sModule+'.ini');
  //Result:=AddString('CATEGORY='+ini.ReadString('Module','CATEGORY',''));
  sParams:=','+ini.ReadString('Module','PARAMS','')+',';
  ini.Free();
  ini:=TMemIniFile.Create(GetProfileDir()+'Content.ini');
  //projedeme vsechny mozne parametry
  while (sParams<>'') do begin
    sPar:=Fetch(sParams,',');
    if(sPar<>'') then begin
{$ifdef GENERATOR}
      s:=ini.ReadString(sItem,sPar,'');
{$else}
      //aby se nacetla implicitni hodnota parametru pro formular, ale pokud
      //ji uzivatel smaze, za behu generatoru nebude implicitni hodnota pouzita
      ////// ale pozor, jakmile se nacte implicitni hodnota, ulozi se
      ////// takze kdyz ji ma uzivatel prazdnou, prepise se mu pri pristi
      ////// uprave JAKEHOKOLI parametru stejneho modulu implicitni hodnotou
      s:=ini.ReadString(sItem,sPar,'XXnovalueXX');
      if(s='XXnovalueXX') then s:=ParamValueFromIni(sModule,sPar,'Default','');
{$endif}
      //pokud je parametr prazdny a je povinny, take nastavime default hodnotu
      if(s='') and (UpperCase(ParamValueFromIni(sModule,sPar,'Mandatory',''))='YES') then begin
        s:=ParamValueFromIni(sModule,sPar,'Default','');
//ShowMessage('sPar='+sPar+CRLF+'s='+s);
{
        if(UpperCase(ParamValueFromIni(sModule,sPar,'Type',''))='FILE') then begin
          s1:=Fetch(s,'|');
          s:=s1;
        end;
}
      end;
      Result.Add(sPar+'='+s);
    end;
  end;
  ini.Free();
  //pro FILE musime vzit jen jmeno souboru
end;

function ColumnWidthCalculate(sWidth:string):integer;
var s:string;
begin
  if(Pos('%',sWidth)>1) then begin
    s:=ReplaceString(sWidth,'%','');
    //z duvodu nepresneho vypoctu (nevim, kolik je sloupcu, kolikrat odecist
    //(margin+border+padding), odecitam rezervu 1 %
    //treba bude nekdy cas to pocitat dusledne, zjistit pocty sloupcu, ...
    Result:=iWidth*(StrToInt(s)-1)/100;  //priblizny vypocet, protoze neuvazuje padding a margin nadrizeneho bloku, nevim jak to pocitat
  end
  else begin
    Result:=StrToInt(sWidth);
  end;
end;

function ScaleColor(iValue,iValueMin,iValueMax:integer;sColorMin,sColorAvg,sColorMax:string):string;
// vytvori skalovanou RGB barvu podle zadaneho rozsahu a hodnoty
// kluje tbodov rozsah Min-sted-Max na barevn prostor ColorMin-ColorAvg-ColorMax
// pokud nejsou barvy skalovane, kontroluje min a max barvy a pokud jsou to
// barvy pouzite pro text tabulky, pouzije ty nebo AVG barvu. Pokud to nejsou
// min a max barvy textu, pouzije polovinu z nich pro vsechny hodnoty jine
// nez min a max (kiReGPS)
var
  iMinR,iMinG,iMinB,iMaxR,iMaxG,iMaxB,iAvgR,iAvgG,iAvgB,iRed,iGreen,iBlue:integer;
  rScale,rValueAvg:extended;
begin
  iMinR:=HexToDec(Copy(sColorMin,1,2));
  iMinG:=HexToDec(Copy(sColorMin,3,2));
  iMinB:=HexToDec(Copy(sColorMin,5,2));
  iMaxR:=HexToDec(Copy(sColorMax,1,2));
  iMaxG:=HexToDec(Copy(sColorMax,3,2));
  iMaxB:=HexToDec(Copy(sColorMax,5,2));
  iAvgR:=HexToDec(Copy(sColorAvg,1,2));
  iAvgG:=HexToDec(Copy(sColorAvg,3,2));
  iAvgB:=HexToDec(Copy(sColorAvg,5,2));
  //pri povolenem skalovani skalujeme tribodove vyslednou barvu
  if(GlobalVarGet('ColorScale',false)='Yes') then begin
    if(iValueMin=iValueMax) then begin
      iRed:=iAvgR;
      iGreen:=iAvgG;
      iBlue:=iAvgB;
    end else begin
      rValueAvg:=iValueMin+(iValueMax-iValueMin)/2.0;
      if iValue<rValueAvg then begin
        rScale:=1.0*(iValue-iValueMin)/(rValueAvg-iValueMin);
        iRed:=Round(iMinR+rScale*(iAvgR-iMinR));
        iGreen:=Round(iMinG+rScale*(iAvgG-iMinG));
        iBlue:=Round(iMinB+rScale*(iAvgB-iMinB));
      end else begin
        rScale:=(iValue-rValueAvg)/(iValueMax-rValueAvg);
        iRed:=Round(iAvgR+rScale*(iMaxR-iAvgR));
        iGreen:=Round(iAvgG+rScale*(iMaxG-iAvgG));
        iBlue:=Round(iAvgB+rScale*(iMaxB-iAvgB));
      end;
    end;
    Result:=DecToHex(iRed,2)+DecToHex(iGreen,2)+DecToHex(iBlue,2)
//if(iValue=100) then Log('XXXX 3 Result='+Result);
  end
  else begin
    //neni povoleno skalovani, pokud se barvy shoduji s barvami pro min a max text,
    //pouzijeme je nebo AvgText
    if(sColorMin=GlobalVarGet('ColorTableMinText',false)) and (sColorMax=GlobalVarGet('ColorTableMaxText',false)) then begin
      if(iValue=iValueMin) then Result:=GlobalVarGet('ColorTableMinText',false)
      else if(iValue=iValueMax) then Result:=GlobalVarGet('ColorTableMaxText',false)
      else Result:=GlobalVarGet('ColorTableAvgText',false);
    end
    else begin //barvy se neshoduji s min a max, proto vezmeme pulku mezi nimi
      //a to pouzijeme pro vsechny, ktere nejsou min a max
      rScale:=0.5;
      iRed:=Round(rScale*(iMaxR-iMinR)+iMinR);
      iGreen:=Round(rScale*(iMaxG-iMinG)+iMinG);
      iBlue:=Round(rScale*(iMaxB-iMinB)+iMinB);
      Result:=DecToHex(iRed,2)+DecToHex(iGreen,2)+DecToHex(iBlue,2)
    end;
  end;
end;

{$ifndef GENERATOR}
procedure AddVariableToList(sName,sFile,sSection,sValue:string);
var s:string;
begin
  s:=' '+sName+'|'+sFile+'|'+sSection+'|'+sValue;
  if(GGForm_lVariables.Items.indexOf(s)<0) then 
    GGForm_lVariables.Items.Add(' '+sName+'|'+sFile+'|'+sSection+'|'+sValue);
end;
{$endif}

procedure ReadReplaceValFromFile(path,section:string);
var ini:TMemIniFile;
    aList:TStringList;
    s,sName:string;
    i:integer;
begin
  if(not FileExists(path)) then begin
{$ifdef GENERATOR}
    Log(_('ERR: File does not exist:')+' '+path);
{$else}
    ShowMessage(_('ERR: File does not exist:')+CRLF+CRLF+path);
{$endif}
    exit;
  end;
{$ifdef GENERATOR}
    Log(_('Get replace strings from file:')+' '+path+', ['+section+']');
{$endif}
  ini:=TMemIniFile.Create(path);
  aList:=TStringList.Create();
  //je otazka, zda vymazat vsechny promenne se zadanym prefixem, prozatim to
  //nedelam
  ini.ReadSectionValues(section,aList);
  for i:=0 to aList.Count-1 do begin
    s:=aList[i];
    //sName:=StringCompress(Fetch(s,'='));
    sName:=Fetch(s,'=');
    aReplaceValName.Add(sName);
    aReplaceValValue.Add(s);
{$ifndef GENERATOR}
    //doplnime do seznamu promennych
    s:=sName+'|'+ReplaceString(path,GetMyDir(),'')+'|'+section+'|'+s;
    if(GGForm_lVariables.Items.indexOf(s)<0) then GGForm_lVariables.Items.Add(s);
{$endif}
//{$ifdef DEBUG_HELPER}
//  LDH('Z INI nastavena globalni promenna: '+prefix+sName+'='+s);
//{$endif}
  end;
  aList.Free();
  ini.Free();
end;

procedure ReadCommonProfileReplaceFile(name,section:string);
var s:string;
begin
  //nacte ini soubor podle jazyka, pokud existuje v Common, a doplni ho z profilu
  s:=GetCommonDir()+name+sLangOut+'.ini';
  if(not FileExists(s)) then s:=GetCommonDir()+name+'.ini';
  ReadReplaceValFromFile(s,section);
  s:=GetProfileDir()+name+'.ini'
  if(FileExists(s)) then ReadReplaceValFromFile(s,section);
end;

procedure ReadCommonProfileIniFile(name,section,prefix:string);
var s:string;
begin
{$ifdef PROFILER}ProfileStart('ReadCommonProfileIniFile');{$endif}
  //nacte ini soubor podle jazyka, pokud existuje v Common, a doplni ho z profilu
  s:=GetCommonDir()+name+sLangOut+'.ini';
  if(not FileExists(s)) then s:=GetCommonDir()+name+'.ini';
  GlobalVarFromFile(s,section,prefix);
  s:=GetProfileDir()+name+'.ini'
  if(FileExists(s)) then GlobalVarFromFile(s,section,prefix);
{$ifdef PROFILER}ProfileStop();{$endif}
end;

procedure ClearColumnFlags(var flags:REC_COLUMN_FLAGS);
begin
  flags.sName:='';
  flags.sAlign:='';
  flags.sSort:='';
  flags.bNumeric:=false;
  flags.bCounting:=false;
  flags.bTagMustExist:=true;
  flags.sOperator:='';
  flags.sValue:='';
end;

procedure ParseColumnFlags(str:string; var flags:REC_COLUMN_FLAGS);
var s:string;
begin
  ClearColumnFlags(flags);      //vycistime
  s:=Fetch(str,'=');  //jmeno sloupce
  flags.sName:=Fetch(s,' ('); //odpareme od jmena poznamku (vysvetlivka o ziskani poctu ze sloupce Count)
  s:=Fetch(str,'#');            //napred hodnota, ta musi byt posledni
  //zbytek terstujeme tak, aby nezalezelo na poradi polozek
  flags.sValue:=str;            
  str:=s;
//{$ifdef GENERATOR}
//Log('ParseColumnFlags(): str='+str);
//{$endif}
  while (str<>'') do begin
    s:=Fetch(str,';');
    case UpperCase(s) of  //kvuli SQL tabulce, ktera ma jmena sloupcu vzdy velkymi
      'NUM':  flags.bNumeric:=true;
      'CNT':  flags.bCounting:=true;
      'NULL': flags.bTagMustExist:=false;
      'ASC','DESC': flags.sSort:=LowerCase(s);
      'LEFT','RIGHT','CENTER','HIDE': flags.sAlign:=LowerCase(s);
      '=','>','<','>=','<=','<>','IN','NOT IN','LIKE','BETWEEN':flags.sOperator:=s;
    end;
  end;
//{$ifdef GENERATOR}
{
Log('ParseColumnFlags(): bNumeric='+IntToStr(flags.bNumeric as integer)
  +', bCounting='+IntToStr(flags.bCounting as integer)
  +', bTagMustExist='+IntToStr(flags.bTagMustExist as integer)
  +', sSort='+flags.sSort
  +', sOperator='+flags.sOperator);
}
//{$endif}
end;

function MakeColumnFlags(flags:REC_COLUMN_FLAGS):string;
begin
  //pokud neni zadano nic nez jmeno a implicitni hodnoty, nechame string prazdny
  Result:=flags.sName;
  if(flags.sAlign='') and (flags.sSort='')
    and (flags.sOperator='') and (flags.sValue='')
    and (not flags.bNumeric) and (not flags.bCounting)
    and (flags.bTagMustExist)
    then exit;
  //nastavime vsechny priznaky  
  Result:=Result+'='+flags.sAlign+';'+flags.sSort+';';
  if(flags.bNumeric) then Result:=Result+'Num';
  Result:=Result+';';
  if(flags.bCounting) then Result:=Result+'Cnt';
  Result:=Result+';';
  if(not flags.bTagMustExist) then Result:=Result+'Null';
  Result:=Result+';'+flags.sOperator;
  if(flags.sValue<>'') then Result:=Result+'#'+flags.sValue;
  Result:=ReplaceString(Result,';;',';');     //vyhazeme prebytecne stredniky
  Result:=ReplaceString(Result,';;',';');
  Result:=ReplaceString(Result,';;',';');
end;

function RemoveModuleTitle(sModule:string):string;
var s:string;
begin
  s:=Fetch(sModule,'('); //odstranime titulek
  Result:=Fetch(s,'|'); //a popkud tam zbyly nejake priznaky, tak i ty
end;

procedure SetOwnedAuthors(aList:TStringList);
var s:string;
begin
  s:=aList.Text;
  if(s<>'') then begin
    s:=ReplaceString(s,'''',''''''); //pro spravne SQL zdvojime apostrofy ve jmene
    //ovsem pokud bude ve jmene ', jsme nahrani, to nevim jak vyresit,
    //zatim necham plavat, u kesi v CR zadny takovy autor zatim neni :)
    s:=''''+ReplaceString(Trim(s),CRLF,''',''')+'''';
  end;
  GlobalVarSet('OwnedAuthorsForInPhrase',s);
{$ifndef GENERATOR}
  AddVariableToList(' OwnedAuthorsForInPhrase','Set in StatorGen.ggp,Stator.lib','GENERATOR',s);
{$endif}
end;

function EscapeRegEx(str:string):string;
var sChar:string;
    i:integer;
begin
  sChar:='\.*{}[]''+'; //seznam problematickych znaku
  Result:=str;
  for i:=1 to Length(sChar) do begin
    Result:=ReplaceString(Result,sChar[i],'\'+sChar[i]);
  end;
{$ifdef GENERATOR}
  Log('INFO: EscapeRegEx('+str+') => '+Result);
{$endif}
end;

procedure SetOwnedIds(sIds:string);
var sSql,sId,s:string;
    aList:TStringList;
begin
  //vytvori a nastavi promennou se seznamem vlastneych kesi
  //napred seznam doplnovanych owneru
{$ifndef GENERATOR}
  s:=''''+ReplaceString(Trim(GGForm_lMiscAuthor.Items.Text),CRLF,''',''')+'''';
{$else}
  s:=GlobalVarGet('OwnedAuthorsForInPhrase',false);
  Log('INFO: OwnedAuthors='+s);
{$endif}
  //seznam kesi podle ownera nebo podle zadanych owneru
  sSql:='SELECT id FROM geocache WHERE '
    +'(author REGEXP ''(?i)(^|\b)'+EscapeRegEx(UpperCase(GEOGET_OWNER))+'($|\b)'' '
    //Rozic neni stejny owner jako Rozic.dc, proto vyradime ty, jejich slovo konci
    //znakem, ktery nemusi byt konec nicku
    +'AND NOT (author REGEXP ''(?i)(^|\b)'+EscapeRegEx(UpperCase(GEOGET_OWNER))+'[._]'')'
    +')';
  if(s<>'""') and (s<>'') and (s<>''''+GEOGET_OWNER+'''') then sSql:=sSql+' OR author IN ('+s+')';
  aList:=TStringList.Create();
{$ifdef GENERATOR}
  Log('INFO: SQL='+sSql);
{$endif}
  Geoget_DB.GetTableStrings(sSql,aList);
  //////
  //ShowMessage('SQL pro ziskani ID kesi:'+CRLF+sSql+CRLF+CRLF+aList.Text);
  sId:=ReplaceString(Trim(aList.Text),'''','''''');
  sId:=''''+ReplaceString(sId,CRLF,''',''')+'''';
  aList.Free();
  //nacteme seznam kesi podle autoru a pridame k seznamu jeste ty podle definovanych ID
{$ifndef GENERATOR}
  s:=''''+ReplaceString(Trim(GGForm_lMiscIdOwned.Items.Text),CRLF,''',''')+'''';
{$else}
  Log('INFO: kese podle autoru='+s);
  s:='';
  if(sIds<>'') then s:=''''+ReplaceString(Trim(sIds),'|',''',''')+'''';
  Log('OwnedIds: '+s);
{$endif}
  if(s<>'""') and (s<>'') then sId:=sId+','+s;
  GlobalVarSet('OwnedIDsForInPhrase',UpperCase(sId));
{$ifdef GENERATOR}
  Log('OwnedIDsForInPhrase='+sId);
{$endif}
end;

procedure ReadIniFiles(bTabListVariable:boolean);
var ini:TMemIniFile;
    aList:TStringList;
begin
{$ifdef PROFILER}ProfileStart('ReadIniFiles');{$endif}
  //pridame promennou se seznamem autoru a seznamem vlastnenych kesi
  ini:=TMemIniFile.Create(GetProfileDir()+'Config.ini');
  try
    aList:=TStringList.Create();
    try
      ini.ReadSection('OwnedAuthors',aList);
      SetOwnedAuthors(aList);
      //vytvorime promennou se seznamem vlastnenych kesi
      SetOwnedIds(ini.ReadString('Main','OwnedId',''));
      sCachePrefix:=ini.ReadString('Main','Prefix','GC');
      sCachePrefixForSql:='substr(gc.id,1,2)="'+sCachePrefix+'"';
    finally
      aList.Free();
    end;
  finally
    ini.Free();
  end;

  GlobalVarSet('GeogetOwner',Geoget_owner);   //vytvorime promennou se seznamem vlastnenych kesi
  GlobalVarSet('Width',IntToStr(iWidth));     //a sirkou statistiky

  //barvy nacteme vzdy, je to potreba, protoze je lze menit
  GlobalVarFromFile(GetProfileDir()+'Colors.ini','COLORS','Color');
  //pokud nejsou definovane nektere barvy, nastavime je podle jinych
  GlobalVarSetUndefByOther('ColorTableMatrixHeaderMaxText','ColorTableMatrixHeaderText');
  GlobalVarSetUndefByOther('ColorTableMatrixHeaderMaxBkg','ColorTableMatrixHeaderBkg');
  GlobalVarSetUndefByOther('ColorTableHighlightedBkg','ColorTableBkg');
  GlobalVarSetUndefByOther('ColorTableHighlightedBkgOdd','ColorTableBkgOdd');
  GlobalVarSetUndefByOther('ColorTableScaleMaxText','ColorTableScaleText');
  //nacteme ikony, z kterych je mozne vybirat pro zalozky, ...
  ReadCommonProfileIniFile('IconsLayout','Icons','IconLayout');

  //pokud neni treba, nenacitame promenne ze souboru, zdrzuje to
  if(bTabListVariable) then begin
    GlobalVarFromFile(GetProfileDir()+'Styles.ini','Styles','Style');
    //INI soubory, ktere jsou v Common s jazykem a v profilu jsou jejich "doplnky" nebo opravy
    ReadCommonProfileIniFile('IconsCacheType','Icons','IconCacheType');
    ReadCommonProfileIniFile('IconsCacheTypeSmall','Icons','IconCacheTypeSmall');
    ReadCommonProfileIniFile('IconsCacheSize','Icons','IconCacheSize');
    ReadCommonProfileIniFile('IconsCacheTerrain','Icons','IconCacheTerr');
    ReadCommonProfileIniFile('IconsCacheDifficulty','Icons','IconCacheDiff');
    ReadCommonProfileIniFile('IconsCacheStatus','Icons','IconCacheStatus');
    ReadCommonProfileIniFile('IconsCacheStatus','Text','TextCacheStatus');
    ReadCommonProfileIniFile('IconsCacheLogtype','Icons','IconCacheLog');
    ReadCommonProfileIniFile('IconsDirection','Icons','IconDirection');
    ReadCommonProfileIniFile('IconsDirection','Abbreviation','AbbrevDirection');
    ReadCommonProfileIniFile('IconsCountry','Icons','IconCountry');

    ReadCommonProfileIniFile('Translate','Days','Day');
    ReadCommonProfileIniFile('Translate','Month','Month');
    ReadCommonProfileIniFile('Translate','Misc','Misc');
    ReadCommonProfileIniFile('ColumnNames','ColumnHeader','ColumnHeader');

    ReadCommonProfileReplaceFile('Replace','Replace');
  end;

{$ifdef GENERATOR}
  ReadReplaceCellValueFiles();
{$endif}

  //promenna bTabListVariable je nastavena i pri generovani statistiky, proto
  //musime v generatoru nasledujici blok vynechat
{$ifndef GENERATOR}
  //nastaveni promennych do seznamu
  if(bTabListVariable) then begin
    AddVariableToList(' Width','Set in StatorGen.ggp','GENERATOR',IntToStr(iWidth));
    AddVariableToList(' StatisticStartDate','Set in StatorGen.ggp','GENERATOR',FormatDateTime('d.m.yyyy',Now()));
    AddVariableToList(' StatisticStartTime','Set in StatorGen.ggp','GENERATOR',FormatDateTime('hh:nn',Now()));
    AddVariableToList(' FoundCachesCount','Set in StatorGen.ggp','GENERATOR',Geoget_DB.GetTableString('SELECT count(id) FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql));
    AddVariableToList(' FoundLogsCount','Set in StatorGen.ggp','GENERATOR',Geoget_DB.GetTableString(
      'SELECT count(finder) pocet FROM geolog gl'
      +' WHERE finder='''+GEOGET_OWNER+''' COLLATE NOCASE AND'
      +'  (type="Found it" OR type="Attended" OR type="Webcam Photo Taken")'
      +' AND '+ReplaceString(sCachePrefixForSql,'gc.','gl.')
      ));
    AddVariableToList(' CRLF','Set in StatorGen.ggp','GENERATOR','\r\n');
    AddVariableToList(' Profile','Set in StatorGen.ggp','GENERATOR',sProfile);
    AddVariableToList(' GeogetOwner','Set in StatorGen.ggp','GENERATOR',GEOGET_OWNER);
    AddVariableToList(' OwnedIDsForInPhrase','Set in StatorGen.ggp','GENERATOR',GlobalVarGet('OwnedIDsForInPhrase',false));
    AddVariableToList(' IdElement','Set in StatorGen.ggp','GENERATOR','i.e. "F58"');
    AddVariableToList(' MainFontSize','Set in StatorGen.ggp','GENERATOR','i.e. "11px"');

    //promenne, ktere nejsou v globalnich promennych, ale primo
    //mezera na zacatku je proto, aby byly zarazene na zacatku seznamu
    AddVariableToList('  sProfile :string','regular variable','VARIABLE',_('profile name'));
    AddVariableToList('  sLang :string','regular variable','VARIABLE',_('plugin language (code CS, ...)'));
    AddVariableToList('  sLangOut :string','regular variable','VARIABLE',_('statistics'' language (code _CS, ...)'));
    AddVariableToList('  sOutCoding :string','regular variable','VARIABLE',_('codepage (cp1250, utf-8, ...)'));
    AddVariableToList('  sCachePrefix :string','regular variable','VARIABLE',_('prefix of processing points (GC, WM, ...)'));
    AddVariableToList('  sGcCzId :string','regular variable','VARIABLE',_('geocaching.cz UID'));
    AddVariableToList('  sGuidCom :string','regular variable','VARIABLE',_('geocaching.com GUID'));
    AddVariableToList('  sRefCode :string','regular variable','VARIABLE',_('geocaching.com User Reference Code'));
    AddVariableToList('  bCss :boolean','regular variable','VARIABLE',_('flag for using CSS'));
    AddVariableToList('  bColorScale :boolean','regular variable','VARIABLE',_('flag for color scaling'));
    AddVariableToList('  fHomeX :extended','regular variable','VARIABLE',_('homecoord. longitude'));
    AddVariableToList('  fHomeY :extended','regular variable','VARIABLE',_('homecoord. latitude'));
    AddVariableToList('  iSortFound :integer','regular variable','VARIABLE',_('way of sorting finds'));
    AddVariableToList('  sIgnoreCaches :string','regular variable','VARIABLE',_('list of ignored caches for distance'));
    AddVariableToList('  iItem :integer','regular variable','VARIABLE',_('index for processed element'));
    AddVariableToList('  iWidth :integer','regular variable','VARIABLE',_('width for module output'));
    AddVariableToList('  iModuleError :integer','regular variable','VARIABLE',_('OUT: number for error from module'));
    AddVariableToList('  nModuleErrors :integer','regular variable','VARIABLE',_('OUT: number of errors from module'));
    AddVariableToList('  sModuleError :string','regular variable','VARIABLE',_('OUT: text for error from module'));
    AddVariableToList('  fOut :TFileStream','regular variable','VARIABLE',_('stream for output'));

    //funkce
    AddVariableToList('GeoBusyTest :boolean;','function','FUNCTION','');
    AddVariableToList('GetMyDir: string;','function','FUNCTION','');
    AddVariableToList('GetModulesDir: string;','function','FUNCTION','');
    AddVariableToList('GetProfilesDir: string;','function','FUNCTION','');
    AddVariableToList('GetProfileDir: string;','function','FUNCTION','');
    AddVariableToList('GraphAxisStep(...):integer;','function','FUNCTION','');
    AddVariableToList('StatorAbort;','function','FUNCTION','');
    AddVariableToList('GetCommonDir: string;','function','FUNCTION','');
    AddVariableToList('ScaleColor(...):string;','function','FUNCTION','');
    AddVariableToList('ConvertFromKm(...):extended;','function','FUNCTION','');
    AddVariableToList('ConvertToKm(...):extended;','function','FUNCTION','');
    AddVariableToList('ConvertLength(...):extended;','function','FUNCTION','');
    AddVariableToList('GetLengthAbbr(...):string;','function','FUNCTION','');
    AddVariableToList('StringCompress(...):string;','function','FUNCTION','');
    AddVariableToList('GlobalVarGet(...):string;','function','FUNCTION','');
    AddVariableToList('GlobalVarSet(...):boolean;','function','FUNCTION','');
    AddVariableToList('GlobalVarSetUndefByOther(...):boolean;','function','FUNCTION','');
    AddVariableToList('GlobalVarRemove(...);','function','FUNCTION','');
    AddVariableToList('GlobalVarRemoveMask(...);','function','FUNCTION','');
    AddVariableToList('GlobalVarFromFile(...);','function','FUNCTION','');
    AddVariableToList('GlobalVarFromTag(...);','function','FUNCTION','');
    AddVariableToList('Log(message: string);','function','FUNCTION','');
    AddVariableToList('MakeHtmlCacheInfo(...)','function','FUNCTION','');
    AddVariableToList('Output(text: string);','function','FUNCTION','');
    AddVariableToList('OutputTableList(...):string;','function','FUNCTION','');
    AddVariableToList('OutputTableListHeader(...):string;','function','FUNCTION','');
    AddVariableToList('OutputTableListRow(...):string;','function','FUNCTION','');
    AddVariableToList('EChartsBarChart(...):string;','function','FUNCTION','');
    AddVariableToList('EChartsPieChart(...):string;','function','FUNCTION','');
    AddVariableToList('StatorBusy(Value:string);','function','FUNCTION','');
    AddVariableToList('TableListMakeSqlFromParams(...):string;','function','FUNCTION','');
  end
  else begin
    //seznam vycistime, at je jistota, ze v nem nic neni zobrazeno (bez ohledu
    //na to, zda je to nacteno v globalnich promennych
    GgForm_lVariables.Items.Clear();
  end;
{$endif}
{$ifdef PROFILER}ProfileStop();{$endif}
end;

function SendFileToGcCz(sFileSrc,sNick,sPwd,sId:string):boolean;
  //odesle soubor statistiky (html nebo css) na gc.cz a zobrazi soubor v browseru
var sUrl,sUpload,sDownload,sFileName,sBound,sExt:string;
    b:boolean;
begin
    //formular je na https://www.geocaching.cz/stator/upload.php
    //prejmenujeme soubor podle ID
    if(not FileExists(sFileSrc)) then begin
      sUpload:=_('ERR: File not found')+': '+CRLF+sFileSrc; 
{$ifdef GENERATOR}
      Log(sUpload);
{$else}
      ShowMessage(sUpload);
{$endif}
      exit;
    end;
    if(sId='') or (sNick='') or (sPwd='') then begin
      sUpload:=_('ERR: Statistics file can''t be sent to geocaching.cz, missing login information (username/password/ID)');
{$ifdef GENERATOR}
      Log(sUpload);
{$else}
      ShowMessage(sUpload);
{$endif}
      exit;
    end;
    sBound:='abcd1234_Stator_'+sId;
    sExt:=RegexSubstitute('.*(\..*)$',sFileSrc,'$1'); //zapamatujeme si priponu souboru
    //vytvorime nove jmeno se spravnou priponou
    //(vypada to, ze PHP to vzdy ulozi jako 'statistika_<ID>.html bez ohledu
    //na jmeno, ktere mu posilam ja)
    sFileName:='statistika_'+sId+sExt;
    {$ifdef DEBUG_HELPER} LDH('Odesilam soubor: '+sFileSrc);{$endif}
    {$ifdef GENERATOR} Log('Odesilam na geocaching.cz soubor: '+sFileSrc);{$endif}
    //sUrl:='https://www.geocaching.cz/statistika/upload.php'; //stary formular, neumoznuje poslat obrazek
    sUrl:='https://www.geocaching.cz/statistika/upload2.php';
    sUpload:='--'+sBound+CRLF
      +'Content-Disposition: form-data; name="u"'+CRLF+CRLF+sNick+CRLF
      +'--'+sBound+CRLF
      +'Content-Disposition: form-data; name="p"'+CRLF+CRLF+sPwd+CRLF
      +'--'+sBound+CRLF
      +'Content-Disposition: form-data; name="s"'+CRLF+CRLF+'stator'+CRLF
      //dalsi moznosti jsou
      //+'Content-Disposition: form-data; name="s"'+CRLF+CRLF+'statistika1'+CRLF
      //+'Content-Disposition: form-data; name="s"'+CRLF+CRLF+'statistika2'+CRLF
      +'--'+sBound+CRLF
      +'Content-Disposition: form-data; name="submit"'+CRLF+CRLF+'upload'+CRLF
      +'--'+sBound+CRLF;
    case sExt of
    '.png': begin
              sUpload:=sUpload+'Content-Disposition: form-data; name="png"; filename="'+sFileName+'"'+CRLF
                +'Content-Type: image/png'+CRLF+CRLF
                +FileToString(sFileSrc)+CRLF;
            end;
    '.jpg','.jpeg': begin
              sUpload:=sUpload+'Content-Disposition: form-data; name="jpg"; filename="'+sFileName+'"'+CRLF
                +'Content-Type: image/jpeg'+CRLF+CRLF
                +FileToString(sFileSrc)+CRLF;
            end;
    '.html','.htm','': begin //prazdny string je kvuli stare chybe v nastaveni, kdy se vytvarel soubor bez pripony
            sUpload:=sUpload+'Content-Disposition: form-data; name="html"; filename="'+sFileName+'"'+CRLF
              +'Content-Type: Application/octet-stream'+CRLF+CRLF
              +FileToString(sFileSrc)+CRLF;
            end;
    '.css': begin
              sUpload:=sUpload+'Content-Disposition: form-data; name="css"; filename="'+sFileName+'"'+CRLF
                +'Content-Type: text/css'+CRLF+CRLF
                +FileToString(sFileSrc)+CRLF;
            end;
    end;
    sUpload:=sUpload+'--'+sBound+'--'+CRLF;
    sDownload:='';
    Result:=HttpAsk('POST',sUrl,
      'multipart/form-data; boundary='+sBound,sUpload, sDownload);
{$ifdef GENERATOR}
    Log('Stav odeslani: '+sDownload);
{$endif}
    if(not Result) then begin
      sUpload:=_('ERR: Error whlie sending file to geocaching.cz')+': '+sFileSrc;  
{$ifdef GENERATOR}
      Log(sUpload);
{$else}
      ShowMessage(sUpload+CRLF+CRLF+sDownload);
{$endif}
      end
    else begin //pokud je to mozne, zobrazime odeslanou statistiku
      //vysledek je v sDownload, parsujeme
      Fetch(sDownload,'url='); //nechame jen URL nahrane statistiky
      sExt:=RegexSubstitute('.*(\..*)$',sDownload,'$1'); //pripona skutecne ulozeneho souboru
      //pokud bylo HTML, zobrazime jej v browseru
      //obrazek (*.png) nebo *.css pochopitelne zobrazovat nebudeme
      if(sExt='.html') then begin
{$ifdef GENERATOR}
        Log(_('Loading statistics')); // Zobrazeni statistiky
{$endif}
        b:=BrowseURL(sDownload);
        if(not b) then
{$ifdef GENERATOR}
          Log(_('ERR: Browser defined in GeoGet doesn''t exist'));  
{$else}
          ShowMessage(_('ERR: Browser defined in GeoGet doesn''t exist'));  
{$endif}
      end;
    end;
{$ifdef DEBUG_HELPER}
    LDH('Odeslano:'+Copy(sUpload,1,600)+' ....');
    LDH('Odeslano: stav='+IntToStr(Result as integer)+CRLF+'Odpoved: '+sDownload);
{$endif}
end;
function GetChromePath:string;
var aReg:TRegistry;
    s:string;
begin
  //najdeme cestu k chrome
  //HKEY_CLASSES_ROOT     = $80000000;
  //HKEY_CURRENT_USER     = $80000001;
  //HKEY_LOCAL_MACHINE    = $80000002;
  //HKEY_USERS            = $80000003;
  //HKEY_PERFORMANCE_DATA = $80000004;
  //HKEY_CURRENT_CONFIG   = $80000005;
  //HKEY_DYN_DATA         = $80000006;
  //KEY_READ              = 131097;
  //HKEY_CLASSES_ROOT\Applications\chrome.exe\shell\open\command
  //HKEY_LOCAL_MACHINE\SOFTWARE\Classes\Applications\chrome.exe\shell\open\command
  aReg:=TRegistry.Create();
  aReg.RootKey:=$80000000;
  aReg.LazyWrite:=false;
  aReg.OpenKey('Applications\chrome.exe\shell\open\command',false); //jen pro cteni
  s:=aReg.ReadString('');      //vychozi hodnota
  if(s='') then begin
    aReg.RootKey:=$80000002;
    aReg.LazyWrite:=false;
    aReg.OpenKey('SOFTWARE\Classes\Applications\chrome.exe\shell\open\command',false); //jen pro cteni
    s:=aReg.ReadString('');      //vychozi hodnota
  end;
  //s:=aReg.ReadString('xx');
{$ifdef DEBUG_HELPER} LDH('Z registru chrome.exe: '+s);{$endif}
  aReg.CloseKey();
  aReg.Free();
  Result:=Trim(ReplaceString(Fetch(s,'--'),'"%1"','')); //nechame jen cestu a jmeno souboru
end;

function SendPreviewImgToGcCz(sPath,gcUsername,gcPassword,sGcCzId:string):boolean;
var s,sUrl,sFile:string;
    i:integer;
begin
  Result:=true;
  if(sPath<>'') then sFile:=sPath //pouzijeme zadany obrazek
  else begin                      //vytvorime obrazek
    //pokud obrazek existuje, smazeme jej
    sFile:=GetProfileDir()+'stator.png';
    if(FileExists(sFile)) then DeleteFile(sFile);
    sUrl:='https://www.geocaching.cz/statistika/u/'+sGcCzId+'/stator.html';
    {$ifdef GENERATOR} Log('Vytvarim nahled na statistiku: url='+sUrl);{$endif}
    {$ifdef DEBUG_HELPER} LDH('Vytvarim nahled na statistiku');{$endif}
  {$ifdef GENERATOR}
  {$endif}
    //nahled vytvarime pomoci chromu a protoze se vraci ihned (ne az po vytvoreni
    //obrazku), musime pockat, nez se obrazek udela
    //chrome.exe --headless --window-size=780,1500 --screenshot=g:\Tmp\obrazek.png  http://gord.8u.cz/Geocaching/Profily/Gordici/Statistics.php
  {$ifndef GENERATOR}
    sPreviewWidth:=GGForm_ePreviewImgWidth.Text;
    sPreviewHeight:=GGForm_ePreviewImgHeight.Text;
  {$endif}
    s:=GetChromePath()+' --headless --window-size='
      +sPreviewWidth+','+sPreviewHeight+' --screenshot="'+sFile+'" '+sUrl;
    {$ifdef DEBUG_HELPER} LDH('Spoustim prikaz: '+s);{$endif}
  //exit;
    //zavolame chrome k vytvoreni nahledu
    i:=RunExec(s);
    //RunShell(s);
    {$ifdef DEBUG_HELPER} LDH('Navratova hodnota: '+IntToStr(i));{$endif}
    if(i<>0) then begin
      {$ifdef GENERATOR} Log('ERR: ziskani nahledu statistiky, navratova hodnota='+IntToStr(i));
      {$else}ShowMessage('ERR: ziskani nahledu statistiky, navratova hodnota='+IntToStr(i));
      {$endif}
      Result:=false;
      exit;
    end;
    //pockame, az bude nahled vytvoren
    i:=120;  //cekame maximalne 2 minuty (po 1 sekunde)
    for i:=120 downto 0 do begin
      Sleep(1000); //pockame sekundu
      if(FileExists(sFile)) then break;
    end;
    if(i=0) then begin
      {$ifdef GENERATOR} Log('ERR: behem cekani nebyl ziskan nahled statistiky');
      {$else}ShowMessage('ERR: behem cekani nebyl ziskan nahled statistiky');
      {$endif}
      Result:=false;
      exit;
    end;
  end;
  {$ifdef GENERATOR} Log('Kopiruji na gc.cz obrazek '+sFile);{$endif}
  {$ifdef DEBUG_HELPER} LDH('Kopiruji na gc.cz obrazek '+sFile);{$endif}
  SendFileToGcCz(sFile,gcUsername,gcPassword,sGcCzId);
end;

function SendFileToFtp(sLocal,sUser,sPwd,sUrl,sBrowserUrl:string):boolean;
var sServer,sPort,sFile,s,sExt:string;
    bFtps:boolean;
  //odesle soubor statistiky na zadany FTP server a zobrazi soubor v browseru
begin
  {$ifdef DEBUG_HELPER} LDH('Odesilam soubor: '+sLocal);{$endif}
  {$ifdef GENERATOR} Log('Odesilam na FTP soubor: '+sLocal);{$endif}
  Result:=false;
  //rozeberem informace pro FTP server
  sFile:=sUrl;
  if(copy(sFile,1,6)='ftp://') then begin s:=fetch(sFile,'//'); bFtps:=false; end;
  if(copy(sFile,1,7)='ftps://') then begin s:=fetch(sFile,'//'); bFtps:=true; end;
  sPort:=fetch(sFile,'/');
  sServer:=fetch(sPort,':');
  if(sPort='') then begin
    sPort:='21';  //port neni zadan, pouzijeme implicitni
    //if(bFtps) then sPort:='990'; //starsi verze FTPS pouziva tento port, novejsi take 21
  end;
  s:=ReplaceString(sLocal,'/','\'); //dame spravne oddelovace
  if(sPwd<>'') and (sUser<>'') and (sFile<>'') and (sPort<>'') and (sServer<>'')
    and (sFile<>'') then begin
    Result:=FtpPutFile(sServer,sPort,sFile,s,sUser,sPwd);
  end;
  {$ifdef DEBUG_HELPER}
  LDH('Odesilam soubor na FTP: '+CRLF
        +'sServer: '+sServer+CRLF
        +'sPort: '+sPort+CRLF
        +'sFile: '+sFile+CRLF
        +'sUser: '+sUser+CRLF
        +'sPwd: '+sPwd+CRLF
        +'sLocalFile: '+s+CRLF);
  {$endif}
  if(not Result) then begin
    sUrl:=_('ERR: FTP error')+': '+
        +'sServer: '+sServer+CRLF
        +'sPort: '+sPort+CRLF
        +'sFile: '+sFile+CRLF
        +'sUser: '+sUser+CRLF
        +'sPwd: '+sPwd+CRLF
        +'sLocalFile: '+s+CRLF;
{$ifdef GENERATOR}
    Log(sUrl);
{$else}
    ShowMessage(sUrl);
{$endif}
  end else begin
  // URL pro FTP neni stejne jako pro http, takze neni mozne rovnou soubor zobrazit
    //sExt:=LowerCase(RegexSubstitute('.*(\..*)$',sBrowserUrl,'$1')); //pripona souboru
    sExt:=LowerCase(RegexSubstitute('.*/.*(\.[a-zA-Z]+)',sBrowserUrl,'$1')); //pripona souboru, pripadne parametry ignorujeme
    if(sExt='.htm') or (sExt='.html') or (sExt='.php') then begin
{$ifdef GENERATOR}
        Log(_('Loading statistics')); 
{$endif}
      if(not BrowseURL(sBrowserUrl)) then
{$ifdef GENERATOR}
        Log(_('ERR: Browser defined in GeoGet doesn''t exist'));  
{$else}
        ShowMessage(_('ERR: Browser defined in GeoGet doesn''t exist'));  
{$endif}
    end;
  end;
end;

{$ifdef GENERATOR}
//podle azimutu vrt jmeno promenne s ikonou smeru (vcetne znaku %...%)
function DirectionToIcon(fAngle:extended):string;
begin
  Result:='%IconDirection'+IntToStr((round(fAngle+45/2)/45)*45)+'%'
end;
{$endif}

{$ifdef GENERATOR}
function GetCacheInfo(sId:string; var sName,sIconCountry,sIconDirection:string;
         var fLat,fLon,fDistance,fDirection,fElevation:extended):boolean;
var geo:TGeo;
    s:string;
begin
  Result:=true;
  geo:=TGeo.Create();
  try
    geo.LoadByGC(sId);
    if(geo.Name='') then begin   //nenalezeno
      Result:=false;
      sName:='';
      sIconCountry:='';
      fLat:=0;
      fLon:=0;
      fDistance:=0;
      fDirection:=0;
      fElevation:=0;
    end
    else begin
      sName:=geo.Name;
      sIconCountry:='%IconCountry'+geo.Country+'%';
      fLat:=geo.latnum;
      fLon:=geo.lonnum;
      //vypocet vzdalenosti a smeru od souradnic nastavenych v profilu
      fDistance:=PointDistanceEx(fHomeX,fHomeY,fLat,fLon,fDirection);
      sIconDirection:=DirectionToIcon(fDirection);
      s:=geo.TagValues('elevation');
      if(s='') then fElevation:=0
      else fElevation:=StrToFloat(s);
    end;
  finally
    geo.Free();
  end;
end;
{$endif}

