{ modul generuje vykonny plugin StatorGen.ggp.pas pro generovani statistiky
}
var aSekvenceInclude:TStringList; //seznam a poradi spoustenych modulu
         //prvni znak modulu je
         //   ! ... bezny modul
         //   # ... automaticky pridavany vypocteni modul ('CALC')
         //   ~ ... rucne zarazeny vypocetni modul ('CALC')
         //obsluha modulu:
         //   !,~ ... vola se Modul_Run(aPar)
         //   #,! ... vola se Modul_Free()
         //   # ..... vola se Modul_Run(nil)

    aUses:TStringList;            //seznam knihoven pro prikaz uses
    bErrMake:boolean;             //priznak chyby pri generovani ggp
{$ifdef DEBUG_HELPER}
    aZavislosti:TStringList;      //seznam zavislych modulu (s uvedenim zavislosti)
{$endif}

function GetModuleProperties(sName:string; var sType:string):TStringList;
//nacte vlastnosti modulu (typ, seznam jmen modulu, na kterych je modul zavisly)
var i:integer;
    ini:TMemIniFile;
begin
  sType:='';
  Result:=TStringList.Create();;
  for i:=0 to nModulesAll-1 do begin
    if(aModulesAll[i].sName=sName) then break;
  end;
  if(i>=nModulesAll) then exit;   //divne, takovy modul neexistuje, asi je to 
                                  //zavislost na necem jinem nez je modul Statoru
  sType:=aModulesAll[i].sCategory;
  //nacteme zavislosti
//LDH('Vlastnosti modulu ze souboru: '+GetModulesDir()+sName+'.meta.ini');
  ini:=TMemIniFile.Create(GetMetaIniPath(sName,aModulesAll[i].sDir));
  try
    ini.ReadSectionValues('Dependency',Result);
  finally
    ini.Free();
  end;
  //for i:=Result.Count-1 downto 0 do begin
  //  Result[i]:=ReplaceString(Result[i],'=','');  //vyhodime koncove =
  //end;
end;

procedure InsertDependencyModule(sModule:string;bAutoInsert,bWarn:boolean);
var j:integer;
    ini:TMemIniFile;
    sCategory,sParams:string;
begin
//if(sModule[1]='#') then ShowMessage('pridavani modulu: '+sModule);
  if(FileExists(GetModuleDirFromName(sModule)+copy(sModule,2,Length(sModule))+'.Stator.pas')) then begin
    //zkontrolujeme, zda uz je modul v seznamu a pokud ne, pridame ho tam
    j:=aSekvenceInclude.IndexOf(sModule);
    //pokud modul nebyl nalezen, zkusime, zda nejde o vypocetni modul vlozeny rucne do stromecku
    if(j<0) then j:=aSekvenceInclude.IndexOf('~'+copy(sModule,2,Length(sModule)));
{$ifdef DEBUG_HELPER} LDH('InsertDependencyModule(): pridavani modulu: '+sModule+CRLF+'j='+IntToStr(j)+CRLF+'bAutoInsert='+IntToStr(bAutoInsert as integer));{$endif}
    if(j<0) then begin
      //zkontrolujeme, zda CALC modul ma zadane nejake parametry a pokud ano,
      //nahlasime chybu, protoze takovy modul musi byt pridan explicitne, aby mu
      //uzivatel mohl parametry nastavit
      {
      pokud ma modul parametry a je automaticky zarazen:
        - nema zaznam v Content.ini
        - v Content.ini nejsou hodnoty parametru
        - neni mozne naplnit hodnoty parametru pro volani hlavni funkce
          modulu
        - hlavni funkce modulu nema s cim pracovat
      Udelat nastaveni parametru pri nezadanem modulu v Content.ini je celkem
      komplikovane, protoze to znamena znovu parsovat prinejmensim oba ini soubory,
      zjistovat typy a hodnoty parametru, atd. (A jeste vedet, v jakem adresari
      ten modul je, protoze muze byt i v podrizenych adresarich.) Tedy to, co se
      dela pri nastavovani naprogramovat jeste jednou pri volani hlavni funkce
      modulu.
      }
      //napred seznam parametru
      ini:=TMemIniFile.Create(GetModuleDirFromName(sModule)+copy(sModule,2,Length(sModule))+'.ini');
      sCategory:=UpperCase(ini.ReadString('Module','CATEGORY','?'));
      sParams:=ini.ReadString('Module','PARAMS','');
      ini.Free();
      {
      //6.1.2016 potlaceno, vsechny vypocetni moduly se vkladaji rucne nebo automaticky,
      //         je na nich, aby se popraly s aPar=nil a nastavily implicitni
      //         hodnoty i v tomto pripade
      if//(Pos('CALC',sCategory)>0) and
        (sParams<>'') and (bAutoInsert) and (bWarn) then begin
        j:=MessBox(
          _('Module')+' '+copy(sModule,2,Length(sModule))+CRLF+CRLF
          +_('ERR: Because module is using it''s own parameters it can''t be used automatically and it''s neccessary to add it manually to used modules and set the parameters. Implicit parameter values can cause incorrect processing.')
          +CRLF+CRLF+_('Cancel processing?'),'Stator',4); // tj. Ano=6/ne=7
        if(j=6) then bErrMake:=true;
      end;
      }
      //rucne vkladany modul, i vypocetni, musi byt vzdy volan pri zpracovani
      //stromecku, aby se takovemu modulu mohly predat spravne parametry
      if(not bAutoInsert) and (Pos('CALC',sCategory)>0) then sModule[1]:='~';
      {$ifdef DEBUG_HELPER} LDH('PRIDAVAM MODUL: '+sModule); {$endif}
      aSekvenceInclude.Add(sModule);
    end;
    {$ifdef DEBUG_HELPER} LDH('Modul '+sModule+', j='+IntToStr(j)); {$endif}
  end;
{$ifdef DEBUG_HELPER}
  //LDH('PRIDAVAM MODUL: '+sModule);
{$endif}
end;

procedure InsertUsesLibrary(sModule:string);
var i:integer;
    ini:TMemIniFile;
    aList:TStringList;
begin
  //ShowMessage('Uses pro modul '+sModule);
  if(FileExists(GetModuleDirFromName(sModule)+sModule+'.Stator.pas')) then begin
    ini:=TMemIniFile.Create(GetModuleDirFromName(sModule)+sModule+'.ini');
    try
      aList:=TStringList.Create();
      try
        ini.ReadSectionValues('Uses',aList);
        //ShowMessage('Nactene knihovny: '+aList.Text);
        for i:=0 to aList.Count-1 do begin
          aUses.Add(ReplaceString(aList[i],'=','')); //vyhodime koncove '='
        end;
      finally
        aList.Free();
      end;
    finally
      ini.Free();
    end;
  end;
end;

procedure InsertDependencyModules(sModuleFull:string;bAutoInsert:boolean);
var aDependency:TStringList;
    sParam,sType,sModule:string;
    bWarn:boolean;
    i:integer;
begin
  sParam:=sModuleFull;
  sModule:=Fetch(sParam,'=');
  aDependency:=GetModuleProperties(sModule,sType);
  if(aDependency<>nil) then begin
{$ifdef DEBUG_HELPER}
  if(aDependency.Count>0) then aZavislosti.Add('     '+sModule+' >>>>> '+ReplaceString(Trim(aDependency.Text),CRLF,', '));
{$endif}
    for i:=0 to aDependency.Count-1 do begin
      //zjistime index modulu, kde je nacteny (abychom jej nasli
      //ve spravnem adresari)
      InsertDependencyModules(aDependency[i],true);
    end;
    aDependency.Free();
  end;
  //zjistime priznak zobrazeni varovani pri zavislosti
  bWarn:=(UpperCase(sParam)<>UpperCase('NoWarn'));
  //nevkladame organizacni bloky, prikazy ani preddefinovane skupiny
{$ifdef DEBUG_HELPER} LDH('ZZZZZ sType='+sType+', bAutoInsert='+IntToStr(bAutoInsert as integer)); {$endif}
  if(sType='') or (sType='ORG') or (sType='COMMAND') or (sType='PREDEFINED') then exit;
  if(Pos('CALC',sType)>0) then InsertDependencyModule('#'+sModule,bAutoInsert,bWarn)
  else InsertDependencyModule('!'+sModule,bAutoInsert,bWarn);
  InsertUsesLibrary(sModule);
end;

procedure SortUsedModules;
//zjisti a vraci seznam vypocetnich modulu podle jejich zavislosti,
//abychom je mohli postupne zavolat
var i:integer;
    sModul:string;
begin
  bErrMake:=false;
  for i:=0 to aContent.Count-1 do begin
    sModul:=RemoveModuleTitle(aContent[i]);
    if((sModul[1]<>'M') or (sModul[4]<>'E')) then continue;
{$ifdef DEBUG_HELPER} LDH('GGGG kontrola zavislych modulu pro: '+sModul); {$endif}
    Fetch(sModul,'.'); //nechame jen jmeno modulu
    InsertDependencyModules(sModul,false);
  end;
end;

function GenerateGgp:boolean;
var s,sDir,sPlugin,sCss:string;
    i:integer;
begin
  Result:=true;
  //vytvorime soubor, ktery vlozi potrebne moduly
  fOut:=TFileStream.Create(GetProfileDir()+'StatorGen.modules.pas',fmCreate or fmShareDenyWrite);
  try
    //pripravime seznam knihoven, razeni abecedne, abychom mohli neukladat
    //stejne knihovny vickrat
    aUses:=TStringList.Create();
    aUses.Sorted:=true;
    aUses.Duplicates:=dupIgnore;
    aUses.Add('simplejson'); //toto je tam vzdy
    //pripravime seznam pouzitych modulu a prepiseme je
    aSekvenceInclude:=TStringList.Create();
{$ifdef DEBUG_HELPER}
    aZavislosti:=TStringList.Create();
    //aZavislosti.CaseSensitive:=false;
    aZavislosti.Duplicates:=dupIgnore;
    aZavislosti.Sorted:=true;
{$endif}
    SortUsedModules();
    if(not bErrMake) then begin //je chyba v zavislosti modulu a uzivatel chce prerusit generovani nahledu
      for i:=0 to aSekvenceInclude.Count-1 do begin
        {$ifdef DEBUG_HELPER} LDH('------------- Zpracovani modulu: '+aSekvenceInclude[i]); {$endif}
        //protoze moduly nejsou v adresari script ani v adresari s pluginem, musime
        //pouzit relativni cestu od script
        sDir:=GetModuleDirFromName(copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i])));
        s:='{$include '
          +ReplaceString(sDir,GEOGET_SCRIPTDIR+'\','')
          +copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i]))+'.Stator.pas}'+CRLF;
        fOut.Write(s,length(s));
        //proverime, zda ma modul svuj styl a pokud ano, nacteme jej
        s:=GetModulesDir()+copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i]))+'.css';
        if(FileExists(s)) then begin
          sCss:=sCss+CRLF+CRLF+'/* CSS pro modul '+copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i]))+' */'+CRLF
            +FileToString(s);
        end;
      end;
      //vytvorime hlavni proceduru
      s:=CRLF
        +'//hlavni procedura pro generovani statistiky'+CRLF
        +'//procedura je automaticky vytvorena podle uzivatelske konfigurace statistik'+CRLF
        +'procedure StatorGen;'+CRLF
        //+'var i:integer;'+CRLF
        //+'    aPar:TStringList;'+CRLF
        +'begin'+CRLF
        +'  //inicializace funkci pro volani modulu'+CRLF
        ;
      fOut.Write(s,length(s));
      //pridame definici hlavnich funkci vsech modulu podle konfigurace
      for i:=0 to aSekvenceInclude.Count-1 do begin
        //vynechame vypocetni moduly, protoze jejich hlavni funkce je jineho
        //typu nez funkce prezentacnich modulu
        if(aSekvenceInclude[i][1]<>'#') then begin //jen prezentacni moduly nebo vypocetni,
                                                  //ktere maji parametry a jsou rucne zarazene
                                                  //zarazene do stromecku
          s:='  aFce['+IntToStr(i)+']:=@'+copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i]))+'_Run;'+Chr(9)+Chr(9);
          //InsertUsesLibrary(copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i])));
        end
        else begin
          s:='  aFce['+IntToStr(i)+']:=nil;'+Chr(9)+Chr(9)+Chr(9);
        end;
        s:=s+'  aModuleName.Add('''+copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i]))+''');'+Chr(9)+Chr(9)
            +'  aModuleSubDir.Add('''+ReplaceString(GetModuleDirFromName(copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i]))),GetModulesDir(),'')+''');'
            +CRLF;
        fOut.Write(s,length(s));
      end;
      s:=CRLF+'  //zavolame hlavni procedury vsech automaticky pridanych vypocetnih modulu'+CRLF;
      fOut.Write(s,length(s));
{$ifdef DEBUG_HLPER} LDH('GGGG Spousteni modulu '+aSekvenceInclude[i]); {$endif}
      for i:=0 to aSekvenceInclude.Count-1 do begin
        if(aSekvenceInclude[i][1]='#') then begin
          //vystupni parametr hlavni funkce vypocetniho modulu ignorujeme
          s:='  '+copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i]))+'_Run(nil);'+CRLF;
          fOut.Write(s,length(s));
        end;
      end;
      //pridame volani zpracovatelske funkce
      s:=CRLF+'  //zavolame zpracovani celeho INI souboru s konfiguraci'+CRLF
        +'  ProcessIni('''+GetProfileDir()+'Content.ini'');'+CRLF
        //+'  if(aPar<>nil) then aPar.Free();'+CRLF
      fOut.Write(s,length(s));
      s:=CRLF+'  //zavolame uvolnovaci procedury vsech vypocetnih modulu'+CRLF;
      fOut.Write(s,length(s));
      for i:=aSekvenceInclude.Count-1 downto 0 do begin
        //funkce pro uvolneni volame u vsech vypocetnich modulu bez ohledu na to,
        //zda byly vlozeny automaticky nebo ze stromecku
        if(aSekvenceInclude[i][1]='#') or (aSekvenceInclude[i][1]='~')then begin
          s:='  '+copy(aSekvenceInclude[i],2,Length(aSekvenceInclude[i]))+'_Free();'+CRLF;
          fOut.Write(s,length(s));
        end;
      end;
      s:='end;'+CRLF;
      fOut.Write(s,length(s));
    end;
  finally
    fOut.Free();
  end;
  aSekvenceInclude.Free();
{$ifdef DEBUG_HELPER}
    LDH('Seznam zavislych modulu:='+CRLF+aZavislosti.Text);
    aZavislosti.Free();
{$endif}
  //prekopirujeme hlavni cast pluginu
  sPlugin:=GetProfileDir()+'StatorGen.ggp.pas'
  fOut:=TFileStream.Create(sPlugin,fmCreate or fmShareDenyWrite);
  try
    s:='';
    //vytvorime prikaz pro vlozeni knihoven
    //ShowMessage('Nactene knihovny: '+aUses.Text);
    if(aUses.Count>0) then begin
      s:='uses '+ReplaceString(Trim(aUses.Text),CRLF,',')+';'+CRLF+CRLF;
    end;
    s:=s+FileToString(GetMyDir()+'StatorGen.Engine.pas')+CRLF
    //nahradime jmeno profilu v titulku a pro include souboru s vkladanymi moduly
    s:=ReplaceString(s,'%PROFILE%',sProfile);
    fOut.Write(s,Length(s));
  finally
    fOut.Free();
  end;
  //ulozime soubor s CSS pouzitych modulu, nebo smazeme stary soubor
  s:=GetProfileDir()+'Modules.css';
  if(sCss<>'') then StringToFile(sCss,s)
  else if(FileExists(s)) then DeleteFile(s);
  aUses.Free();
  if(not bErrMake) then begin
    //ulozime ggp do skupiny ke Statoru a dame na toolbar
    i:=0;
    s:=GeoGetPluginGroup(sPlugin);  //toto je skupina pluginu
    if((GeoGetPluginGroup(sPlugin)='') or (s=GeoGetDefaultGroup())) then begin
      s:=GeoGetPluginGroup(GEOGET_SCRIPTFULLNAME);  //toto je skupina Statoru
      GeoSetPluginGroup(sPlugin,s); //nastavime skupinu
      Inc(i);
    end;
    if(GGForm_bMiscIconToToolbar.Checked) then begin  //a dame ho na toolbar, kdyz tam jeste neni
      if(not GeoGetToolbar(sPlugin)) then begin
        GeoSetToolbar(sPlugin,true);
        Inc(i);
      end;
    end
    else begin //odstranime z toolbaru, pokud tam je
      if(GeoGetToolbar(sPlugin)) then begin
        GeoSetToolbar(sPlugin,false);
        Inc(i);
      end;
    end;
    if(i>0) then GeoReloadPlugins();   //refresh toolbaru
  end;
  Result:=(not bErrMake);
end;