//obsluha formulare se seznamem vsech modulu
const MAX_CATEGORY=15;

type
  REC_CATEGORY=Record
    sName:string;                //jmeno kategorie v sCategory
    sDesc:string;                //popis zobrazeny v seznamu
    iMode:integer;               //min uroven rezimu, pri kterem je kategorie zobrazena
    bOpen:boolean;               //priznak rozbaleneho seznam
  end;
     
var aCategory:array[0..MAX_CATEGORY] of REC_CATEGORY;
    nCategory:integer;           //pocet vyuzitych kategorii
    iMouseX,iMouseY:integer;     //poloha mysi pri kliknuti
    iIdxLastModule:integer;      //index naposledy zobrazeneho modulu
    iPreviewModule:integer;     //poradove cislo zobrazeneho nahledoveho obrazku

procedure AddCategory(name,desc:string;open:boolean;mode:integer);
begin
  if(nCategory+1>MAX_CATEGORY) then begin
    ShowMessage(_('Too much categories: ')+CRLF+name);
    exit;
  end;
  aCategory[nCategory].sName:=name;
  aCategory[nCategory].sDesc:=desc;
  aCategory[nCategory].bOpen:=open;
  aCategory[nCategory].iMode:=mode;
  Inc(nCategory);
end;

function FindIdxFromModulesAllIdx(iIndex:integer;var bCategory:boolean):integer;
  //vraci priznak toho, zda bylo kliknuto na kategorii nebo modul
  //a index v prislusnem poli aCategory nebo aModulesAll
var s:string;
begin
  Result:=-1;
  bCategory:=false;
  if(iIndex<0) then exit;
  s:=GGForm_lModulesAll.Items[iIndex];
  //napred hledame mezi kategoriemi, tech je mene
  bCategory:=true;
  for Result:=0 to nCategory-1 do begin
    if(aCategory[Result].sName=s) then exit;
  end;
  bCategory:=false;
  for Result:=0 to nModulesAll-1 do begin
    if(aModulesAll[Result].sName=s) then exit;
  end;
end;

function FindIdxFromModulesAll(var bCategory:boolean):integer;
begin
  Result:=FindIdxFromModulesAllIdx(GGForm_lModulesAll.ItemIndex,bCategory);
end;

procedure FillModulesAll;
var i,j,k:integer;
begin
  k:=GGForm_lModulesAll.ItemIndex;
  GGForm_lModulesAll.Items.Clear();
  //pridame vsechny moduly do seznamu
  j:=0;
  for j:=0 to nCategory-1 do begin
    if(GGForm_lMode.ItemIndex<aCategory[j].iMode) then continue;
    GGForm_lModulesAll.Items.Add(aCategory[j].sName);
    if(not aCategory[j].bOpen) then continue;
    for i:=0 to nModulesAll-1 do begin
      if(Pos(aCategory[j].sName,aModulesAll[i].sCategory)>0) then begin
        //pokud je PREDEFINED, pridame jen kdyz neni zadna jina kategorie
        if(aCategory[j].sName<>'PREDEFINED') or (Pos(',',aModulesAll[i].sCategory)<1) then
          GGForm_lModulesAll.Items.Add(aModulesAll[i].sName);
      end;
    end;
  end;
  if(k>GGForm_lModulesAll.Items.Count-1) then k:=GGForm_lModulesAll.Items.Count-1;
  if(k<0) then k:=0;
  GGForm_lModulesAll.ItemIndex:=k;
end;

procedure gPreviewShow(preview:TImage;previewTitle:TLabel);
var aList:TStringList;
    s,s1:string;
    i,idx,n:integer;
begin
  aList:=TStringList.Create();
  s:=GetModuleDirFromName(aModulesAll[iIdxLastModule].sName);
  //adresar Predefined ignorujeme
  s:=ReplaceString(s,'\Predefined\','\');
  FileList(s+'Images',aList);
  //vyhazeme vse, co neodpovida moznemu jmenu obrazku
  s:='.*\\'+aModulesAll[iIdxLastModule].sName+'\..*\.{0,1}png$';
  s:=ReplaceString(s,' ','\ ');
  s:=ReplaceString(s,'(','\(');
  s:='(?i)'+ReplaceString(s,')','\)');
{$ifdef DEBUG_HELPER}
  LDH('iIdxLasmodule='+IntToStr(iIdxLastModule));
  LDH('sName='+aModulesAll[iIdxLastModule].sName);
  LDH('Dir='+GetModuleDirFromName(aModulesAll[iIdxLastModule].sName));
  LDH('Pocet souboru v adresari '+IntToStr(aList.Count));
  LDH('Regularni vyraz s='+s);
{$endif}
  //pro kazdy soubor nacteme parametry modulu
  n:=0;
  idx:=-1;
  for i:=0 to aList.Count-1 do begin
{$ifdef DEBUG_HELPER}
    //LDH('iPreviewModule='+IntToStr(iPreviewModule)+', i='+IntToStr(i));
{$endif}
    if(RegexFind(s,aList[i])) then begin
{$ifdef DEBUG_HELPER}
      LDH('Regex shoda, file='+aList[i]);
{$endif}
      if(s1='') then s1:=aList[i]; //pro pripad, ze bychom museli skocit na prvni obrazek
      if(idx<0) and (iPreviewModule=n) then begin //nalezen spravny obrazek
        s1:=aList[i];
        Inc(iPreviewModule);
        idx:=i;
        //break; //neukoncime, abychom spocitali pocet onrazku
      end;
      Inc(n);
    end;
  end;
  if(idx<0) then iPreviewModule:=1; //ted je zobrazen 1. v poradi, priste zobrazime dalsi
  if(s1<>'') then begin //zobrazime obrazek
    preview.Picture.LoadFromFile(s1);
    {
    //preview.Center:=true;
    if((preview.Height>=preview.Picture.Bitmap.Height) and
      (preview.Width>=preview.Picture.Bitmap.Width)) then preview.Center:=true
    else preview.Center:=false;
    }
    preview.Visible:=true;
    previewTitle.Caption:=IntToStr(iPreviewModule)+'/'+IntToStr(n);
    previewTitle.Visible:=true;
    GGForm_ePreviewLabel.Visible:=true;
  end
  else begin
    preview.Visible:=false;
    previewTitle.Visible:=false;
    GGForm_ePreviewLabel.Visible:=false;
  end;
  aList.Free();
end;

procedure gPreviewModuleOnClick(sender:TObject); //zobrazi dalsi obrazek nahledu na modul
begin
  gPreviewShow(GGForm_gPreview,GGForm_ePreviewTitle);
end;

procedure lModulesAllOnKeyDown(sender:TObject;var Key: Word; Shift: TShiftState);
var bCat:boolean; //vraci priznak toho, zda bylo kliknuto na kategorii nebo modul
    idx:integer;  //a index v prislusnem poli aCategory nebo aModulesAll
begin
  if((Key=37) or (Key=39)) and (sender=GGForm_lModulesAll) then begin
    idx:=FindIdxFromModulesAll(bCat);
    if(bCat) then begin
      aCategory[idx].bOpen:=not aCategory[idx].bOpen;
{$ifdef DEBUG_HELPER}
  LDH('0..lModulesAllOnKeyDown, bOpen='+IntToStr(aCategory[idx].bOpen as integer));
{$endif}
      Key:=0; //win se jinak chovaji jako by byla sipka dolu
      FillModulesAll();
    end;
  end;
end;

procedure EnableDragDrop(b:boolean);
begin
  //povoleni Drag&Drop z neznamych duvodu zpusobi to, ze kliknuti mysi vyvolava
  //nekdy 2 x funkci OnClick - jednou pri stlaceni mysi, podruhe pri uvolneni
  //!!! proto je asi bez dalsiho vyzkumu tato funkce nepouzitelna !!!
  if(b) then GGForm_lModulesAll.DragMode:=dmAutomatic //1, povolime Drag&Drop 
  else GGForm_lModulesAll.DragMode:=dmManual; //0, zakazeme Drag&Drop
///////////GGForm_lModulesAll.DragMode:=dmAutomatic;
{$ifdef DEBUG_HELPER}
//  LDH('Povoleni Drag&Drop: '+IntToStr(GGForm_lModulesAll.DragMode as integer));
{$endif}
end;

procedure lModulesAllOnClick(sender:TObject);
var bCat:boolean; //vraci priznak toho, zda bylo kliknuto na kategorii nebo modul
    idx:integer;  //a index v prislusnem poli aCategory nebo aModulesAll
begin
  GGForm_ScrollBox1.VertScrollBar.Position:=0; //posuneme scrollbar nahoru
  idx:=FindIdxFromModulesAll(bCat);
{$ifdef DEBUG_HELPER}
  LDH('0..lModulesAllOnClick, ItemIndex='+IntToStr(GGForm_lModulesAll.ItemIndex));
{$endif}
  if(bCat) and (iMouseX>=2) and (iMouseX<=11) then begin
    aCategory[idx].bOpen:=not aCategory[idx].bOpen;
{$ifdef DEBUG_HELPER}
  LDH('0a..lModulesAllOnClick, ItemIndex='+IntToStr(GGForm_lModulesAll.ItemIndex));
{$endif}
    FillModulesAll();
{$ifdef DEBUG_HELPER}
  LDH('0b..lModulesAllOnClick, ItemIndex='+IntToStr(GGForm_lModulesAll.ItemIndex));
{$endif}
  end;
  if(bCat) then begin
    GGForm_eDesc.Caption:='';
    GGForm_gPreview.Visible:=false;
    GGForm_ePreviewTitle.Visible:=false;
    GGForm_ePreviewLabel.Visible:=false;
    iPreviewModule:=0;
  end
  else begin
    if(idx<>iIdxLastModule) then begin
      iIdxLastModule:=idx;
      iPreviewModule:=0;
    end;
    GGForm_eDesc.Caption:=aModulesAll[idx].sDesc;
    GGForm_gPreview.Visible:=true;
    GGForm_ePreviewTitle.Visible:=true;
    GGForm_ePreviewLabel.Visible:=true;
    gPreviewModuleOnClick(nil);
  end;
  //povolime tlacitko pro pridani (vypocetni moduly pridavat nelze)
  //(umoznim modul pridat, aby uzivatel mohl explicitne pouzit modul i kdyz
  //na nem zadny z jim pouzivanych modulu neni zavisly)
  //GGForm_butAddModule.Enabled:=((not bCat) and (aModulesAll[idx].sCategory<>'CALC'));
  //EnableDragDrop(not bCat);
{$ifdef DEBUG_HELPER}
  LDH('0c..lModulesAllOnClick, ItemIndex='+IntToStr(GGForm_lModulesAll.ItemIndex));
{$endif}
end;

procedure AddNewModule(name,dir,desc,cat,params,paramsGgp:string;iCss,iJs:integer);
var i,j:integer;
begin
  if(nModulesAll>=MAX_MODULES) then ShowMessage(_('ERR: Too much modules'))
  else begin
    //najdemem pozici, kam prijde modul zaradit, aby byly abecedne podle jmena
    for i:=0 to nModulesAll-1 do begin
      if(aModulesAll[i].sName>name) then break;
    end;
    if(i<nModulesAll) then begin //udelame misto
      for j:=nModulesAll-1 downto i do begin
        aModulesAll[j+1].sName:=aModulesAll[j].sName;
        aModulesAll[j+1].sDir:=aModulesAll[j].sDir;
        aModulesAll[j+1].sDesc:=aModulesAll[j].sDesc;
        aModulesAll[j+1].sCategory:=aModulesAll[j].sCategory;
        aModulesAll[j+1].sParams:=aModulesAll[j].sParams;
        aModulesAll[j+1].sParamsGgp:= aModulesAll[j].sParamsGgp;
        aModulesAll[j+1].iCss:=aModulesAll[j].iCss;
        aModulesAll[j+1].iJavascript:=aModulesAll[j].iJavascript;
      end;
    end;
    //ulozime na spravnou pozici
    aModulesAll[i].sName:=name;
    aModulesAll[i].sDir:=dir;
    aModulesAll[i].sDesc:=desc;
    aModulesAll[i].sCategory:=UpperCase(cat);
    aModulesAll[i].sParams:=params;
    aModulesAll[i].sParamsGgp:=paramsGgp;
    aModulesAll[i].iCss:=iCss;
    aModulesAll[i].iJavascript:=iJs;
    Inc(nModulesAll);
  end;
end;

procedure ReadModulesFromDir(sParentDir:string);
var i:integer;
    iCss,iJs:integer;
    aList:TStringList;
    ini:TMemIniFile;
    s,name,dir,desc,cat,params,paramsGgp:string;
begin
  aList:=TStringList.Create();
  FileList(sParentDir,aList);
  try
    //pro kazdy soubor nacteme parametry modulu
    if(aList.Count>0) then begin
      s:=aList[0];
      cat:=RegexSubstitute('(?i)^(.*\\)',s,'$1');
      dir:=ReplaceString(cat,GetModulesDir(),'');
    end;
    for i:=0 to aList.Count-1 do begin
      name:=RegexSubstitute('(?i)^.*\\(.*?)\.ini$',aList[i],'$1');
      if(name='') then continue;
      //soubory meta.ini a params.ini ignorujeme
      if(RegexFind('(?i)\.meta$',name)) then continue;
      if(RegexFind('(?i)\.params$',name)) then continue;

      //nacteme vlastnosti modulu
      ini:=TMemIniFile.Create(GetMetaIniPath(name,dir));
      desc:=ini.ReadString('info','Description_'+sLang,'???');
      if(desc='???') then desc:=ini.ReadString('info','Description','???');
      ini.Free();
      ini:=TMemIniFile.Create(GetModulesDir()+dir+name+'.ini');
      cat:=Uppercase(ini.ReadString('Module','CATEGORY','???'));
      params:=ini.ReadString('Module','PARAMS','');
      paramsGgp:=ini.ReadString('Module','PARAMS_GGP','');
      s:=Uppercase(ini.ReadString('Module','CSS','NO'));
      case s of
      'NO': iCss:=-1;
      'POSSIBILY': iCss:=0;
      'ONLY': iCss:=1;
      else iCss:=-1;
      end;
      s:=Uppercase(ini.ReadString('Module','JAVASCRIPT','NO'));
      case s of
      'NO': iJs:=-1;
      'POSSIBILY': iJs:=0;
      'ONLY': iJs:=1;
      else iJs:=-1;
      end;
      AddNewModule(name,dir,desc,cat,params,paramsGgp,iCss,iJs);
      //nacteme promenne, ktere modul poskytuje
      GlobalVarFromFile(GetMetaIniPath(name,dir),'Variables','');
      ini.Free();
    end;
    //zpracujeme postupne vsechny vnorene adresare, to delame az ted,
    //aby vsechny nestandardni moduly byly za standardnimi
    for i:=0 to aList.Count-1 do begin
      if(DirectoryExists(aList[i])) then ReadModulesFromDir(aList[i]);
    end;
  finally
    aList.Free();
  end;
end;

procedure ReadModules;  //nacte vsechny moduly do seznamu pro vyber modulu
begin
  //pridame vsechny kategorie
  GGForm_lModulesAll.Clear();
  nCategory:=0;
  AddCategory('ORG',_('Layout elements'),false,MODE_BEGINNER);
  AddCategory('COMMAND',_('Commands'),false,MODE_EXPERT);
  AddCategory('PREDEFINED',_('Predefined groups'),false,MODE_BEGINNER);
  AddCategory('CALC',_('Calculations and settings for other modules'),false,MODE_EXPERT);
  AddCategory('FOUND_TABLE',_('Finds - Tables (list, with histogram)'),false,MODE_EXPERT);
  AddCategory('FOUND_MATRIX',_('Finds - Matrix tables'),false,MODE_EXPERT);
  AddCategory('FOUND_CHART',_('Finds - Charts (histogram, pie, ...)'),false,MODE_EXPERT);
  AddCategory('FOUND_MAP',_('Finds - Maps'),false,MODE_EXPERT);
  AddCategory('MY_OWN',_('My own caches (charts, tables)'),false,MODE_BEGINNER);
  AddCategory('OTHER',_('Other'),false,MODE_EXPERT);
//  AddCategory('TEAM',_('Statistics for cacher''s team (charts, tables)'),false);
  //AddCategory('INLINE',_('Direct output, without running a module'),false);
  //z adresare s moduly ziskame jmena vsech *.meta.ini souboru
  nModulesAll:=0;
  ReadModulesFromDir(GetModulesDir());
  FillModulesAll();
end;

//poloha mysi pro klikaci ikonky v radku seznamu
procedure lModuleasAllOnMouseDown (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//var bod:TPoint;
    //i:integer;
    //bCat:boolean;
begin
  iMouseX:=X;
  iMouseY:=Y;
  //zjistime, zda jde o kategorii nebo ne a podle toho povolime Drag&Drop
  //i:=GGForm_lModulesAll.ItemAtPos(bod,true);
  //{i:=}FindIdxFromModulesAllIdx(i,bCat);
  //EnableDragDrop(not bCat);
end;

procedure lModulesAllDrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte //podle dokumentace je typu TOwnerDrawState, ale v enginu je byte
  );
var
  Bitmap:TBitmap;
  RectSrc,RectTrg:TRect;
  idx,i:integer;
  bCat:boolean;
begin
  with GGForm_lModulesAll.Canvas do begin
    Brush.Color:=clWindow;
    i:=5;
    if((State AND 1)=1) then begin                 //polozka je vybrana
      Brush.Color:=COLOR_BKG_SEL;
      Font.Color:=COLOR_TXT_SEL;
    end;
    FillRect(Rect);                                //vybarvit pozadi
    idx:=FindIdxFromModulesAllIdx(Index,bCat); //zjistime index polozky v seznamu
    if(bCat) then begin
      Font.Style:=[fsBold];            //vypsano tucnym fontem
      if((State AND 1)=1) then Font.Color:=COLOR_TXT_CATEGORY_SEL;  //vybrana kategorie
      if(aCategory[idx].bOpen) then Bitmap:=Base64ToBitmap(BITMAP_CLOSE)
      else Bitmap:=Base64ToBitmap(BITMAP_OPEN);
      //ikona rozbaleni/zabaleni kategorie
      RectSrc.Left:=0; RectSrc.Top:=0; RectSrc.Right:=Bitmap.Width; RectSrc.Bottom:=Bitmap.Height;
      RectTrg.Left:=Rect.Left+2; RectTrg.Top:=Rect.Top+4;
      RectTrg.Right:=Rect.Left+2+Bitmap.Width; RectTrg.Bottom:=Rect.Top+4+Bitmap.Height;
      // zkopirovat bitmapu do Canvasu, barva v levem spodnim rohu je pruhledna
      BrushCopy(RectTrg,Bitmap,RectSrc,Bitmap.Canvas.Pixels[0,0]);
      Bitmap.Free();
      Bitmap:=nil;
      //doplnime ikonu kategorie
      case aCategory[idx].sName of
      'ORG':          Bitmap:=Base64ToBitmap(BITMAP_CAT_ORG);
      'COMMAND':      Bitmap:=Base64ToBitmap(BITMAP_CAT_COMMAND);
      'PREDEFINED':   Bitmap:=Base64ToBitmap(BITMAP_CAT_PREDEFINED);
      'CALC':         Bitmap:=Base64ToBitmap(BITMAP_CAT_CALC);
      'FOUND_TABLE':  Bitmap:=Base64ToBitmap(BITMAP_CAT_TABLE);
      'FOUND_MATRIX': Bitmap:=Base64ToBitmap(BITMAP_CAT_MATRIX);
      'FOUND_CHART':  Bitmap:=Base64ToBitmap(BITMAP_CAT_CHART);
      'FOUND_MAP':    Bitmap:=Base64ToBitmap(BITMAP_CAT_MAP);
      //'BADGES':		  Bitmap:=Base64ToBitmap(BITMAP_CAT_BADGES);
      'MY_OWN':       Bitmap:=Base64ToBitmap(BITMAP_CAT_OWN);
      'OTHER':        Bitmap:=Base64ToBitmap(BITMAP_CAT_OTHER);
      end;
      if(Bitmap<>nil) then begin
        RectSrc.Left:=0; RectSrc.Top:=0; RectSrc.Right:=Bitmap.Width; RectSrc.Bottom:=Bitmap.Height;
        RectTrg.Left:=Rect.Left+22; RectTrg.Top:=Rect.Top+1;
        RectTrg.Right:=Rect.Left+22+Bitmap.Width; RectTrg.Bottom:=Rect.Top+1+Bitmap.Height;
        // zkopirovat bitmapu do Canvasu, barva v levem spodnim rohu je pruhledna
        BrushCopy(RectTrg,Bitmap,RectSrc,Bitmap.Canvas.Pixels[0,0]);
        Bitmap.Free();
        Bitmap:=nil;
      end;
    end;
    //vypsat text
    if(bCat) then TextOut(Rect.Left+42,Rect.Top+1,{GGForm_lModulesAll.Items[Index]}aCategory[idx].sDesc)
    else TextOut(Rect.Left+42,Rect.Top+1,GGForm_lModulesAll.Items[Index]);
  end;
end;

procedure InitModules;
begin
{$ifdef PROFILER}ProfileStart('InitModules');{$endif}   //OK
{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitModules(), start');
{$endif}
  GeoBusyKind(_('Loading modules'' list')); 
  ReadModules();           //nacteme vsechny dostupne moduly
  GGForm_lModulesAll.OnClick:=@lModulesAllOnClick;
  GGForm_lModulesAll.OnKeyDown:=@lModulesAllOnKeyDown;
  GGForm_lModulesAll.OnMouseDown:=@lModuleasAllOnMouseDown;
  GGForm_lModulesAll.OnDrawItem:=@lModulesAllDrawItem;
  //GGForm_lModulesAll.OnClick:=@gPreviewModuleOnClick;

  GGForm_eDesc.Caption:='';
  GGForm_gPreview.Visible:=false;
  GGForm_ePreviewTitle.Visible:=false;
  GGForm_ePreviewLabel.Visible:=false;
{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitModules(), stop');
{$endif}
{$ifdef PROFILER}ProfileStop();{$endif}
end;