procedure SetActualThemeText;
var ini:TMemIniFile;
begin
  ini:=TMemIniFile.Create(GetProfileDir()+'Styles.ini');
  try
    GGForm_sThemeActual.Caption:=_('Currently used visual style was based on theme:')
      +'   '
      +ini.ReadString('Version','SourceTheme','???')+' (v. '
      +ini.ReadString('Version','StyleVersion','???')+')';
  finally
    ini.Free();
  end;
end;

//obsluha zalozky s tematy vzhledu
procedure ShowTheme();
var s:string;
    i:integer;
begin
  i:=GGForm_lThemes.ItemIndex;
  if(i<0) then exit;
  s:='<html>'+CRLF
    +'<head>'+CRLF
    +'</head>'+CRLF
    +'<body style="margin:0px; padding:0px; text-align:center;">'+CRLF
    +'<img src="'+GetThemesDir()+GGForm_lThemes.Items[i]+'.png" />'+CRLF
    +'</body>'+CRLF
    +'</html>'+CRLF
    ;
  GGForm_hTheme.LoadFromString(s,'',HTMLtype);
end;

procedure tabOnChange(Sender: TObject);
var tab:TTabSheet;
    i:integer;
    b:boolean;
begin
  //zjistime aktivni zalozku
  i:=0;
  tab:=GGForm_Tabs.ActivePage;
  if(tab.Name='tabThemes') and (GGForm_butSave.Visible) then i:=-1
  else if(tab.Name<>'tabThemes') then i:=1;
  if(i=0) then exit;
  //zmizime nebo zobrazime ovladaci prvky
  b:=(i=1);
  GGForm_lMode.Visible:=b;
  GGForm_butSaveMode.Visible:=b;
  GGForm_eDescMode.Visible:=b;
  GGForm_butPreviewModule.Visible:=b;
  GGForm_butOK.Visible:=b;
  GGForm_butSaveGgp.Visible:=((b) and (GGForm_lMode.ItemIndex>MODE_EXPERT));
  GGForm_butSave.Visible:=((b) and (GGForm_lMode.ItemIndex>MODE_EXPERT));
  //nezobrazime zadne tema, aby to uzivatele nematlo a nemyslel si
  //ze je to treba aktualne pouzivane tema
  //ShowTheme();
end;

procedure lThemesOnClick(sender:TObject);
begin
  ShowTheme();
end;

procedure butThemeUseOnClick(Sender: TObject);
var i,ii:integer;
    s:string;
    ini:TMemIniFile;
    bColorScale:boolean;
begin
  //pokud neni ulozeno, nemuzeme pokracovat
  if(GGForm_lThemes.ItemIndex<0) then exit;
  if(GGForm_butSave.Enabled) then begin
    s:=_('Changes not saved! Save settings first!')+CRLF
     +'     '+_('"Yes" ... save settings, change theme')+CRLF
     +'     '+_('"No" ... exit without theme change')+CRLF
     ;
    ii:=MessBox(s,_('Save settings?'),4{tj. Ano=6/Ne=7});
    if(ii<>6) then exit;
    fceSave(nil);
  end;
  s:=_('All custom color changes will be irretrievably discarded after applying')+' '
    +_('this theme (this also applies to all edits of the Styles.ini file).')+' '
    +_('It''s recommended to try the theme choices in a new, testing')+' '
    +_('profile before making any permanent changes in your working profile.')
    +CRLF+CRLF
    +_('A new profile can be created on the ''Main settings'' tab.')
    +CRLF+CRLF
    +_('Use predefined colors from chosen theme?')+CRLF
    +'     '+_('"Yes" ... colors and layout elements definitions from theme will be used')+CRLF
    +'     '+_('"No" ... only layout elements definitions will be used, colors won''t change')+CRLF
    +'     '+_('"Cancel" ... nothing will be changed')+CRLF
    ;
  ii:=MessBox(s,_('Set new theme'),3{tj. Ano=6/Ne=7/Cancel=2});
  if(ii<>7) and (ii<>6) then exit;
  //zkopirovat Styles.ini a Colors.ini, nastavit v nich zdrojove tema, aby se
  //poznalo, podle ceho to je udelany
  i:=GGForm_lThemes.ItemIndex;
  CopyFile(GetProfileDir()+'Styles.ini',GetProfileDir()+'Styles.ini.bak');
  CopyFile(GetThemesDir()+GGForm_lThemes.Items[i]+'\Styles.ini',GetProfileDir()+'Styles.ini');
  ini:=TMemIniFile.Create(GetProfileDir()+'Styles.ini');
  try
    ini.WriteString('Version','SourceTheme',GGForm_lThemes.Items[i]);
  finally
    ini.UpdateFile();
    ini.Free();
  end;
  if(ii=6) then begin
    CopyFile(GetProfileDir()+'Colors.ini',GetProfileDir()+'Colors.ini.bak');
    CopyFile(GetThemesDir()+GGForm_lThemes.Items[i]+'\Colors.ini',GetProfileDir()+'Colors.ini');
    ini:=TMemIniFile.Create(GetProfileDir()+'Colors.ini');
    try
      ini.WriteString('Version','SourceTheme',GGForm_lThemes.Items[i]);
    finally
      ini.UpdateFile();
      ini.Free();
    end;
  end;
  //znovu nacist vsechny barvy
  GlobalVarFromFile(GetProfileDir()+'Colors.ini','COLORS','Color');
  //refresh barevneho seznamu
  bColorScale:=(Uppercase(GlobalVarGet('ColorScale',false))='YES');
  GGForm_bLayColorScale.Checked:=bColorScale;
  SetActualThemeText();
  ShowColorPreview();
  if(ii=6) then ShowMessage(_('Styles and colors were changed according to theme:')+' '+GGForm_lThemes.Items[i])
  else ShowMessage(_('Only styles definition was changed according to theme:')+' '+GGForm_lThemes.Items[i]+'. '+_('Colors stayed your own.'));
end;

procedure FillThemes;
var aList:TStringList;
    s:string;
    i:integer;
begin
  GGForm_lThemes.Items.Clear();
  aList:=TStringList.Create();
  try
    FileList(GetThemesDir(),aList);
    for i:=0 to aList.Count-1 do begin
      s:=RegexSubstitute('.*\\(.*)\\$',aList[i],'$1');
      if(s<>'') then GGForm_lThemes.Items.Add(s);
    end;
  finally
    aList.Free();
  end;
  //nevybirame zadne tema, ze stejneho duvodu jako jej nezobrazujeme
  //hned pri 1. zobrazeni zalozky
  //if(GGForm_lThemes.Items.Count>0) then GGForm_lThemes.ItemIndex:=0;
  SetActualThemeText();
end;


procedure InitThemes;
begin
{$ifdef PROFILER}ProfileStart('InitThemes');{$endif}     //OK
{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitThemes(), start');
{$endif}
  GeoBusyKind(_('Loading themes')); 
  //naplnime seznam temat
  FillThemes();
  GGForm_lThemes.OnClick:=@lThemesOnClick;
  GGForm_Tabs.OnChange:=@tabOnChange;
  GGForm_butThemeUse.OnClick:=@butThemeUseOnClick;
{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitThemes(), stop');
{$endif}
{$ifdef PROFILER}ProfileStop();{$endif}
end;