//funkce pro vyhodnoceni stringu
//  bere ohled na prioritu
//  umi zakladni operace + - * / ^ (mocnina)
//  umi zavorky () ale jen nevnorene (?)

var EvalIPos:integer;
    EvalChar:char;
    EvalStr:string;

function FormatFloatDot(const sFormat:string; eValue:extended):string; forward;

function EvalGetChar:char;
begin
  if(EvalIPos<Length(EvalStr)) then begin
    Inc(EvalIPos);
    EvalChar:=EvalStr[EvalIPos];
  end
  else EvalChar:=#0;
  Result:=EvalChar;
  //Log('EvalGetChar() 2: EvalStr='+EvalStr+', iPos='+IntToStr(EvalIPos)+', EvalChar='+EvalChar);
end;

//deklarace pozdeji definovane funkce
function EvalPlusMinus:extended; forward;
function EvalGetNumber:extended;
var s:string;
    bPoint:boolean;
begin
  bPoint:=false;
  while ((EvalChar>='0') and (EvalChar<='9')) do begin
    s:=s+EvalChar;
    if(EvalGetChar()='.') and not bPoint then begin
      s:=s+EvalChar;
      EvalGetChar();
      bPoint:=true;
    end;
  end;
  Result:=StrToFloat(s);
  //Log('EvalGetNumber() 2: EvalStr='+EvalStr+', iPos='+IntToStr(EvalIPos)+', EvalChar='+EvalChar+', Result='+FloatToStr(Result));
end;

function EvalExpressionInBrackets:extended;
var s:string;
begin
  Result:=EvalPlusMinus();
  if(EvalChar=')') then EvalGetChar()
  else begin
    s:=_('ERR: Evaluate(): Missing '')'' in expression')+' '+EvalStr;
    Log(s);
    ShowMessage(s);
  end;
  //Log('EvalExpressionInBrackets() 2: EvalStr='+EvalStr+', iPos='+IntToStr(EvalIPos)+', EvalChar='+EvalChar+', Result='+FloatToStr(Result));
end;

function EvalTerm:extended;
var s:string;
begin
  case EvalChar of
    '0'..'9' : Result:=EvalGetNumber();
    '(' : Result:=EvalExpressionInBrackets();
  else begin
      s:=_('ERR: Evaluate(): Syntax error in expression')+' '+EvalStr;
      Log(s);
      ShowMessage(s);
    end;
  end;
  //Log('EvalTerm() 2: EvalStr='+EvalStr+', iPos='+IntToStr(EvalIPos)+', EvalChar='+EvalChar+', Result='+FloatToStr(Result));
end;

function EvalSignedTerm:extended;
begin
  //case EvalGetNonWhitespace() of
  case EvalGetChar() of
    '+' : Result:=EvalSignedTerm();
    '-' : Result:=-EvalSignedTerm();
    else  Result:=EvalTerm();
  end;
  //Log('EvalSignedTerm() 2: EvalStr='+EvalStr+', iPos='+IntToStr(EvalIPos)+', EvalChar='+EvalChar+', Result='+FloatToStr(Result));
end;

function EvalPower:extended;
begin
  Result:=EvalSignedTerm;
  while EvalChar='^' do begin
    Result:=Power(Result,EvalSignedTerm());
  end;
  //Log('EvalPower() 2: EvalStr='+EvalStr+', iPos='+IntToStr(EvalIPos)+', EvalChar='+EvalChar+', Result='+FloatToStr(Result));
end;

function EvalMultiplication:extended;
begin
  Result:=EvalPower();
  while (EvalChar='*') or (EvalChar='/') do begin
    case EvalChar of
      '*' : Result:=Result * EvalPower();
      '/' : Result:=Result / EvalPower();
    end;
  end;
  //Log('EvalMultiplication() 2: EvalStr='+EvalStr+', iPos='+IntToStr(EvalIPos)+', EvalChar='+EvalChar+', Result='+FloatToStr(Result));
end;

function EvalPlusMinus:extended;
begin
  Result:=EvalMultiplication();
  while (EvalChar='+') or (EvalChar='-') do begin
    case EvalChar of
      '+' : Result:=Result + EvalMultiplication();
      '-' : Result:=Result - EvalMultiplication();
    end;
  end;
  //Log('EvalPlusMinus() 2: EvalStr='+EvalStr+', iPos='+IntToStr(EvalIPos)+', EvalChar='+EvalChar+', Result='+FloatToStr(Result));
end;

function Evaluate(aPar:TStringList):string;
var   f:extended;
      iDes:integer;
      sFormat:string;
begin
  EvalIPos:=0;
  if(aPar.Count<1) then begin
    Log(_('WARN: Evaluate() - missing parameters'));
    exit;
  end;
  EvalStr:=ReplaceString(aPar[0],' ','');  //vyhazeme vsechny mezery
  if(aPar.Count>1) then iDes:=StrToInt(aPar[1]); //pocet desetinnych mist
  Result:='';
  EvalChar:=' ';
  EvalIPos:=0;
  f:=0.;
  f:=EvalPlusMinus();   //zaciname operaci s nejnizsi prioritou
  sFormat:='0';
  if(iDes>0) then sFormat:=sFormat+Copy('.0000000000000000000',1,iDes+1);
  //Log('CCCCCC Format pro Evaluate(): '+sFormat);
  Result:=FormatFloatDot(sFormat,f);
end;