//funkce, ktere mohou pouzivat moduly
procedure StatorBusy(sMessage:string);         //naformatuje text do BusyDialogu
begin
  //Pokud byl pusteny nejaky externi modul (serie, odznacky, ...), muze byt
  //titulek prepsan. Proto je prepiseme svym
  GeoBusyCaption('Stator, '+_('generating statistics ...'));
  if(nMaxElem>0) then begin
    GeoBusyProgress(iCurrentElem,nMaxElem);
    //nebo v procentech
    //GeoBusyProgress(round(100.*iTootElem/nMaxElem))100);
  end;
  {if(aMessage<>'XX') then} GeoBusyKind(sMessage);
end;

procedure Output(str:string); //zapise string do vystupniho souboru
var s:string;
begin
  if(fOut=nil) then exit;
  s:=GlobalVarReplace(str);
  if(UpperCase(sOutCoding)<>'ANSI') then s:=UtfToCharset(AnsiToUtf(s),sOutcoding);
  if(fOut<>nil) then fOut.Write(s,Length(s));
end;

function ConvertToKm(fLength:extended; sUnitSrc:string):extended;
begin
  Result:=fLength;
  case sUnitSrc of
  'm',  'Meter': Result:=Result/1000.;
  'mi', 'Mile': Result:=Result/0.621;
  'yd', 'Yard': Result:=Result/1094;
  'ft', 'Foot': Result:=Result/3281;
  'in', 'Inch': Result:=Result/39370; 
  end;
end;

function ConvertFromKm(fLength:extended; sUnitTrg:string):extended;
begin
  Result:=fLength;
  case sUnitTrg of
  'm',  'Meter': Result:=Result*1000.;
  'mi', 'Mile': Result:=Result*0.621;
  'yd', 'Yard': Result:=Result*1094;
  'ft', 'Foot': Result:=Result*3281;
  'in', 'Inch': Result:=Result*39370; 
  end;
end;

function ConvertLength(fLength:extended; sUnitSrc,sUnitTrg:string):extended;
begin
  Result:=fLength;
  if(sUnitSrc=sUnitTrg) then exit;
  //prevedeme na kilometry
  Result:=ConvertToKm(Result,sUnitSrc);
  //prevedeme na pozadovane jednotky
  Result:=ConvertFromKm(Result,sUnitTrg);
end;

function GetLengthAbbr(sUnit:string):string;
begin
  Result:=sUnit;
  case sUnit of
  'Kilometer': Result:='km';
  'Meter': Result:='m';
  'Mile': Result:='mi';
  'Yard': Result:='yd';
  'Foot': Result:='ft';
  'Inch': Result:='in'; 
  end;
  Result:=LowerCase(Result);
end;

//nacte kroky do pole a vrati pocet nactenych/vyuzitych kroku
function ReadStepsToArray(str:string; arr:array of integer):integer;
var s:string;
begin
  Result:=0;
  while(str<>'') do begin
    if(Result>high(arr)) then break;
    s:=Fetch(str,',');
    arr[Result]:=StrToInt(s);
    Inc(Result);
  end;
end;

function GraphAxisStep(eRange:extended):integer;
// automatick nastaven kroku osy grafu 
begin
  // Pascal script zejm nezn exponenciln funkci, proto budeme naivn testovat
  Result:=1;
  if eRange>10 then Result:=2;
  if eRange>25 then Result:=5;
  if eRange>50 then Result:=10;
  if eRange>100 then Result:=20;
  if eRange>250 then Result:=50;
  if eRange>500 then Result:=100;
  if eRange>1000 then Result:=200;
  if eRange>2500 then Result:=500;
  if eRange>5000 then Result:=1000;
  if eRange>10000 then Result:=2000;
  if eRange>25000 then Result:=5000;
  if eRange>50000 then Result:=10000;
  if eRange>100000 then Result:=20000;
  if eRange>250000 then Result:=50000;
  if eRange>500000 then Result:=100000;
end;

function InsertThousSep(sNum:string):string;
var i,n:integer;
begin
  //pokud je desetinny oddelovac, prepiseme desetiny rovnou
//LDH('MMMM sNum='+sNum);
  i:=Pos('.',sNum);
  if(i>0) then begin
    Result:=Copy(sNum,i,Length(sNum));
    sNum:=Copy(sNum,1,i-1);
  end;
  n:=Length(sNum);
  for i:=1 to n do begin
//LDH('NNNN sNum='+sNum+', Result='+Result+', i='+IntToStr(i));
    if(i>1) and (((i-1) mod 3)=0) then Result:=' '+Result;
    Result:=sNum[n+1-i]+Result;
  end;
//LDH('MMMM Result='+Result);
end;

function FormatFloatDot(const sFormat:string; eValue:extended):string;
// naformtuje slo s desetinnou tekou (nezvisle na systmov definici oddlovae)
// (vhodn pro Google Image Chart, kde je nutn desetinn oddlova teka - tm pdem neme obsahovat oddlova tisc!!!) 
begin
  //Result:=InsertThousSep(ReplaceString(FormatFloat(sFormat,eValue),',','.'));
  Result:=ReplaceString(FormatFloat(sFormat,eValue),',','.');
end;

function SetDefaultColumnAlign(sName:string;bHeader:boolean):string; //vrati implicitni zarovnani podle jmena sloupce
begin
  //vsechny sloupce jsou implicitne zarovnany vlevo, jen vybrane zarovname jinak
  //u ciselnych sloupcu je jinak zarovnana hlavicka
  Result:='left';
  case UpperCase(sName) of
    'TYPE ICON':            Result:='center';
    'SIZE ICON':            Result:='center';
    'DIFFICULTY':           Result:='center';
    'DIFFICULTY ICON':      Result:='center';
    'TERRAIN':              Result:='center';
    'TERRAIN ICON':         Result:='center';
    //'IDTAG':              Result:='center';
    'STATUS ICON':          Result:='center';
    'DATECREATE':           Result:='right'; 
    'DISTANCE':             Result:='right';
    'DIRECTION':            Result:='right';
    'DIRECTION ICON':       Result:='center';
    'COUNTRY FLAG':         Result:='center';
    'FOUND DATE':           Result:='right';
    'FOUND TIME':           Result:='right';
    'FOUND DATETIME':       Result:='right';
    'DATE OF LAST FOUND':   Result:='right';
    'COUNT':                if(bHeader) then Result:='center' else Result:='right';
    'COUNT EXPLICIT':       if(bHeader) then Result:='center' else Result:='right';
    'ORDER FINDING',        //toto je spatne a nechavan to jen z historickych duvodu
                            //aby neprestaly chodit stare selecty
    'ORDER BY FINDS':       if(bHeader) then Result:='center' else Result:='right';
    'ORDER ROW':            if(bHeader) then Result:='center' else Result:='right';
    'MILESTONE':            if(bHeader) then Result:='center' else Result:='right';
    'MILESTONE, INTERVAL':  if(bHeader) then Result:='center' else Result:='right';
    'INTERVAL':             if(bHeader) then Result:='center' else Result:='right';
    'PERCENT':              if(bHeader) then Result:='center' else Result:='right';
    'PERCENT EXPLICIT':     if(bHeader) then Result:='center' else Result:='right';
  end;
end;

function OutputTableListHeader(sCols:string):string;
var sCol,s1,s2,sWidth,sStyle:string;
    flags:REC_COLUMN_FLAGS;
    //ini:TMemIniFile;
begin
  //protoze sirka muze byt dana i primo v px, musime nahradit styl a v nem sirku,
  //jinak pri globalni nahrade je pouzita sirka cele statistiky
  Result:='<table style="'+GlobalVarGet('StyleTableList',false)+'"><thead>'+CRLF+'  <tr style="%StyleTableListTr%">'+CRLF;
  sWidth:=IntToStr(iWidth);
  Result:=ReplaceString(Result,'%Width%',sWidth);
  sStyle:=GlobalVarGet('StyleTableListTh',false);
  if(iAlignTitles<>0) then begin //pripravime pro zmenu zarovnani nadpisu
    sStyle:=RegexReplace('text-align:(.*?);',sStyle,'text-align:XXXX;',false);
    if(Pos('text-align:',sStyle)<1) then sStyle:=sStyle+' text-align:XXXX;';
  end;
  while (sCols<>'') do begin
    s1:=Fetch(sCols,'|');
    ParseColumnFlags(s1,flags);
    s2:=Fetch(s1,'='); //odpareme pripadny priznak zarovnani
    if(flags.sAlign='hide') then continue; //preskocime neviditelne sloupce
    if(flags.sAlign='') then flags.sAlign:=LowerCase(SetDefaultColumnAlign(flags.sName,(iAlignTitles=0)));
    sCol:=flags.sName; //odpareme pripadny komentar
    //odpareme pripadnou hodnotu tagu
    if(Pos('tag-',sCol)=1) then begin
      s1:=sCol;
      sCol:=Fetch(s1,'#');
    end;
    sWidth:='';
    if(UpperCase(sCol)='HISTOGRAM') or (UpperCase(sCol)='HISTOGRAM EXPLICIT') then sWidth:=' %StyleTableListHistogramWidth% ';
    //kvuli TAGum a dalsim sloupcum, ktere nebudou mit jmeno v INI souboru,
    //nemuzeme rovnou zapsat jmeno promenne, ale musime existenci zkontrolovat
    s1:=GlobalVarGet('ColumnHeader'+sCol,false);
    if(s1='ColumnHeader'+sCol) then begin
      s1:=ReplaceString(sCol,'tag-','');
    end;
    Result:=Result+'    <th style="';
    //pokud maji byt nadpisy zarovnany stejne jako hodnoty ve sloupci, nastavime
    //spravne
    if(iAlignTitles=0) then Result:=Result+sStyle
    else Result:=Result+ReplaceString(sStyle,'text-align:XXXX;',
      'text-align:'+flags.sAlign+';');
    Result:=Result+sWidth+'"';
    //if(sCol='Histogram') then Result:=Result+' WIDTH="150"';
    //if(s1='') then s1:='&nbsp;'; s nedlitelnou mezerou v zhlav jsou zmeneny ikony v bukch tabulky...
    if(s1='') {or (s1='&nbsp;')}  //Chrome s nedelitelnou mezerou udela uzky sloupec a pokud jsou v nem ikony, zmensi jejich velikost
                                  //ale pokud je to zobrazeno primo na gc.com, tak se pri ' ' nezobrazuji ikony vubec!!!, proto to nedelam
      then s1:=' ';
    Result:=Result+'>'+s1+'</th>'+CRLF;
  end;
  Result:=ReplaceString(Result+'  </tr>'+CRLF+'</thead><tbody>'+CRLF,'&eq;','=');
end;

function AndIfNeed(str:string):string;
begin
  Result:='';
  if(str<>'') then Result:=' AND ';
end;

function CommaIfNeed(str:string):string;
begin
  Result:='';
  if(str<>'') then Result:=', ';
end;

function MakeTagWhereItem(flags:REC_COLUMN_FLAGS):string;
var s:string;
begin
  //zkonstruuje frazi WHERE podle pozadovaneho operatoru
  //hodnotu tagu musime prevest z ANSI na UTF-8
  //!!!!! ale knigovna neni kompatibilni s unicodestring, takze stale ocekava
  //!!!!! ansi, proto nelze prevadet na UTF
  s:={AnsiToUtf}(flags.sValue);
  if(flags.bNumeric) then Result:='(0+value)'
  else Result:='value ';
  case flags.sOperator of
  'IN':      Result:=Result+' IN ('+s+')';
  'NOT IN':  Result:=Result+' NOT IN ('+s+')';
  'LIKE':    Result:=Result+' LIKE '+s;
  'BETWEEN': Result:=Result+' BETWEEN '+ReplaceString(s,',',' AND ');
  else Result:=Result+flags.sOperator+s;
  end;
  if(not flags.bNumeric) then Result:=Result+' COLLATE NOCASE';
end;

function MakeWhereItem(flags:REC_COLUMN_FLAGS):string;
var s:string;
begin
  //zkonstruuje frazi WHERE podle pozadovaneho operatoru
  //hodnotu tagu musime prevest z ANSI na UTF-8
  //!!!!! ale knigovna neni kompatibilni s unicodestring, takze stale ocekava
  //!!!!! ansi, proto nelze prevadet na UTF
  s:={AnsiToUtf}(flags.sValue);
  //pokud s ma byt string a neni v apostrofech, doplnime je, ale neni to
  //univerzalni, pro IN, LIKE, BETWEEN to urcite fungovat nebude
  if(not flags.bNumeric) and (s[1]<>'"') and (s[1]<>'''') then s:=''''+s+'''';
  case flags.sOperator of
  'IN':      Result:=' IN ('+s+')';
  'NOT IN':  Result:=' NOT IN ('+s+')';
  'LIKE':    Result:=' LIKE '+s;
  'BETWEEN': Result:=' BETWEEN '+ReplaceString(s,',',' AND ');
  else Result:=flags.sOperator+s;
  end;
end;

function SetSqlFilter(aPar:TStringList):string;
begin
  Result:='';
  if(UpperCase(aPar.Values['UseFilter'])='YES') then begin
    Result:=GlobalVarGet('Set_FilteredCaches',true);
    if(Result<>'') then Result:='  AND gc.id IN ('+Result+')'+CRLF;
  end;

end;

function TableListMakeSqlFromParams(aPar:TStringList; bIncludeIgnoring:boolean; sIncludeCacheTypes:string; var idxCount:integer):string;
var bTag,bFoundOnly:boolean;
    sSelect,sFrom,sWhere,sGroup,sOrder,sCol,sTag,sJoin,sTagID,sTagValue,sStatorTable:string;
    s,s1,s2,sColOrder,sColGroup,sColCount:string;
    flags:REC_COLUMN_FLAGS;
begin
  //sestavime jednotlive casti SQL dotazu podle pozadovanych sloupcu
  bTag:=false;
  sSelect:='';
  sFrom:='geocache gc';
  sWhere:='';
  sGroup:='';
  sOrder:='';
  sTag:='';
  sJoin:='';
  sStatorTable:='';
  //projdeme pozadovane sloupce a doplnime sSelect, sFrom a sWhere
  //pokud hledame jen mezi nalezenymi
  bFoundOnly:=(aPar.Values['FoundOnly']='Yes');
  if(bFoundOnly) then begin
    sFrom:='temp.Stator st, '+sFrom;
    //sWhere:='gc.dtfound>0';
    sWhere:='gc.id=st.id';
  end
  else sWhere:=sCachePrefixForSql;
  //pokud ma byt pouzit filtr, rovnou ho pridame
  if(aPar.Values['UseFilter']='Yes') then begin
    s:=GlobalVarGet('Set_FilteredCaches',true);
    if(s<>'') then sWhere:=sWhere+' AND gc.id IN ('+s+') '+CRLF;
  end;
  s:=aPar.Values['Columns'];
  idxCount:=0;  //sem budeme pocitat poradi datoveho sloupce v selectu, z ktereho brat pocet pro soucet, procentra a histogram
  while (s<>'') do begin
    bTag:=false;
    sColOrder:='';   
    s1:=Fetch(s,'|');
    ParseColumnFlags(s1,flags); //parametry tohoto sloupce
    sCol:=flags.sName;
//Log('FFFFF sloupec='+sCol);
    if(Pos('tag-',sCol)=1) then begin
      bTag:=true;
      Fetch(sCol,'-');        //nechame jen kategorii tagu
      //pokud je pozadovana i nejaka hodnota tagu, zjistime ji
      sTagValue:=flags.sValue;
      sTagID:='T'+IntToStr(Length(s));

      if(flags.sOperator='') then begin
        //##s2:='IFNULL((SELECT value FROM geotagvalue WHERE key=g'+sTagID+'.ptrvalue),'''') '
        //##  +'val'+sTagID; //takto se sloupec bude jmenovat
        s2:='(SELECT value FROM geotagvalue WHERE key=g'+sTagID+'.ptrvalue) '
          +'val'+sTagID; //takto se sloupec bude jmenovat
      end
      else begin
      //Log('AAAAAA test: '+MakeTagWhereItem(flags));
        s2:='(SELECT value FROM geotagvalue '
          +'WHERE key=g'+sTagID+'.ptrvalue AND '+MakeTagWhereItem(flags) //+' COLLATE NOCASE'
          +') '
          +'val'+sTagID; //takto se sloupec bude jmenovat
        sWhere:=sWhere+AndIfNeed(sWhere)+'val'+sTagID+' IS NOT NULL';
      end;
       //jak tady obslouzit bCounting?  ####
      sSelect:=sSelect+CommaIfNeed(sSelect)+s2;
      //nutnost/nepovinnost nalezeni kese uz je obslouzena pridanim tabulky 
      //temp.Stator a podminkou na shodu ID
      if(flags.bTagMustExist) then s2:='JOIN '
      else s2:='LEFT OUTER JOIN ';
      //sestavime SQL s ohledem na to, zda ma byt hodnota tagu primo uvedena
      //(to je potreba v pripade, kdy se jen pripravuje SQL pro nejake pozdejsi
      //pouziti)
      if(aPar.Values['SqlReplaceTagValues']='YES') then begin
        sJoin:=sJoin+CRLF+s2+'geotag g'+sTagID+' ON '
          +'(gc.id=g'+sTagID+'.id and g'+sTagID+'.ptrkat IN (SELECT key FROM geotagcategory '
          +'  WHERE value='''+AnsiToUtf(sCol)+''' COLLATE NOCASE))'+CRLF;
        //hodnotu kategorie musime prevest z ANSI na UTF-8
        //Log(':TagCat_'+sTagID+'='+AnsiToUtf(sCol));
      end
      else begin
        sJoin:=sJoin+CRLF+s2+'geotag g'+sTagID+' ON '
          +'(gc.id=g'+sTagID+'.id and g'+sTagID+'.ptrkat IN (SELECT key FROM geotagcategory '
          +'  WHERE value=:TagCat_'+sTagID+' COLLATE NOCASE))'+CRLF;
        //hodnotu kategorie musime prevest z ANSI na UTF-8
        Geoget_DB.AddParamText(':TagCat_'+sTagID,AnsiToUtf(sCol));
      end;
//Log('DDDDDD sCol='+sCol+', sSort='+flags.sSort+', bNumeric='+IntToStr(flags.bNumeric as integer));
      if(flags.sSort<>'') then begin
        if(flags.bNumeric) then sColOrder:='(0.+val'+sTagID+')'
        else sColOrder:='val'+sTagID;
      end;
      if(flags.bCounting) then sColGroup:='val'+sTagID;
      if(flags.bCounting) then sColCount:='(SELECT value FROM geotagvalue WHERE key=g'+sTagID+'.ptrvalue)';
    end
    else begin
      case sCol of
      'ID':             begin
                          sCol:='gc.id';
                          if(flags.sOperator<>'') then 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.id'+MakeWhereItem(flags);
                        end;
      'Type icon',
      'Type icon, text',
      'Type':           begin
                          sCol:='gc.cachetype';
                          if(flags.sOperator<>'') then 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.cachetype'+MakeWhereItem(flags);
                        end;
      'Name':           begin
                          sColOrder:='gc.Name';
                          sCol:='CASE (gc.cachestatus) when "0" then "+"||gc.name when "1" then "-"||gc.name when "2" then "#"||gc.name else "?"||gc.name END';
						  sColOrder:='gc.Name';
                          if(flags.sOperator<>'') then 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.name'+MakeWhereItem(flags);
                        end;  
      'Size icon',
      'Size icon, text',
      'Size':           begin
                          sCol:='gc.cachesize';
                          if(flags.sOperator<>'') then 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.cachesize'+MakeWhereItem(flags);
                        end;  
      'Size as num':    begin 
                          sCol:='CASE (gc.cachesize) '
                             +'WHEN "Not chosen" THEN "0 Not chosen" '
                             +'WHEN "Micro" THEN "1 Micro" '
                             +'WHEN "Small" THEN "2 Small" '
                             +'WHEN "Regular" THEN "3 Regular" '
                             +'WHEN "Large" THEN "4 Large" '
                             +'WHEN "Virtual" THEN "5 Virtual" '
                             +'WHEN "Other" THEN "6 Other" '
                             +'ELSE  "7 Unknown" '
                             +'END SizeNum';
                          if(flags.bCounting) then sColCount:='gc.cachesize';
                          if(flags.bCounting) then sColGroup:='gc.cachesize';
                          if(flags.sSort<>'') then sColOrder:='SizeNum';   
                          if(flags.sOperator<>'') then 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.cachesize'+MakeWhereItem(flags);
                       end; 
      'Difficulty icon',
      'Difficulty icon, text',
      'Difficulty':     begin
                          sCol:='gc.difficulty';
                          if(flags.sOperator<>'') then 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.difficulty'+MakeWhereItem(flags);
                        end;  
      'Terrain icon',
      'Terrain icon, text',
      'Terrain':        begin 
                          sCol:='gc.terrain';
                          if(flags.sOperator<>'') then 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.terrain'+MakeWhereItem(flags);
                        end;  
      //'IDTag':        sCol:=',gc.';
      'Status icon',
      'Status icon, text',
      'Status':         begin
                          sCol:='gc.cachestatus';
                          if(flags.sOperator<>'') then 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.cachestatus'+MakeWhereItem(flags);
                        end;  
      'Author':         begin
                          sCol:='gc.author';
                          if(flags.sOperator<>'') then 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.author'+MakeWhereItem(flags);
                        end;  
      'DateCreate':     begin
                          sCol:='gc.dthidden';
                          if(flags.sOperator<>'') then
                            //tady fakt nvim, jak by mela hodnota vypadat, aby to fungovalo 
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.author'+MakeWhereItem(flags);
                        end;  
      'Distance':       begin
                          sCol:='st.distance';
                          if(Pos('Stator st',sFrom)<1) then begin
                            sFrom:=sFrom+', temp.Stator st';
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.id=st.id';
                          if(flags.sOperator<>'') then
                            sWhere:=sWhere+AndIfNeed(sWhere)+'st.distance'+MakeWhereItem(flags);
                          end;
                        end;
      'Direction',
      'Direction icon': begin
                          sCol:='st.angle';
                          if(Pos('Stator st',sFrom)<1) then begin
                            sFrom:=sFrom+', temp.Stator st';
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.id=st.id';
                          end;
                          if(flags.sOperator<>'') then
                            sWhere:=sWhere+AndIfNeed(sWhere)+'st.angle'+MakeWhereItem(flags);
                        end;
      'Coordinates':    sCol:='gc.x||";"||gc.y';
      'Country flag',
      'Country flag, text',
      'Country':        begin
                          sCol:='gc.country';
                          if(flags.sOperator<>'') then
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.country'+MakeWhereItem(flags);
                        end;
      'Cache info':     sCol:='gc.id||";"||gc.cachetype||";"||gc.cachestatus||";"||gc.country||";"||gc.name';
      'Cache info short': sCol:='gc.id||";"||gc.cachetype||";"||gc.cachestatus||";"||gc.name';
      'State':          begin
                          sCol:='gc.state';
                          if(flags.sOperator<>'') then
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.state'+MakeWhereItem(flags);
                        end;
      'Found date':     begin
                          sCol:='gc.dtfound';
                          if(flags.sOperator<>'') then
                            sWhere:=sWhere+AndIfNeed(sWhere)+'gc.dtfound'+MakeWhereItem(flags);
                        end;
      'Found time':     begin
                          sCol:='substr("000"||gc.dtfoundtime,-4,2)||":"||substr("000"||gc.dtfoundtime,-2,2)';
                          if(flags.sOperator<>'') then
                            sWhere:=sWhere+AndIfNeed(sWhere)
                              +'substr("000"||gc.dtfoundtime,-4,2)||":"||substr("000"||gc.dtfoundtime,-2,2)'
                              +MakeWhereItem(flags);
                        end;
      'Found DateTime': sCol:='gc.dtfound*10000+gc.dtfoundtime';
      'Date of last found': sCol:='gc.dtlast';
      'Count':          begin
                          sCol:='count(%COUNT%)';
                          if(flags.sSort<>'') then sColOrder:='count(%COUNT%)';
                          {
                          if(iOrder=0) then sColOrder:='ORDER BY count(%COUNT%) desc'; //######
                          //pokud je sloupec zaroven poctem, nastavime jinak, aby nedoslo k "cykleni"
                          if(iCount=0) then begin
                            sCol:='count(gc.id)';
                            sCount:='count(gc.id)';
                            if(iOrder=0) then sOrder:='ORDER BY count(gc.id) desc'; //#####
                          end;
                          }
                          if(flags.sOperator<>'') then
                            sWhere:=sWhere+AndIfNeed(sWhere)+'count(%COUNT%)'+MakeWhereItem(flags);
                        end;
      'Order finding',  //toto je spatne a nechavan to jen z historickych duvodu
                        //aby neprestaly chodit stare selecty
      'Order by finds':  begin
                          if(bFoundOnly) then begin
                            if(Pos('Stator st',sFrom)<1) then begin
                              sWhere:=sWhere+AndIfNeed(sWhere)+'gc.id=st.id';
                            end;
                          end;
                          //pokud neni bFoundOnly, tak neni pripojena tabulka st!!!!!!
                          //ale jen pokud jiz tabulka byla pridana
                          if((not bFoundOnly) and (Pos('temp.Stator st',sJoin)<1)) then begin
                            sJoin:=sJoin+CRLF+'LEFT OUTER JOIN temp.Stator st ON (gc.id=st.id)';
                          end;
                          sCol:='st.rowid';
                          if(flags.sOperator<>'') then
                            sWhere:=sWhere+AndIfNeed(sWhere)+'st.rowid'+MakeWhereItem(flags);
                        end;
      'Milestone':      begin
                          //sFrom:=sFrom+', temp.Stator st';
                          //sWhere:=sWhere+AndIfNeed(sWhere)+'gc.id=st.id';
                          sCol:='distinct st.rowid Milestones';
                          if(flags.sSort<>'') then sColOrder:='Milestones';
                        end;
      'Milestone, interval': sCol:='gc.dtfound';
      'Interval':       sCol:='gc.dtfound';
      'Order row':      sCol:='"?"';       //pri SQL ignorujeme
      'Percent':        sCol:='"?"';      //pri SQL ignorujeme
      'Percent explicit': sCol:='"?"';    //pri SQL ignorujeme
      'Histogram':      sCol:='"?"';     //pri SQL ignorujeme
      else begin Log(_('ERR: unknown column name:')+' '+sCol); continue; end;
      end;
      //doplnime podle sloupce podminku, pokud je potreba a neni to 
    end;
    if(flags.bCounting) then begin
      if(sColGroup='') then sColGroup:=sCol;
      sGroup:='GROUP BY '+sColGroup;
      if(sColCount='') then sColCount:=sCol;
    end;
    if(sCol<>'') then begin
      if(not bTag) then sSelect:=sSelect+CommaIfNeed(sSelect)+sCol;
//Log('HHHHH sSelect='+sSelect);
      if(flags.sSort<>'') then begin
        if(sColOrder='') then begin
          if(not flags.bNumeric) then sColOrder:=sCol
          else sColOrder:='(0.+'+sCol+')';
        end;
        if(sOrder='') then sOrder:='ORDER BY '
        else sOrder:=sOrder+', ';
        sOrder:=sOrder+sColOrder+' '+flags.sSort;
      end;
    end;
  end;
//{$ifdef DEBUG_HELPER}LDH('LLLLL sSelect='+sSelect);{$endif}
  //protoze pocet mohl byt pred sloupcem, nahradime ted spravny sloupec pro pocet
  //???? co kdyz neni zadny sloupec, z ktereho by se pocet bral?
  //     (to by bylo v pripade, kdy sloupec pro vypocet je jen z databaze, ale
  //     nikam se do vystupni tabulky nevypisuje)
  if(Pos('%COUNT%',sSelect)>0) and (sColCount='') then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('ERR: Index of SQL column for Count not set'));
    Log(_('ERR: Index of SQL column for Count not set'));
    exit;
  end;
  {
  if(Pos('%GROUP%',sSelect)>0) and (sColGroup='') then begin
    Log(_('ERR: Index of SQL column for Group not set'));
    exit;
  end;
  }
  //pokud je potreba vyradime ze zpracovani ignorovane kese
  s:=GlobalVarGet('sIgnoreCaches',false);
  if(not bIncludeIgnoring) and (s<>'') then sWhere:=sWhere+AndIfNeed(sWhere)
    +'gc.id NOT IN ('+s+')'+CRLF;
  if(sIncludeCacheTypes<>'') then sWhere:=sWhere+AndIfNeed(sWhere)
    +'gc.cachetype NOT IN ("'+ReplaceString(Trim(sIncludeCacheTypes),'|','","')+'")'+CRLF;
  //Log('sssssss= '+s+', sWhere='+sWhere);
  sSelect:=ReplaceString(sSelect,'%COUNT%',sColCount);
  sGroup:=ReplaceString(sGroup,'%COUNT%',sColCount);
  sOrder:=ReplaceString(sOrder,'%COUNT%',sColCount);
  //pokud bylo vice tagu, uzavreme zavorku
  Result:='SELECT '+sSelect+CRLF+' FROM '+sFrom+sTag+sJoin;
  if(sWhere<>'') then Result:=Result+CRLF+'WHERE '+sWhere;
  Result:=GlobalVarReplace(Result+CRLF+' '+sGroup+CRLF+' '+sOrder);
  Log('SQL= '+Result);
end;

function MakeHtmlCacheInfo(sId,sType,sName,sCountry,sStatus:string):string;
var s1,s2:string;
begin
  //pokud je sCountry='', nekresli se vlajecka
  //pokud je iStatus jiny nez '1'/'2', nemeni se barva a styl pisma podle stavu kese
  case sStatus of
  '1': begin s2:='</span>'; s1:='<span style="text-decoration:line-through; color:#%ColorCacheDisabledText%">'; end;
  '2': begin s2:='</span>'; s1:='<span style="text-decoration:line-through; color:#%ColorCacheArchivedText%">'; end;
  end;
  Result:='<img src="%IconCacheTypeSmall'+sType+'%" /> '
      +'<a href="https://coord.info/'+sId+'"';
  if(sStatus<>'') then Result:=Result+' target="_blank" title="%TextCacheStatus'+sStatus+'%"';
  Result:=Result+'>'+s1+sId+s2+'</a> - '+s1+sName+s2;

  if(sCountry<>'') then Result:=Result
    +' <img src="%IconCountry'+sCountry+'%" title="'+sCountry+'" />';
end;

function MakeHtmlCacheInfoFromId(sId:string):string;
var bod:TGeo;
begin
  Result:='';
  bod:=TGeo.Create();
  try
    bod.LoadByGc(sId);
    //bod.id:=sId; //toto nestaci, musi byt LoadByGc()
    Result:=MakeHtmlCacheInfo(sId,bod.CacheType,UtfToAnsi(bod.Name),bod.Country,IntToStr(bod.cachestatus));
  finally
    bod.Free();
  end;
end;

function MakeHtmlShortCacheInfoFromId(sId:string):string;
var bod:TGeo;
begin
  Result:='';
  bod:=TGeo.Create();
  try
    bod.LoadByGc(sId);
    //bod.id:=sId; //toto nestaci, musi byt LoadByGc()
    Result:=MakeHtmlCacheInfo(sId,bod.CacheType,UtfToAnsi(bod.Name),'',IntToStr(bod.cachestatus));
  finally
    bod.Free();
  end;
end;

function OutputTableListRow(sCols:string; aList:TStringList; iRow,iMin,iMax,iSuma,nCols,idxCount,iHistogramWidth:integer):string;
var sCol,s1,s2,sAlign,sOdd,sPomId,sPomName,sPomType,sPomStatus,sPomCountry:string;
    i,j,iCol:integer;
    f,fX1,fY1,fU,fLength:extended;
    dt:TDateTime;
    flags:REC_COLUMN_FLAGS;
    bHighlight:boolean;
begin
  sOdd:='';
  bHighlight:=false;
  if((iRow Mod 2)=0) then sOdd:='Odd';
  iCol:=0; //zaciname sloupcem 0
  s2:=UtfToAnsi(aList[iRow*nCols+iCol]);
  if(Pos(CONST_HIGHLIGHT,s2)=1) then begin
    bHighlight:=true;
    sOdd:=sOdd+'Highlight';
    aList[iRow*nCols+iCol]:=ReplaceString(aList[iRow*nCols+iCol],CONST_HIGHLIGHT,'');
  end;
  // else
  Result:='  <tr style="%StyleTableListTr'+sOdd+'%">'+CRLF;
  while (sCols<>'') do begin
    s1:=Fetch(sCols,'|');
    ParseColumnFlags(s1,flags);
    if(flags.sAlign='hide') then begin Inc(iCol); continue; end; //preskocime neviditelne sloupce
    sCol:=flags.sName; //odpareme pripadny komentar
    if(flags.sAlign='') then flags.sAlign:=LowerCase(SetDefaultColumnAlign(flags.sName,false));
    sAlign:=flags.sAlign;
    Result:=Result+'    <td style="%StyleTableListTd'+sOdd+'%';
    //zpracujeme
    s2:=UtfToAnsi(aList[iRow*nCols+iCol]);
    //nektere sloupce jsou pocitane, nejsou v datech
//LDH('   Sloupec: '+sCol+' -> '+s2);
   case UpperCase(sCol) of
    'ID':                       s2:='<a href="https://coord.info/'+s2+'" target="_blank">'+s2+'</a>';
    'TYPE':                     s2:=ReplaceColumnValue(sCol,s2);
    'TYPE ICON':                if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheTypeSmall'+s2+'%" />'
                                else s2:='';
    'TYPE ICON, TEXT':          if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheTypeSmall'+s2+'%" />&nbsp;&nbsp;'+ReplaceColumnValue(sCol,s2)
                                else s2:=ReplaceString(s2,CONST_NOICON,'');
    'NAME':                     begin
                                  //prvni znak indikuje status kese, pokud je archivovana, piseme preskrtnute
                                  if(s2<>'') then begin
                                    case s2[1] of
                                    '#': s2:='<span style="text-decoration:line-through; color:#%ColorCacheArchivedText%">'+copy(s2,2,length(s2)-1)+'</span>';
                                    '-': s2:='<span style="text-decoration:line-through; color:#%ColorCacheDisabledText%">'+copy(s2,2,length(s2)-1)+'</span>';
                                    '+', //dostupna
                                    '?': //neznamo
                                         s2:=copy(s2,2,length(s2)-1);
                                    //else; //v ostatnich pripadech tam je primo text
                                    end;
                                  end;
                                end;
    'SIZE':                     s2:=ReplaceColumnValue(sCol,s2);
    'SIZE ICON':                if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheSize'+s2+'%" />'
                                else s2:='';
    'SIZE ICON, TEXT':          if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheSize'+s2+'%" />&nbsp;&nbsp;'+ReplaceColumnValue(sCol,s2)
                                else s2:=ReplaceString(s2,CONST_NOICON,'');
    'SIZE AS NUM': //tento sloupec se pouziva jako skryty jen pro razeni, ale budiz, kdyz nekdo chce ...   p1: skrytej neni :), opravuju zarovnani
                                begin 
                                  //sAlign:='left';
                                  Fetch(s2,' ');
                                  s2:=ReplaceColumnValue(sCol,s2);
                                end;
    'DIFFICULTY':               s2:=ReplaceColumnValue(sCol,s2);
    'DIFFICULTY ICON':          if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheDiff'+s2+'%" />'
                                else s2:='';
    'DIFFICULTY ICON, TEXT':    if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheDiff'+s2+'%" />&nbsp;&nbsp;'+ReplaceColumnValue(sCol,s2)
                                else s2:=ReplaceString(s2,CONST_NOICON,'');
    'TERRAIN':                  s2:=ReplaceColumnValue(sCol,s2);
    'TERRAIN ICON':             if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheTerr'+s2+'%" />'
                                else s2:='';
    'TERRAIN ICON, TEXT':       if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheTerr'+s2+'%" />&nbsp;&nbsp;'+ReplaceColumnValue(sCol,s2)
                                else s2:=ReplaceString(s2,CONST_NOICON,'');
    //'IDTAG':                  s2:=ReplaceColumnValue(sCol,s2);
    'STATUS':                   s2:=ReplaceColumnValue(sCol,GlobalVarGet('TextCacheStatus'+s2,false));
    'STATUS ICON':              if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheStatus'+s2+'%" title="%TextCacheStatus'+s2+'%"/>'
                                else s2:='';
    'STATUS ICON, TEXT':        if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCacheStatus'+s2+'%" />&nbsp;&nbsp;'+ReplaceColumnValue(sCol,GlobalVarGet('TextCacheStatus'+s2,false))
                                else s2:=ReplaceString(s2,CONST_NOICON,'');
    'AUTHOR':                   s2:=ReplaceColumnValue(sCol,s2);
    'DATECREATE':               begin 
                                  s2:=FormatDateTime('d.m.yyyy',IntToDate(s2));
                                  if(s2='30.12.1899') then s2:='';
                                  s2:=ReplaceColumnValue(sCol,s2)
                                end;
    'DISTANCE':                 begin 
                                  //fX1:=StrToFloat(Fetch(s2,';'));
                                  //fY1:=StrToFloat(s2);
                                  //fLength:=PointDistanceEx(fHomeX,fHomeY,fX1,fY1,fU);
                                  if(s2<>'') then begin //pokud je nejaka hodnota, prevedeme ji na float
                                    fLength:=StrToFloat(s2);
                                    //prevedeme na pozadovane jednotky
                                    fLength:=ConvertFromKm(fLength,sUnit);
                                    s2:=FormatFloatDot('0.00',fLength);
                                    //s2:=ReplaceColumnValue(sCol,s2);
                                  end;
                                end;
    'DIRECTION':                begin 
                                  //fX1:=StrToFloat(Fetch(s2,';'));
                                  //fY1:=StrToFloat(s2);
                                  //fLength:=PointDistanceEx(fHomeX,fHomeY,fX1,fY1,fU);
                                  if(s2<>'') then begin //pokud je nejaka hodnota, prevedeme ji na float
                                    fU:=StrToFloat(s2);
                                    s2:=IntToStr(Round(fU))+' ';
                                  end;
                                end;
    'DIRECTION ICON':           begin 
                                  //fX1:=StrToFloat(Fetch(s2,';'));
                                  //fY1:=StrToFloat(s2);
                                  //fLength:=PointDistanceEx(fHomeX,fHomeY,fX1,fY1,fU);
                                  if(s2<>'') then begin //pokud je nejaka hodnota, prevedeme ji na float
                                    fU:=StrToFloat(s2);
                                    s2:='<img src="'+DirectionToIcon(fU)+'"'
                                      //+' title="L='+FormatFloatDot('0.00',fLength)+'; U='+FloatToStr(fU)+'"'
                                      +' />';
                                  end;
                                end;
    'COORDINATES':              begin 
                                  fX1:=StrToFloat(Fetch(s2,';'));
                                  fY1:=StrToFloat(s2);
                                  s2:=FormatCoordNum(fX1,fY1);
                                end;
    'COUNTRY':                  s2:=ReplaceColumnValue(sCol,s2);
    'CACHE INFO':               begin
                                  sPomId:=Fetch(s2,';');
                                  sPomType:=Fetch(s2,';');
                                  sPomStatus:=Fetch(s2,';');
                                  sPomCountry:=Fetch(s2,';');
                                  sPomName:=s2;   
                                  s2:=MakeHtmlCacheInfo(sPomId,sPomType,sPomName,sPomCountry,sPomStatus);
                                end;
    'CACHE INFO SHORT':         begin
                                  sPomId:=Fetch(s2,';');
                                  sPomType:=Fetch(s2,';');
                                  sPomStatus:=Fetch(s2,';');
                                  sPomName:=s2;
                                  s2:=MakeHtmlCacheInfo(sPomId,sPomType,sPomName,'',sPomStatus);
                                end;
    'COUNTRY FLAG':             //pokud neni jmeno statu (posledni radek v tabulce z modulu FindByTypeInCountry)
                                //nevytvarime ikonu
                                if(s2<>'') then begin
                                  if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCountry'+s2+'%" title="'+s2+'" />'
                                  else s2:='';
                                end;
    'COUNTRY FLAG, TEXT':       if(s2<>'') then begin
                                  if(Pos(CONST_NOICON,s2)<1) then s2:='<img src="%IconCountry'+s2+'%" />&nbsp;&nbsp;'+ReplaceColumnValue(sCol,s2)
                                  else s2:=ReplaceString(s2,CONST_NOICON,'');
                                end;
    'STATE':                    s2:=ReplaceColumnValue(sCol,s2);
    'FOUND DATE':               begin
                                  s2:=FormatDateTime('d.m.yyyy',IntToDate(s2));
                                  if(s2='30.12.1899') then s2:='';
                                  s2:=ReplaceColumnValue(sCol,s2);
                                end;
    'FOUND TIME':               begin
                                  if(Pos(':',s2)<1) then begin
                                    s2:=Copy('0000'+s2,length(s2)+4-3,length(s2)+4);
                                    s2:=Copy(s2,1,2)+':'+Copy(s2,3,length(s2));
                                  end;
                                end;
    'FOUND DATETIME':           begin 
                                  s2:=FormatDateTime('d.m.yyyy',IntToDate(Copy(s2,1,8)))
                                    +' '+Copy(s2,9,2)+':'+Copy(s2,11,2);
                                  if(s2='30.12.1899 :') then s2:='';
                                end;
    'DATE OF LAST FOUND':       begin 
                                  s2:=FormatDateTime('d.m.yyyy',IntToDate(s2));
                                  if(s2='30.12.1899') then s2:='';
                                end;
    'COUNT':                    ;
    'COUNT EXPLICIT':           ;
    'ORDER FINDING':            ; //toto je spatne a nechavam to jen z historickych duvodu
                                  //aby neprestaly chodit stare selecty
    'ORDER BY FINDS':           ;
    'ORDER ROW':                s2:=IntToStr(iRow+1);
    'MILESTONE':                ;
    'MILESTONE, INTERVAL',
    'INTERVAL':                 begin
                                  //prevedeme na datum a cas a odecteme posledni hodnotu,
                                  //tim ziskame pocet dni od posledniho milniku
                                  dt:=IntToDate(s2);
                                  if(dtMilestoneLastFound=0) then s2:=''
                                  else s2:=IntToStr(Trunc(dt-dtMilestoneLastFound));
                                  dtMilestoneLastFound:=dt;
                                end;
    'PERCENT':                  begin
                                  if(idxCount>=0) then begin
                                    i:=StrToInt(aList[iRow*nCols+idxCount]);
                                    f:=100*i;
                                    if(iSuma=0) then s2:='0.00'
                                    else s2:=FormatFloatDot('0.00',f/iSuma);
                                  end else s2:='';
                                  //s2:=ReplaceColumnValue(sCol,s2);
                                end;
    'PERCENT EXPLICIT':         begin //procenta primo jako vysledek ve sloupci SQL
                                  s2:=ReplaceString(s2,'.',','); //at mame oddelovac vzdy stejny
                                  //s2:=ReplaceColumnValue(sCol,s2);
                                end;
    'HISTOGRAM':                begin
                                  if(idxCount>=0) then begin
                                    //sirka histogramu je iHistogramWidth
                                    i:=StrToInt(aList[iRow*nCols+idxCount]);
                                    if(iMax=0) then j:=0
                                    else //j:=Trunc(0.9+iHistogramWidth*i/iMax);
                                         j:=Trunc(0.9+100*i/iMax);
                                    s2:='<div style="width:'+IntToStr(j)
                                      //+'px; background-color:#'
                                      +'%; background-color:#'
                                      +ScaleColor(i,0,iMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
                                      +';%StyleTableListHistogram%">&nbsp;</div>';
                                  end else s2:='';
                                end;
    'HISTOGRAM EXPLICIT':       begin //procenta histogramu primo jako vysledek ve sloupci SQL
                                  s2:=ReplaceString(s2,',','.');
                                  j:=Round(StrToFloat(s2));
{$ifdef DEBUG_HELPER}
  LDH('AAAA j='+IntToStr(j)+', iMax='+IntToStr(iMax));
{$endif}
                                  s2:='<div style="width:'+IntToStr(j)
                                    //+'px; background-color:#'
                                    +'%; background-color:#'
                                    //pokud neni urcen sloupec s pocitanim, pak neni spravne
                                    //iMax a barva tedy asi nebude spravna
                                    +ScaleColor(j,0,iMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
                                    +';%StyleTableListHistogram%">&nbsp;</div>';
                                end;
    else s2:=ReplaceColumnValue(sCol,s2);
    //protoze funkce muze byt volana po obecnem SQL, muze byt sloupec oznacen
    //jakkoli a muze mit skutecne libovolny obsah. Proto nejde hlasit chybu.
    //else if(Pos('tag-',sCol)<>1) then Log(_('ERR: unknown column name:')+' '+sCol);
    end;
    Inc(iCol); //budem nacitat hodnotu z dalsiho sloupce
    if(sAlign<>'') then sAlign:=' text-align:'+LowerCase(sAlign)+';';
    Result:=Result+sAlign+'">'+s2+'</td>'+CRLF;
  end;
  Result:=Result+'  </tr>'+CRLF;
end;

function OutputTableList(sCols:string; aData:TStringList; iRowFirst,nRowCount,idxCount:integer; var nRest:integer):string;
var s,s1,s2:string;
    i,n,nCols,nRows,iMin,iMax,iSuma,iHistogramWidth:integer;
begin
  Result:='';
  //spocitame pocet sloupcu a poradi sloupce pro zjisteni poctu
  s:=sCols;
  nCols:=0;
  n:=-1;
  nRest:=0;
  iMin:=0;
  GlobalVarSet('TableListLastRowCount','0');
  //pro nektere sloupce je potreba rozumna hodnota indexu sloupce, podle nehoz
  //se keskupuji kese a ziskava se pocet kesi. Zjistime, zda takovy sloupec je.
  while(s<>'') do begin
    s2:=Fetch(s,'|');
    s1:=Fetch(s2,'=');
    if(s1='HISTOGRAM') then iMin:=iMin+1
    else if(s1='PERCENT') then iMin:=iMin+2
    else if(s1='COUNT') then iMin:=iMin+4;
    Inc(nCols);
  end;
{$ifdef DEBUG_HELPER} LDH('OOOO Pocet sloupcu tabulky: '+IntToStr(nCols)); {$endif}
{$ifdef DEBUG_HELPER} LDH('PPPP idxCount='+IntToStr(idxCount)); {$endif}
{$ifdef DEBUG_HELPER} LDH('QQQQ sCols='+sCols); {$endif}
  if(iMin>0) and ((idxCount=-1) or (idxCount>=nCols)) then begin
{$ifdef DEBUG_HELPER} LDH('RRRR iMin='+IntToStr(iMin)+', sCols='+sCols); {$endif}
    Log('WARN: '+_('Maybe you didn''t choose the column for grouping rows to count caches in group (country, tag, direction, ...).'));
    exit;
  end;
  iMin:=0;

  if(aData.Count<1) then Result:=OutputTableListHeader(sCols)
  else begin
    if(aData[0]<>'!NoHeader!') then Result:=OutputTableListHeader(sCols)
    else begin
      Result:='<table style="'+GlobalVarGet('StyleTableList',false)+'">'+CRLF;
      aData.Delete(0); //vymazat prvni datovou polozku
    end;
    s:=GlobalVarGet('StyleTableListHistogramWidth',false);  //zjistime sirku histogramu pro vypocet
    s:=RegexSubstitute('width:\s*(\d+)',s,'$1');
    if(s='') then begin
      Log(_('WARN: Cannot read width of histogram from')+' Styles.ini, TableListHistogramWidth');
      iHistogramWidth:=150;
    end
    else iHistogramWidth:=StrToInt(s);
    //spocitame minimum, maximum a soucet
    nRows:=aData.Count/nCols;   //pocet datovych radku
    //ulozime do globalni promenne pocet radku tabulky
    GlobalVarSet('TableListLastRowCount',IntToStr(nRows));
    iMin:=1; iMax:=1; iSuma:=0;
//{$ifdef DEBUG_HELPER} LDH('EEEEE idxCount='+IntToStr(idxCount));{$endif}
    if(idxCount>=0) then begin
      iMin:=999999; iMax:=-999999;
      for i:=0 to nRows-1 do begin
        //pokud to je desetinne cislo, tak z nej udelame cele
        //(to kvuli explicit procentum a histogramu)
//{$ifdef DEBUG_HELPER} LDH('EEEEE aData[i*nCols+idxCount]='+aData[i*nCols+idxCount]);{$endif}
        s:=ReplaceString(aData[i*nCols+idxCount],',','.');
        if(RegexFind('(?i)[^0-9.]',s)) then s:=''; //neplatne znaky nejdou prevest na cislo
        if(s='') then begin
          //Text ve sloupci nelze prevest na cislo!
          //3.1.2019 ne vzdy tu musi byt cislo, takze casto je s='' korektni a neni mozne hlasit vzdy chybu
          //Log(_('ERR: Text in this column can not be converted to number!')+' idxCount='+IntToStr(idxCount)+', s='+s);
          s:='0';
        end;
        n:=Round(StrToFloat(s));
        //s1:=Fetch(s,'.');
        //n:=StrToInt(s1);
        iSuma:=iSuma+n;
        if(n<iMin) then iMin:=n;
        if(n>iMax) then iMax:=n;
//{$ifdef DEBUG_HELPER} LDH('FFFFF data='+aData[i*nCols+iDxCount]+', n='+IntToStr(n)+', iMax='+IntToStr(iMax)); {$endif}
      end;
    end;

    //spocitame index posledniho vypisovaneho radku
    if(iRowFirst<0) then iRowFirst:=0;
    if(nRowCount<0) then nRowCount:=nRows;
//Log('SSSSSSSS 1 idxCount='+IntToStr(idxCount)+', nCols='+IntToStr(nCols)
//  +', nRows='+IntToStr(nRows)
//  +', iMin='+IntToStr(iMin)+', iMax='+IntToStr(iMax)
//  +', iSuma='+IntToStr(iSuma)
//  +', nRowCount='+IntToStr(nRowCount)
//  );
//Log('SSSS 2 iRowFirst='+IntToStr(iRowFirst)+', nRowCount='+IntToStr(nRowCount)+', nRows='+IntToStr(nRows));
//LDH('SSSS 3 sCols='+sCols+', delKA pole='+iNTtOsTR(aData.Count));
//LDH('SSSS 4 iRowFirst='+IntToStr(iRowFirst)+', nRowCount='+IntToStr(nRowCount)+', nRows='+IntToStr(nRows));
    if(iRowFirst<nRows) then begin
      n:=nRowCount;
      if(n+iRowFirst>=nRows) then n:=nRows-iRowFirst;
//LDH('SSSS 5 iRowFirst='+IntToStr(iRowFirst)+', nRowCount='+IntToStr(nRowCount)+', n='+IntToStr(n)+', nRows='+IntToStr(nRows));
      for i:=0 to n-1 do begin
//LDH('SSSS 6 radek '+IntToStr(i+1)+' z '+IntToStr(n));
        Result:=Result+OutputTableListRow(sCols,aData,i+iRowFirst,iMin,iMax,iSuma,nCols,idxCount,iHistogramWidth);
      end;
      nRest:=nRows-n-iRowFirst;
    end;
  end;
  Result:=Result+'</tbody></table>';
end;

function OutputSwitchButtons(sId,sSwitchType:string; iListboxSize:integer; bCheckboxUnique:boolean; aData:TStringList):string;
  //vytvari sadu prepinacich prvku a jejich obsluhu
  //sID ... ID hlavniho prvku (modulu), v kterem je vytvareno prepinani
  //sSwitchType ... typ prepinaciho prvku (Button, Radiobutton, Checkbox, Listbox, Combobox)
  //iListboxSize... pocet radku listboxu
  //aData ... pro kazde tlacitko 2 stringy: text na tlacitko a ID prvku, ktery bude zviditelnen
var i,j,n:integer;
    s:string;
begin
  n:=aData.Count/2;
{$ifdef DEBUG_HELPER}
  //LDH('Switch: sId='+sId+', SwitchType='+sSwitchType+', n='+IntToStr(n)+CRLF+'aData[text,ID]='+aData.Text);
{$endif}
  if(sSwitchType='None') or (n<=1) then exit;    //to umoznuje dalsi moduly zaradit za prepinane bloky
  Result:='<div style="text-align:center; margin:15px;"> <!-- prepinaci tlacitka: '+sSwitchType+' -->'+CRLF; //vse ve vystredenem bloku
  //pro Listbox a Combobox vytvorime ovladaci javascript
  if(sSwitchType='Listbox') or (sSwitchType='Combobox') then begin
    s:='';
    //pripravit javascript pro obsluhu vyberu
    s:='var aButt=Array();'+CRLF
      +'var nButtons,i,j;'+CRLF;
    for i:=0 to n-1 do begin
      s:=s+'aButt['+IntToStr(i)+']='''+aData[i*2+1]+''';    ';
    end;
    Result:=Result+'<select id="sel'+sId+'"';
    //zjistime skutecnou velikost listboxu a nastavime ji
    if(sSwitchType='Listbox') then begin
      i:=n;
      if(i>iListboxSize) then i:=iListboxSize;
      Result:=Result+' size='+IntToStr(i);
    end;
    s:=s+'nButtons='+IntToStr(n)+';'+CRLF
        //+'alert(document.getElementById(''sel'+aSwitch[iSwitchIdx]+''').value);'+CRLF
        +'for(i=0; i<nButtons; i++){'+CRLF
        +'  if(document.getElementById(''sel'+sId+''').value==aButt[i]){'+CRLF
        +'    document.getElementById(aButt[i]).style.display=''block'';'+CRLF
        +'  }'+CRLF
        +'  else{'+CRLF
        +'    document.getElementById(aButt[i]).style.display=''none'';'+CRLF
        +'  }'+CRLF
        +'}'+CRLF
        +'return(false);'+CRLF;
    Result:=Result+CRLF+' onchange="'+s+'">';
  end;
  //vytvorime ovladaci tlacitka
  for i:=0 to n-1 do begin
    case sSwitchType of
    'Button': begin
                s:='<button id="b'+sId+'_'+IntToStr(i)+'" style="cursor:pointer; margin:2px 2px 5px 2px; font-weight:';
                if(i=0) then s:=s+'bold;'
                else s:=s+'normal;';
                s:=s+';" onclick="';
                //obsluha tlacitka k prepinani
                for j:=0 to n-1 do begin
                  //pepnac logika
                  if(j=i) then
                    s:=s+'document.getElementById('''+aData[j*2+1]+''').style.display=''block''; '
                        +'document.getElementById(''b'+sId+'_'+IntToStr(j)+''').style.fontWeight=''bold''; '
                  else
                    s:=s+'document.getElementById('''+aData[j*2+1]+''').style.display=''none''; '
                        +'document.getElementById(''b'+sId+'_'+IntToStr(j)+''').style.fontWeight=''normal''; '
                  ;
                end;
                Result:=Result+s+'return(false);">'+aData[i*2]+'</button>'+CRLF;
              end;
    'Radiobutton',
    'Checkbox': begin
                //span zabrani oddeleni zaskrtavatka od textu
                s:='<span style="white-space:nowrap;"><input type=';
                if(sSwitchType='Checkbox') then s:=s+'"checkbox"'
                else s:=s+'"radio" name="'+sId+'"';
                s:=s+' id="b'+sId+'_'+IntToStr(i)+'"';
                if(i=0)then s:=s+' checked';
                s:=s+' onclick="';
                //obsluha tlacitka k prepinani
                for j:=0 to n-1 do begin
                  //pepnac logika
                  if(j=i) then begin
                    if(sSwitchType='Checkbox') and (bCheckboxUnique) then
                      s:=s+'document.getElementById(''b'+sId+'_'+IntToStr(j)+''').checked=true; ';
                    s:=s+'document.getElementById('''+aData[j*2+1]+''').style.display=';
                    if(sSwitchType<>'Checkbox') or (bCheckboxUnique) then s:=s+'''block''; '
                    else s:=s+'(document.getElementById(''b'+sId+'_'+IntToStr(j)+''').checked)?''block'':''none''; ';
                  end
                  else begin
                    if(sSwitchType<>'Checkbox') or (bCheckboxUnique) then
                      s:=s+'document.getElementById('''+aData[j*2+1]+''').style.display=''none''; ';
                    if(sSwitchType='Checkbox') and (bCheckboxUnique) then
                      s:=s+'document.getElementById(''b'+sId+'_'+IntToStr(j)+''').checked=false; ';
                  end;
                end;
                Result:=Result+s+'" />'+aData[i*2]+'</span>'+CRLF;
              end;
    'Listbox',
    'Combobox': begin
               //obsluha musi byt na udalosti onchange() na prvku select!
                s:='<option value="'+aData[i*2+1]+'"';
                if(i=0)then s:=s+' selected';
                Result:=Result+s+'>'+aData[i*2]+'</option>'+CRLF;
              end;
    end;
  end;
  if(sSwitchType='Listbox') or (sSwitchType='Combobox') then Result:=Result+'</select>'+CRLF;
  Result:=Result+'</div>'+CRLF;
end;

function ColorToRGBA(sColor,sAlpha:string):string; //prevede barvu a pruhlednost na format s rgba()
var i:integer;
begin
  Result:='''rgba(';
  i:=1;
  if(sColor[1]='#') then i:=2;
  Result:=Result+IntToStr(HexToDec(Copy(sColor,i,2)))+','
    +IntToStr(HexToDec(Copy(sColor,i+2,2)))+','
    +IntToStr(HexToDec(Copy(sColor,i+4,2)))+','+sAlpha+')''';
end;

function ColorToRGB(sColor:string):string; //prevede barvu do dekadickych slozek na format s rgb()
var i:integer;
begin
  Result:='''rgb(';
  i:=1;
  if(sColor[1]='#') then i:=2;
  Result:=Result+IntToStr(HexToDec(Copy(sColor,i,2)))+','
    +IntToStr(HexToDec(Copy(sColor,i+2,2)))+','
    +IntToStr(HexToDec(Copy(sColor,i+4,2)))+')''';
end;

{$ifdef CHART_CHARTS}
//function ChartsChart(sId,sChartType,sData,sOptions:string):string; //vygeneruje javascript pro zobrazeni grafu pres knihovnu Charts.js
//begin
//  //canvas pro graf
//  Result:='<canvas id="'+sId+'" width="'+IntToStr(iWidth)+'" height="'+IntToStr(iWidth/3)+'"></canvas>'+CRLF;
//  //vlastni vykresleni grafu
//  Result:=Result+'<script>'+CRLF
//          +'var c_'+sId+'=document.getElementById("'+sId+'");'+CRLF
//          +'var chart_'+sId+'=new Chart(c_'+sId+',{'+CRLF
//          +'  type: '''+sChartType+''','+CRLF
//          +'  data:{'+CRLF+sData+CRLF+'  },'+CRLF
//          +'  options:{'+CRLF+sOptions+CRLF+'  }'+CRLF
//          +'});'+CRLF+'</script>'+CRLF+CRLF;
//end;
{$endif}

{$ifdef CHART_PLOTLY}
//function PlotlyChart(sId,sData,sLayout:string):string; //vygeneruje javascript pro zobrazeni grafu pres knihovnu Charts.js
//begin
//  //typ grafu je soucasti sData
//  Result:='<div id="'+sId+'"></div>'+CRLF;
//  //vlastni vykresleni grafu
//  Result:=Result+'<script>'+CRLF
//          +'  var divPlotly_'+sId+'=document.getElementById("'+sId+'");'+CRLF
//          +'  Plotly.plot(divPlotly_'+sId+',[{'+CRLF+sData+CRLF+'  }],{'+CRLF+sLayout+CRLF+'  },'+CRLF
//          //nastaveni konfigurace (nepovinny parametr, ale upravime jim tlacitka na modeBaru
//          //odstranit logo z buttonbaru
//          +'    { displaylogo: false, showTips: false,'+CRLF
//          //odstranit i pridalsi nepotrebne ikony
//          //+'      modeBarButtonsToRemove: [''sendDataToCloud'', ''autoScale2d'','
//          //+'      ''hoverClosestCartesian'',''hoverCompareCartesian'', ''lasso2d'', ''select2d'']'
//          //pripadne odstranime cely modeBar (ale tlacitko pro ziskani grafu jako obrazku neni na skodu)
//          //+' displayModeBar:false,'
//          +'});'+CRLF
//          +'</script>'+CRLF+CRLF;
//end;
{$endif}

function SetPieHeight(iHeight:integer):integer; //vraci vysku kolacoveho grafu
begin
  Result:=iHeight;
  if(Result>1) then exit;
  if(iWidth<420) then Result:=Result*3/4
  else Result:=Result/2;
end;

function SetPieHeightDefault:integer; //vraci implicitni vysku kolacoveho grafu
begin
  Result:=180;
end;

function EChartsTheme:string;
//vystup implicitniho tematu pro ECharts
//viz napr. https://echarts.baidu.com/echarts2/doc/example/themeDesigner.html#-en
//popis vlastnosti: https://ecomfe.github.io/echarts-doc/public/en/option.html#title
var sCpie:string;
begin
  Result:='';
  if(bEChartsTheme) then exit;
  bEChartsTheme:=true; //aby se uz znovu neposilalo do vystupu
  //pripravime barvy pro Pie (v dostatecnem poctu)
  //stridat budeme jen 2 barvy, vysec s maximem bude mit hodnotu explicitne urcenou
  sCpie:='''#'+GlobalVarGet('ColorTableScaleAvgBkg',false)+''',''#'+GlobalVarGet('ColorTableScaleMinBkg',false)+'''';
  sCpie:=sCpie+','+sCPie; //4
  sCpie:=sCpie+','+sCPie; //8
  sCpie:=sCpie+','+sCPie; //16
  sCpie:=sCpie+','+sCPie; //32
  sCpie:=sCpie+','+sCPie; //64   //to by mohlo stacit :-)
  Result:=Result+'<script type="text/javascript">'+CRLF
    //vlozeni vlastni knihovny
{$ifdef DEBUG_HELPER}
    //funkce pro vypis vlastnosti a hodnotu Javascriptoveho objektu
    +'  function debugProperty(text,item,bDialog){'+CRLF
    +'    var typ;'+CRLF
    +'    var s=text+" (typ:"+typeof(item)+", hodnota="+item+")<br/>---------------<br/>\n";'+CRLF
    +'    var i=0;'+CRLF
    +'    for(c in item){    //vsechny podrizene prvky'+CRLF
    +'      typ=typeof(item[c]);'+CRLF
    +'      s=s+c;           //jmeno'+CRLF
    +'      if(typ!="undefined" && typ!="object" && typ!="function"){'+CRLF
    +'        s=s+"="+item[c]; //pokud je to mozne jeho hodnotu'+CRLF
    +'      }'+CRLF
    +'      s=s+" (typ:"+typ /*+") (poradi v poli:"+i*/+"), ";'+CRLF
    +'      i++;'+CRLF
    +'      if(i==2){ i=0; s+="<br/>\n";}'+CRLF
    +'    }'+CRLF
    +'    if(bDialog){ alert(s); s="";} //zobrazime jako dialog'+CRLF
    +'    return(s);'+CRLF
    +'  };'+CRLF+CRLF
{$endif}
    //dokumentace: https://ecomfe.github.io/echarts-doc/public/en/option.html
    +'StatorTheme={'+CRLF
    //implicitni definece pro kolacovy graf
    +'  pie:{'+CRLF
    +'    center:[''50%'',''50%''], radius:[0,''75%''], startAngle:0, minAngle:0,'+CRLF
    +'    color:['+sCpie+'],'+CRLF
    +'    label:{show:true, position:''outer'', color:''#'+GlobalVarGet('ColorMainText',false)+'''},'+CRLF
    +'    labelLine:{lineStyle:{color:''#'+GlobalVarGet('ColorMainText',false)+'''}},'+CRLF
    //pokud je tooltip zde, pak je pouzit vzdy, kdyz je v explicitni definici grafu
    //alespon tooltip{} (na obsahu nezalezi, vzdy bude pouzit tento)
    //pokud v explicit ni definice neni tooltip{} uveden, nebude zobrazen ani tento
    //implicitni
    //pokud zde (v globalni definici) neni tooltip, pak se pouzije ten v explicitni
    //definici nebo default (netusim, kde je) "{a}<br/>{b}: {c} ({d} %)"
    +'    tooltip:{ trigger:''item'', formatter: "{b}: {c} ({d} %)"},'+CRLF
    +'  },'+CRLF       //konec Pie
    //implicitni definice pro sloupcovy graf
    +'  bar:{'+CRLF
    //grid a osy nejde popsat globalni
    //+'    grid:{ left:5, right:5, bottom:5, top:15, containLabel: true },'+CRLF
    +'    color:[''#'+GlobalVarGet('ColorTableScaleAvgBkg',false)+'''],'+CRLF
    //tooltip je treba globalni, protoze ma kazdy graf jiny text
    //+'    tooltip:{trigger:''axis'', axisPointer:{ type:''shadow''}},'+CRLF
    +'    label:{show:true, position:''top'', distance:1, fontStyle:400, fontSize:10, color:''#'+GlobalVarGet('ColorMainText',false)+'''},'+CRLF
    +'  },'+CRLF       //konec Bar
    +'  line:{'+CRLF
    +'    color:[''#'+GlobalVarGet('ColorTableScaleAvgBkg',false)+''']'+CRLF  //barva cary v carovem grafu
    +'  },'+CRLF       //konec line

    +'};'+CRLF         //konec theme

    //dokumentace: https://ecomfe.github.io/echarts-doc/public/en/option.html
    +'StatorThemeBarNoLabels={'+CRLF
    +'  bar:{'+CRLF
    +'    color:[''#'+GlobalVarGet('ColorTableScaleAvgBkg',false)+'''],'+CRLF
    +'    label:{show:false},'+CRLF
    +'  },'+CRLF       //konec Bar
    +'  line:{'+CRLF
    +'    color:[''#'+GlobalVarGet('ColorTableScaleAvgBkg',false)+''']'+CRLF  //barva cary v carovem grafu
    +'  },'+CRLF       //konec line
    +'};'+CRLF         //konec theme

    //nastaveni barvy pro osy, popis os a datovych bodu a hodnot sloupcu
    //+'StatorThemeAxisColors={'+CRLF
    //+'  line:{'+CRLF
    //+'    xAxis:{axisLine:{lineStyle:{color:'+ColorToRGBA(GlobalVarGet('ColorTableScaleAvgBkg',false),'1')+'}},'+CRLF
    //+'      axisLabel:{color:'+ColorToRGBA(GlobalVarGet('ColorTableScaleAvgBkg',false),'1')+'}}'+CRLF
    //+'  },'+CRLF //konec line
    //+'};'+CRLF   //konec theme
    +'</script>'+CRLF
    ;

end;

function PieScaleRGBAColors(sValues:string):string;
//vraci barvy pro kazdou datovou hodnotu pro kolacovy graf, barvy oddelene CRLF
//kazda hodnota muze byt take poloe hodnot (napr [pocet nalezu,pocet dnu v mesici])
//  pak se bere v uvahu jen prvni hodnota
//pro prehlednost grafu ma maximum hodnotu Max, u zbylych barev se stridaji barvy pro Min a Avg
var fMax,fVal:extended;
    s,s1,sMax,sVal,sV:string;
    //b:boolean;
begin
  //pro kolacovy graf se stridaji barvy Avg a Min, jen maximalni hodnota ma barvu Max
  //zjistime maximalni hodnotu
  s:=Trim(sValues);
  //{$ifdef DEBUG_HELPER} LDH('Hledani maximalni hodnoty v: '+s); {$endif}
  while(s<>'') do begin
    sV:=Fetch(s,CRLF);
    s1:=sV;
    sVal:=Fetch(s1,','); //pokud je polozka pole, vezmeme jen prvni hodnotu
    if(sVal[1]='[') then sVal:=Fetch(s1,',');
    fVal:=StrToFloat(sVal);
    if(fVal>fMax) then begin
      //{$ifdef DEBUG_HELPER} LDH('...maximalni hodnota: '+sV); {$endif}
      fMax:=fVal;
      sMax:=sV;
    end;
  end;
  //sestavime barvy ve tvaru #RRGGBB
  //{$ifdef DEBUG_HELPER} LDH('...maximum: '+sMax); {$endif}
  s:=Trim(sValues);
  while(s<>'') do begin
    sVal:=Fetch(s,CRLF);
    if(sVal=sMax) then Result:=Result+ColorToRGBA(GlobalVarGet('ColorTableScaleMaxBkg',false),'1')+CRLF
    else begin
      //if(b) then Result:=Result+ColorToRGBA(GlobalVarGet('ColorTableScaleMinBkg',false),'1')+CRLF
      //else Result:=Result+ColorToRGBA(GlobalVarGet('ColorTableScaleAvgBkg',false),'1')+CRLF;
      //b:=(not b);
      //bez barvy, bude pouzito implicitni nastaveni z registrovaneho tematu StatorTheme
      Result:=Result+CRLF;
    end;
  end;
  //{$ifdef DEBUG_HELPER} LDH('...barvy: '+Result); {$endif}
end;

function DataColoredBarMaxValue(sData:string):string;
var f,fMax:extended;
    s,s1,sV,sVal,sMax:string;
begin
  Result:='';
  fMax:=0;
  s:=Trim(sData);
  while(s<>'') do begin
    sV:=Fetch(s,CRLF);
    s1:=sV;
    sVal:=Fetch(s1,','); //pokud je polozka pole [X,Y,...], vezmeme jen Y hodnotu
    if(sVal[1]='[') then sVal:=Fetch(s1,',');
    if(sVal='') then f:=0
    else f:=StrToFloat(sVal);
    if(f>fMax) then begin fMax:=f; sMax:=sV; end;
  end;
  s1:=Trim(sData);
  while(s1<>'') do begin
    s:=Fetch(s1,CRLF);
    if(s<>sMax) then Result:=Result+s+CRLF
    else Result:=Result+'{value:'+s+', itemStyle:{color:''#'+GlobalVarGet('ColorTableScaleMaxBkg',false)+'''}}'+CRLF;
  end;
  Result:=ReplaceString(Trim(Result),CRLF,',');
end;

//ukazky grafu ECharts:
//  https://ecomfe.github.io/echarts-examples/public/index.html
//  https://echarts.baidu.com/echarts2/doc/example-en.html
function EChartsPieChart(sId,sData,sNames:string; Width,Height:integer):string;
var s,sName,sValue,sColor,sColors:string;
begin
  s:='';
  if(sData='') then begin
    Log(_('ERR: PieChart - no data!')+' sId='+sId); 
    exit;
  end;
  //nastavime rozmery divu, pokud necio neni zadane
  if(Width<=0) then Width:=iWidth;
  Height:=SetPieHeight(Height);
  sColors:=PieScaleRGBAColors(sData);
  while(sData<>'') do begin
    sValue:=Fetch(sData,CRLF);
    sName:=Fetch(sNames,CRLF);
    sColor:=Fetch(sColors,CRLF);
    //barva bude nastavena jen pro maximalni hodnotu
    if(sColor<>'') then sColor:=', itemStyle:{color: '+sColor+'}';
    s:=s+'      {name:'''+sName+''', value:'+sValue+sColor+'},'+CRLF;
  end;
  Result:=EChartsTheme()+'<div id="'+sId+'" style="width:'+IntToStr(Width)+'px; height:'+IntToStr(Height)+'px;"></div>'+CRLF
         +'<script type="text/javascript">'+CRLF
         +'  var chart_'+sId+'=echarts.init(document.getElementById('''+sId+'''), StatorTheme);'+CRLF
         +'  option={'+CRLF+
         //+'  title:{text:''nadpis'', subtext:''podnadpis'',x=''center''},'+CRLF
         //+'  tooltip:{ trigger:''item'', formatter: "{a}-{b}<br/>{c} ({d} %)"},'+CRLF
         //pouzijeme tooltip z globalni definice
         +'  tooltip:{},'+CRLF
         //nasledujici tooltip by byl pouzit jen kdyby nebyl v globalni definici
         //+'  tooltip:{ trigger:''item'', formatter: "{a}-{b}<br/>{c} ({d} %)"},'+CRLF
         +'  series:[{'+CRLF
         +'    name:''XXX'','+CRLF
         +'    type:''pie'','+CRLF
         +'    data:['+CRLF+s+'    ],'+CRLF
         +'    label:{normal:{textStyle:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'1')+'}}},'+CRLF
         +'    labelLine:{normal:{lineStyle:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'1')+'}},'
         //+'      smooth:0.2, length:10, Length2:10'
         +'    },'+CRLF
         +'  }],'+CRLF
         +'  };'+CRLF
         //vytvoreni grafu s potrebnymi parametry a definovanym tematem
         +'  chart_'+sId+'.setOption(option);'+CRLF
         +'</script>'+CRLF+CRLF;
end;

//ukazky grafu ECharts:
//  https://ecomfe.github.io/echarts-examples/public/index.html
//  https://echarts.baidu.com/echarts2/doc/example-en.html
function EChartsBarChart(sId,sData,sNames,sAddOptions,sTooltip:string; bLabels,bZoom:boolean; Width,Height:integer):string;
var s,sColors,sTheme,sZoom,sHelp:string;
    iBottom:integer;
begin
  s:='';
  if(sData='') then begin
    Log(_('ERR: PieChart - no data!')+' sId='+sId); 
    exit;
  end;
//{$ifdef DEBUG_HELPER} LDH('sData='+sData); LDH('sNames='+sNames);{$endif}
  //nastavime rozmery divu, pokud necio neni zadane
  if(Width<=0) then Width:=iWidth;
  Height:=SetPieHeight(Height);
  sColors:=PieScaleRGBAColors(sData); //nastavi barvu jen maximalni hodnote

  //while(sData<>'') do begin
  //  sValue:=Fetch(sData,CRLF);
  //  sName:=Fetch(sNames,CRLF);
  //  sColor:=Fetch(sColors,CRLF);
    //barva bude nastavena jen pro maximalni hodnotu
  //  if(sColor<>'') then sColor:=', itemStyle:{color: '+sColor+'}';
  //  s:=s+'      {name:'''+sName+''', value:'+sValue+sColor+'},'+CRLF;
  //end;
  //pokud tooltip neobsahuje funkci, obalime ho uvozovkami
  if(Pos('function',sTooltip)<1) then sTooltip:='"'+sTooltip+'"';
  //pokud je pozadavek na moznost zoomovani, upravime spodni hranu grafu
  iBottom:=5; sZoom:=''; sHelp:='';
  if(bZoom) then begin
    iBottom:=40;
    sZoom:='    dataZoom: [{type: ''inside''}, {type: ''slider''}],'+CRLF;
    sHelp:='%StyleTableBottomTextStartHtml%'+
      +'<i>'+_('You can zoom by scrolling or using sliders under the chart.')+'</i>'     
      +'%StyleTableBottomTextEndHtml%'+CRLF;
  end;
  if(bLabels) then sTheme:='StatorTheme' else sTheme:='StatorThemeBarNoLabels';
  Result:=EChartsTheme()
    +'<div id="'+sId+'" style="width:'+IntToStr(Width)+'px; height:'+IntToStr(Height)+'px;"></div>'+CRLF
    +sHelp
    +'<script type="text/javascript">'+CRLF
    +'  var chart_'+sId+'=echarts.init(document.getElementById('''+sId+'''), '+sTheme+');'+CRLF
    +'  option={'+CRLF+
    +sAddOptions
    +'    tooltip:{trigger:''axis'',axisPointer:{ type:''shadow''}, formatter: '+sTooltip+'},'+CRLF
    +sZoom  //pripadny pozadavek na moznost zoomovani
    +'    grid:{ left:5, right:5, bottom:'+IntToStr(iBottom)+', top:15, containLabel: true },'+CRLF
    //pokud neni definice os tady, ale v global, knihovna hlasi chybu
          //splitArea zajistuje rozdeleni do jednotlivych pasku s odlisnou barvou
          // !!!! zacatek radku az po prvni carku (vcetne) nemenit         !!!!
          // !!!! pouziva se pro nahradu pri nastaveni maximalniho rozsahu !!!!
          // !!!! os v modulu YearlyStats                                  !!!!
    +'    yAxis:[{type:''value'',splitArea:{show: true},axisLabel:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'1')+'}}],'+CRLF
    +'    xAxis:[{'+CRLF
    +'      type:''category'','+CRLF
    +'      axisLabel:{color:'+ColorToRGBA(GlobalVarGet('ColorMainText',false),'1')+'},'+CRLF
    //+'      axisTick:{alignWithLabel:true},'+CRLF
    +'      data:['''+ReplaceString(Trim(sNames),CRLF,''',''')+''']'+CRLF
    +'    }],'+CRLF
    +'    series:[{'+CRLF
    +'      type:''bar'','+CRLF
    +'      data:['+DataColoredBarMaxValue(sData)+']'+CRLF
    +'    }]'+CRLF
    +'  };'+CRLF
    //vytvoreni grafu s potrebnymi parametry a definovanym tematem
    +'  chart_'+sId+'.setOption(option);'+CRLF
    +'</script>'+CRLF+CRLF;
end;
